module Life(
			clk_ltm,
			reset_n,
			x_cnt,
			y_cnt,
			life,
			oOVERRIDE,
			oADDR
			);

input clk_ltm;
input reset_n;
input [10:0] x_cnt;
input [9:0] y_cnt;
input [3:0]life;
output oOVERRIDE;
output [17:0] oADDR;
//PARAMETER
parameter BASE_ADDR = 89025;
parameter INIT = 2'b00;
parameter START = 2'b01;
parameter PAUSE = 2'b10; 
parameter H_LINE = 1056;
parameter V_LINE = 525;
parameter Hsync_Blank = 216;
parameter Hsync_Front_Porch = 40;
parameter Vertical_Back_Porch = 35;
parameter Vertical_Front_Porch = 10; 
parameter heart_base = 18'd92639;
//WIRE & REG
wire [17:0] address;
wire [1:0] OVERRIDE;
symbol heart(				
				.iclk(clk_ltm),
				.ireset_n(reset_n),
				.ix_cnt(x_cnt),
				.iy_cnt(y_cnt),
				.isymbol_pos_x(Hsync_Blank-1+730),
				.isymbol_pos_y(Vertical_Back_Porch+90),
				.iBASE_ADDR(heart_base),
				.oOVERRIDE(OVERRIDE[1]),
				.oADDR(address)
);

number life1(				
				.iclk(clk_ltm),
				.iReset_n(reset_n),
				.ixcount(x_cnt),
				.iycount(y_cnt),
				.iled_pos_x(Hsync_Blank-1+600),
				.iled_pos_y(Vertical_Back_Porch+80),
				.inumber(life),
				.oOVERRIDE(OVERRIDE[0])
);

////OUTPUT 
assign oOVERRIDE = OVERRIDE[0] || OVERRIDE[1];
assign oADDR = OVERRIDE[0] ? BASE_ADDR :
					OVERRIDE[1] ? address : 18'bZ;

endmodule
