module Score(
			clk_ltm,
			reset_n,
			x_cnt,
			y_cnt,
			iScore0,
			iScore1,
			iScore2,
			oOVERRIDE,
			oADDR
			);

input clk_ltm;
input reset_n;
input [10:0] x_cnt;
input [9:0] y_cnt;
input [4:0] iScore0;
input [4:0] iScore1;
input [4:0] iScore2;
output oOVERRIDE;
output [17:0] oADDR;
//PARAMETER
parameter BASE_ADDR = 89025;
parameter INIT = 2'b00;
parameter START = 2'b01;
parameter PAUSE = 2'b10; 
parameter H_LINE = 1056;
parameter V_LINE = 525;
parameter Hsync_Blank = 216;
parameter Hsync_Front_Porch = 40;
parameter Vertical_Back_Porch = 35;
parameter Vertical_Front_Porch = 10; 
parameter coin_base = 18'd96239;
//WIRE & REG

wire [3:0] OVERRIDE;
wire [4:0] score[0:2];
wire [17:0] address;
assign score[0] = iScore0;
assign score[1] = iScore1;
assign score[2] = iScore2;
symbol coin(				
				.iclk(clk_ltm),
				.ireset_n(reset_n),
				.ix_cnt(x_cnt),
				.iy_cnt(y_cnt),
				.isymbol_pos_x(Hsync_Blank-1+730),
				.isymbol_pos_y(Vertical_Back_Porch+170),
				.iBASE_ADDR(coin_base),
				.oOVERRIDE(OVERRIDE[3]),
				.oADDR(address)
);

number score0(				
				.iclk(clk_ltm),
				.iReset_n(reset_n),
				.ixcount(x_cnt),
				.iycount(y_cnt),
				.iled_pos_x(Hsync_Blank-1+600),
				.iled_pos_y(Vertical_Back_Porch+160),
				.inumber(score[0]),
				.oOVERRIDE(OVERRIDE[0])
);

number score1(				
				.iclk(clk_ltm),
				.iReset_n(reset_n),
				.ixcount(x_cnt),
				.iycount(y_cnt),
				.iled_pos_x(Hsync_Blank-1+640),
				.iled_pos_y(Vertical_Back_Porch+160),
				.inumber(score[1]),
				.oOVERRIDE(OVERRIDE[1])
);

number score2(				
				.iclk(clk_ltm),
				.iReset_n(reset_n),
				.ixcount(x_cnt),
				.iycount(y_cnt),
				.iled_pos_x(Hsync_Blank-1+680),
				.iled_pos_y(Vertical_Back_Porch+160),
				.inumber(score[2]),
				.oOVERRIDE(OVERRIDE[2])
);
////OUTPUT 
assign oOVERRIDE = OVERRIDE[0] || OVERRIDE [1] || OVERRIDE[2] || OVERRIDE[3];
assign oADDR = (OVERRIDE[0] || OVERRIDE [1] || OVERRIDE[2]) ? BASE_ADDR :
					OVERRIDE[3] ? address : 18'bZ;

endmodule
