module command(
			clk,
			reset_n,
			chipselect,
			read,
			write,
			address,
			readdata,
			writedata,
			oMOLECTRL,
			oPANELCTRL
			);

//=================================
//IO PORT
//=================================
input clk;
input reset_n;
input chipselect;
input read;
input write;
input [4:0] address;
output [31:0] readdata;
input [31:0] writedata;
output [31:0]oMOLECTRL;
output [31:0]oPANELCTRL;

//===================================
//REG and WIRE
//====================================
reg [31:0] mole;
reg [31:0] panel;



//====================================
//STRUCTURE LOGIC
//====================================		
always@(posedge clk or negedge reset_n)
begin
	if(!reset_n)
		begin
			mole <= 0;
			panel <= 0;
		end
	else if (chipselect)
		begin
			if(write)
			begin
				if(address == 5'b00000)
					panel <= writedata;
				else if(address == 5'b00001)
					mole <= writedata;
			end
		end
end

assign oMOLECTRL = mole;
assign oPANELCTRL = panel;

endmodule

