module lose(
				iclk,
				ireset_n,
				ix_cnt,
				iy_cnt,
				oADDR);
				
//===============================================
//Parameter===============================
//===============================================	
parameter A = 5'd1;
parameter B = 5'd2;
parameter C = 5'd3;
parameter D = 5'd4;
parameter E = 5'd5;
parameter F = 5'd6;
parameter G = 5'd7;
parameter H = 5'd8;
parameter I = 5'd9;
parameter J = 5'd10;
parameter K = 5'd11;
parameter L = 5'd12;
parameter M = 5'd13;
parameter N = 5'd14;
parameter O = 5'd15;
parameter P = 5'd16;
parameter Q = 5'd17;
parameter R = 5'd18;
parameter S = 5'd19;
parameter T = 5'd20;
parameter U = 5'd21;
parameter V = 5'd22;
parameter W = 5'd23;
parameter X = 5'd24;
parameter Y = 5'd25;
parameter Z = 5'd26;

parameter H_LINE = 1056;
parameter V_LINE = 525;
parameter Hsync_Blank = 216;
parameter Hsync_Front_Porch = 40;
parameter Vertical_Back_Porch = 35;
parameter Vertical_Front_Porch = 10; 				
//===============================================
//I/O DECALARATION===============================
//===============================================	
input iclk;
input ireset_n;
input [10:0] ix_cnt;
input [9:0] iy_cnt;
output [17:0] oADDR;

//===============================================
//WIRE & REG===============================
//===============================================	
wire [4:0] letter[0:20];
wire [10:0] letter_pos_x[0:20];
wire [9:0] letter_pos_y[0:20];
wire [20:0] override;
wire [17:0] address[0:20];
reg [17:0] oADDR;
//===============================================
//Structured logic===============================
//===============================================	
//Assign Letters
assign letter[0] = Y;
assign letter[1] = O;
assign letter[2] = U;
assign letter[3] = L;
assign letter[4] = O;
assign letter[5] = S;
assign letter[6] = E;
assign letter[7] = P;
assign letter[8] = L;
assign letter[9] = E;
assign letter[10] = A;
assign letter[11] = S;
assign letter[12] = E;
assign letter[13] = T;
assign letter[14] = R;
assign letter[15] = Y;
assign letter[16] = A;
assign letter[17] = G;
assign letter[18] = A;
assign letter[19] = I;
assign letter[20] = N;


//assign letter position
assign letter_pos_x[0] = Hsync_Blank-2+496;
assign letter_pos_x[1] = Hsync_Blank-2+464;
assign letter_pos_x[2] = Hsync_Blank-2+432;
assign letter_pos_x[3] = Hsync_Blank-2+368;
assign letter_pos_x[4] = Hsync_Blank-2+336;
assign letter_pos_x[5] = Hsync_Blank-2+304;
assign letter_pos_x[6] = Hsync_Blank-2+272;

assign letter_pos_x[7] = Hsync_Blank-2+624;
assign letter_pos_x[8] = Hsync_Blank-2+592;
assign letter_pos_x[9] = Hsync_Blank-2+560;
assign letter_pos_x[10] = Hsync_Blank-2+528;
assign letter_pos_x[11] = Hsync_Blank-2+496;
assign letter_pos_x[12] = Hsync_Blank-2+464;

assign letter_pos_x[13] = Hsync_Blank-2+400;
assign letter_pos_x[14] = Hsync_Blank-2+368;
assign letter_pos_x[15] = Hsync_Blank-2+336;

assign letter_pos_x[16] = Hsync_Blank-2+272;
assign letter_pos_x[17] = Hsync_Blank-2+240;
assign letter_pos_x[18] = Hsync_Blank-2+208;
assign letter_pos_x[19] = Hsync_Blank-2+176;
assign letter_pos_x[20] = Hsync_Blank-2+144;


assign letter_pos_y[0] = Vertical_Back_Porch-1+160;
assign letter_pos_y[1] = Vertical_Back_Porch-1+160;
assign letter_pos_y[2] = Vertical_Back_Porch-1+160;
assign letter_pos_y[3] = Vertical_Back_Porch-1+160;
assign letter_pos_y[4] = Vertical_Back_Porch-1+160;
assign letter_pos_y[5] = Vertical_Back_Porch-1+160;
assign letter_pos_y[6] = Vertical_Back_Porch-1+160;

assign letter_pos_y[7] = Vertical_Back_Porch-1+240;
assign letter_pos_y[8] = Vertical_Back_Porch-1+240;
assign letter_pos_y[9] = Vertical_Back_Porch-1+240;
assign letter_pos_y[10] = Vertical_Back_Porch-1+240;
assign letter_pos_y[11] = Vertical_Back_Porch-1+240;
assign letter_pos_y[12] = Vertical_Back_Porch-1+240;
assign letter_pos_y[13] = Vertical_Back_Porch-1+240;
assign letter_pos_y[14] = Vertical_Back_Porch-1+240;
assign letter_pos_y[15] = Vertical_Back_Porch-1+240;
assign letter_pos_y[16] = Vertical_Back_Porch-1+240;
assign letter_pos_y[17] = Vertical_Back_Porch-1+240;
assign letter_pos_y[18] = Vertical_Back_Porch-1+240;
assign letter_pos_y[19] = Vertical_Back_Porch-1+240;
assign letter_pos_y[20] = Vertical_Back_Porch-1+240;


letter letter0(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[0]),
				.iletter_pos_y(letter_pos_y[0]),
				.iletter(letter[0]),
				.oOVERRIDE(override[0]),
				.oADDR(address[0])
				);
				
letter letter1(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[1]),
				.iletter_pos_y(letter_pos_y[1]),
				.iletter(letter[1]),
				.oOVERRIDE(override[1]),
				.oADDR(address[1])
				);
				
letter letter2(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[2]),
				.iletter_pos_y(letter_pos_y[2]),
				.iletter(letter[2]),
				.oOVERRIDE(override[2]),
				.oADDR(address[2])
				);
				
letter letter3(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[3]),
				.iletter_pos_y(letter_pos_y[3]),
				.iletter(letter[3]),
				.oOVERRIDE(override[3]),
				.oADDR(address[3])
				);
				
letter letter4(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[4]),
				.iletter_pos_y(letter_pos_y[4]),
				.iletter(letter[4]),
				.oOVERRIDE(override[4]),
				.oADDR(address[4])
				);
				
letter letter5(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[5]),
				.iletter_pos_y(letter_pos_y[5]),
				.iletter(letter[5]),
				.oOVERRIDE(override[5]),
				.oADDR(address[5])
				);
				
letter letter6(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[6]),
				.iletter_pos_y(letter_pos_y[6]),
				.iletter(letter[6]),
				.oOVERRIDE(override[6]),
				.oADDR(address[6])
				);
				
letter letter7(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[7]),
				.iletter_pos_y(letter_pos_y[7]),
				.iletter(letter[7]),
				.oOVERRIDE(override[7]),
				.oADDR(address[7])
				);
				
letter letter8(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[8]),
				.iletter_pos_y(letter_pos_y[8]),
				.iletter(letter[8]),
				.oOVERRIDE(override[8]),
				.oADDR(address[8])
				);
				
letter letter9(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[9]),
				.iletter_pos_y(letter_pos_y[9]),
				.iletter(letter[9]),
				.oOVERRIDE(override[9]),
				.oADDR(address[9])
				);
				
letter letter10(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[10]),
				.iletter_pos_y(letter_pos_y[10]),
				.iletter(letter[10]),
				.oOVERRIDE(override[10]),
				.oADDR(address[10])
				);
				
letter letter11(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[11]),
				.iletter_pos_y(letter_pos_y[11]),
				.iletter(letter[11]),
				.oOVERRIDE(override[11]),
				.oADDR(address[11])
				);
				
letter letter12(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[12]),
				.iletter_pos_y(letter_pos_y[12]),
				.iletter(letter[12]),
				.oOVERRIDE(override[12]),
				.oADDR(address[12])
				);
				
letter letter13(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[13]),
				.iletter_pos_y(letter_pos_y[13]),
				.iletter(letter[13]),
				.oOVERRIDE(override[13]),
				.oADDR(address[13])
				);
				
letter letter14(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[14]),
				.iletter_pos_y(letter_pos_y[14]),
				.iletter(letter[14]),
				.oOVERRIDE(override[14]),
				.oADDR(address[14])
				);
				
letter letter15(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[15]),
				.iletter_pos_y(letter_pos_y[15]),
				.iletter(letter[15]),
				.oOVERRIDE(override[15]),
				.oADDR(address[15])
				);
				
letter letter16(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[16]),
				.iletter_pos_y(letter_pos_y[16]),
				.iletter(letter[16]),
				.oOVERRIDE(override[16]),
				.oADDR(address[16])
				);
				
letter letter17(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[17]),
				.iletter_pos_y(letter_pos_y[17]),
				.iletter(letter[17]),
				.oOVERRIDE(override[17]),
				.oADDR(address[17])
				);
				
letter letter18(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[18]),
				.iletter_pos_y(letter_pos_y[18]),
				.iletter(letter[18]),
				.oOVERRIDE(override[18]),
				.oADDR(address[18])
				);
				
letter letter19(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[19]),
				.iletter_pos_y(letter_pos_y[19]),
				.iletter(letter[19]),
				.oOVERRIDE(override[19]),
				.oADDR(address[19])
				);
				
letter letter20(
				.iclk(iclk),
				.ireset_n(ireset_n),
				.ix_cnt(ix_cnt),
				.iy_cnt(iy_cnt),
				.iletter_pos_x(letter_pos_x[20]),
				.iletter_pos_y(letter_pos_y[20]),
				.iletter(letter[20]),
				.oOVERRIDE(override[20]),
				.oADDR(address[20])
				);
				
				
always@(posedge iclk or negedge ireset_n)
begin
	if(!ireset_n)
		oADDR <= 18'bZ;
	else
		case(override)
		21'b000000000000000000001 : oADDR <= address[0];
		21'b000000000000000000010 : oADDR <= address[1];
		21'b000000000000000000100 : oADDR <= address[2];
		21'b000000000000000001000 : oADDR <= address[3];
		21'b000000000000000010000 : oADDR <= address[4];
		21'b000000000000000100000 : oADDR <= address[5];
		21'b000000000000001000000 : oADDR <= address[6];
		21'b000000000000010000000 : oADDR <= address[7];
		21'b000000000000100000000 : oADDR <= address[8];
		21'b000000000001000000000 : oADDR <= address[9];
		21'b000000000010000000000 : oADDR <= address[10];
		21'b000000000100000000000 : oADDR <= address[11];
		21'b000000001000000000000 : oADDR <= address[12];
		21'b000000010000000000000 : oADDR <= address[13];
		21'b000000100000000000000 : oADDR <= address[14];
		21'b000001000000000000000 : oADDR <= address[15];
		21'b000010000000000000000 : oADDR <= address[16];
		21'b000100000000000000000 : oADDR <= address[17];
		21'b001000000000000000000 : oADDR <= address[18];
		21'b010000000000000000000 : oADDR <= address[19];
		21'b100000000000000000000 : oADDR <= address[20];
		default: oADDR <= 18'd89025;
		endcase;
end

endmodule
