//////////////////////Number Display Module///////////////////////////
module number(
				iclk,
				iReset_n,
				ixcount,
				iycount,
				iled_pos_x,
				iled_pos_y,
				inumber,
				oOVERRIDE,
				);

//Port IO
input iclk;
input iReset_n;
input [3:0]inumber;
input [10:0] ixcount;
input [9:0]  iycount;
input [10:0] iled_pos_x;
input [10:0] iled_pos_y;
output oOVERRIDE;

//Wire & Reg
reg oOVERRIDE;
wire display_area;
wire number_area;
wire a;
wire b;
wire c;
wire d;
wire e;
wire f;
wire g;
wire a_en;
wire b_en;
wire c_en;
wire d_en;
wire e_en;
wire f_en;
wire g_en;

//Structure
assign display_area = ((ixcount > (iled_pos_x -1)) 
							&& (ixcount < (iled_pos_x+ 60) ) 
							&& (iycount > (iled_pos_y -1))
							&& (iycount < (iled_pos_y +80))) ? 1'b1:1'b0;
							
assign number_area = ((ixcount > (iled_pos_x +4)) 
							&& (ixcount < (iled_pos_x+ 35) ) 
							&& (iycount > (iled_pos_y + 9))
							&& (iycount < (iled_pos_y +70))) ? 1'b1:1'b0;
							
assign a = ((ixcount > (iled_pos_x + 4)) 
				&& (ixcount < (iled_pos_x + 35)) 
				&&(iycount > (iled_pos_y + 9))
				&&(iycount < (iled_pos_y + 18))) ? 1'b1 : 1'b0;
assign b = 	((ixcount > (iled_pos_x + 4)) 
				&& (ixcount < (iled_pos_x + 13)) 
				&&(iycount > (iled_pos_y + 9))
				&&(iycount < (iled_pos_y + 40))) ? 1'b1 : 1'b0;	
assign c =  ((ixcount > (iled_pos_x + 4)) 
				&& (ixcount < (iled_pos_x + 13)) 
				&&(iycount > (iled_pos_y + 39))
				&&(iycount < (iled_pos_y + 70))) ? 1'b1 : 1'b0;	
assign d = 	 ((ixcount > (iled_pos_x + 4)) 
				&& (ixcount < (iled_pos_x + 35)) 
				&&(iycount > (iled_pos_y + 61))
				&&(iycount < (iled_pos_y + 70))) ? 1'b1 : 1'b0;
assign e = 	 ((ixcount > (iled_pos_x + 26)) 
				&& (ixcount < (iled_pos_x + 35)) 
				&&(iycount > (iled_pos_y + 39))
				&&(iycount < (iled_pos_y + 70))) ? 1'b1 : 1'b0;
assign f = 	 ((ixcount > (iled_pos_x + 26)) 
				&& (ixcount < (iled_pos_x + 35)) 
				&&(iycount > (iled_pos_y + 9))
				&&(iycount < (iled_pos_y + 40))) ? 1'b1 : 1'b0;	
assign g = 	 ((ixcount > (iled_pos_x + 4)) 
				&& (ixcount < (iled_pos_x + 35)) 
				&&(iycount > (iled_pos_y + 35))
				&&(iycount < (iled_pos_y + 44))) ? 1'b1 : 1'b0;	

//assign a_en = ((inumber != 1) && (inumber != 4)) ? 1'b1 : 1'b0;
//assign b_en = ((inumber != 5) && (inumber != 6)) ? 1'b1 : 1'b0;
//assign c_en = ((inumber != 2)) ? 1'b1 : 1'b0;
//assign d_en = ((inumber != 1) && (inumber != 4) && (inumber != 7)) ? 1'b1 : 1'b0;
//assign e_en = ((inumber == 2) || (inumber == 6) || (inumber == 8) || (inumber == 0)) ? 1'b1: 1'b0;
//assign f_en = ((inumber == 4) || (inumber == 5) || (inumber == 6) || (inumber == 8) 
//					|| (inumber == 9) || (inumber == 0)) ? 1'b1: 1'b0;
//assign g_en = ((inumber != 1) && (inumber != 7) && (inumber != 0)) ? 1'b1 : 1'b0;
				
always @(posedge iclk or negedge iReset_n)
begin 
	if(!iReset_n)
			oOVERRIDE <= 1'b0;
	else 
	case(inumber)
		0: oOVERRIDE <= (a||b||c||d||e||f);
		1: oOVERRIDE <= (b||c);
		2: oOVERRIDE <= (a||b||g||e||d);
		3: oOVERRIDE <= (a||b||c||d||g);
		4: oOVERRIDE <= (b||c||f||g);
		5: oOVERRIDE <= (a||c||d||f||g);
		6: oOVERRIDE <= (a||c||d||e||f||g);
		7: oOVERRIDE <= (a||b||c);
		8: oOVERRIDE <= (a||b||c||d||e||f||g);
		9: oOVERRIDE <= (a||b||c||d||f||g);
		default : oOVERRIDE <= 1'b0;
	endcase
end
endmodule
