module xycoord_interface	(
						clk, 				
						reset_n, 			
						read,
						write,
						chipselect,
						address,
						readdata,
						writedata,
					iX_COORD,
					iY_COORD
					///////////////////
					);
					

//===========================================================================
// PORT declarations
//=========================================================================== 
input	clk;   // system clock 50Mhz
input reset_n;// system reset
input	read;
input write;
input chipselect;
input [4:0]address;
output [15:0]readdata;
input [15:0]writedata;  
input	[11:0]	iX_COORD;
input	[11:0]	iY_COORD;
				
//=============================================================================
// REG/WIRE declarations
//=============================================================================
reg		[11:0]	oX_COORD;
reg		[11:0]	oY_COORD;
reg [15:0] readdata_buff;
//=============================================================================
// Structural coding
//=============================================================================

assign readdata = readdata_buff;
//write the x y coordinates to the avalon bus	
always@(posedge clk or negedge reset_n)
	begin
		if(!reset_n)
			readdata_buff <= 12'b0;
		else if (chipselect && read)
			begin
						if(address == 5'b00000)
							readdata_buff <= iX_COORD;
						else if (address == 5'b00001)
							readdata_buff <= iY_COORD;
			end
	end


endmodule