module symbol(
				iclk,
				ireset_n,
				ix_cnt,
				iy_cnt,
				isymbol_pos_x,
				isymbol_pos_y,
				iBASE_ADDR,
				oOVERRIDE,
				oADDR
				);
				
//===============================================
//I/O DECALARATION===============================
//===============================================		
input iclk;
input ireset_n;
input [10:0] ix_cnt;
input [9:0] iy_cnt;
input [10:0]isymbol_pos_x;
input [9:0]isymbol_pos_y;
input [17:0] iBASE_ADDR;
output oOVERRIDE;
output [17:0] oADDR;


//===============================================
//WIRE & REG===============================
//===============================================	
reg  oOVERRIDE;
reg [17:0] oADDR;
reg [5:0] counter;
wire display_area;
reg white[0:3599];

//===============================================
//Structured logic===============================
//===============================================	
assign display_area = ((ix_cnt > isymbol_pos_x-1) && (ix_cnt < isymbol_pos_x + 60)  
								&& (iy_cnt > isymbol_pos_y -1) && (iy_cnt < isymbol_pos_y + 60)) ? 1'b1:1'b0;


always@(negedge ireset_n)
begin
	if(!ireset_n)
		begin
		case(iBASE_ADDR)
		//clock
		18'd89039: begin
		white[ 0 ]<=0;
		white[ 1 ]<=0;
		white[ 2 ]<=0;
		white[ 3 ]<=0;
		white[ 4 ]<=0;
		white[ 5 ]<=0;
		white[ 6 ]<=0;
		white[ 7 ]<=0;
		white[ 8 ]<=0;
		white[ 9 ]<=0;
		white[ 10 ]<=0;
		white[ 11 ]<=0;
		white[ 12 ]<=0;
		white[ 13 ]<=0;
		white[ 14 ]<=0;
		white[ 15 ]<=1;
		white[ 16 ]<=1;
		white[ 17 ]<=1;
		white[ 18 ]<=1;
		white[ 19 ]<=1;
		white[ 20 ]<=1;
		white[ 21 ]<=1;
		white[ 22 ]<=0;
		white[ 23 ]<=0;
		white[ 24 ]<=0;
		white[ 25 ]<=0;
		white[ 26 ]<=0;
		white[ 27 ]<=0;
		white[ 28 ]<=0;
		white[ 29 ]<=0;
		white[ 30 ]<=0;
		white[ 31 ]<=0;
		white[ 32 ]<=0;
		white[ 33 ]<=0;
		white[ 34 ]<=0;
		white[ 35 ]<=0;
		white[ 36 ]<=0;
		white[ 37 ]<=0;
		white[ 38 ]<=1;
		white[ 39 ]<=1;
		white[ 40 ]<=1;
		white[ 41 ]<=1;
		white[ 42 ]<=1;
		white[ 43 ]<=1;
		white[ 44 ]<=1;
		white[ 45 ]<=0;
		white[ 46 ]<=0;
		white[ 47 ]<=0;
		white[ 48 ]<=0;
		white[ 49 ]<=0;
		white[ 50 ]<=0;
		white[ 51 ]<=0;
		white[ 52 ]<=0;
		white[ 53 ]<=0;
		white[ 54 ]<=0;
		white[ 55 ]<=0;
		white[ 56 ]<=0;
		white[ 57 ]<=0;
		white[ 58 ]<=0;
		white[ 59 ]<=0;
		white[ 60 ]<=0;
		white[ 61 ]<=0;
		white[ 62 ]<=0;
		white[ 63 ]<=0;
		white[ 64 ]<=0;
		white[ 65 ]<=0;
		white[ 66 ]<=0;
		white[ 67 ]<=0;
		white[ 68 ]<=0;
		white[ 69 ]<=0;
		white[ 70 ]<=0;
		white[ 71 ]<=0;
		white[ 72 ]<=0;
		white[ 73 ]<=1;
		white[ 74 ]<=1;
		white[ 75 ]<=1;
		white[ 76 ]<=1;
		white[ 77 ]<=1;
		white[ 78 ]<=1;
		white[ 79 ]<=1;
		white[ 80 ]<=1;
		white[ 81 ]<=1;
		white[ 82 ]<=1;
		white[ 83 ]<=1;
		white[ 84 ]<=0;
		white[ 85 ]<=0;
		white[ 86 ]<=0;
		white[ 87 ]<=0;
		white[ 88 ]<=0;
		white[ 89 ]<=0;
		white[ 90 ]<=0;
		white[ 91 ]<=0;
		white[ 92 ]<=0;
		white[ 93 ]<=0;
		white[ 94 ]<=0;
		white[ 95 ]<=0;
		white[ 96 ]<=1;
		white[ 97 ]<=1;
		white[ 98 ]<=1;
		white[ 99 ]<=1;
		white[ 100 ]<=1;
		white[ 101 ]<=1;
		white[ 102 ]<=1;
		white[ 103 ]<=1;
		white[ 104 ]<=1;
		white[ 105 ]<=1;
		white[ 106 ]<=1;
		white[ 107 ]<=0;
		white[ 108 ]<=0;
		white[ 109 ]<=0;
		white[ 110 ]<=0;
		white[ 111 ]<=0;
		white[ 112 ]<=0;
		white[ 113 ]<=0;
		white[ 114 ]<=0;
		white[ 115 ]<=0;
		white[ 116 ]<=0;
		white[ 117 ]<=0;
		white[ 118 ]<=0;
		white[ 119 ]<=0;
		white[ 120 ]<=0;
		white[ 121 ]<=0;
		white[ 122 ]<=0;
		white[ 123 ]<=0;
		white[ 124 ]<=0;
		white[ 125 ]<=0;
		white[ 126 ]<=0;
		white[ 127 ]<=0;
		white[ 128 ]<=0;
		white[ 129 ]<=0;
		white[ 130 ]<=0;
		white[ 131 ]<=0;
		white[ 132 ]<=1;
		white[ 133 ]<=1;
		white[ 134 ]<=1;
		white[ 135 ]<=1;
		white[ 136 ]<=1;
		white[ 137 ]<=1;
		white[ 138 ]<=1;
		white[ 139 ]<=1;
		white[ 140 ]<=1;
		white[ 141 ]<=1;
		white[ 142 ]<=1;
		white[ 143 ]<=1;
		white[ 144 ]<=0;
		white[ 145 ]<=0;
		white[ 146 ]<=0;
		white[ 147 ]<=0;
		white[ 148 ]<=0;
		white[ 149 ]<=0;
		white[ 150 ]<=0;
		white[ 151 ]<=0;
		white[ 152 ]<=0;
		white[ 153 ]<=0;
		white[ 154 ]<=0;
		white[ 155 ]<=0;
		white[ 156 ]<=1;
		white[ 157 ]<=1;
		white[ 158 ]<=1;
		white[ 159 ]<=1;
		white[ 160 ]<=1;
		white[ 161 ]<=1;
		white[ 162 ]<=1;
		white[ 163 ]<=1;
		white[ 164 ]<=1;
		white[ 165 ]<=1;
		white[ 166 ]<=1;
		white[ 167 ]<=1;
		white[ 168 ]<=0;
		white[ 169 ]<=0;
		white[ 170 ]<=0;
		white[ 171 ]<=0;
		white[ 172 ]<=0;
		white[ 173 ]<=0;
		white[ 174 ]<=0;
		white[ 175 ]<=0;
		white[ 176 ]<=0;
		white[ 177 ]<=0;
		white[ 178 ]<=0;
		white[ 179 ]<=0;
		white[ 180 ]<=0;
		white[ 181 ]<=0;
		white[ 182 ]<=0;
		white[ 183 ]<=0;
		white[ 184 ]<=0;
		white[ 185 ]<=0;
		white[ 186 ]<=0;
		white[ 187 ]<=0;
		white[ 188 ]<=0;
		white[ 189 ]<=0;
		white[ 190 ]<=0;
		white[ 191 ]<=1;
		white[ 192 ]<=1;
		white[ 193 ]<=1;
		white[ 194 ]<=1;
		white[ 195 ]<=1;
		white[ 196 ]<=1;
		white[ 197 ]<=1;
		white[ 198 ]<=1;
		white[ 199 ]<=1;
		white[ 200 ]<=1;
		white[ 201 ]<=1;
		white[ 202 ]<=1;
		white[ 203 ]<=1;
		white[ 204 ]<=1;
		white[ 205 ]<=0;
		white[ 206 ]<=0;
		white[ 207 ]<=0;
		white[ 208 ]<=0;
		white[ 209 ]<=0;
		white[ 210 ]<=0;
		white[ 211 ]<=0;
		white[ 212 ]<=0;
		white[ 213 ]<=0;
		white[ 214 ]<=0;
		white[ 215 ]<=1;
		white[ 216 ]<=1;
		white[ 217 ]<=1;
		white[ 218 ]<=1;
		white[ 219 ]<=1;
		white[ 220 ]<=1;
		white[ 221 ]<=1;
		white[ 222 ]<=1;
		white[ 223 ]<=1;
		white[ 224 ]<=1;
		white[ 225 ]<=1;
		white[ 226 ]<=1;
		white[ 227 ]<=1;
		white[ 228 ]<=1;
		white[ 229 ]<=0;
		white[ 230 ]<=0;
		white[ 231 ]<=0;
		white[ 232 ]<=0;
		white[ 233 ]<=0;
		white[ 234 ]<=0;
		white[ 235 ]<=0;
		white[ 236 ]<=0;
		white[ 237 ]<=0;
		white[ 238 ]<=0;
		white[ 239 ]<=0;
		white[ 240 ]<=0;
		white[ 241 ]<=0;
		white[ 242 ]<=0;
		white[ 243 ]<=0;
		white[ 244 ]<=0;
		white[ 245 ]<=0;
		white[ 246 ]<=0;
		white[ 247 ]<=0;
		white[ 248 ]<=0;
		white[ 249 ]<=1;
		white[ 250 ]<=1;
		white[ 251 ]<=1;
		white[ 252 ]<=1;
		white[ 253 ]<=1;
		white[ 254 ]<=1;
		white[ 255 ]<=1;
		white[ 256 ]<=1;
		white[ 257 ]<=1;
		white[ 258 ]<=1;
		white[ 259 ]<=1;
		white[ 260 ]<=1;
		white[ 261 ]<=1;
		white[ 262 ]<=1;
		white[ 263 ]<=1;
		white[ 264 ]<=1;
		white[ 265 ]<=1;
		white[ 266 ]<=0;
		white[ 267 ]<=0;
		white[ 268 ]<=0;
		white[ 269 ]<=0;
		white[ 270 ]<=0;
		white[ 271 ]<=0;
		white[ 272 ]<=0;
		white[ 273 ]<=0;
		white[ 274 ]<=1;
		white[ 275 ]<=1;
		white[ 276 ]<=1;
		white[ 277 ]<=1;
		white[ 278 ]<=1;
		white[ 279 ]<=1;
		white[ 280 ]<=1;
		white[ 281 ]<=1;
		white[ 282 ]<=1;
		white[ 283 ]<=1;
		white[ 284 ]<=1;
		white[ 285 ]<=1;
		white[ 286 ]<=1;
		white[ 287 ]<=1;
		white[ 288 ]<=1;
		white[ 289 ]<=1;
		white[ 290 ]<=1;
		white[ 291 ]<=0;
		white[ 292 ]<=0;
		white[ 293 ]<=0;
		white[ 294 ]<=0;
		white[ 295 ]<=0;
		white[ 296 ]<=0;
		white[ 297 ]<=0;
		white[ 298 ]<=0;
		white[ 299 ]<=0;
		white[ 300 ]<=0;
		white[ 301 ]<=0;
		white[ 302 ]<=0;
		white[ 303 ]<=0;
		white[ 304 ]<=0;
		white[ 305 ]<=0;
		white[ 306 ]<=0;
		white[ 307 ]<=0;
		white[ 308 ]<=1;
		white[ 309 ]<=1;
		white[ 310 ]<=1;
		white[ 311 ]<=1;
		white[ 312 ]<=1;
		white[ 313 ]<=1;
		white[ 314 ]<=1;
		white[ 315 ]<=1;
		white[ 316 ]<=1;
		white[ 317 ]<=1;
		white[ 318 ]<=1;
		white[ 319 ]<=1;
		white[ 320 ]<=1;
		white[ 321 ]<=1;
		white[ 322 ]<=1;
		white[ 323 ]<=1;
		white[ 324 ]<=1;
		white[ 325 ]<=1;
		white[ 326 ]<=0;
		white[ 327 ]<=0;
		white[ 328 ]<=0;
		white[ 329 ]<=0;
		white[ 330 ]<=0;
		white[ 331 ]<=0;
		white[ 332 ]<=0;
		white[ 333 ]<=0;
		white[ 334 ]<=1;
		white[ 335 ]<=1;
		white[ 336 ]<=1;
		white[ 337 ]<=1;
		white[ 338 ]<=1;
		white[ 339 ]<=1;
		white[ 340 ]<=1;
		white[ 341 ]<=1;
		white[ 342 ]<=1;
		white[ 343 ]<=1;
		white[ 344 ]<=1;
		white[ 345 ]<=1;
		white[ 346 ]<=1;
		white[ 347 ]<=1;
		white[ 348 ]<=1;
		white[ 349 ]<=1;
		white[ 350 ]<=1;
		white[ 351 ]<=1;
		white[ 352 ]<=0;
		white[ 353 ]<=0;
		white[ 354 ]<=0;
		white[ 355 ]<=0;
		white[ 356 ]<=0;
		white[ 357 ]<=0;
		white[ 358 ]<=0;
		white[ 359 ]<=0;
		white[ 360 ]<=0;
		white[ 361 ]<=0;
		white[ 362 ]<=0;
		white[ 363 ]<=0;
		white[ 364 ]<=0;
		white[ 365 ]<=0;
		white[ 366 ]<=0;
		white[ 367 ]<=1;
		white[ 368 ]<=1;
		white[ 369 ]<=1;
		white[ 370 ]<=1;
		white[ 371 ]<=1;
		white[ 372 ]<=1;
		white[ 373 ]<=1;
		white[ 374 ]<=1;
		white[ 375 ]<=1;
		white[ 376 ]<=1;
		white[ 377 ]<=1;
		white[ 378 ]<=1;
		white[ 379 ]<=1;
		white[ 380 ]<=1;
		white[ 381 ]<=1;
		white[ 382 ]<=0;
		white[ 383 ]<=0;
		white[ 384 ]<=0;
		white[ 385 ]<=0;
		white[ 386 ]<=0;
		white[ 387 ]<=0;
		white[ 388 ]<=0;
		white[ 389 ]<=0;
		white[ 390 ]<=0;
		white[ 391 ]<=0;
		white[ 392 ]<=0;
		white[ 393 ]<=0;
		white[ 394 ]<=0;
		white[ 395 ]<=0;
		white[ 396 ]<=0;
		white[ 397 ]<=0;
		white[ 398 ]<=1;
		white[ 399 ]<=1;
		white[ 400 ]<=1;
		white[ 401 ]<=1;
		white[ 402 ]<=1;
		white[ 403 ]<=1;
		white[ 404 ]<=1;
		white[ 405 ]<=1;
		white[ 406 ]<=1;
		white[ 407 ]<=1;
		white[ 408 ]<=1;
		white[ 409 ]<=1;
		white[ 410 ]<=1;
		white[ 411 ]<=1;
		white[ 412 ]<=1;
		white[ 413 ]<=0;
		white[ 414 ]<=0;
		white[ 415 ]<=0;
		white[ 416 ]<=0;
		white[ 417 ]<=0;
		white[ 418 ]<=0;
		white[ 419 ]<=0;
		white[ 420 ]<=0;
		white[ 421 ]<=0;
		white[ 422 ]<=0;
		white[ 423 ]<=0;
		white[ 424 ]<=0;
		white[ 425 ]<=0;
		white[ 426 ]<=1;
		white[ 427 ]<=1;
		white[ 428 ]<=1;
		white[ 429 ]<=1;
		white[ 430 ]<=1;
		white[ 431 ]<=1;
		white[ 432 ]<=1;
		white[ 433 ]<=1;
		white[ 434 ]<=1;
		white[ 435 ]<=1;
		white[ 436 ]<=1;
		white[ 437 ]<=1;
		white[ 438 ]<=1;
		white[ 439 ]<=0;
		white[ 440 ]<=0;
		white[ 441 ]<=0;
		white[ 442 ]<=0;
		white[ 443 ]<=0;
		white[ 444 ]<=1;
		white[ 445 ]<=1;
		white[ 446 ]<=1;
		white[ 447 ]<=1;
		white[ 448 ]<=1;
		white[ 449 ]<=1;
		white[ 450 ]<=1;
		white[ 451 ]<=1;
		white[ 452 ]<=1;
		white[ 453 ]<=1;
		white[ 454 ]<=1;
		white[ 455 ]<=1;
		white[ 456 ]<=0;
		white[ 457 ]<=0;
		white[ 458 ]<=0;
		white[ 459 ]<=0;
		white[ 460 ]<=0;
		white[ 461 ]<=1;
		white[ 462 ]<=1;
		white[ 463 ]<=1;
		white[ 464 ]<=1;
		white[ 465 ]<=1;
		white[ 466 ]<=1;
		white[ 467 ]<=1;
		white[ 468 ]<=1;
		white[ 469 ]<=1;
		white[ 470 ]<=1;
		white[ 471 ]<=1;
		white[ 472 ]<=1;
		white[ 473 ]<=1;
		white[ 474 ]<=0;
		white[ 475 ]<=0;
		white[ 476 ]<=0;
		white[ 477 ]<=0;
		white[ 478 ]<=0;
		white[ 479 ]<=0;
		white[ 480 ]<=0;
		white[ 481 ]<=0;
		white[ 482 ]<=0;
		white[ 483 ]<=0;
		white[ 484 ]<=0;
		white[ 485 ]<=0;
		white[ 486 ]<=1;
		white[ 487 ]<=1;
		white[ 488 ]<=1;
		white[ 489 ]<=1;
		white[ 490 ]<=1;
		white[ 491 ]<=1;
		white[ 492 ]<=1;
		white[ 493 ]<=1;
		white[ 494 ]<=1;
		white[ 495 ]<=1;
		white[ 496 ]<=1;
		white[ 497 ]<=0;
		white[ 498 ]<=0;
		white[ 499 ]<=0;
		white[ 500 ]<=1;
		white[ 501 ]<=1;
		white[ 502 ]<=1;
		white[ 503 ]<=1;
		white[ 504 ]<=1;
		white[ 505 ]<=1;
		white[ 506 ]<=1;
		white[ 507 ]<=1;
		white[ 508 ]<=1;
		white[ 509 ]<=1;
		white[ 510 ]<=1;
		white[ 511 ]<=1;
		white[ 512 ]<=1;
		white[ 513 ]<=1;
		white[ 514 ]<=1;
		white[ 515 ]<=1;
		white[ 516 ]<=1;
		white[ 517 ]<=1;
		white[ 518 ]<=1;
		white[ 519 ]<=1;
		white[ 520 ]<=0;
		white[ 521 ]<=0;
		white[ 522 ]<=0;
		white[ 523 ]<=1;
		white[ 524 ]<=1;
		white[ 525 ]<=1;
		white[ 526 ]<=1;
		white[ 527 ]<=1;
		white[ 528 ]<=1;
		white[ 529 ]<=1;
		white[ 530 ]<=1;
		white[ 531 ]<=1;
		white[ 532 ]<=1;
		white[ 533 ]<=1;
		white[ 534 ]<=0;
		white[ 535 ]<=0;
		white[ 536 ]<=0;
		white[ 537 ]<=0;
		white[ 538 ]<=0;
		white[ 539 ]<=0;
		white[ 540 ]<=0;
		white[ 541 ]<=0;
		white[ 542 ]<=0;
		white[ 543 ]<=0;
		white[ 544 ]<=0;
		white[ 545 ]<=1;
		white[ 546 ]<=1;
		white[ 547 ]<=1;
		white[ 548 ]<=1;
		white[ 549 ]<=1;
		white[ 550 ]<=1;
		white[ 551 ]<=1;
		white[ 552 ]<=1;
		white[ 553 ]<=1;
		white[ 554 ]<=1;
		white[ 555 ]<=0;
		white[ 556 ]<=0;
		white[ 557 ]<=0;
		white[ 558 ]<=1;
		white[ 559 ]<=1;
		white[ 560 ]<=1;
		white[ 561 ]<=1;
		white[ 562 ]<=1;
		white[ 563 ]<=1;
		white[ 564 ]<=1;
		white[ 565 ]<=1;
		white[ 566 ]<=1;
		white[ 567 ]<=1;
		white[ 568 ]<=1;
		white[ 569 ]<=1;
		white[ 570 ]<=1;
		white[ 571 ]<=1;
		white[ 572 ]<=1;
		white[ 573 ]<=1;
		white[ 574 ]<=1;
		white[ 575 ]<=1;
		white[ 576 ]<=1;
		white[ 577 ]<=1;
		white[ 578 ]<=1;
		white[ 579 ]<=1;
		white[ 580 ]<=1;
		white[ 581 ]<=1;
		white[ 582 ]<=0;
		white[ 583 ]<=0;
		white[ 584 ]<=0;
		white[ 585 ]<=1;
		white[ 586 ]<=1;
		white[ 587 ]<=1;
		white[ 588 ]<=1;
		white[ 589 ]<=1;
		white[ 590 ]<=1;
		white[ 591 ]<=1;
		white[ 592 ]<=1;
		white[ 593 ]<=1;
		white[ 594 ]<=1;
		white[ 595 ]<=0;
		white[ 596 ]<=0;
		white[ 597 ]<=0;
		white[ 598 ]<=0;
		white[ 599 ]<=0;
		white[ 600 ]<=0;
		white[ 601 ]<=0;
		white[ 602 ]<=0;
		white[ 603 ]<=0;
		white[ 604 ]<=0;
		white[ 605 ]<=1;
		white[ 606 ]<=1;
		white[ 607 ]<=1;
		white[ 608 ]<=1;
		white[ 609 ]<=1;
		white[ 610 ]<=1;
		white[ 611 ]<=1;
		white[ 612 ]<=1;
		white[ 613 ]<=1;
		white[ 614 ]<=0;
		white[ 615 ]<=0;
		white[ 616 ]<=0;
		white[ 617 ]<=1;
		white[ 618 ]<=1;
		white[ 619 ]<=1;
		white[ 620 ]<=1;
		white[ 621 ]<=1;
		white[ 622 ]<=1;
		white[ 623 ]<=1;
		white[ 624 ]<=1;
		white[ 625 ]<=1;
		white[ 626 ]<=1;
		white[ 627 ]<=1;
		white[ 628 ]<=1;
		white[ 629 ]<=1;
		white[ 630 ]<=1;
		white[ 631 ]<=1;
		white[ 632 ]<=1;
		white[ 633 ]<=1;
		white[ 634 ]<=1;
		white[ 635 ]<=1;
		white[ 636 ]<=1;
		white[ 637 ]<=1;
		white[ 638 ]<=1;
		white[ 639 ]<=1;
		white[ 640 ]<=1;
		white[ 641 ]<=1;
		white[ 642 ]<=1;
		white[ 643 ]<=0;
		white[ 644 ]<=0;
		white[ 645 ]<=0;
		white[ 646 ]<=1;
		white[ 647 ]<=1;
		white[ 648 ]<=1;
		white[ 649 ]<=1;
		white[ 650 ]<=1;
		white[ 651 ]<=1;
		white[ 652 ]<=1;
		white[ 653 ]<=1;
		white[ 654 ]<=1;
		white[ 655 ]<=0;
		white[ 656 ]<=0;
		white[ 657 ]<=0;
		white[ 658 ]<=0;
		white[ 659 ]<=0;
		white[ 660 ]<=0;
		white[ 661 ]<=0;
		white[ 662 ]<=0;
		white[ 663 ]<=0;
		white[ 664 ]<=0;
		white[ 665 ]<=0;
		white[ 666 ]<=1;
		white[ 667 ]<=1;
		white[ 668 ]<=1;
		white[ 669 ]<=1;
		white[ 670 ]<=1;
		white[ 671 ]<=1;
		white[ 672 ]<=0;
		white[ 673 ]<=0;
		white[ 674 ]<=0;
		white[ 675 ]<=1;
		white[ 676 ]<=1;
		white[ 677 ]<=1;
		white[ 678 ]<=1;
		white[ 679 ]<=1;
		white[ 680 ]<=1;
		white[ 681 ]<=1;
		white[ 682 ]<=1;
		white[ 683 ]<=1;
		white[ 684 ]<=1;
		white[ 685 ]<=1;
		white[ 686 ]<=0;
		white[ 687 ]<=0;
		white[ 688 ]<=0;
		white[ 689 ]<=0;
		white[ 690 ]<=0;
		white[ 691 ]<=0;
		white[ 692 ]<=0;
		white[ 693 ]<=0;
		white[ 694 ]<=1;
		white[ 695 ]<=1;
		white[ 696 ]<=1;
		white[ 697 ]<=1;
		white[ 698 ]<=1;
		white[ 699 ]<=1;
		white[ 700 ]<=1;
		white[ 701 ]<=1;
		white[ 702 ]<=1;
		white[ 703 ]<=1;
		white[ 704 ]<=1;
		white[ 705 ]<=0;
		white[ 706 ]<=0;
		white[ 707 ]<=0;
		white[ 708 ]<=1;
		white[ 709 ]<=1;
		white[ 710 ]<=1;
		white[ 711 ]<=1;
		white[ 712 ]<=1;
		white[ 713 ]<=1;
		white[ 714 ]<=0;
		white[ 715 ]<=0;
		white[ 716 ]<=0;
		white[ 717 ]<=0;
		white[ 718 ]<=0;
		white[ 719 ]<=0;
		white[ 720 ]<=0;
		white[ 721 ]<=0;
		white[ 722 ]<=0;
		white[ 723 ]<=0;
		white[ 724 ]<=0;
		white[ 725 ]<=0;
		white[ 726 ]<=1;
		white[ 727 ]<=1;
		white[ 728 ]<=1;
		white[ 729 ]<=1;
		white[ 730 ]<=1;
		white[ 731 ]<=0;
		white[ 732 ]<=0;
		white[ 733 ]<=1;
		white[ 734 ]<=1;
		white[ 735 ]<=1;
		white[ 736 ]<=1;
		white[ 737 ]<=1;
		white[ 738 ]<=1;
		white[ 739 ]<=1;
		white[ 740 ]<=1;
		white[ 741 ]<=1;
		white[ 742 ]<=1;
		white[ 743 ]<=0;
		white[ 744 ]<=0;
		white[ 745 ]<=0;
		white[ 746 ]<=0;
		white[ 747 ]<=0;
		white[ 748 ]<=0;
		white[ 749 ]<=0;
		white[ 750 ]<=0;
		white[ 751 ]<=0;
		white[ 752 ]<=0;
		white[ 753 ]<=0;
		white[ 754 ]<=0;
		white[ 755 ]<=0;
		white[ 756 ]<=0;
		white[ 757 ]<=1;
		white[ 758 ]<=1;
		white[ 759 ]<=1;
		white[ 760 ]<=1;
		white[ 761 ]<=1;
		white[ 762 ]<=1;
		white[ 763 ]<=1;
		white[ 764 ]<=1;
		white[ 765 ]<=1;
		white[ 766 ]<=1;
		white[ 767 ]<=0;
		white[ 768 ]<=0;
		white[ 769 ]<=1;
		white[ 770 ]<=1;
		white[ 771 ]<=1;
		white[ 772 ]<=1;
		white[ 773 ]<=1;
		white[ 774 ]<=0;
		white[ 775 ]<=0;
		white[ 776 ]<=0;
		white[ 777 ]<=0;
		white[ 778 ]<=0;
		white[ 779 ]<=0;
		white[ 780 ]<=0;
		white[ 781 ]<=0;
		white[ 782 ]<=0;
		white[ 783 ]<=0;
		white[ 784 ]<=0;
		white[ 785 ]<=0;
		white[ 786 ]<=0;
		white[ 787 ]<=1;
		white[ 788 ]<=1;
		white[ 789 ]<=1;
		white[ 790 ]<=0;
		white[ 791 ]<=0;
		white[ 792 ]<=1;
		white[ 793 ]<=1;
		white[ 794 ]<=1;
		white[ 795 ]<=1;
		white[ 796 ]<=1;
		white[ 797 ]<=1;
		white[ 798 ]<=1;
		white[ 799 ]<=1;
		white[ 800 ]<=1;
		white[ 801 ]<=0;
		white[ 802 ]<=0;
		white[ 803 ]<=0;
		white[ 804 ]<=0;
		white[ 805 ]<=0;
		white[ 806 ]<=0;
		white[ 807 ]<=0;
		white[ 808 ]<=0;
		white[ 809 ]<=0;
		white[ 810 ]<=0;
		white[ 811 ]<=0;
		white[ 812 ]<=0;
		white[ 813 ]<=0;
		white[ 814 ]<=0;
		white[ 815 ]<=0;
		white[ 816 ]<=0;
		white[ 817 ]<=0;
		white[ 818 ]<=0;
		white[ 819 ]<=1;
		white[ 820 ]<=1;
		white[ 821 ]<=1;
		white[ 822 ]<=1;
		white[ 823 ]<=1;
		white[ 824 ]<=1;
		white[ 825 ]<=1;
		white[ 826 ]<=1;
		white[ 827 ]<=1;
		white[ 828 ]<=0;
		white[ 829 ]<=0;
		white[ 830 ]<=1;
		white[ 831 ]<=1;
		white[ 832 ]<=1;
		white[ 833 ]<=0;
		white[ 834 ]<=0;
		white[ 835 ]<=0;
		white[ 836 ]<=0;
		white[ 837 ]<=0;
		white[ 838 ]<=0;
		white[ 839 ]<=0;
		white[ 840 ]<=0;
		white[ 841 ]<=0;
		white[ 842 ]<=0;
		white[ 843 ]<=0;
		white[ 844 ]<=0;
		white[ 845 ]<=0;
		white[ 846 ]<=0;
		white[ 847 ]<=1;
		white[ 848 ]<=1;
		white[ 849 ]<=0;
		white[ 850 ]<=0;
		white[ 851 ]<=1;
		white[ 852 ]<=1;
		white[ 853 ]<=1;
		white[ 854 ]<=1;
		white[ 855 ]<=1;
		white[ 856 ]<=1;
		white[ 857 ]<=1;
		white[ 858 ]<=1;
		white[ 859 ]<=0;
		white[ 860 ]<=0;
		white[ 861 ]<=0;
		white[ 862 ]<=0;
		white[ 863 ]<=0;
		white[ 864 ]<=0;
		white[ 865 ]<=0;
		white[ 866 ]<=0;
		white[ 867 ]<=0;
		white[ 868 ]<=0;
		white[ 869 ]<=1;
		white[ 870 ]<=1;
		white[ 871 ]<=0;
		white[ 872 ]<=0;
		white[ 873 ]<=0;
		white[ 874 ]<=0;
		white[ 875 ]<=0;
		white[ 876 ]<=0;
		white[ 877 ]<=0;
		white[ 878 ]<=0;
		white[ 879 ]<=0;
		white[ 880 ]<=0;
		white[ 881 ]<=1;
		white[ 882 ]<=1;
		white[ 883 ]<=1;
		white[ 884 ]<=1;
		white[ 885 ]<=1;
		white[ 886 ]<=1;
		white[ 887 ]<=1;
		white[ 888 ]<=1;
		white[ 889 ]<=0;
		white[ 890 ]<=0;
		white[ 891 ]<=1;
		white[ 892 ]<=1;
		white[ 893 ]<=0;
		white[ 894 ]<=0;
		white[ 895 ]<=0;
		white[ 896 ]<=0;
		white[ 897 ]<=0;
		white[ 898 ]<=0;
		white[ 899 ]<=0;
		white[ 900 ]<=0;
		white[ 901 ]<=0;
		white[ 902 ]<=0;
		white[ 903 ]<=0;
		white[ 904 ]<=0;
		white[ 905 ]<=0;
		white[ 906 ]<=0;
		white[ 907 ]<=0;
		white[ 908 ]<=1;
		white[ 909 ]<=0;
		white[ 910 ]<=0;
		white[ 911 ]<=1;
		white[ 912 ]<=1;
		white[ 913 ]<=1;
		white[ 914 ]<=1;
		white[ 915 ]<=1;
		white[ 916 ]<=1;
		white[ 917 ]<=0;
		white[ 918 ]<=0;
		white[ 919 ]<=0;
		white[ 920 ]<=0;
		white[ 921 ]<=0;
		white[ 922 ]<=0;
		white[ 923 ]<=0;
		white[ 924 ]<=0;
		white[ 925 ]<=0;
		white[ 926 ]<=0;
		white[ 927 ]<=0;
		white[ 928 ]<=1;
		white[ 929 ]<=1;
		white[ 930 ]<=1;
		white[ 931 ]<=1;
		white[ 932 ]<=0;
		white[ 933 ]<=0;
		white[ 934 ]<=0;
		white[ 935 ]<=0;
		white[ 936 ]<=0;
		white[ 937 ]<=0;
		white[ 938 ]<=0;
		white[ 939 ]<=0;
		white[ 940 ]<=0;
		white[ 941 ]<=0;
		white[ 942 ]<=0;
		white[ 943 ]<=1;
		white[ 944 ]<=1;
		white[ 945 ]<=1;
		white[ 946 ]<=1;
		white[ 947 ]<=1;
		white[ 948 ]<=1;
		white[ 949 ]<=0;
		white[ 950 ]<=0;
		white[ 951 ]<=1;
		white[ 952 ]<=0;
		white[ 953 ]<=0;
		white[ 954 ]<=0;
		white[ 955 ]<=0;
		white[ 956 ]<=0;
		white[ 957 ]<=0;
		white[ 958 ]<=0;
		white[ 959 ]<=0;
		white[ 960 ]<=0;
		white[ 961 ]<=0;
		white[ 962 ]<=0;
		white[ 963 ]<=0;
		white[ 964 ]<=0;
		white[ 965 ]<=0;
		white[ 966 ]<=0;
		white[ 967 ]<=0;
		white[ 968 ]<=0;
		white[ 969 ]<=1;
		white[ 970 ]<=1;
		white[ 971 ]<=1;
		white[ 972 ]<=1;
		white[ 973 ]<=1;
		white[ 974 ]<=1;
		white[ 975 ]<=1;
		white[ 976 ]<=0;
		white[ 977 ]<=0;
		white[ 978 ]<=0;
		white[ 979 ]<=0;
		white[ 980 ]<=0;
		white[ 981 ]<=0;
		white[ 982 ]<=0;
		white[ 983 ]<=0;
		white[ 984 ]<=0;
		white[ 985 ]<=0;
		white[ 986 ]<=0;
		white[ 987 ]<=0;
		white[ 988 ]<=1;
		white[ 989 ]<=1;
		white[ 990 ]<=1;
		white[ 991 ]<=1;
		white[ 992 ]<=0;
		white[ 993 ]<=0;
		white[ 994 ]<=0;
		white[ 995 ]<=0;
		white[ 996 ]<=0;
		white[ 997 ]<=0;
		white[ 998 ]<=0;
		white[ 999 ]<=0;
		white[ 1000 ]<=0;
		white[ 1001 ]<=0;
		white[ 1002 ]<=0;
		white[ 1003 ]<=0;
		white[ 1004 ]<=1;
		white[ 1005 ]<=1;
		white[ 1006 ]<=1;
		white[ 1007 ]<=1;
		white[ 1008 ]<=1;
		white[ 1009 ]<=1;
		white[ 1010 ]<=1;
		white[ 1011 ]<=0;
		white[ 1012 ]<=0;
		white[ 1013 ]<=0;
		white[ 1014 ]<=0;
		white[ 1015 ]<=0;
		white[ 1016 ]<=0;
		white[ 1017 ]<=0;
		white[ 1018 ]<=0;
		white[ 1019 ]<=0;
		white[ 1020 ]<=0;
		white[ 1021 ]<=0;
		white[ 1022 ]<=0;
		white[ 1023 ]<=0;
		white[ 1024 ]<=0;
		white[ 1025 ]<=0;
		white[ 1026 ]<=0;
		white[ 1027 ]<=0;
		white[ 1028 ]<=0;
		white[ 1029 ]<=1;
		white[ 1030 ]<=1;
		white[ 1031 ]<=1;
		white[ 1032 ]<=1;
		white[ 1033 ]<=1;
		white[ 1034 ]<=1;
		white[ 1035 ]<=0;
		white[ 1036 ]<=0;
		white[ 1037 ]<=0;
		white[ 1038 ]<=0;
		white[ 1039 ]<=0;
		white[ 1040 ]<=0;
		white[ 1041 ]<=0;
		white[ 1042 ]<=0;
		white[ 1043 ]<=0;
		white[ 1044 ]<=0;
		white[ 1045 ]<=0;
		white[ 1046 ]<=0;
		white[ 1047 ]<=0;
		white[ 1048 ]<=1;
		white[ 1049 ]<=1;
		white[ 1050 ]<=1;
		white[ 1051 ]<=1;
		white[ 1052 ]<=0;
		white[ 1053 ]<=0;
		white[ 1054 ]<=0;
		white[ 1055 ]<=0;
		white[ 1056 ]<=0;
		white[ 1057 ]<=0;
		white[ 1058 ]<=0;
		white[ 1059 ]<=0;
		white[ 1060 ]<=0;
		white[ 1061 ]<=0;
		white[ 1062 ]<=0;
		white[ 1063 ]<=0;
		white[ 1064 ]<=0;
		white[ 1065 ]<=1;
		white[ 1066 ]<=1;
		white[ 1067 ]<=1;
		white[ 1068 ]<=1;
		white[ 1069 ]<=1;
		white[ 1070 ]<=1;
		white[ 1071 ]<=0;
		white[ 1072 ]<=0;
		white[ 1073 ]<=0;
		white[ 1074 ]<=0;
		white[ 1075 ]<=0;
		white[ 1076 ]<=0;
		white[ 1077 ]<=0;
		white[ 1078 ]<=0;
		white[ 1079 ]<=0;
		white[ 1080 ]<=0;
		white[ 1081 ]<=0;
		white[ 1082 ]<=0;
		white[ 1083 ]<=0;
		white[ 1084 ]<=0;
		white[ 1085 ]<=0;
		white[ 1086 ]<=0;
		white[ 1087 ]<=0;
		white[ 1088 ]<=1;
		white[ 1089 ]<=1;
		white[ 1090 ]<=1;
		white[ 1091 ]<=1;
		white[ 1092 ]<=1;
		white[ 1093 ]<=1;
		white[ 1094 ]<=0;
		white[ 1095 ]<=0;
		white[ 1096 ]<=0;
		white[ 1097 ]<=0;
		white[ 1098 ]<=0;
		white[ 1099 ]<=0;
		white[ 1100 ]<=0;
		white[ 1101 ]<=0;
		white[ 1102 ]<=0;
		white[ 1103 ]<=0;
		white[ 1104 ]<=0;
		white[ 1105 ]<=0;
		white[ 1106 ]<=0;
		white[ 1107 ]<=0;
		white[ 1108 ]<=1;
		white[ 1109 ]<=1;
		white[ 1110 ]<=1;
		white[ 1111 ]<=1;
		white[ 1112 ]<=0;
		white[ 1113 ]<=0;
		white[ 1114 ]<=0;
		white[ 1115 ]<=0;
		white[ 1116 ]<=0;
		white[ 1117 ]<=0;
		white[ 1118 ]<=0;
		white[ 1119 ]<=0;
		white[ 1120 ]<=0;
		white[ 1121 ]<=0;
		white[ 1122 ]<=0;
		white[ 1123 ]<=0;
		white[ 1124 ]<=0;
		white[ 1125 ]<=0;
		white[ 1126 ]<=1;
		white[ 1127 ]<=1;
		white[ 1128 ]<=1;
		white[ 1129 ]<=1;
		white[ 1130 ]<=1;
		white[ 1131 ]<=1;
		white[ 1132 ]<=0;
		white[ 1133 ]<=0;
		white[ 1134 ]<=0;
		white[ 1135 ]<=0;
		white[ 1136 ]<=0;
		white[ 1137 ]<=0;
		white[ 1138 ]<=0;
		white[ 1139 ]<=0;
		white[ 1140 ]<=0;
		white[ 1141 ]<=0;
		white[ 1142 ]<=0;
		white[ 1143 ]<=0;
		white[ 1144 ]<=0;
		white[ 1145 ]<=0;
		white[ 1146 ]<=0;
		white[ 1147 ]<=1;
		white[ 1148 ]<=1;
		white[ 1149 ]<=1;
		white[ 1150 ]<=1;
		white[ 1151 ]<=1;
		white[ 1152 ]<=1;
		white[ 1153 ]<=0;
		white[ 1154 ]<=0;
		white[ 1155 ]<=0;
		white[ 1156 ]<=0;
		white[ 1157 ]<=0;
		white[ 1158 ]<=0;
		white[ 1159 ]<=0;
		white[ 1160 ]<=0;
		white[ 1161 ]<=0;
		white[ 1162 ]<=0;
		white[ 1163 ]<=0;
		white[ 1164 ]<=0;
		white[ 1165 ]<=0;
		white[ 1166 ]<=0;
		white[ 1167 ]<=0;
		white[ 1168 ]<=1;
		white[ 1169 ]<=1;
		white[ 1170 ]<=1;
		white[ 1171 ]<=1;
		white[ 1172 ]<=0;
		white[ 1173 ]<=0;
		white[ 1174 ]<=0;
		white[ 1175 ]<=0;
		white[ 1176 ]<=0;
		white[ 1177 ]<=0;
		white[ 1178 ]<=0;
		white[ 1179 ]<=0;
		white[ 1180 ]<=0;
		white[ 1181 ]<=0;
		white[ 1182 ]<=0;
		white[ 1183 ]<=0;
		white[ 1184 ]<=0;
		white[ 1185 ]<=0;
		white[ 1186 ]<=0;
		white[ 1187 ]<=1;
		white[ 1188 ]<=1;
		white[ 1189 ]<=1;
		white[ 1190 ]<=1;
		white[ 1191 ]<=1;
		white[ 1192 ]<=1;
		white[ 1193 ]<=0;
		white[ 1194 ]<=0;
		white[ 1195 ]<=0;
		white[ 1196 ]<=0;
		white[ 1197 ]<=0;
		white[ 1198 ]<=0;
		white[ 1199 ]<=0;
		white[ 1200 ]<=0;
		white[ 1201 ]<=0;
		white[ 1202 ]<=0;
		white[ 1203 ]<=0;
		white[ 1204 ]<=0;
		white[ 1205 ]<=0;
		white[ 1206 ]<=0;
		white[ 1207 ]<=1;
		white[ 1208 ]<=1;
		white[ 1209 ]<=1;
		white[ 1210 ]<=1;
		white[ 1211 ]<=1;
		white[ 1212 ]<=0;
		white[ 1213 ]<=0;
		white[ 1214 ]<=0;
		white[ 1215 ]<=0;
		white[ 1216 ]<=0;
		white[ 1217 ]<=0;
		white[ 1218 ]<=0;
		white[ 1219 ]<=0;
		white[ 1220 ]<=0;
		white[ 1221 ]<=0;
		white[ 1222 ]<=0;
		white[ 1223 ]<=0;
		white[ 1224 ]<=0;
		white[ 1225 ]<=0;
		white[ 1226 ]<=0;
		white[ 1227 ]<=0;
		white[ 1228 ]<=1;
		white[ 1229 ]<=1;
		white[ 1230 ]<=1;
		white[ 1231 ]<=1;
		white[ 1232 ]<=0;
		white[ 1233 ]<=0;
		white[ 1234 ]<=0;
		white[ 1235 ]<=0;
		white[ 1236 ]<=0;
		white[ 1237 ]<=0;
		white[ 1238 ]<=0;
		white[ 1239 ]<=0;
		white[ 1240 ]<=0;
		white[ 1241 ]<=0;
		white[ 1242 ]<=0;
		white[ 1243 ]<=0;
		white[ 1244 ]<=0;
		white[ 1245 ]<=0;
		white[ 1246 ]<=0;
		white[ 1247 ]<=0;
		white[ 1248 ]<=1;
		white[ 1249 ]<=1;
		white[ 1250 ]<=1;
		white[ 1251 ]<=1;
		white[ 1252 ]<=1;
		white[ 1253 ]<=0;
		white[ 1254 ]<=0;
		white[ 1255 ]<=0;
		white[ 1256 ]<=0;
		white[ 1257 ]<=0;
		white[ 1258 ]<=0;
		white[ 1259 ]<=0;
		white[ 1260 ]<=0;
		white[ 1261 ]<=0;
		white[ 1262 ]<=0;
		white[ 1263 ]<=0;
		white[ 1264 ]<=0;
		white[ 1265 ]<=0;
		white[ 1266 ]<=1;
		white[ 1267 ]<=1;
		white[ 1268 ]<=1;
		white[ 1269 ]<=1;
		white[ 1270 ]<=1;
		white[ 1271 ]<=0;
		white[ 1272 ]<=0;
		white[ 1273 ]<=0;
		white[ 1274 ]<=0;
		white[ 1275 ]<=0;
		white[ 1276 ]<=0;
		white[ 1277 ]<=0;
		white[ 1278 ]<=0;
		white[ 1279 ]<=0;
		white[ 1280 ]<=0;
		white[ 1281 ]<=0;
		white[ 1282 ]<=0;
		white[ 1283 ]<=0;
		white[ 1284 ]<=0;
		white[ 1285 ]<=0;
		white[ 1286 ]<=0;
		white[ 1287 ]<=0;
		white[ 1288 ]<=1;
		white[ 1289 ]<=1;
		white[ 1290 ]<=1;
		white[ 1291 ]<=1;
		white[ 1292 ]<=0;
		white[ 1293 ]<=0;
		white[ 1294 ]<=0;
		white[ 1295 ]<=0;
		white[ 1296 ]<=0;
		white[ 1297 ]<=0;
		white[ 1298 ]<=0;
		white[ 1299 ]<=0;
		white[ 1300 ]<=0;
		white[ 1301 ]<=0;
		white[ 1302 ]<=0;
		white[ 1303 ]<=0;
		white[ 1304 ]<=0;
		white[ 1305 ]<=0;
		white[ 1306 ]<=0;
		white[ 1307 ]<=0;
		white[ 1308 ]<=0;
		white[ 1309 ]<=1;
		white[ 1310 ]<=1;
		white[ 1311 ]<=1;
		white[ 1312 ]<=1;
		white[ 1313 ]<=1;
		white[ 1314 ]<=0;
		white[ 1315 ]<=0;
		white[ 1316 ]<=0;
		white[ 1317 ]<=0;
		white[ 1318 ]<=0;
		white[ 1319 ]<=0;
		white[ 1320 ]<=0;
		white[ 1321 ]<=0;
		white[ 1322 ]<=0;
		white[ 1323 ]<=0;
		white[ 1324 ]<=0;
		white[ 1325 ]<=0;
		white[ 1326 ]<=1;
		white[ 1327 ]<=1;
		white[ 1328 ]<=1;
		white[ 1329 ]<=1;
		white[ 1330 ]<=1;
		white[ 1331 ]<=0;
		white[ 1332 ]<=0;
		white[ 1333 ]<=0;
		white[ 1334 ]<=0;
		white[ 1335 ]<=0;
		white[ 1336 ]<=0;
		white[ 1337 ]<=0;
		white[ 1338 ]<=0;
		white[ 1339 ]<=0;
		white[ 1340 ]<=0;
		white[ 1341 ]<=0;
		white[ 1342 ]<=0;
		white[ 1343 ]<=0;
		white[ 1344 ]<=0;
		white[ 1345 ]<=0;
		white[ 1346 ]<=0;
		white[ 1347 ]<=0;
		white[ 1348 ]<=1;
		white[ 1349 ]<=1;
		white[ 1350 ]<=1;
		white[ 1351 ]<=1;
		white[ 1352 ]<=0;
		white[ 1353 ]<=0;
		white[ 1354 ]<=0;
		white[ 1355 ]<=0;
		white[ 1356 ]<=0;
		white[ 1357 ]<=0;
		white[ 1358 ]<=0;
		white[ 1359 ]<=0;
		white[ 1360 ]<=0;
		white[ 1361 ]<=0;
		white[ 1362 ]<=0;
		white[ 1363 ]<=0;
		white[ 1364 ]<=0;
		white[ 1365 ]<=0;
		white[ 1366 ]<=0;
		white[ 1367 ]<=0;
		white[ 1368 ]<=0;
		white[ 1369 ]<=1;
		white[ 1370 ]<=1;
		white[ 1371 ]<=1;
		white[ 1372 ]<=1;
		white[ 1373 ]<=1;
		white[ 1374 ]<=0;
		white[ 1375 ]<=0;
		white[ 1376 ]<=0;
		white[ 1377 ]<=0;
		white[ 1378 ]<=0;
		white[ 1379 ]<=0;
		white[ 1380 ]<=0;
		white[ 1381 ]<=0;
		white[ 1382 ]<=0;
		white[ 1383 ]<=0;
		white[ 1384 ]<=0;
		white[ 1385 ]<=1;
		white[ 1386 ]<=1;
		white[ 1387 ]<=1;
		white[ 1388 ]<=1;
		white[ 1389 ]<=1;
		white[ 1390 ]<=1;
		white[ 1391 ]<=0;
		white[ 1392 ]<=0;
		white[ 1393 ]<=0;
		white[ 1394 ]<=0;
		white[ 1395 ]<=0;
		white[ 1396 ]<=0;
		white[ 1397 ]<=0;
		white[ 1398 ]<=0;
		white[ 1399 ]<=0;
		white[ 1400 ]<=0;
		white[ 1401 ]<=0;
		white[ 1402 ]<=0;
		white[ 1403 ]<=0;
		white[ 1404 ]<=0;
		white[ 1405 ]<=0;
		white[ 1406 ]<=0;
		white[ 1407 ]<=0;
		white[ 1408 ]<=1;
		white[ 1409 ]<=1;
		white[ 1410 ]<=1;
		white[ 1411 ]<=1;
		white[ 1412 ]<=0;
		white[ 1413 ]<=0;
		white[ 1414 ]<=0;
		white[ 1415 ]<=0;
		white[ 1416 ]<=0;
		white[ 1417 ]<=0;
		white[ 1418 ]<=0;
		white[ 1419 ]<=0;
		white[ 1420 ]<=0;
		white[ 1421 ]<=0;
		white[ 1422 ]<=0;
		white[ 1423 ]<=0;
		white[ 1424 ]<=0;
		white[ 1425 ]<=0;
		white[ 1426 ]<=0;
		white[ 1427 ]<=0;
		white[ 1428 ]<=0;
		white[ 1429 ]<=1;
		white[ 1430 ]<=1;
		white[ 1431 ]<=1;
		white[ 1432 ]<=1;
		white[ 1433 ]<=1;
		white[ 1434 ]<=1;
		white[ 1435 ]<=0;
		white[ 1436 ]<=0;
		white[ 1437 ]<=0;
		white[ 1438 ]<=0;
		white[ 1439 ]<=0;
		white[ 1440 ]<=0;
		white[ 1441 ]<=0;
		white[ 1442 ]<=0;
		white[ 1443 ]<=0;
		white[ 1444 ]<=0;
		white[ 1445 ]<=1;
		white[ 1446 ]<=1;
		white[ 1447 ]<=1;
		white[ 1448 ]<=1;
		white[ 1449 ]<=1;
		white[ 1450 ]<=0;
		white[ 1451 ]<=0;
		white[ 1452 ]<=0;
		white[ 1453 ]<=0;
		white[ 1454 ]<=0;
		white[ 1455 ]<=0;
		white[ 1456 ]<=0;
		white[ 1457 ]<=0;
		white[ 1458 ]<=0;
		white[ 1459 ]<=0;
		white[ 1460 ]<=0;
		white[ 1461 ]<=0;
		white[ 1462 ]<=0;
		white[ 1463 ]<=0;
		white[ 1464 ]<=0;
		white[ 1465 ]<=0;
		white[ 1466 ]<=0;
		white[ 1467 ]<=0;
		white[ 1468 ]<=1;
		white[ 1469 ]<=1;
		white[ 1470 ]<=1;
		white[ 1471 ]<=1;
		white[ 1472 ]<=0;
		white[ 1473 ]<=0;
		white[ 1474 ]<=0;
		white[ 1475 ]<=0;
		white[ 1476 ]<=0;
		white[ 1477 ]<=0;
		white[ 1478 ]<=0;
		white[ 1479 ]<=0;
		white[ 1480 ]<=0;
		white[ 1481 ]<=0;
		white[ 1482 ]<=0;
		white[ 1483 ]<=0;
		white[ 1484 ]<=0;
		white[ 1485 ]<=0;
		white[ 1486 ]<=0;
		white[ 1487 ]<=0;
		white[ 1488 ]<=0;
		white[ 1489 ]<=0;
		white[ 1490 ]<=1;
		white[ 1491 ]<=1;
		white[ 1492 ]<=1;
		white[ 1493 ]<=1;
		white[ 1494 ]<=1;
		white[ 1495 ]<=0;
		white[ 1496 ]<=0;
		white[ 1497 ]<=0;
		white[ 1498 ]<=0;
		white[ 1499 ]<=0;
		white[ 1500 ]<=0;
		white[ 1501 ]<=0;
		white[ 1502 ]<=0;
		white[ 1503 ]<=0;
		white[ 1504 ]<=0;
		white[ 1505 ]<=1;
		white[ 1506 ]<=1;
		white[ 1507 ]<=1;
		white[ 1508 ]<=1;
		white[ 1509 ]<=1;
		white[ 1510 ]<=0;
		white[ 1511 ]<=0;
		white[ 1512 ]<=0;
		white[ 1513 ]<=0;
		white[ 1514 ]<=0;
		white[ 1515 ]<=0;
		white[ 1516 ]<=0;
		white[ 1517 ]<=0;
		white[ 1518 ]<=0;
		white[ 1519 ]<=0;
		white[ 1520 ]<=0;
		white[ 1521 ]<=0;
		white[ 1522 ]<=0;
		white[ 1523 ]<=0;
		white[ 1524 ]<=0;
		white[ 1525 ]<=0;
		white[ 1526 ]<=0;
		white[ 1527 ]<=0;
		white[ 1528 ]<=1;
		white[ 1529 ]<=1;
		white[ 1530 ]<=1;
		white[ 1531 ]<=1;
		white[ 1532 ]<=0;
		white[ 1533 ]<=0;
		white[ 1534 ]<=0;
		white[ 1535 ]<=0;
		white[ 1536 ]<=0;
		white[ 1537 ]<=0;
		white[ 1538 ]<=0;
		white[ 1539 ]<=0;
		white[ 1540 ]<=0;
		white[ 1541 ]<=0;
		white[ 1542 ]<=0;
		white[ 1543 ]<=0;
		white[ 1544 ]<=0;
		white[ 1545 ]<=0;
		white[ 1546 ]<=0;
		white[ 1547 ]<=0;
		white[ 1548 ]<=0;
		white[ 1549 ]<=0;
		white[ 1550 ]<=1;
		white[ 1551 ]<=1;
		white[ 1552 ]<=1;
		white[ 1553 ]<=1;
		white[ 1554 ]<=1;
		white[ 1555 ]<=0;
		white[ 1556 ]<=0;
		white[ 1557 ]<=0;
		white[ 1558 ]<=0;
		white[ 1559 ]<=0;
		white[ 1560 ]<=0;
		white[ 1561 ]<=0;
		white[ 1562 ]<=0;
		white[ 1563 ]<=0;
		white[ 1564 ]<=1;
		white[ 1565 ]<=1;
		white[ 1566 ]<=1;
		white[ 1567 ]<=1;
		white[ 1568 ]<=1;
		white[ 1569 ]<=0;
		white[ 1570 ]<=0;
		white[ 1571 ]<=0;
		white[ 1572 ]<=0;
		white[ 1573 ]<=0;
		white[ 1574 ]<=0;
		white[ 1575 ]<=0;
		white[ 1576 ]<=0;
		white[ 1577 ]<=0;
		white[ 1578 ]<=0;
		white[ 1579 ]<=0;
		white[ 1580 ]<=0;
		white[ 1581 ]<=0;
		white[ 1582 ]<=0;
		white[ 1583 ]<=0;
		white[ 1584 ]<=0;
		white[ 1585 ]<=0;
		white[ 1586 ]<=0;
		white[ 1587 ]<=0;
		white[ 1588 ]<=1;
		white[ 1589 ]<=1;
		white[ 1590 ]<=1;
		white[ 1591 ]<=1;
		white[ 1592 ]<=0;
		white[ 1593 ]<=0;
		white[ 1594 ]<=0;
		white[ 1595 ]<=0;
		white[ 1596 ]<=0;
		white[ 1597 ]<=0;
		white[ 1598 ]<=0;
		white[ 1599 ]<=0;
		white[ 1600 ]<=0;
		white[ 1601 ]<=0;
		white[ 1602 ]<=0;
		white[ 1603 ]<=0;
		white[ 1604 ]<=0;
		white[ 1605 ]<=0;
		white[ 1606 ]<=0;
		white[ 1607 ]<=0;
		white[ 1608 ]<=0;
		white[ 1609 ]<=0;
		white[ 1610 ]<=0;
		white[ 1611 ]<=1;
		white[ 1612 ]<=1;
		white[ 1613 ]<=1;
		white[ 1614 ]<=1;
		white[ 1615 ]<=1;
		white[ 1616 ]<=0;
		white[ 1617 ]<=0;
		white[ 1618 ]<=0;
		white[ 1619 ]<=0;
		white[ 1620 ]<=0;
		white[ 1621 ]<=0;
		white[ 1622 ]<=0;
		white[ 1623 ]<=0;
		white[ 1624 ]<=1;
		white[ 1625 ]<=1;
		white[ 1626 ]<=1;
		white[ 1627 ]<=1;
		white[ 1628 ]<=1;
		white[ 1629 ]<=0;
		white[ 1630 ]<=0;
		white[ 1631 ]<=0;
		white[ 1632 ]<=0;
		white[ 1633 ]<=0;
		white[ 1634 ]<=0;
		white[ 1635 ]<=0;
		white[ 1636 ]<=0;
		white[ 1637 ]<=0;
		white[ 1638 ]<=0;
		white[ 1639 ]<=0;
		white[ 1640 ]<=0;
		white[ 1641 ]<=0;
		white[ 1642 ]<=0;
		white[ 1643 ]<=0;
		white[ 1644 ]<=0;
		white[ 1645 ]<=0;
		white[ 1646 ]<=0;
		white[ 1647 ]<=0;
		white[ 1648 ]<=1;
		white[ 1649 ]<=1;
		white[ 1650 ]<=1;
		white[ 1651 ]<=1;
		white[ 1652 ]<=0;
		white[ 1653 ]<=0;
		white[ 1654 ]<=0;
		white[ 1655 ]<=0;
		white[ 1656 ]<=0;
		white[ 1657 ]<=0;
		white[ 1658 ]<=0;
		white[ 1659 ]<=0;
		white[ 1660 ]<=0;
		white[ 1661 ]<=0;
		white[ 1662 ]<=0;
		white[ 1663 ]<=0;
		white[ 1664 ]<=0;
		white[ 1665 ]<=0;
		white[ 1666 ]<=0;
		white[ 1667 ]<=0;
		white[ 1668 ]<=0;
		white[ 1669 ]<=0;
		white[ 1670 ]<=0;
		white[ 1671 ]<=1;
		white[ 1672 ]<=1;
		white[ 1673 ]<=1;
		white[ 1674 ]<=1;
		white[ 1675 ]<=1;
		white[ 1676 ]<=0;
		white[ 1677 ]<=0;
		white[ 1678 ]<=0;
		white[ 1679 ]<=0;
		white[ 1680 ]<=0;
		white[ 1681 ]<=0;
		white[ 1682 ]<=0;
		white[ 1683 ]<=0;
		white[ 1684 ]<=1;
		white[ 1685 ]<=1;
		white[ 1686 ]<=1;
		white[ 1687 ]<=1;
		white[ 1688 ]<=1;
		white[ 1689 ]<=0;
		white[ 1690 ]<=0;
		white[ 1691 ]<=0;
		white[ 1692 ]<=0;
		white[ 1693 ]<=0;
		white[ 1694 ]<=0;
		white[ 1695 ]<=0;
		white[ 1696 ]<=0;
		white[ 1697 ]<=0;
		white[ 1698 ]<=0;
		white[ 1699 ]<=0;
		white[ 1700 ]<=0;
		white[ 1701 ]<=0;
		white[ 1702 ]<=0;
		white[ 1703 ]<=0;
		white[ 1704 ]<=0;
		white[ 1705 ]<=0;
		white[ 1706 ]<=0;
		white[ 1707 ]<=0;
		white[ 1708 ]<=1;
		white[ 1709 ]<=1;
		white[ 1710 ]<=1;
		white[ 1711 ]<=1;
		white[ 1712 ]<=0;
		white[ 1713 ]<=0;
		white[ 1714 ]<=0;
		white[ 1715 ]<=0;
		white[ 1716 ]<=0;
		white[ 1717 ]<=0;
		white[ 1718 ]<=0;
		white[ 1719 ]<=0;
		white[ 1720 ]<=0;
		white[ 1721 ]<=0;
		white[ 1722 ]<=0;
		white[ 1723 ]<=0;
		white[ 1724 ]<=0;
		white[ 1725 ]<=0;
		white[ 1726 ]<=0;
		white[ 1727 ]<=0;
		white[ 1728 ]<=0;
		white[ 1729 ]<=0;
		white[ 1730 ]<=0;
		white[ 1731 ]<=1;
		white[ 1732 ]<=1;
		white[ 1733 ]<=1;
		white[ 1734 ]<=1;
		white[ 1735 ]<=1;
		white[ 1736 ]<=0;
		white[ 1737 ]<=0;
		white[ 1738 ]<=0;
		white[ 1739 ]<=0;
		white[ 1740 ]<=0;
		white[ 1741 ]<=0;
		white[ 1742 ]<=0;
		white[ 1743 ]<=0;
		white[ 1744 ]<=1;
		white[ 1745 ]<=1;
		white[ 1746 ]<=1;
		white[ 1747 ]<=1;
		white[ 1748 ]<=0;
		white[ 1749 ]<=0;
		white[ 1750 ]<=0;
		white[ 1751 ]<=0;
		white[ 1752 ]<=0;
		white[ 1753 ]<=0;
		white[ 1754 ]<=0;
		white[ 1755 ]<=0;
		white[ 1756 ]<=0;
		white[ 1757 ]<=0;
		white[ 1758 ]<=0;
		white[ 1759 ]<=0;
		white[ 1760 ]<=0;
		white[ 1761 ]<=0;
		white[ 1762 ]<=0;
		white[ 1763 ]<=0;
		white[ 1764 ]<=0;
		white[ 1765 ]<=0;
		white[ 1766 ]<=0;
		white[ 1767 ]<=0;
		white[ 1768 ]<=1;
		white[ 1769 ]<=1;
		white[ 1770 ]<=1;
		white[ 1771 ]<=1;
		white[ 1772 ]<=0;
		white[ 1773 ]<=0;
		white[ 1774 ]<=0;
		white[ 1775 ]<=0;
		white[ 1776 ]<=0;
		white[ 1777 ]<=0;
		white[ 1778 ]<=0;
		white[ 1779 ]<=0;
		white[ 1780 ]<=0;
		white[ 1781 ]<=0;
		white[ 1782 ]<=0;
		white[ 1783 ]<=0;
		white[ 1784 ]<=0;
		white[ 1785 ]<=0;
		white[ 1786 ]<=0;
		white[ 1787 ]<=0;
		white[ 1788 ]<=0;
		white[ 1789 ]<=0;
		white[ 1790 ]<=0;
		white[ 1791 ]<=0;
		white[ 1792 ]<=1;
		white[ 1793 ]<=1;
		white[ 1794 ]<=1;
		white[ 1795 ]<=1;
		white[ 1796 ]<=0;
		white[ 1797 ]<=0;
		white[ 1798 ]<=0;
		white[ 1799 ]<=0;
		white[ 1800 ]<=0;
		white[ 1801 ]<=0;
		white[ 1802 ]<=0;
		white[ 1803 ]<=0;
		white[ 1804 ]<=1;
		white[ 1805 ]<=1;
		white[ 1806 ]<=1;
		white[ 1807 ]<=1;
		white[ 1808 ]<=0;
		white[ 1809 ]<=0;
		white[ 1810 ]<=0;
		white[ 1811 ]<=0;
		white[ 1812 ]<=0;
		white[ 1813 ]<=0;
		white[ 1814 ]<=0;
		white[ 1815 ]<=0;
		white[ 1816 ]<=0;
		white[ 1817 ]<=0;
		white[ 1818 ]<=0;
		white[ 1819 ]<=0;
		white[ 1820 ]<=0;
		white[ 1821 ]<=0;
		white[ 1822 ]<=0;
		white[ 1823 ]<=0;
		white[ 1824 ]<=0;
		white[ 1825 ]<=0;
		white[ 1826 ]<=0;
		white[ 1827 ]<=0;
		white[ 1828 ]<=1;
		white[ 1829 ]<=1;
		white[ 1830 ]<=1;
		white[ 1831 ]<=1;
		white[ 1832 ]<=0;
		white[ 1833 ]<=0;
		white[ 1834 ]<=0;
		white[ 1835 ]<=0;
		white[ 1836 ]<=0;
		white[ 1837 ]<=0;
		white[ 1838 ]<=0;
		white[ 1839 ]<=0;
		white[ 1840 ]<=0;
		white[ 1841 ]<=0;
		white[ 1842 ]<=0;
		white[ 1843 ]<=0;
		white[ 1844 ]<=0;
		white[ 1845 ]<=0;
		white[ 1846 ]<=0;
		white[ 1847 ]<=0;
		white[ 1848 ]<=0;
		white[ 1849 ]<=0;
		white[ 1850 ]<=0;
		white[ 1851 ]<=0;
		white[ 1852 ]<=1;
		white[ 1853 ]<=1;
		white[ 1854 ]<=1;
		white[ 1855 ]<=1;
		white[ 1856 ]<=0;
		white[ 1857 ]<=0;
		white[ 1858 ]<=0;
		white[ 1859 ]<=0;
		white[ 1860 ]<=0;
		white[ 1861 ]<=0;
		white[ 1862 ]<=0;
		white[ 1863 ]<=0;
		white[ 1864 ]<=1;
		white[ 1865 ]<=1;
		white[ 1866 ]<=1;
		white[ 1867 ]<=1;
		white[ 1868 ]<=0;
		white[ 1869 ]<=0;
		white[ 1870 ]<=0;
		white[ 1871 ]<=0;
		white[ 1872 ]<=1;
		white[ 1873 ]<=1;
		white[ 1874 ]<=1;
		white[ 1875 ]<=1;
		white[ 1876 ]<=1;
		white[ 1877 ]<=1;
		white[ 1878 ]<=1;
		white[ 1879 ]<=1;
		white[ 1880 ]<=1;
		white[ 1881 ]<=1;
		white[ 1882 ]<=1;
		white[ 1883 ]<=1;
		white[ 1884 ]<=1;
		white[ 1885 ]<=1;
		white[ 1886 ]<=1;
		white[ 1887 ]<=1;
		white[ 1888 ]<=1;
		white[ 1889 ]<=1;
		white[ 1890 ]<=1;
		white[ 1891 ]<=1;
		white[ 1892 ]<=0;
		white[ 1893 ]<=0;
		white[ 1894 ]<=0;
		white[ 1895 ]<=0;
		white[ 1896 ]<=0;
		white[ 1897 ]<=0;
		white[ 1898 ]<=0;
		white[ 1899 ]<=0;
		white[ 1900 ]<=0;
		white[ 1901 ]<=0;
		white[ 1902 ]<=0;
		white[ 1903 ]<=0;
		white[ 1904 ]<=0;
		white[ 1905 ]<=0;
		white[ 1906 ]<=0;
		white[ 1907 ]<=0;
		white[ 1908 ]<=0;
		white[ 1909 ]<=0;
		white[ 1910 ]<=0;
		white[ 1911 ]<=0;
		white[ 1912 ]<=1;
		white[ 1913 ]<=1;
		white[ 1914 ]<=1;
		white[ 1915 ]<=1;
		white[ 1916 ]<=0;
		white[ 1917 ]<=0;
		white[ 1918 ]<=0;
		white[ 1919 ]<=0;
		white[ 1920 ]<=0;
		white[ 1921 ]<=0;
		white[ 1922 ]<=0;
		white[ 1923 ]<=0;
		white[ 1924 ]<=1;
		white[ 1925 ]<=1;
		white[ 1926 ]<=1;
		white[ 1927 ]<=1;
		white[ 1928 ]<=0;
		white[ 1929 ]<=0;
		white[ 1930 ]<=0;
		white[ 1931 ]<=1;
		white[ 1932 ]<=1;
		white[ 1933 ]<=1;
		white[ 1934 ]<=1;
		white[ 1935 ]<=1;
		white[ 1936 ]<=1;
		white[ 1937 ]<=1;
		white[ 1938 ]<=1;
		white[ 1939 ]<=1;
		white[ 1940 ]<=1;
		white[ 1941 ]<=1;
		white[ 1942 ]<=1;
		white[ 1943 ]<=1;
		white[ 1944 ]<=1;
		white[ 1945 ]<=1;
		white[ 1946 ]<=1;
		white[ 1947 ]<=1;
		white[ 1948 ]<=1;
		white[ 1949 ]<=1;
		white[ 1950 ]<=1;
		white[ 1951 ]<=1;
		white[ 1952 ]<=0;
		white[ 1953 ]<=0;
		white[ 1954 ]<=0;
		white[ 1955 ]<=0;
		white[ 1956 ]<=0;
		white[ 1957 ]<=0;
		white[ 1958 ]<=0;
		white[ 1959 ]<=0;
		white[ 1960 ]<=0;
		white[ 1961 ]<=0;
		white[ 1962 ]<=0;
		white[ 1963 ]<=0;
		white[ 1964 ]<=0;
		white[ 1965 ]<=0;
		white[ 1966 ]<=0;
		white[ 1967 ]<=0;
		white[ 1968 ]<=0;
		white[ 1969 ]<=0;
		white[ 1970 ]<=0;
		white[ 1971 ]<=0;
		white[ 1972 ]<=1;
		white[ 1973 ]<=1;
		white[ 1974 ]<=1;
		white[ 1975 ]<=1;
		white[ 1976 ]<=0;
		white[ 1977 ]<=0;
		white[ 1978 ]<=0;
		white[ 1979 ]<=0;
		white[ 1980 ]<=0;
		white[ 1981 ]<=0;
		white[ 1982 ]<=0;
		white[ 1983 ]<=0;
		white[ 1984 ]<=1;
		white[ 1985 ]<=1;
		white[ 1986 ]<=1;
		white[ 1987 ]<=1;
		white[ 1988 ]<=0;
		white[ 1989 ]<=0;
		white[ 1990 ]<=0;
		white[ 1991 ]<=1;
		white[ 1992 ]<=1;
		white[ 1993 ]<=1;
		white[ 1994 ]<=1;
		white[ 1995 ]<=1;
		white[ 1996 ]<=1;
		white[ 1997 ]<=1;
		white[ 1998 ]<=1;
		white[ 1999 ]<=1;
		white[ 2000 ]<=1;
		white[ 2001 ]<=1;
		white[ 2002 ]<=1;
		white[ 2003 ]<=1;
		white[ 2004 ]<=1;
		white[ 2005 ]<=1;
		white[ 2006 ]<=1;
		white[ 2007 ]<=1;
		white[ 2008 ]<=1;
		white[ 2009 ]<=1;
		white[ 2010 ]<=1;
		white[ 2011 ]<=1;
		white[ 2012 ]<=0;
		white[ 2013 ]<=0;
		white[ 2014 ]<=0;
		white[ 2015 ]<=0;
		white[ 2016 ]<=0;
		white[ 2017 ]<=0;
		white[ 2018 ]<=0;
		white[ 2019 ]<=0;
		white[ 2020 ]<=0;
		white[ 2021 ]<=0;
		white[ 2022 ]<=0;
		white[ 2023 ]<=0;
		white[ 2024 ]<=0;
		white[ 2025 ]<=0;
		white[ 2026 ]<=0;
		white[ 2027 ]<=0;
		white[ 2028 ]<=0;
		white[ 2029 ]<=0;
		white[ 2030 ]<=0;
		white[ 2031 ]<=0;
		white[ 2032 ]<=1;
		white[ 2033 ]<=1;
		white[ 2034 ]<=1;
		white[ 2035 ]<=1;
		white[ 2036 ]<=0;
		white[ 2037 ]<=0;
		white[ 2038 ]<=0;
		white[ 2039 ]<=0;
		white[ 2040 ]<=0;
		white[ 2041 ]<=0;
		white[ 2042 ]<=0;
		white[ 2043 ]<=0;
		white[ 2044 ]<=1;
		white[ 2045 ]<=1;
		white[ 2046 ]<=1;
		white[ 2047 ]<=1;
		white[ 2048 ]<=0;
		white[ 2049 ]<=0;
		white[ 2050 ]<=0;
		white[ 2051 ]<=1;
		white[ 2052 ]<=1;
		white[ 2053 ]<=1;
		white[ 2054 ]<=1;
		white[ 2055 ]<=1;
		white[ 2056 ]<=1;
		white[ 2057 ]<=1;
		white[ 2058 ]<=1;
		white[ 2059 ]<=1;
		white[ 2060 ]<=1;
		white[ 2061 ]<=1;
		white[ 2062 ]<=1;
		white[ 2063 ]<=1;
		white[ 2064 ]<=1;
		white[ 2065 ]<=1;
		white[ 2066 ]<=1;
		white[ 2067 ]<=1;
		white[ 2068 ]<=1;
		white[ 2069 ]<=1;
		white[ 2070 ]<=1;
		white[ 2071 ]<=1;
		white[ 2072 ]<=0;
		white[ 2073 ]<=0;
		white[ 2074 ]<=0;
		white[ 2075 ]<=0;
		white[ 2076 ]<=0;
		white[ 2077 ]<=0;
		white[ 2078 ]<=0;
		white[ 2079 ]<=0;
		white[ 2080 ]<=0;
		white[ 2081 ]<=0;
		white[ 2082 ]<=0;
		white[ 2083 ]<=0;
		white[ 2084 ]<=0;
		white[ 2085 ]<=0;
		white[ 2086 ]<=0;
		white[ 2087 ]<=0;
		white[ 2088 ]<=0;
		white[ 2089 ]<=0;
		white[ 2090 ]<=0;
		white[ 2091 ]<=0;
		white[ 2092 ]<=1;
		white[ 2093 ]<=1;
		white[ 2094 ]<=1;
		white[ 2095 ]<=1;
		white[ 2096 ]<=0;
		white[ 2097 ]<=0;
		white[ 2098 ]<=0;
		white[ 2099 ]<=0;
		white[ 2100 ]<=0;
		white[ 2101 ]<=0;
		white[ 2102 ]<=0;
		white[ 2103 ]<=0;
		white[ 2104 ]<=1;
		white[ 2105 ]<=1;
		white[ 2106 ]<=1;
		white[ 2107 ]<=1;
		white[ 2108 ]<=0;
		white[ 2109 ]<=0;
		white[ 2110 ]<=0;
		white[ 2111 ]<=0;
		white[ 2112 ]<=1;
		white[ 2113 ]<=1;
		white[ 2114 ]<=1;
		white[ 2115 ]<=1;
		white[ 2116 ]<=1;
		white[ 2117 ]<=1;
		white[ 2118 ]<=1;
		white[ 2119 ]<=1;
		white[ 2120 ]<=1;
		white[ 2121 ]<=1;
		white[ 2122 ]<=1;
		white[ 2123 ]<=1;
		white[ 2124 ]<=1;
		white[ 2125 ]<=1;
		white[ 2126 ]<=1;
		white[ 2127 ]<=1;
		white[ 2128 ]<=1;
		white[ 2129 ]<=1;
		white[ 2130 ]<=1;
		white[ 2131 ]<=0;
		white[ 2132 ]<=0;
		white[ 2133 ]<=0;
		white[ 2134 ]<=0;
		white[ 2135 ]<=0;
		white[ 2136 ]<=0;
		white[ 2137 ]<=0;
		white[ 2138 ]<=0;
		white[ 2139 ]<=0;
		white[ 2140 ]<=0;
		white[ 2141 ]<=0;
		white[ 2142 ]<=0;
		white[ 2143 ]<=0;
		white[ 2144 ]<=0;
		white[ 2145 ]<=0;
		white[ 2146 ]<=0;
		white[ 2147 ]<=0;
		white[ 2148 ]<=0;
		white[ 2149 ]<=0;
		white[ 2150 ]<=0;
		white[ 2151 ]<=0;
		white[ 2152 ]<=1;
		white[ 2153 ]<=1;
		white[ 2154 ]<=1;
		white[ 2155 ]<=1;
		white[ 2156 ]<=0;
		white[ 2157 ]<=0;
		white[ 2158 ]<=0;
		white[ 2159 ]<=0;
		white[ 2160 ]<=0;
		white[ 2161 ]<=0;
		white[ 2162 ]<=0;
		white[ 2163 ]<=0;
		white[ 2164 ]<=1;
		white[ 2165 ]<=1;
		white[ 2166 ]<=1;
		white[ 2167 ]<=1;
		white[ 2168 ]<=0;
		white[ 2169 ]<=0;
		white[ 2170 ]<=0;
		white[ 2171 ]<=0;
		white[ 2172 ]<=0;
		white[ 2173 ]<=0;
		white[ 2174 ]<=0;
		white[ 2175 ]<=0;
		white[ 2176 ]<=0;
		white[ 2177 ]<=0;
		white[ 2178 ]<=0;
		white[ 2179 ]<=0;
		white[ 2180 ]<=0;
		white[ 2181 ]<=0;
		white[ 2182 ]<=0;
		white[ 2183 ]<=0;
		white[ 2184 ]<=0;
		white[ 2185 ]<=0;
		white[ 2186 ]<=0;
		white[ 2187 ]<=0;
		white[ 2188 ]<=0;
		white[ 2189 ]<=0;
		white[ 2190 ]<=0;
		white[ 2191 ]<=0;
		white[ 2192 ]<=0;
		white[ 2193 ]<=0;
		white[ 2194 ]<=0;
		white[ 2195 ]<=0;
		white[ 2196 ]<=0;
		white[ 2197 ]<=0;
		white[ 2198 ]<=0;
		white[ 2199 ]<=0;
		white[ 2200 ]<=0;
		white[ 2201 ]<=0;
		white[ 2202 ]<=0;
		white[ 2203 ]<=0;
		white[ 2204 ]<=0;
		white[ 2205 ]<=0;
		white[ 2206 ]<=0;
		white[ 2207 ]<=0;
		white[ 2208 ]<=0;
		white[ 2209 ]<=0;
		white[ 2210 ]<=0;
		white[ 2211 ]<=0;
		white[ 2212 ]<=1;
		white[ 2213 ]<=1;
		white[ 2214 ]<=1;
		white[ 2215 ]<=1;
		white[ 2216 ]<=0;
		white[ 2217 ]<=0;
		white[ 2218 ]<=0;
		white[ 2219 ]<=0;
		white[ 2220 ]<=0;
		white[ 2221 ]<=0;
		white[ 2222 ]<=0;
		white[ 2223 ]<=0;
		white[ 2224 ]<=1;
		white[ 2225 ]<=1;
		white[ 2226 ]<=1;
		white[ 2227 ]<=1;
		white[ 2228 ]<=0;
		white[ 2229 ]<=0;
		white[ 2230 ]<=0;
		white[ 2231 ]<=0;
		white[ 2232 ]<=0;
		white[ 2233 ]<=0;
		white[ 2234 ]<=0;
		white[ 2235 ]<=0;
		white[ 2236 ]<=0;
		white[ 2237 ]<=0;
		white[ 2238 ]<=0;
		white[ 2239 ]<=0;
		white[ 2240 ]<=0;
		white[ 2241 ]<=0;
		white[ 2242 ]<=0;
		white[ 2243 ]<=0;
		white[ 2244 ]<=0;
		white[ 2245 ]<=0;
		white[ 2246 ]<=0;
		white[ 2247 ]<=0;
		white[ 2248 ]<=0;
		white[ 2249 ]<=0;
		white[ 2250 ]<=0;
		white[ 2251 ]<=0;
		white[ 2252 ]<=0;
		white[ 2253 ]<=0;
		white[ 2254 ]<=0;
		white[ 2255 ]<=0;
		white[ 2256 ]<=0;
		white[ 2257 ]<=0;
		white[ 2258 ]<=0;
		white[ 2259 ]<=0;
		white[ 2260 ]<=0;
		white[ 2261 ]<=0;
		white[ 2262 ]<=0;
		white[ 2263 ]<=0;
		white[ 2264 ]<=0;
		white[ 2265 ]<=0;
		white[ 2266 ]<=0;
		white[ 2267 ]<=0;
		white[ 2268 ]<=0;
		white[ 2269 ]<=0;
		white[ 2270 ]<=0;
		white[ 2271 ]<=0;
		white[ 2272 ]<=1;
		white[ 2273 ]<=1;
		white[ 2274 ]<=1;
		white[ 2275 ]<=1;
		white[ 2276 ]<=0;
		white[ 2277 ]<=0;
		white[ 2278 ]<=0;
		white[ 2279 ]<=0;
		white[ 2280 ]<=0;
		white[ 2281 ]<=0;
		white[ 2282 ]<=0;
		white[ 2283 ]<=0;
		white[ 2284 ]<=1;
		white[ 2285 ]<=1;
		white[ 2286 ]<=1;
		white[ 2287 ]<=1;
		white[ 2288 ]<=1;
		white[ 2289 ]<=0;
		white[ 2290 ]<=0;
		white[ 2291 ]<=0;
		white[ 2292 ]<=0;
		white[ 2293 ]<=0;
		white[ 2294 ]<=0;
		white[ 2295 ]<=0;
		white[ 2296 ]<=0;
		white[ 2297 ]<=0;
		white[ 2298 ]<=0;
		white[ 2299 ]<=0;
		white[ 2300 ]<=0;
		white[ 2301 ]<=0;
		white[ 2302 ]<=0;
		white[ 2303 ]<=0;
		white[ 2304 ]<=0;
		white[ 2305 ]<=0;
		white[ 2306 ]<=0;
		white[ 2307 ]<=0;
		white[ 2308 ]<=0;
		white[ 2309 ]<=0;
		white[ 2310 ]<=0;
		white[ 2311 ]<=0;
		white[ 2312 ]<=0;
		white[ 2313 ]<=0;
		white[ 2314 ]<=0;
		white[ 2315 ]<=0;
		white[ 2316 ]<=0;
		white[ 2317 ]<=0;
		white[ 2318 ]<=0;
		white[ 2319 ]<=0;
		white[ 2320 ]<=0;
		white[ 2321 ]<=0;
		white[ 2322 ]<=0;
		white[ 2323 ]<=0;
		white[ 2324 ]<=0;
		white[ 2325 ]<=0;
		white[ 2326 ]<=0;
		white[ 2327 ]<=0;
		white[ 2328 ]<=0;
		white[ 2329 ]<=0;
		white[ 2330 ]<=0;
		white[ 2331 ]<=1;
		white[ 2332 ]<=1;
		white[ 2333 ]<=1;
		white[ 2334 ]<=1;
		white[ 2335 ]<=1;
		white[ 2336 ]<=0;
		white[ 2337 ]<=0;
		white[ 2338 ]<=0;
		white[ 2339 ]<=0;
		white[ 2340 ]<=0;
		white[ 2341 ]<=0;
		white[ 2342 ]<=0;
		white[ 2343 ]<=0;
		white[ 2344 ]<=1;
		white[ 2345 ]<=1;
		white[ 2346 ]<=1;
		white[ 2347 ]<=1;
		white[ 2348 ]<=1;
		white[ 2349 ]<=0;
		white[ 2350 ]<=0;
		white[ 2351 ]<=0;
		white[ 2352 ]<=0;
		white[ 2353 ]<=0;
		white[ 2354 ]<=0;
		white[ 2355 ]<=0;
		white[ 2356 ]<=0;
		white[ 2357 ]<=0;
		white[ 2358 ]<=0;
		white[ 2359 ]<=0;
		white[ 2360 ]<=0;
		white[ 2361 ]<=0;
		white[ 2362 ]<=0;
		white[ 2363 ]<=0;
		white[ 2364 ]<=0;
		white[ 2365 ]<=0;
		white[ 2366 ]<=0;
		white[ 2367 ]<=0;
		white[ 2368 ]<=0;
		white[ 2369 ]<=0;
		white[ 2370 ]<=0;
		white[ 2371 ]<=0;
		white[ 2372 ]<=0;
		white[ 2373 ]<=0;
		white[ 2374 ]<=0;
		white[ 2375 ]<=0;
		white[ 2376 ]<=0;
		white[ 2377 ]<=0;
		white[ 2378 ]<=0;
		white[ 2379 ]<=0;
		white[ 2380 ]<=0;
		white[ 2381 ]<=0;
		white[ 2382 ]<=0;
		white[ 2383 ]<=0;
		white[ 2384 ]<=0;
		white[ 2385 ]<=0;
		white[ 2386 ]<=0;
		white[ 2387 ]<=0;
		white[ 2388 ]<=0;
		white[ 2389 ]<=0;
		white[ 2390 ]<=0;
		white[ 2391 ]<=1;
		white[ 2392 ]<=1;
		white[ 2393 ]<=1;
		white[ 2394 ]<=1;
		white[ 2395 ]<=1;
		white[ 2396 ]<=0;
		white[ 2397 ]<=0;
		white[ 2398 ]<=0;
		white[ 2399 ]<=0;
		white[ 2400 ]<=0;
		white[ 2401 ]<=0;
		white[ 2402 ]<=0;
		white[ 2403 ]<=0;
		white[ 2404 ]<=1;
		white[ 2405 ]<=1;
		white[ 2406 ]<=1;
		white[ 2407 ]<=1;
		white[ 2408 ]<=1;
		white[ 2409 ]<=0;
		white[ 2410 ]<=0;
		white[ 2411 ]<=0;
		white[ 2412 ]<=0;
		white[ 2413 ]<=0;
		white[ 2414 ]<=0;
		white[ 2415 ]<=0;
		white[ 2416 ]<=0;
		white[ 2417 ]<=0;
		white[ 2418 ]<=0;
		white[ 2419 ]<=0;
		white[ 2420 ]<=0;
		white[ 2421 ]<=0;
		white[ 2422 ]<=0;
		white[ 2423 ]<=0;
		white[ 2424 ]<=0;
		white[ 2425 ]<=0;
		white[ 2426 ]<=0;
		white[ 2427 ]<=0;
		white[ 2428 ]<=0;
		white[ 2429 ]<=0;
		white[ 2430 ]<=0;
		white[ 2431 ]<=0;
		white[ 2432 ]<=0;
		white[ 2433 ]<=0;
		white[ 2434 ]<=0;
		white[ 2435 ]<=0;
		white[ 2436 ]<=0;
		white[ 2437 ]<=0;
		white[ 2438 ]<=0;
		white[ 2439 ]<=0;
		white[ 2440 ]<=0;
		white[ 2441 ]<=0;
		white[ 2442 ]<=0;
		white[ 2443 ]<=0;
		white[ 2444 ]<=0;
		white[ 2445 ]<=0;
		white[ 2446 ]<=0;
		white[ 2447 ]<=0;
		white[ 2448 ]<=0;
		white[ 2449 ]<=0;
		white[ 2450 ]<=0;
		white[ 2451 ]<=1;
		white[ 2452 ]<=1;
		white[ 2453 ]<=1;
		white[ 2454 ]<=1;
		white[ 2455 ]<=1;
		white[ 2456 ]<=0;
		white[ 2457 ]<=0;
		white[ 2458 ]<=0;
		white[ 2459 ]<=0;
		white[ 2460 ]<=0;
		white[ 2461 ]<=0;
		white[ 2462 ]<=0;
		white[ 2463 ]<=0;
		white[ 2464 ]<=1;
		white[ 2465 ]<=1;
		white[ 2466 ]<=1;
		white[ 2467 ]<=1;
		white[ 2468 ]<=1;
		white[ 2469 ]<=1;
		white[ 2470 ]<=0;
		white[ 2471 ]<=0;
		white[ 2472 ]<=0;
		white[ 2473 ]<=0;
		white[ 2474 ]<=0;
		white[ 2475 ]<=0;
		white[ 2476 ]<=0;
		white[ 2477 ]<=0;
		white[ 2478 ]<=0;
		white[ 2479 ]<=0;
		white[ 2480 ]<=0;
		white[ 2481 ]<=0;
		white[ 2482 ]<=0;
		white[ 2483 ]<=0;
		white[ 2484 ]<=0;
		white[ 2485 ]<=0;
		white[ 2486 ]<=0;
		white[ 2487 ]<=0;
		white[ 2488 ]<=0;
		white[ 2489 ]<=0;
		white[ 2490 ]<=0;
		white[ 2491 ]<=0;
		white[ 2492 ]<=0;
		white[ 2493 ]<=0;
		white[ 2494 ]<=0;
		white[ 2495 ]<=0;
		white[ 2496 ]<=0;
		white[ 2497 ]<=0;
		white[ 2498 ]<=0;
		white[ 2499 ]<=0;
		white[ 2500 ]<=0;
		white[ 2501 ]<=0;
		white[ 2502 ]<=0;
		white[ 2503 ]<=0;
		white[ 2504 ]<=0;
		white[ 2505 ]<=0;
		white[ 2506 ]<=0;
		white[ 2507 ]<=0;
		white[ 2508 ]<=0;
		white[ 2509 ]<=0;
		white[ 2510 ]<=1;
		white[ 2511 ]<=1;
		white[ 2512 ]<=1;
		white[ 2513 ]<=1;
		white[ 2514 ]<=1;
		white[ 2515 ]<=1;
		white[ 2516 ]<=0;
		white[ 2517 ]<=0;
		white[ 2518 ]<=0;
		white[ 2519 ]<=0;
		white[ 2520 ]<=0;
		white[ 2521 ]<=0;
		white[ 2522 ]<=0;
		white[ 2523 ]<=0;
		white[ 2524 ]<=0;
		white[ 2525 ]<=1;
		white[ 2526 ]<=1;
		white[ 2527 ]<=1;
		white[ 2528 ]<=1;
		white[ 2529 ]<=1;
		white[ 2530 ]<=0;
		white[ 2531 ]<=0;
		white[ 2532 ]<=0;
		white[ 2533 ]<=0;
		white[ 2534 ]<=0;
		white[ 2535 ]<=0;
		white[ 2536 ]<=0;
		white[ 2537 ]<=0;
		white[ 2538 ]<=0;
		white[ 2539 ]<=0;
		white[ 2540 ]<=0;
		white[ 2541 ]<=0;
		white[ 2542 ]<=0;
		white[ 2543 ]<=0;
		white[ 2544 ]<=0;
		white[ 2545 ]<=0;
		white[ 2546 ]<=0;
		white[ 2547 ]<=0;
		white[ 2548 ]<=0;
		white[ 2549 ]<=0;
		white[ 2550 ]<=0;
		white[ 2551 ]<=0;
		white[ 2552 ]<=0;
		white[ 2553 ]<=0;
		white[ 2554 ]<=0;
		white[ 2555 ]<=0;
		white[ 2556 ]<=0;
		white[ 2557 ]<=0;
		white[ 2558 ]<=0;
		white[ 2559 ]<=0;
		white[ 2560 ]<=0;
		white[ 2561 ]<=0;
		white[ 2562 ]<=0;
		white[ 2563 ]<=0;
		white[ 2564 ]<=0;
		white[ 2565 ]<=0;
		white[ 2566 ]<=0;
		white[ 2567 ]<=0;
		white[ 2568 ]<=0;
		white[ 2569 ]<=0;
		white[ 2570 ]<=1;
		white[ 2571 ]<=1;
		white[ 2572 ]<=1;
		white[ 2573 ]<=1;
		white[ 2574 ]<=1;
		white[ 2575 ]<=0;
		white[ 2576 ]<=0;
		white[ 2577 ]<=0;
		white[ 2578 ]<=0;
		white[ 2579 ]<=0;
		white[ 2580 ]<=0;
		white[ 2581 ]<=0;
		white[ 2582 ]<=0;
		white[ 2583 ]<=0;
		white[ 2584 ]<=0;
		white[ 2585 ]<=1;
		white[ 2586 ]<=1;
		white[ 2587 ]<=1;
		white[ 2588 ]<=1;
		white[ 2589 ]<=1;
		white[ 2590 ]<=1;
		white[ 2591 ]<=0;
		white[ 2592 ]<=0;
		white[ 2593 ]<=0;
		white[ 2594 ]<=0;
		white[ 2595 ]<=0;
		white[ 2596 ]<=0;
		white[ 2597 ]<=0;
		white[ 2598 ]<=0;
		white[ 2599 ]<=0;
		white[ 2600 ]<=0;
		white[ 2601 ]<=0;
		white[ 2602 ]<=0;
		white[ 2603 ]<=0;
		white[ 2604 ]<=0;
		white[ 2605 ]<=0;
		white[ 2606 ]<=0;
		white[ 2607 ]<=0;
		white[ 2608 ]<=0;
		white[ 2609 ]<=0;
		white[ 2610 ]<=0;
		white[ 2611 ]<=0;
		white[ 2612 ]<=0;
		white[ 2613 ]<=0;
		white[ 2614 ]<=0;
		white[ 2615 ]<=0;
		white[ 2616 ]<=0;
		white[ 2617 ]<=0;
		white[ 2618 ]<=0;
		white[ 2619 ]<=0;
		white[ 2620 ]<=0;
		white[ 2621 ]<=0;
		white[ 2622 ]<=0;
		white[ 2623 ]<=0;
		white[ 2624 ]<=0;
		white[ 2625 ]<=0;
		white[ 2626 ]<=0;
		white[ 2627 ]<=0;
		white[ 2628 ]<=0;
		white[ 2629 ]<=1;
		white[ 2630 ]<=1;
		white[ 2631 ]<=1;
		white[ 2632 ]<=1;
		white[ 2633 ]<=1;
		white[ 2634 ]<=1;
		white[ 2635 ]<=0;
		white[ 2636 ]<=0;
		white[ 2637 ]<=0;
		white[ 2638 ]<=0;
		white[ 2639 ]<=0;
		white[ 2640 ]<=0;
		white[ 2641 ]<=0;
		white[ 2642 ]<=0;
		white[ 2643 ]<=0;
		white[ 2644 ]<=0;
		white[ 2645 ]<=0;
		white[ 2646 ]<=1;
		white[ 2647 ]<=1;
		white[ 2648 ]<=1;
		white[ 2649 ]<=1;
		white[ 2650 ]<=1;
		white[ 2651 ]<=0;
		white[ 2652 ]<=0;
		white[ 2653 ]<=0;
		white[ 2654 ]<=0;
		white[ 2655 ]<=0;
		white[ 2656 ]<=0;
		white[ 2657 ]<=0;
		white[ 2658 ]<=0;
		white[ 2659 ]<=0;
		white[ 2660 ]<=0;
		white[ 2661 ]<=0;
		white[ 2662 ]<=0;
		white[ 2663 ]<=0;
		white[ 2664 ]<=0;
		white[ 2665 ]<=0;
		white[ 2666 ]<=0;
		white[ 2667 ]<=0;
		white[ 2668 ]<=0;
		white[ 2669 ]<=0;
		white[ 2670 ]<=0;
		white[ 2671 ]<=0;
		white[ 2672 ]<=0;
		white[ 2673 ]<=0;
		white[ 2674 ]<=0;
		white[ 2675 ]<=0;
		white[ 2676 ]<=0;
		white[ 2677 ]<=0;
		white[ 2678 ]<=0;
		white[ 2679 ]<=0;
		white[ 2680 ]<=0;
		white[ 2681 ]<=0;
		white[ 2682 ]<=0;
		white[ 2683 ]<=0;
		white[ 2684 ]<=0;
		white[ 2685 ]<=0;
		white[ 2686 ]<=0;
		white[ 2687 ]<=0;
		white[ 2688 ]<=0;
		white[ 2689 ]<=1;
		white[ 2690 ]<=1;
		white[ 2691 ]<=1;
		white[ 2692 ]<=1;
		white[ 2693 ]<=1;
		white[ 2694 ]<=0;
		white[ 2695 ]<=0;
		white[ 2696 ]<=0;
		white[ 2697 ]<=0;
		white[ 2698 ]<=0;
		white[ 2699 ]<=0;
		white[ 2700 ]<=0;
		white[ 2701 ]<=0;
		white[ 2702 ]<=0;
		white[ 2703 ]<=0;
		white[ 2704 ]<=0;
		white[ 2705 ]<=0;
		white[ 2706 ]<=1;
		white[ 2707 ]<=1;
		white[ 2708 ]<=1;
		white[ 2709 ]<=1;
		white[ 2710 ]<=1;
		white[ 2711 ]<=0;
		white[ 2712 ]<=0;
		white[ 2713 ]<=0;
		white[ 2714 ]<=0;
		white[ 2715 ]<=0;
		white[ 2716 ]<=0;
		white[ 2717 ]<=0;
		white[ 2718 ]<=0;
		white[ 2719 ]<=0;
		white[ 2720 ]<=0;
		white[ 2721 ]<=0;
		white[ 2722 ]<=0;
		white[ 2723 ]<=0;
		white[ 2724 ]<=0;
		white[ 2725 ]<=0;
		white[ 2726 ]<=0;
		white[ 2727 ]<=0;
		white[ 2728 ]<=0;
		white[ 2729 ]<=0;
		white[ 2730 ]<=0;
		white[ 2731 ]<=0;
		white[ 2732 ]<=0;
		white[ 2733 ]<=0;
		white[ 2734 ]<=0;
		white[ 2735 ]<=0;
		white[ 2736 ]<=0;
		white[ 2737 ]<=0;
		white[ 2738 ]<=0;
		white[ 2739 ]<=0;
		white[ 2740 ]<=0;
		white[ 2741 ]<=0;
		white[ 2742 ]<=0;
		white[ 2743 ]<=0;
		white[ 2744 ]<=0;
		white[ 2745 ]<=0;
		white[ 2746 ]<=0;
		white[ 2747 ]<=0;
		white[ 2748 ]<=0;
		white[ 2749 ]<=1;
		white[ 2750 ]<=1;
		white[ 2751 ]<=1;
		white[ 2752 ]<=1;
		white[ 2753 ]<=1;
		white[ 2754 ]<=0;
		white[ 2755 ]<=0;
		white[ 2756 ]<=0;
		white[ 2757 ]<=0;
		white[ 2758 ]<=0;
		white[ 2759 ]<=0;
		white[ 2760 ]<=0;
		white[ 2761 ]<=0;
		white[ 2762 ]<=0;
		white[ 2763 ]<=0;
		white[ 2764 ]<=0;
		white[ 2765 ]<=0;
		white[ 2766 ]<=0;
		white[ 2767 ]<=1;
		white[ 2768 ]<=1;
		white[ 2769 ]<=1;
		white[ 2770 ]<=1;
		white[ 2771 ]<=1;
		white[ 2772 ]<=0;
		white[ 2773 ]<=0;
		white[ 2774 ]<=0;
		white[ 2775 ]<=0;
		white[ 2776 ]<=0;
		white[ 2777 ]<=0;
		white[ 2778 ]<=0;
		white[ 2779 ]<=0;
		white[ 2780 ]<=0;
		white[ 2781 ]<=0;
		white[ 2782 ]<=0;
		white[ 2783 ]<=0;
		white[ 2784 ]<=0;
		white[ 2785 ]<=0;
		white[ 2786 ]<=0;
		white[ 2787 ]<=0;
		white[ 2788 ]<=0;
		white[ 2789 ]<=0;
		white[ 2790 ]<=0;
		white[ 2791 ]<=0;
		white[ 2792 ]<=0;
		white[ 2793 ]<=0;
		white[ 2794 ]<=0;
		white[ 2795 ]<=0;
		white[ 2796 ]<=0;
		white[ 2797 ]<=0;
		white[ 2798 ]<=0;
		white[ 2799 ]<=0;
		white[ 2800 ]<=0;
		white[ 2801 ]<=0;
		white[ 2802 ]<=0;
		white[ 2803 ]<=0;
		white[ 2804 ]<=0;
		white[ 2805 ]<=0;
		white[ 2806 ]<=0;
		white[ 2807 ]<=0;
		white[ 2808 ]<=1;
		white[ 2809 ]<=1;
		white[ 2810 ]<=1;
		white[ 2811 ]<=1;
		white[ 2812 ]<=1;
		white[ 2813 ]<=0;
		white[ 2814 ]<=0;
		white[ 2815 ]<=0;
		white[ 2816 ]<=0;
		white[ 2817 ]<=0;
		white[ 2818 ]<=0;
		white[ 2819 ]<=0;
		white[ 2820 ]<=0;
		white[ 2821 ]<=0;
		white[ 2822 ]<=0;
		white[ 2823 ]<=0;
		white[ 2824 ]<=0;
		white[ 2825 ]<=0;
		white[ 2826 ]<=0;
		white[ 2827 ]<=1;
		white[ 2828 ]<=1;
		white[ 2829 ]<=1;
		white[ 2830 ]<=1;
		white[ 2831 ]<=1;
		white[ 2832 ]<=1;
		white[ 2833 ]<=0;
		white[ 2834 ]<=0;
		white[ 2835 ]<=0;
		white[ 2836 ]<=0;
		white[ 2837 ]<=0;
		white[ 2838 ]<=0;
		white[ 2839 ]<=0;
		white[ 2840 ]<=0;
		white[ 2841 ]<=0;
		white[ 2842 ]<=0;
		white[ 2843 ]<=0;
		white[ 2844 ]<=0;
		white[ 2845 ]<=0;
		white[ 2846 ]<=0;
		white[ 2847 ]<=0;
		white[ 2848 ]<=0;
		white[ 2849 ]<=0;
		white[ 2850 ]<=0;
		white[ 2851 ]<=0;
		white[ 2852 ]<=0;
		white[ 2853 ]<=0;
		white[ 2854 ]<=0;
		white[ 2855 ]<=0;
		white[ 2856 ]<=0;
		white[ 2857 ]<=0;
		white[ 2858 ]<=0;
		white[ 2859 ]<=0;
		white[ 2860 ]<=0;
		white[ 2861 ]<=0;
		white[ 2862 ]<=0;
		white[ 2863 ]<=0;
		white[ 2864 ]<=0;
		white[ 2865 ]<=0;
		white[ 2866 ]<=0;
		white[ 2867 ]<=1;
		white[ 2868 ]<=1;
		white[ 2869 ]<=1;
		white[ 2870 ]<=1;
		white[ 2871 ]<=1;
		white[ 2872 ]<=1;
		white[ 2873 ]<=0;
		white[ 2874 ]<=0;
		white[ 2875 ]<=0;
		white[ 2876 ]<=0;
		white[ 2877 ]<=0;
		white[ 2878 ]<=0;
		white[ 2879 ]<=0;
		white[ 2880 ]<=0;
		white[ 2881 ]<=0;
		white[ 2882 ]<=0;
		white[ 2883 ]<=0;
		white[ 2884 ]<=0;
		white[ 2885 ]<=0;
		white[ 2886 ]<=0;
		white[ 2887 ]<=0;
		white[ 2888 ]<=1;
		white[ 2889 ]<=1;
		white[ 2890 ]<=1;
		white[ 2891 ]<=1;
		white[ 2892 ]<=1;
		white[ 2893 ]<=1;
		white[ 2894 ]<=0;
		white[ 2895 ]<=0;
		white[ 2896 ]<=0;
		white[ 2897 ]<=0;
		white[ 2898 ]<=0;
		white[ 2899 ]<=0;
		white[ 2900 ]<=0;
		white[ 2901 ]<=0;
		white[ 2902 ]<=0;
		white[ 2903 ]<=0;
		white[ 2904 ]<=0;
		white[ 2905 ]<=0;
		white[ 2906 ]<=0;
		white[ 2907 ]<=0;
		white[ 2908 ]<=0;
		white[ 2909 ]<=0;
		white[ 2910 ]<=0;
		white[ 2911 ]<=0;
		white[ 2912 ]<=0;
		white[ 2913 ]<=0;
		white[ 2914 ]<=0;
		white[ 2915 ]<=0;
		white[ 2916 ]<=0;
		white[ 2917 ]<=0;
		white[ 2918 ]<=0;
		white[ 2919 ]<=0;
		white[ 2920 ]<=0;
		white[ 2921 ]<=0;
		white[ 2922 ]<=0;
		white[ 2923 ]<=0;
		white[ 2924 ]<=0;
		white[ 2925 ]<=0;
		white[ 2926 ]<=1;
		white[ 2927 ]<=1;
		white[ 2928 ]<=1;
		white[ 2929 ]<=1;
		white[ 2930 ]<=1;
		white[ 2931 ]<=1;
		white[ 2932 ]<=0;
		white[ 2933 ]<=0;
		white[ 2934 ]<=0;
		white[ 2935 ]<=0;
		white[ 2936 ]<=0;
		white[ 2937 ]<=0;
		white[ 2938 ]<=0;
		white[ 2939 ]<=0;
		white[ 2940 ]<=0;
		white[ 2941 ]<=0;
		white[ 2942 ]<=0;
		white[ 2943 ]<=0;
		white[ 2944 ]<=0;
		white[ 2945 ]<=0;
		white[ 2946 ]<=0;
		white[ 2947 ]<=0;
		white[ 2948 ]<=0;
		white[ 2949 ]<=1;
		white[ 2950 ]<=1;
		white[ 2951 ]<=1;
		white[ 2952 ]<=1;
		white[ 2953 ]<=1;
		white[ 2954 ]<=1;
		white[ 2955 ]<=0;
		white[ 2956 ]<=0;
		white[ 2957 ]<=0;
		white[ 2958 ]<=0;
		white[ 2959 ]<=0;
		white[ 2960 ]<=0;
		white[ 2961 ]<=0;
		white[ 2962 ]<=0;
		white[ 2963 ]<=0;
		white[ 2964 ]<=0;
		white[ 2965 ]<=0;
		white[ 2966 ]<=0;
		white[ 2967 ]<=0;
		white[ 2968 ]<=0;
		white[ 2969 ]<=0;
		white[ 2970 ]<=0;
		white[ 2971 ]<=0;
		white[ 2972 ]<=0;
		white[ 2973 ]<=0;
		white[ 2974 ]<=0;
		white[ 2975 ]<=0;
		white[ 2976 ]<=0;
		white[ 2977 ]<=0;
		white[ 2978 ]<=0;
		white[ 2979 ]<=0;
		white[ 2980 ]<=0;
		white[ 2981 ]<=0;
		white[ 2982 ]<=0;
		white[ 2983 ]<=0;
		white[ 2984 ]<=0;
		white[ 2985 ]<=1;
		white[ 2986 ]<=1;
		white[ 2987 ]<=1;
		white[ 2988 ]<=1;
		white[ 2989 ]<=1;
		white[ 2990 ]<=1;
		white[ 2991 ]<=0;
		white[ 2992 ]<=0;
		white[ 2993 ]<=0;
		white[ 2994 ]<=0;
		white[ 2995 ]<=0;
		white[ 2996 ]<=0;
		white[ 2997 ]<=0;
		white[ 2998 ]<=0;
		white[ 2999 ]<=0;
		white[ 3000 ]<=0;
		white[ 3001 ]<=0;
		white[ 3002 ]<=0;
		white[ 3003 ]<=0;
		white[ 3004 ]<=0;
		white[ 3005 ]<=0;
		white[ 3006 ]<=0;
		white[ 3007 ]<=0;
		white[ 3008 ]<=0;
		white[ 3009 ]<=1;
		white[ 3010 ]<=1;
		white[ 3011 ]<=1;
		white[ 3012 ]<=1;
		white[ 3013 ]<=1;
		white[ 3014 ]<=1;
		white[ 3015 ]<=1;
		white[ 3016 ]<=0;
		white[ 3017 ]<=0;
		white[ 3018 ]<=0;
		white[ 3019 ]<=0;
		white[ 3020 ]<=0;
		white[ 3021 ]<=0;
		white[ 3022 ]<=0;
		white[ 3023 ]<=0;
		white[ 3024 ]<=0;
		white[ 3025 ]<=0;
		white[ 3026 ]<=0;
		white[ 3027 ]<=0;
		white[ 3028 ]<=0;
		white[ 3029 ]<=0;
		white[ 3030 ]<=0;
		white[ 3031 ]<=0;
		white[ 3032 ]<=0;
		white[ 3033 ]<=0;
		white[ 3034 ]<=0;
		white[ 3035 ]<=0;
		white[ 3036 ]<=0;
		white[ 3037 ]<=0;
		white[ 3038 ]<=0;
		white[ 3039 ]<=0;
		white[ 3040 ]<=0;
		white[ 3041 ]<=0;
		white[ 3042 ]<=0;
		white[ 3043 ]<=0;
		white[ 3044 ]<=1;
		white[ 3045 ]<=1;
		white[ 3046 ]<=1;
		white[ 3047 ]<=1;
		white[ 3048 ]<=1;
		white[ 3049 ]<=1;
		white[ 3050 ]<=1;
		white[ 3051 ]<=0;
		white[ 3052 ]<=0;
		white[ 3053 ]<=0;
		white[ 3054 ]<=0;
		white[ 3055 ]<=0;
		white[ 3056 ]<=0;
		white[ 3057 ]<=0;
		white[ 3058 ]<=0;
		white[ 3059 ]<=0;
		white[ 3060 ]<=0;
		white[ 3061 ]<=0;
		white[ 3062 ]<=0;
		white[ 3063 ]<=0;
		white[ 3064 ]<=0;
		white[ 3065 ]<=0;
		white[ 3066 ]<=0;
		white[ 3067 ]<=0;
		white[ 3068 ]<=0;
		white[ 3069 ]<=0;
		white[ 3070 ]<=1;
		white[ 3071 ]<=1;
		white[ 3072 ]<=1;
		white[ 3073 ]<=1;
		white[ 3074 ]<=1;
		white[ 3075 ]<=1;
		white[ 3076 ]<=1;
		white[ 3077 ]<=0;
		white[ 3078 ]<=0;
		white[ 3079 ]<=0;
		white[ 3080 ]<=0;
		white[ 3081 ]<=0;
		white[ 3082 ]<=0;
		white[ 3083 ]<=0;
		white[ 3084 ]<=0;
		white[ 3085 ]<=0;
		white[ 3086 ]<=0;
		white[ 3087 ]<=0;
		white[ 3088 ]<=0;
		white[ 3089 ]<=0;
		white[ 3090 ]<=0;
		white[ 3091 ]<=0;
		white[ 3092 ]<=0;
		white[ 3093 ]<=0;
		white[ 3094 ]<=0;
		white[ 3095 ]<=0;
		white[ 3096 ]<=0;
		white[ 3097 ]<=0;
		white[ 3098 ]<=0;
		white[ 3099 ]<=0;
		white[ 3100 ]<=0;
		white[ 3101 ]<=0;
		white[ 3102 ]<=0;
		white[ 3103 ]<=1;
		white[ 3104 ]<=1;
		white[ 3105 ]<=1;
		white[ 3106 ]<=1;
		white[ 3107 ]<=1;
		white[ 3108 ]<=1;
		white[ 3109 ]<=1;
		white[ 3110 ]<=0;
		white[ 3111 ]<=0;
		white[ 3112 ]<=0;
		white[ 3113 ]<=0;
		white[ 3114 ]<=0;
		white[ 3115 ]<=0;
		white[ 3116 ]<=0;
		white[ 3117 ]<=0;
		white[ 3118 ]<=0;
		white[ 3119 ]<=0;
		white[ 3120 ]<=0;
		white[ 3121 ]<=0;
		white[ 3122 ]<=0;
		white[ 3123 ]<=0;
		white[ 3124 ]<=0;
		white[ 3125 ]<=0;
		white[ 3126 ]<=0;
		white[ 3127 ]<=0;
		white[ 3128 ]<=0;
		white[ 3129 ]<=0;
		white[ 3130 ]<=0;
		white[ 3131 ]<=1;
		white[ 3132 ]<=1;
		white[ 3133 ]<=1;
		white[ 3134 ]<=1;
		white[ 3135 ]<=1;
		white[ 3136 ]<=1;
		white[ 3137 ]<=1;
		white[ 3138 ]<=0;
		white[ 3139 ]<=0;
		white[ 3140 ]<=0;
		white[ 3141 ]<=0;
		white[ 3142 ]<=0;
		white[ 3143 ]<=0;
		white[ 3144 ]<=0;
		white[ 3145 ]<=0;
		white[ 3146 ]<=0;
		white[ 3147 ]<=0;
		white[ 3148 ]<=0;
		white[ 3149 ]<=0;
		white[ 3150 ]<=0;
		white[ 3151 ]<=0;
		white[ 3152 ]<=0;
		white[ 3153 ]<=0;
		white[ 3154 ]<=0;
		white[ 3155 ]<=0;
		white[ 3156 ]<=0;
		white[ 3157 ]<=0;
		white[ 3158 ]<=0;
		white[ 3159 ]<=0;
		white[ 3160 ]<=0;
		white[ 3161 ]<=0;
		white[ 3162 ]<=1;
		white[ 3163 ]<=1;
		white[ 3164 ]<=1;
		white[ 3165 ]<=1;
		white[ 3166 ]<=1;
		white[ 3167 ]<=1;
		white[ 3168 ]<=1;
		white[ 3169 ]<=0;
		white[ 3170 ]<=0;
		white[ 3171 ]<=0;
		white[ 3172 ]<=0;
		white[ 3173 ]<=0;
		white[ 3174 ]<=0;
		white[ 3175 ]<=0;
		white[ 3176 ]<=0;
		white[ 3177 ]<=0;
		white[ 3178 ]<=0;
		white[ 3179 ]<=0;
		white[ 3180 ]<=0;
		white[ 3181 ]<=0;
		white[ 3182 ]<=0;
		white[ 3183 ]<=0;
		white[ 3184 ]<=0;
		white[ 3185 ]<=0;
		white[ 3186 ]<=0;
		white[ 3187 ]<=0;
		white[ 3188 ]<=0;
		white[ 3189 ]<=0;
		white[ 3190 ]<=0;
		white[ 3191 ]<=0;
		white[ 3192 ]<=1;
		white[ 3193 ]<=1;
		white[ 3194 ]<=1;
		white[ 3195 ]<=1;
		white[ 3196 ]<=1;
		white[ 3197 ]<=1;
		white[ 3198 ]<=1;
		white[ 3199 ]<=1;
		white[ 3200 ]<=0;
		white[ 3201 ]<=0;
		white[ 3202 ]<=0;
		white[ 3203 ]<=0;
		white[ 3204 ]<=0;
		white[ 3205 ]<=0;
		white[ 3206 ]<=0;
		white[ 3207 ]<=0;
		white[ 3208 ]<=0;
		white[ 3209 ]<=0;
		white[ 3210 ]<=0;
		white[ 3211 ]<=0;
		white[ 3212 ]<=0;
		white[ 3213 ]<=0;
		white[ 3214 ]<=0;
		white[ 3215 ]<=0;
		white[ 3216 ]<=0;
		white[ 3217 ]<=0;
		white[ 3218 ]<=0;
		white[ 3219 ]<=0;
		white[ 3220 ]<=1;
		white[ 3221 ]<=1;
		white[ 3222 ]<=1;
		white[ 3223 ]<=1;
		white[ 3224 ]<=1;
		white[ 3225 ]<=1;
		white[ 3226 ]<=1;
		white[ 3227 ]<=1;
		white[ 3228 ]<=0;
		white[ 3229 ]<=0;
		white[ 3230 ]<=0;
		white[ 3231 ]<=0;
		white[ 3232 ]<=0;
		white[ 3233 ]<=0;
		white[ 3234 ]<=0;
		white[ 3235 ]<=0;
		white[ 3236 ]<=0;
		white[ 3237 ]<=0;
		white[ 3238 ]<=0;
		white[ 3239 ]<=0;
		white[ 3240 ]<=0;
		white[ 3241 ]<=0;
		white[ 3242 ]<=0;
		white[ 3243 ]<=0;
		white[ 3244 ]<=0;
		white[ 3245 ]<=0;
		white[ 3246 ]<=0;
		white[ 3247 ]<=0;
		white[ 3248 ]<=0;
		white[ 3249 ]<=0;
		white[ 3250 ]<=0;
		white[ 3251 ]<=0;
		white[ 3252 ]<=0;
		white[ 3253 ]<=1;
		white[ 3254 ]<=1;
		white[ 3255 ]<=1;
		white[ 3256 ]<=1;
		white[ 3257 ]<=1;
		white[ 3258 ]<=1;
		white[ 3259 ]<=1;
		white[ 3260 ]<=1;
		white[ 3261 ]<=1;
		white[ 3262 ]<=0;
		white[ 3263 ]<=0;
		white[ 3264 ]<=0;
		white[ 3265 ]<=0;
		white[ 3266 ]<=0;
		white[ 3267 ]<=0;
		white[ 3268 ]<=0;
		white[ 3269 ]<=0;
		white[ 3270 ]<=0;
		white[ 3271 ]<=0;
		white[ 3272 ]<=0;
		white[ 3273 ]<=0;
		white[ 3274 ]<=0;
		white[ 3275 ]<=0;
		white[ 3276 ]<=0;
		white[ 3277 ]<=0;
		white[ 3278 ]<=1;
		white[ 3279 ]<=1;
		white[ 3280 ]<=1;
		white[ 3281 ]<=1;
		white[ 3282 ]<=1;
		white[ 3283 ]<=1;
		white[ 3284 ]<=1;
		white[ 3285 ]<=1;
		white[ 3286 ]<=1;
		white[ 3287 ]<=0;
		white[ 3288 ]<=0;
		white[ 3289 ]<=0;
		white[ 3290 ]<=0;
		white[ 3291 ]<=0;
		white[ 3292 ]<=0;
		white[ 3293 ]<=0;
		white[ 3294 ]<=0;
		white[ 3295 ]<=0;
		white[ 3296 ]<=0;
		white[ 3297 ]<=0;
		white[ 3298 ]<=0;
		white[ 3299 ]<=0;
		white[ 3300 ]<=0;
		white[ 3301 ]<=0;
		white[ 3302 ]<=0;
		white[ 3303 ]<=0;
		white[ 3304 ]<=0;
		white[ 3305 ]<=0;
		white[ 3306 ]<=0;
		white[ 3307 ]<=0;
		white[ 3308 ]<=0;
		white[ 3309 ]<=0;
		white[ 3310 ]<=0;
		white[ 3311 ]<=0;
		white[ 3312 ]<=0;
		white[ 3313 ]<=0;
		white[ 3314 ]<=0;
		white[ 3315 ]<=1;
		white[ 3316 ]<=1;
		white[ 3317 ]<=1;
		white[ 3318 ]<=1;
		white[ 3319 ]<=1;
		white[ 3320 ]<=1;
		white[ 3321 ]<=1;
		white[ 3322 ]<=1;
		white[ 3323 ]<=1;
		white[ 3324 ]<=1;
		white[ 3325 ]<=0;
		white[ 3326 ]<=0;
		white[ 3327 ]<=0;
		white[ 3328 ]<=0;
		white[ 3329 ]<=0;
		white[ 3330 ]<=0;
		white[ 3331 ]<=0;
		white[ 3332 ]<=0;
		white[ 3333 ]<=0;
		white[ 3334 ]<=0;
		white[ 3335 ]<=1;
		white[ 3336 ]<=1;
		white[ 3337 ]<=1;
		white[ 3338 ]<=1;
		white[ 3339 ]<=1;
		white[ 3340 ]<=1;
		white[ 3341 ]<=1;
		white[ 3342 ]<=1;
		white[ 3343 ]<=1;
		white[ 3344 ]<=1;
		white[ 3345 ]<=0;
		white[ 3346 ]<=0;
		white[ 3347 ]<=0;
		white[ 3348 ]<=0;
		white[ 3349 ]<=0;
		white[ 3350 ]<=0;
		white[ 3351 ]<=0;
		white[ 3352 ]<=0;
		white[ 3353 ]<=0;
		white[ 3354 ]<=0;
		white[ 3355 ]<=0;
		white[ 3356 ]<=0;
		white[ 3357 ]<=0;
		white[ 3358 ]<=0;
		white[ 3359 ]<=0;
		white[ 3360 ]<=0;
		white[ 3361 ]<=0;
		white[ 3362 ]<=0;
		white[ 3363 ]<=0;
		white[ 3364 ]<=0;
		white[ 3365 ]<=0;
		white[ 3366 ]<=0;
		white[ 3367 ]<=0;
		white[ 3368 ]<=0;
		white[ 3369 ]<=0;
		white[ 3370 ]<=0;
		white[ 3371 ]<=0;
		white[ 3372 ]<=0;
		white[ 3373 ]<=0;
		white[ 3374 ]<=0;
		white[ 3375 ]<=0;
		white[ 3376 ]<=1;
		white[ 3377 ]<=1;
		white[ 3378 ]<=1;
		white[ 3379 ]<=1;
		white[ 3380 ]<=1;
		white[ 3381 ]<=1;
		white[ 3382 ]<=1;
		white[ 3383 ]<=1;
		white[ 3384 ]<=1;
		white[ 3385 ]<=1;
		white[ 3386 ]<=1;
		white[ 3387 ]<=1;
		white[ 3388 ]<=1;
		white[ 3389 ]<=1;
		white[ 3390 ]<=1;
		white[ 3391 ]<=1;
		white[ 3392 ]<=1;
		white[ 3393 ]<=1;
		white[ 3394 ]<=1;
		white[ 3395 ]<=1;
		white[ 3396 ]<=1;
		white[ 3397 ]<=1;
		white[ 3398 ]<=1;
		white[ 3399 ]<=1;
		white[ 3400 ]<=1;
		white[ 3401 ]<=1;
		white[ 3402 ]<=1;
		white[ 3403 ]<=1;
		white[ 3404 ]<=0;
		white[ 3405 ]<=0;
		white[ 3406 ]<=0;
		white[ 3407 ]<=0;
		white[ 3408 ]<=0;
		white[ 3409 ]<=0;
		white[ 3410 ]<=0;
		white[ 3411 ]<=0;
		white[ 3412 ]<=0;
		white[ 3413 ]<=0;
		white[ 3414 ]<=0;
		white[ 3415 ]<=0;
		white[ 3416 ]<=0;
		white[ 3417 ]<=0;
		white[ 3418 ]<=0;
		white[ 3419 ]<=0;
		white[ 3420 ]<=0;
		white[ 3421 ]<=0;
		white[ 3422 ]<=0;
		white[ 3423 ]<=0;
		white[ 3424 ]<=0;
		white[ 3425 ]<=0;
		white[ 3426 ]<=0;
		white[ 3427 ]<=0;
		white[ 3428 ]<=0;
		white[ 3429 ]<=0;
		white[ 3430 ]<=0;
		white[ 3431 ]<=0;
		white[ 3432 ]<=0;
		white[ 3433 ]<=0;
		white[ 3434 ]<=0;
		white[ 3435 ]<=0;
		white[ 3436 ]<=0;
		white[ 3437 ]<=0;
		white[ 3438 ]<=1;
		white[ 3439 ]<=1;
		white[ 3440 ]<=1;
		white[ 3441 ]<=1;
		white[ 3442 ]<=1;
		white[ 3443 ]<=1;
		white[ 3444 ]<=1;
		white[ 3445 ]<=1;
		white[ 3446 ]<=1;
		white[ 3447 ]<=1;
		white[ 3448 ]<=1;
		white[ 3449 ]<=1;
		white[ 3450 ]<=1;
		white[ 3451 ]<=1;
		white[ 3452 ]<=1;
		white[ 3453 ]<=1;
		white[ 3454 ]<=1;
		white[ 3455 ]<=1;
		white[ 3456 ]<=1;
		white[ 3457 ]<=1;
		white[ 3458 ]<=1;
		white[ 3459 ]<=1;
		white[ 3460 ]<=1;
		white[ 3461 ]<=1;
		white[ 3462 ]<=0;
		white[ 3463 ]<=0;
		white[ 3464 ]<=0;
		white[ 3465 ]<=0;
		white[ 3466 ]<=0;
		white[ 3467 ]<=0;
		white[ 3468 ]<=0;
		white[ 3469 ]<=0;
		white[ 3470 ]<=0;
		white[ 3471 ]<=0;
		white[ 3472 ]<=0;
		white[ 3473 ]<=0;
		white[ 3474 ]<=0;
		white[ 3475 ]<=0;
		white[ 3476 ]<=0;
		white[ 3477 ]<=0;
		white[ 3478 ]<=0;
		white[ 3479 ]<=0;
		white[ 3480 ]<=0;
		white[ 3481 ]<=0;
		white[ 3482 ]<=0;
		white[ 3483 ]<=0;
		white[ 3484 ]<=0;
		white[ 3485 ]<=0;
		white[ 3486 ]<=0;
		white[ 3487 ]<=0;
		white[ 3488 ]<=0;
		white[ 3489 ]<=0;
		white[ 3490 ]<=0;
		white[ 3491 ]<=0;
		white[ 3492 ]<=0;
		white[ 3493 ]<=0;
		white[ 3494 ]<=0;
		white[ 3495 ]<=0;
		white[ 3496 ]<=0;
		white[ 3497 ]<=0;
		white[ 3498 ]<=0;
		white[ 3499 ]<=0;
		white[ 3500 ]<=1;
		white[ 3501 ]<=1;
		white[ 3502 ]<=1;
		white[ 3503 ]<=1;
		white[ 3504 ]<=1;
		white[ 3505 ]<=1;
		white[ 3506 ]<=1;
		white[ 3507 ]<=1;
		white[ 3508 ]<=1;
		white[ 3509 ]<=1;
		white[ 3510 ]<=1;
		white[ 3511 ]<=1;
		white[ 3512 ]<=1;
		white[ 3513 ]<=1;
		white[ 3514 ]<=1;
		white[ 3515 ]<=1;
		white[ 3516 ]<=1;
		white[ 3517 ]<=1;
		white[ 3518 ]<=1;
		white[ 3519 ]<=1;
		white[ 3520 ]<=0;
		white[ 3521 ]<=0;
		white[ 3522 ]<=0;
		white[ 3523 ]<=0;
		white[ 3524 ]<=0;
		white[ 3525 ]<=0;
		white[ 3526 ]<=0;
		white[ 3527 ]<=0;
		white[ 3528 ]<=0;
		white[ 3529 ]<=0;
		white[ 3530 ]<=0;
		white[ 3531 ]<=0;
		white[ 3532 ]<=0;
		white[ 3533 ]<=0;
		white[ 3534 ]<=0;
		white[ 3535 ]<=0;
		white[ 3536 ]<=0;
		white[ 3537 ]<=0;
		white[ 3538 ]<=0;
		white[ 3539 ]<=0;
		white[ 3540 ]<=0;
		white[ 3541 ]<=0;
		white[ 3542 ]<=0;
		white[ 3543 ]<=0;
		white[ 3544 ]<=0;
		white[ 3545 ]<=0;
		white[ 3546 ]<=0;
		white[ 3547 ]<=0;
		white[ 3548 ]<=0;
		white[ 3549 ]<=0;
		white[ 3550 ]<=0;
		white[ 3551 ]<=0;
		white[ 3552 ]<=0;
		white[ 3553 ]<=0;
		white[ 3554 ]<=0;
		white[ 3555 ]<=0;
		white[ 3556 ]<=0;
		white[ 3557 ]<=0;
		white[ 3558 ]<=0;
		white[ 3559 ]<=0;
		white[ 3560 ]<=0;
		white[ 3561 ]<=0;
		white[ 3562 ]<=1;
		white[ 3563 ]<=1;
		white[ 3564 ]<=1;
		white[ 3565 ]<=1;
		white[ 3566 ]<=1;
		white[ 3567 ]<=1;
		white[ 3568 ]<=1;
		white[ 3569 ]<=1;
		white[ 3570 ]<=1;
		white[ 3571 ]<=1;
		white[ 3572 ]<=1;
		white[ 3573 ]<=1;
		white[ 3574 ]<=1;
		white[ 3575 ]<=1;
		white[ 3576 ]<=1;
		white[ 3577 ]<=1;
		white[ 3578 ]<=0;
		white[ 3579 ]<=0;
		white[ 3580 ]<=0;
		white[ 3581 ]<=0;
		white[ 3582 ]<=0;
		white[ 3583 ]<=0;
		white[ 3584 ]<=0;
		white[ 3585 ]<=0;
		white[ 3586 ]<=0;
		white[ 3587 ]<=0;
		white[ 3588 ]<=0;
		white[ 3589 ]<=0;
		white[ 3590 ]<=0;
		white[ 3591 ]<=0;
		white[ 3592 ]<=0;
		white[ 3593 ]<=0;
		white[ 3594 ]<=0;
		white[ 3595 ]<=0;
		white[ 3596 ]<=0;
		white[ 3597 ]<=0;
		white[ 3598 ]<=0;
		white[ 3599 ]<=0;
		end
		//heart
		18'd92639: begin
		white[ 0 ]<=0;
		white[ 1 ]<=0;
		white[ 2 ]<=0;
		white[ 3 ]<=0;
		white[ 4 ]<=0;
		white[ 5 ]<=0;
		white[ 6 ]<=0;
		white[ 7 ]<=0;
		white[ 8 ]<=0;
		white[ 9 ]<=0;
		white[ 10 ]<=0;
		white[ 11 ]<=0;
		white[ 12 ]<=0;
		white[ 13 ]<=0;
		white[ 14 ]<=0;
		white[ 15 ]<=0;
		white[ 16 ]<=0;
		white[ 17 ]<=0;
		white[ 18 ]<=0;
		white[ 19 ]<=0;
		white[ 20 ]<=0;
		white[ 21 ]<=0;
		white[ 22 ]<=0;
		white[ 23 ]<=0;
		white[ 24 ]<=0;
		white[ 25 ]<=0;
		white[ 26 ]<=0;
		white[ 27 ]<=0;
		white[ 28 ]<=0;
		white[ 29 ]<=0;
		white[ 30 ]<=0;
		white[ 31 ]<=0;
		white[ 32 ]<=0;
		white[ 33 ]<=0;
		white[ 34 ]<=0;
		white[ 35 ]<=0;
		white[ 36 ]<=0;
		white[ 37 ]<=0;
		white[ 38 ]<=0;
		white[ 39 ]<=0;
		white[ 40 ]<=0;
		white[ 41 ]<=0;
		white[ 42 ]<=0;
		white[ 43 ]<=0;
		white[ 44 ]<=0;
		white[ 45 ]<=0;
		white[ 46 ]<=0;
		white[ 47 ]<=0;
		white[ 48 ]<=0;
		white[ 49 ]<=0;
		white[ 50 ]<=0;
		white[ 51 ]<=0;
		white[ 52 ]<=0;
		white[ 53 ]<=0;
		white[ 54 ]<=0;
		white[ 55 ]<=0;
		white[ 56 ]<=0;
		white[ 57 ]<=0;
		white[ 58 ]<=0;
		white[ 59 ]<=0;
		white[ 60 ]<=0;
		white[ 61 ]<=0;
		white[ 62 ]<=0;
		white[ 63 ]<=0;
		white[ 64 ]<=0;
		white[ 65 ]<=0;
		white[ 66 ]<=0;
		white[ 67 ]<=0;
		white[ 68 ]<=0;
		white[ 69 ]<=0;
		white[ 70 ]<=0;
		white[ 71 ]<=0;
		white[ 72 ]<=0;
		white[ 73 ]<=0;
		white[ 74 ]<=0;
		white[ 75 ]<=0;
		white[ 76 ]<=0;
		white[ 77 ]<=0;
		white[ 78 ]<=0;
		white[ 79 ]<=0;
		white[ 80 ]<=0;
		white[ 81 ]<=0;
		white[ 82 ]<=0;
		white[ 83 ]<=0;
		white[ 84 ]<=0;
		white[ 85 ]<=0;
		white[ 86 ]<=0;
		white[ 87 ]<=0;
		white[ 88 ]<=0;
		white[ 89 ]<=0;
		white[ 90 ]<=0;
		white[ 91 ]<=0;
		white[ 92 ]<=0;
		white[ 93 ]<=0;
		white[ 94 ]<=0;
		white[ 95 ]<=0;
		white[ 96 ]<=0;
		white[ 97 ]<=0;
		white[ 98 ]<=0;
		white[ 99 ]<=0;
		white[ 100 ]<=0;
		white[ 101 ]<=0;
		white[ 102 ]<=0;
		white[ 103 ]<=0;
		white[ 104 ]<=0;
		white[ 105 ]<=0;
		white[ 106 ]<=0;
		white[ 107 ]<=0;
		white[ 108 ]<=0;
		white[ 109 ]<=0;
		white[ 110 ]<=0;
		white[ 111 ]<=0;
		white[ 112 ]<=0;
		white[ 113 ]<=0;
		white[ 114 ]<=0;
		white[ 115 ]<=0;
		white[ 116 ]<=0;
		white[ 117 ]<=0;
		white[ 118 ]<=0;
		white[ 119 ]<=0;
		white[ 120 ]<=0;
		white[ 121 ]<=0;
		white[ 122 ]<=0;
		white[ 123 ]<=0;
		white[ 124 ]<=0;
		white[ 125 ]<=0;
		white[ 126 ]<=0;
		white[ 127 ]<=0;
		white[ 128 ]<=0;
		white[ 129 ]<=0;
		white[ 130 ]<=0;
		white[ 131 ]<=0;
		white[ 132 ]<=0;
		white[ 133 ]<=0;
		white[ 134 ]<=0;
		white[ 135 ]<=0;
		white[ 136 ]<=0;
		white[ 137 ]<=0;
		white[ 138 ]<=0;
		white[ 139 ]<=0;
		white[ 140 ]<=0;
		white[ 141 ]<=0;
		white[ 142 ]<=0;
		white[ 143 ]<=0;
		white[ 144 ]<=0;
		white[ 145 ]<=0;
		white[ 146 ]<=0;
		white[ 147 ]<=0;
		white[ 148 ]<=0;
		white[ 149 ]<=0;
		white[ 150 ]<=0;
		white[ 151 ]<=0;
		white[ 152 ]<=0;
		white[ 153 ]<=0;
		white[ 154 ]<=0;
		white[ 155 ]<=0;
		white[ 156 ]<=0;
		white[ 157 ]<=0;
		white[ 158 ]<=0;
		white[ 159 ]<=0;
		white[ 160 ]<=0;
		white[ 161 ]<=0;
		white[ 162 ]<=0;
		white[ 163 ]<=0;
		white[ 164 ]<=0;
		white[ 165 ]<=0;
		white[ 166 ]<=0;
		white[ 167 ]<=0;
		white[ 168 ]<=0;
		white[ 169 ]<=0;
		white[ 170 ]<=0;
		white[ 171 ]<=0;
		white[ 172 ]<=0;
		white[ 173 ]<=0;
		white[ 174 ]<=0;
		white[ 175 ]<=0;
		white[ 176 ]<=0;
		white[ 177 ]<=0;
		white[ 178 ]<=0;
		white[ 179 ]<=0;
		white[ 180 ]<=0;
		white[ 181 ]<=0;
		white[ 182 ]<=0;
		white[ 183 ]<=0;
		white[ 184 ]<=0;
		white[ 185 ]<=0;
		white[ 186 ]<=0;
		white[ 187 ]<=0;
		white[ 188 ]<=0;
		white[ 189 ]<=0;
		white[ 190 ]<=0;
		white[ 191 ]<=1;
		white[ 192 ]<=1;
		white[ 193 ]<=1;
		white[ 194 ]<=1;
		white[ 195 ]<=1;
		white[ 196 ]<=1;
		white[ 197 ]<=0;
		white[ 198 ]<=0;
		white[ 199 ]<=0;
		white[ 200 ]<=0;
		white[ 201 ]<=0;
		white[ 202 ]<=0;
		white[ 203 ]<=0;
		white[ 204 ]<=0;
		white[ 205 ]<=0;
		white[ 206 ]<=0;
		white[ 207 ]<=0;
		white[ 208 ]<=0;
		white[ 209 ]<=0;
		white[ 210 ]<=0;
		white[ 211 ]<=0;
		white[ 212 ]<=0;
		white[ 213 ]<=0;
		white[ 214 ]<=0;
		white[ 215 ]<=0;
		white[ 216 ]<=0;
		white[ 217 ]<=0;
		white[ 218 ]<=0;
		white[ 219 ]<=0;
		white[ 220 ]<=0;
		white[ 221 ]<=0;
		white[ 222 ]<=0;
		white[ 223 ]<=1;
		white[ 224 ]<=1;
		white[ 225 ]<=1;
		white[ 226 ]<=1;
		white[ 227 ]<=1;
		white[ 228 ]<=1;
		white[ 229 ]<=0;
		white[ 230 ]<=0;
		white[ 231 ]<=0;
		white[ 232 ]<=0;
		white[ 233 ]<=0;
		white[ 234 ]<=0;
		white[ 235 ]<=0;
		white[ 236 ]<=0;
		white[ 237 ]<=0;
		white[ 238 ]<=0;
		white[ 239 ]<=0;
		white[ 240 ]<=0;
		white[ 241 ]<=0;
		white[ 242 ]<=0;
		white[ 243 ]<=0;
		white[ 244 ]<=0;
		white[ 245 ]<=0;
		white[ 246 ]<=0;
		white[ 247 ]<=0;
		white[ 248 ]<=1;
		white[ 249 ]<=1;
		white[ 250 ]<=1;
		white[ 251 ]<=1;
		white[ 252 ]<=1;
		white[ 253 ]<=1;
		white[ 254 ]<=1;
		white[ 255 ]<=1;
		white[ 256 ]<=1;
		white[ 257 ]<=1;
		white[ 258 ]<=1;
		white[ 259 ]<=1;
		white[ 260 ]<=0;
		white[ 261 ]<=0;
		white[ 262 ]<=0;
		white[ 263 ]<=0;
		white[ 264 ]<=0;
		white[ 265 ]<=0;
		white[ 266 ]<=0;
		white[ 267 ]<=0;
		white[ 268 ]<=0;
		white[ 269 ]<=0;
		white[ 270 ]<=0;
		white[ 271 ]<=0;
		white[ 272 ]<=0;
		white[ 273 ]<=0;
		white[ 274 ]<=0;
		white[ 275 ]<=0;
		white[ 276 ]<=0;
		white[ 277 ]<=0;
		white[ 278 ]<=0;
		white[ 279 ]<=0;
		white[ 280 ]<=1;
		white[ 281 ]<=1;
		white[ 282 ]<=1;
		white[ 283 ]<=1;
		white[ 284 ]<=1;
		white[ 285 ]<=1;
		white[ 286 ]<=1;
		white[ 287 ]<=1;
		white[ 288 ]<=1;
		white[ 289 ]<=1;
		white[ 290 ]<=1;
		white[ 291 ]<=1;
		white[ 292 ]<=0;
		white[ 293 ]<=0;
		white[ 294 ]<=0;
		white[ 295 ]<=0;
		white[ 296 ]<=0;
		white[ 297 ]<=0;
		white[ 298 ]<=0;
		white[ 299 ]<=0;
		white[ 300 ]<=0;
		white[ 301 ]<=0;
		white[ 302 ]<=0;
		white[ 303 ]<=0;
		white[ 304 ]<=0;
		white[ 305 ]<=0;
		white[ 306 ]<=1;
		white[ 307 ]<=1;
		white[ 308 ]<=1;
		white[ 309 ]<=1;
		white[ 310 ]<=1;
		white[ 311 ]<=1;
		white[ 312 ]<=1;
		white[ 313 ]<=1;
		white[ 314 ]<=1;
		white[ 315 ]<=1;
		white[ 316 ]<=1;
		white[ 317 ]<=1;
		white[ 318 ]<=1;
		white[ 319 ]<=1;
		white[ 320 ]<=1;
		white[ 321 ]<=1;
		white[ 322 ]<=0;
		white[ 323 ]<=0;
		white[ 324 ]<=0;
		white[ 325 ]<=0;
		white[ 326 ]<=0;
		white[ 327 ]<=0;
		white[ 328 ]<=0;
		white[ 329 ]<=0;
		white[ 330 ]<=0;
		white[ 331 ]<=0;
		white[ 332 ]<=0;
		white[ 333 ]<=0;
		white[ 334 ]<=0;
		white[ 335 ]<=0;
		white[ 336 ]<=0;
		white[ 337 ]<=0;
		white[ 338 ]<=1;
		white[ 339 ]<=1;
		white[ 340 ]<=1;
		white[ 341 ]<=1;
		white[ 342 ]<=1;
		white[ 343 ]<=1;
		white[ 344 ]<=1;
		white[ 345 ]<=1;
		white[ 346 ]<=1;
		white[ 347 ]<=1;
		white[ 348 ]<=1;
		white[ 349 ]<=1;
		white[ 350 ]<=1;
		white[ 351 ]<=1;
		white[ 352 ]<=1;
		white[ 353 ]<=0;
		white[ 354 ]<=0;
		white[ 355 ]<=0;
		white[ 356 ]<=0;
		white[ 357 ]<=0;
		white[ 358 ]<=0;
		white[ 359 ]<=0;
		white[ 360 ]<=0;
		white[ 361 ]<=0;
		white[ 362 ]<=0;
		white[ 363 ]<=0;
		white[ 364 ]<=0;
		white[ 365 ]<=1;
		white[ 366 ]<=1;
		white[ 367 ]<=1;
		white[ 368 ]<=1;
		white[ 369 ]<=1;
		white[ 370 ]<=1;
		white[ 371 ]<=1;
		white[ 372 ]<=1;
		white[ 373 ]<=1;
		white[ 374 ]<=1;
		white[ 375 ]<=1;
		white[ 376 ]<=1;
		white[ 377 ]<=1;
		white[ 378 ]<=1;
		white[ 379 ]<=1;
		white[ 380 ]<=1;
		white[ 381 ]<=1;
		white[ 382 ]<=1;
		white[ 383 ]<=1;
		white[ 384 ]<=0;
		white[ 385 ]<=0;
		white[ 386 ]<=0;
		white[ 387 ]<=0;
		white[ 388 ]<=0;
		white[ 389 ]<=0;
		white[ 390 ]<=0;
		white[ 391 ]<=0;
		white[ 392 ]<=0;
		white[ 393 ]<=0;
		white[ 394 ]<=0;
		white[ 395 ]<=0;
		white[ 396 ]<=1;
		white[ 397 ]<=1;
		white[ 398 ]<=1;
		white[ 399 ]<=1;
		white[ 400 ]<=1;
		white[ 401 ]<=1;
		white[ 402 ]<=1;
		white[ 403 ]<=1;
		white[ 404 ]<=1;
		white[ 405 ]<=1;
		white[ 406 ]<=1;
		white[ 407 ]<=1;
		white[ 408 ]<=1;
		white[ 409 ]<=1;
		white[ 410 ]<=1;
		white[ 411 ]<=1;
		white[ 412 ]<=1;
		white[ 413 ]<=1;
		white[ 414 ]<=1;
		white[ 415 ]<=0;
		white[ 416 ]<=0;
		white[ 417 ]<=0;
		white[ 418 ]<=0;
		white[ 419 ]<=0;
		white[ 420 ]<=0;
		white[ 421 ]<=0;
		white[ 422 ]<=0;
		white[ 423 ]<=0;
		white[ 424 ]<=1;
		white[ 425 ]<=1;
		white[ 426 ]<=1;
		white[ 427 ]<=1;
		white[ 428 ]<=1;
		white[ 429 ]<=1;
		white[ 430 ]<=1;
		white[ 431 ]<=1;
		white[ 432 ]<=1;
		white[ 433 ]<=1;
		white[ 434 ]<=1;
		white[ 435 ]<=1;
		white[ 436 ]<=1;
		white[ 437 ]<=1;
		white[ 438 ]<=1;
		white[ 439 ]<=1;
		white[ 440 ]<=1;
		white[ 441 ]<=1;
		white[ 442 ]<=1;
		white[ 443 ]<=1;
		white[ 444 ]<=1;
		white[ 445 ]<=0;
		white[ 446 ]<=0;
		white[ 447 ]<=0;
		white[ 448 ]<=0;
		white[ 449 ]<=0;
		white[ 450 ]<=0;
		white[ 451 ]<=0;
		white[ 452 ]<=0;
		white[ 453 ]<=0;
		white[ 454 ]<=0;
		white[ 455 ]<=1;
		white[ 456 ]<=1;
		white[ 457 ]<=1;
		white[ 458 ]<=1;
		white[ 459 ]<=1;
		white[ 460 ]<=1;
		white[ 461 ]<=1;
		white[ 462 ]<=1;
		white[ 463 ]<=1;
		white[ 464 ]<=1;
		white[ 465 ]<=1;
		white[ 466 ]<=1;
		white[ 467 ]<=1;
		white[ 468 ]<=1;
		white[ 469 ]<=1;
		white[ 470 ]<=1;
		white[ 471 ]<=1;
		white[ 472 ]<=1;
		white[ 473 ]<=1;
		white[ 474 ]<=1;
		white[ 475 ]<=1;
		white[ 476 ]<=0;
		white[ 477 ]<=0;
		white[ 478 ]<=0;
		white[ 479 ]<=0;
		white[ 480 ]<=0;
		white[ 481 ]<=0;
		white[ 482 ]<=0;
		white[ 483 ]<=1;
		white[ 484 ]<=1;
		white[ 485 ]<=1;
		white[ 486 ]<=1;
		white[ 487 ]<=1;
		white[ 488 ]<=1;
		white[ 489 ]<=1;
		white[ 490 ]<=1;
		white[ 491 ]<=1;
		white[ 492 ]<=1;
		white[ 493 ]<=1;
		white[ 494 ]<=1;
		white[ 495 ]<=1;
		white[ 496 ]<=1;
		white[ 497 ]<=1;
		white[ 498 ]<=1;
		white[ 499 ]<=1;
		white[ 500 ]<=1;
		white[ 501 ]<=1;
		white[ 502 ]<=1;
		white[ 503 ]<=1;
		white[ 504 ]<=1;
		white[ 505 ]<=1;
		white[ 506 ]<=0;
		white[ 507 ]<=0;
		white[ 508 ]<=0;
		white[ 509 ]<=0;
		white[ 510 ]<=0;
		white[ 511 ]<=0;
		white[ 512 ]<=0;
		white[ 513 ]<=0;
		white[ 514 ]<=1;
		white[ 515 ]<=1;
		white[ 516 ]<=1;
		white[ 517 ]<=1;
		white[ 518 ]<=1;
		white[ 519 ]<=1;
		white[ 520 ]<=1;
		white[ 521 ]<=1;
		white[ 522 ]<=1;
		white[ 523 ]<=1;
		white[ 524 ]<=1;
		white[ 525 ]<=1;
		white[ 526 ]<=1;
		white[ 527 ]<=1;
		white[ 528 ]<=1;
		white[ 529 ]<=1;
		white[ 530 ]<=1;
		white[ 531 ]<=1;
		white[ 532 ]<=1;
		white[ 533 ]<=1;
		white[ 534 ]<=1;
		white[ 535 ]<=1;
		white[ 536 ]<=1;
		white[ 537 ]<=0;
		white[ 538 ]<=0;
		white[ 539 ]<=0;
		white[ 540 ]<=0;
		white[ 541 ]<=0;
		white[ 542 ]<=0;
		white[ 543 ]<=1;
		white[ 544 ]<=1;
		white[ 545 ]<=1;
		white[ 546 ]<=1;
		white[ 547 ]<=1;
		white[ 548 ]<=1;
		white[ 549 ]<=1;
		white[ 550 ]<=1;
		white[ 551 ]<=1;
		white[ 552 ]<=1;
		white[ 553 ]<=1;
		white[ 554 ]<=1;
		white[ 555 ]<=1;
		white[ 556 ]<=1;
		white[ 557 ]<=1;
		white[ 558 ]<=1;
		white[ 559 ]<=1;
		white[ 560 ]<=1;
		white[ 561 ]<=1;
		white[ 562 ]<=1;
		white[ 563 ]<=1;
		white[ 564 ]<=1;
		white[ 565 ]<=1;
		white[ 566 ]<=1;
		white[ 567 ]<=0;
		white[ 568 ]<=0;
		white[ 569 ]<=0;
		white[ 570 ]<=0;
		white[ 571 ]<=0;
		white[ 572 ]<=0;
		white[ 573 ]<=1;
		white[ 574 ]<=1;
		white[ 575 ]<=1;
		white[ 576 ]<=1;
		white[ 577 ]<=1;
		white[ 578 ]<=1;
		white[ 579 ]<=1;
		white[ 580 ]<=1;
		white[ 581 ]<=1;
		white[ 582 ]<=1;
		white[ 583 ]<=1;
		white[ 584 ]<=1;
		white[ 585 ]<=1;
		white[ 586 ]<=1;
		white[ 587 ]<=1;
		white[ 588 ]<=1;
		white[ 589 ]<=1;
		white[ 590 ]<=1;
		white[ 591 ]<=1;
		white[ 592 ]<=1;
		white[ 593 ]<=1;
		white[ 594 ]<=1;
		white[ 595 ]<=1;
		white[ 596 ]<=1;
		white[ 597 ]<=0;
		white[ 598 ]<=0;
		white[ 599 ]<=0;
		white[ 600 ]<=0;
		white[ 601 ]<=0;
		white[ 602 ]<=1;
		white[ 603 ]<=1;
		white[ 604 ]<=1;
		white[ 605 ]<=1;
		white[ 606 ]<=1;
		white[ 607 ]<=1;
		white[ 608 ]<=1;
		white[ 609 ]<=1;
		white[ 610 ]<=1;
		white[ 611 ]<=1;
		white[ 612 ]<=1;
		white[ 613 ]<=1;
		white[ 614 ]<=1;
		white[ 615 ]<=1;
		white[ 616 ]<=1;
		white[ 617 ]<=1;
		white[ 618 ]<=1;
		white[ 619 ]<=1;
		white[ 620 ]<=1;
		white[ 621 ]<=1;
		white[ 622 ]<=1;
		white[ 623 ]<=1;
		white[ 624 ]<=1;
		white[ 625 ]<=1;
		white[ 626 ]<=1;
		white[ 627 ]<=1;
		white[ 628 ]<=0;
		white[ 629 ]<=0;
		white[ 630 ]<=0;
		white[ 631 ]<=0;
		white[ 632 ]<=1;
		white[ 633 ]<=1;
		white[ 634 ]<=1;
		white[ 635 ]<=1;
		white[ 636 ]<=1;
		white[ 637 ]<=1;
		white[ 638 ]<=1;
		white[ 639 ]<=1;
		white[ 640 ]<=1;
		white[ 641 ]<=1;
		white[ 642 ]<=1;
		white[ 643 ]<=1;
		white[ 644 ]<=1;
		white[ 645 ]<=1;
		white[ 646 ]<=1;
		white[ 647 ]<=1;
		white[ 648 ]<=1;
		white[ 649 ]<=1;
		white[ 650 ]<=1;
		white[ 651 ]<=1;
		white[ 652 ]<=1;
		white[ 653 ]<=1;
		white[ 654 ]<=1;
		white[ 655 ]<=1;
		white[ 656 ]<=1;
		white[ 657 ]<=1;
		white[ 658 ]<=0;
		white[ 659 ]<=0;
		white[ 660 ]<=0;
		white[ 661 ]<=0;
		white[ 662 ]<=1;
		white[ 663 ]<=1;
		white[ 664 ]<=1;
		white[ 665 ]<=1;
		white[ 666 ]<=1;
		white[ 667 ]<=1;
		white[ 668 ]<=1;
		white[ 669 ]<=1;
		white[ 670 ]<=1;
		white[ 671 ]<=1;
		white[ 672 ]<=1;
		white[ 673 ]<=1;
		white[ 674 ]<=1;
		white[ 675 ]<=1;
		white[ 676 ]<=1;
		white[ 677 ]<=1;
		white[ 678 ]<=1;
		white[ 679 ]<=1;
		white[ 680 ]<=1;
		white[ 681 ]<=1;
		white[ 682 ]<=1;
		white[ 683 ]<=1;
		white[ 684 ]<=1;
		white[ 685 ]<=1;
		white[ 686 ]<=1;
		white[ 687 ]<=1;
		white[ 688 ]<=1;
		white[ 689 ]<=0;
		white[ 690 ]<=0;
		white[ 691 ]<=1;
		white[ 692 ]<=1;
		white[ 693 ]<=1;
		white[ 694 ]<=1;
		white[ 695 ]<=1;
		white[ 696 ]<=1;
		white[ 697 ]<=1;
		white[ 698 ]<=1;
		white[ 699 ]<=1;
		white[ 700 ]<=1;
		white[ 701 ]<=1;
		white[ 702 ]<=1;
		white[ 703 ]<=1;
		white[ 704 ]<=1;
		white[ 705 ]<=1;
		white[ 706 ]<=1;
		white[ 707 ]<=1;
		white[ 708 ]<=1;
		white[ 709 ]<=1;
		white[ 710 ]<=1;
		white[ 711 ]<=1;
		white[ 712 ]<=1;
		white[ 713 ]<=1;
		white[ 714 ]<=1;
		white[ 715 ]<=1;
		white[ 716 ]<=1;
		white[ 717 ]<=1;
		white[ 718 ]<=0;
		white[ 719 ]<=0;
		white[ 720 ]<=0;
		white[ 721 ]<=0;
		white[ 722 ]<=1;
		white[ 723 ]<=1;
		white[ 724 ]<=1;
		white[ 725 ]<=1;
		white[ 726 ]<=1;
		white[ 727 ]<=1;
		white[ 728 ]<=1;
		white[ 729 ]<=1;
		white[ 730 ]<=1;
		white[ 731 ]<=1;
		white[ 732 ]<=1;
		white[ 733 ]<=1;
		white[ 734 ]<=1;
		white[ 735 ]<=1;
		white[ 736 ]<=1;
		white[ 737 ]<=1;
		white[ 738 ]<=1;
		white[ 739 ]<=1;
		white[ 740 ]<=1;
		white[ 741 ]<=1;
		white[ 742 ]<=1;
		white[ 743 ]<=1;
		white[ 744 ]<=1;
		white[ 745 ]<=1;
		white[ 746 ]<=1;
		white[ 747 ]<=1;
		white[ 748 ]<=1;
		white[ 749 ]<=1;
		white[ 750 ]<=1;
		white[ 751 ]<=1;
		white[ 752 ]<=1;
		white[ 753 ]<=1;
		white[ 754 ]<=1;
		white[ 755 ]<=1;
		white[ 756 ]<=1;
		white[ 757 ]<=1;
		white[ 758 ]<=1;
		white[ 759 ]<=1;
		white[ 760 ]<=1;
		white[ 761 ]<=1;
		white[ 762 ]<=1;
		white[ 763 ]<=1;
		white[ 764 ]<=1;
		white[ 765 ]<=1;
		white[ 766 ]<=1;
		white[ 767 ]<=1;
		white[ 768 ]<=1;
		white[ 769 ]<=1;
		white[ 770 ]<=1;
		white[ 771 ]<=1;
		white[ 772 ]<=1;
		white[ 773 ]<=1;
		white[ 774 ]<=1;
		white[ 775 ]<=1;
		white[ 776 ]<=1;
		white[ 777 ]<=1;
		white[ 778 ]<=0;
		white[ 779 ]<=0;
		white[ 780 ]<=0;
		white[ 781 ]<=1;
		white[ 782 ]<=1;
		white[ 783 ]<=1;
		white[ 784 ]<=1;
		white[ 785 ]<=1;
		white[ 786 ]<=1;
		white[ 787 ]<=1;
		white[ 788 ]<=1;
		white[ 789 ]<=1;
		white[ 790 ]<=1;
		white[ 791 ]<=1;
		white[ 792 ]<=1;
		white[ 793 ]<=1;
		white[ 794 ]<=1;
		white[ 795 ]<=1;
		white[ 796 ]<=1;
		white[ 797 ]<=1;
		white[ 798 ]<=1;
		white[ 799 ]<=1;
		white[ 800 ]<=1;
		white[ 801 ]<=1;
		white[ 802 ]<=1;
		white[ 803 ]<=1;
		white[ 804 ]<=1;
		white[ 805 ]<=1;
		white[ 806 ]<=1;
		white[ 807 ]<=1;
		white[ 808 ]<=1;
		white[ 809 ]<=1;
		white[ 810 ]<=1;
		white[ 811 ]<=1;
		white[ 812 ]<=1;
		white[ 813 ]<=1;
		white[ 814 ]<=1;
		white[ 815 ]<=1;
		white[ 816 ]<=1;
		white[ 817 ]<=1;
		white[ 818 ]<=1;
		white[ 819 ]<=1;
		white[ 820 ]<=1;
		white[ 821 ]<=1;
		white[ 822 ]<=1;
		white[ 823 ]<=1;
		white[ 824 ]<=1;
		white[ 825 ]<=1;
		white[ 826 ]<=1;
		white[ 827 ]<=1;
		white[ 828 ]<=1;
		white[ 829 ]<=1;
		white[ 830 ]<=1;
		white[ 831 ]<=1;
		white[ 832 ]<=1;
		white[ 833 ]<=1;
		white[ 834 ]<=1;
		white[ 835 ]<=1;
		white[ 836 ]<=1;
		white[ 837 ]<=1;
		white[ 838 ]<=0;
		white[ 839 ]<=0;
		white[ 840 ]<=0;
		white[ 841 ]<=1;
		white[ 842 ]<=1;
		white[ 843 ]<=1;
		white[ 844 ]<=1;
		white[ 845 ]<=1;
		white[ 846 ]<=1;
		white[ 847 ]<=1;
		white[ 848 ]<=1;
		white[ 849 ]<=1;
		white[ 850 ]<=1;
		white[ 851 ]<=1;
		white[ 852 ]<=1;
		white[ 853 ]<=1;
		white[ 854 ]<=1;
		white[ 855 ]<=1;
		white[ 856 ]<=1;
		white[ 857 ]<=1;
		white[ 858 ]<=1;
		white[ 859 ]<=1;
		white[ 860 ]<=1;
		white[ 861 ]<=1;
		white[ 862 ]<=1;
		white[ 863 ]<=1;
		white[ 864 ]<=1;
		white[ 865 ]<=1;
		white[ 866 ]<=1;
		white[ 867 ]<=1;
		white[ 868 ]<=1;
		white[ 869 ]<=1;
		white[ 870 ]<=1;
		white[ 871 ]<=1;
		white[ 872 ]<=1;
		white[ 873 ]<=1;
		white[ 874 ]<=1;
		white[ 875 ]<=1;
		white[ 876 ]<=1;
		white[ 877 ]<=1;
		white[ 878 ]<=1;
		white[ 879 ]<=1;
		white[ 880 ]<=1;
		white[ 881 ]<=1;
		white[ 882 ]<=1;
		white[ 883 ]<=1;
		white[ 884 ]<=1;
		white[ 885 ]<=1;
		white[ 886 ]<=1;
		white[ 887 ]<=1;
		white[ 888 ]<=1;
		white[ 889 ]<=1;
		white[ 890 ]<=1;
		white[ 891 ]<=1;
		white[ 892 ]<=1;
		white[ 893 ]<=1;
		white[ 894 ]<=1;
		white[ 895 ]<=1;
		white[ 896 ]<=1;
		white[ 897 ]<=1;
		white[ 898 ]<=1;
		white[ 899 ]<=0;
		white[ 900 ]<=0;
		white[ 901 ]<=1;
		white[ 902 ]<=1;
		white[ 903 ]<=1;
		white[ 904 ]<=1;
		white[ 905 ]<=1;
		white[ 906 ]<=1;
		white[ 907 ]<=1;
		white[ 908 ]<=1;
		white[ 909 ]<=1;
		white[ 910 ]<=1;
		white[ 911 ]<=1;
		white[ 912 ]<=1;
		white[ 913 ]<=1;
		white[ 914 ]<=1;
		white[ 915 ]<=1;
		white[ 916 ]<=1;
		white[ 917 ]<=1;
		white[ 918 ]<=1;
		white[ 919 ]<=1;
		white[ 920 ]<=1;
		white[ 921 ]<=1;
		white[ 922 ]<=1;
		white[ 923 ]<=1;
		white[ 924 ]<=1;
		white[ 925 ]<=1;
		white[ 926 ]<=1;
		white[ 927 ]<=1;
		white[ 928 ]<=1;
		white[ 929 ]<=1;
		white[ 930 ]<=1;
		white[ 931 ]<=1;
		white[ 932 ]<=1;
		white[ 933 ]<=1;
		white[ 934 ]<=1;
		white[ 935 ]<=1;
		white[ 936 ]<=1;
		white[ 937 ]<=1;
		white[ 938 ]<=1;
		white[ 939 ]<=1;
		white[ 940 ]<=1;
		white[ 941 ]<=1;
		white[ 942 ]<=1;
		white[ 943 ]<=1;
		white[ 944 ]<=1;
		white[ 945 ]<=1;
		white[ 946 ]<=1;
		white[ 947 ]<=1;
		white[ 948 ]<=1;
		white[ 949 ]<=1;
		white[ 950 ]<=1;
		white[ 951 ]<=1;
		white[ 952 ]<=1;
		white[ 953 ]<=1;
		white[ 954 ]<=1;
		white[ 955 ]<=1;
		white[ 956 ]<=1;
		white[ 957 ]<=1;
		white[ 958 ]<=1;
		white[ 959 ]<=0;
		white[ 960 ]<=0;
		white[ 961 ]<=1;
		white[ 962 ]<=1;
		white[ 963 ]<=1;
		white[ 964 ]<=1;
		white[ 965 ]<=1;
		white[ 966 ]<=1;
		white[ 967 ]<=1;
		white[ 968 ]<=1;
		white[ 969 ]<=1;
		white[ 970 ]<=1;
		white[ 971 ]<=1;
		white[ 972 ]<=1;
		white[ 973 ]<=1;
		white[ 974 ]<=1;
		white[ 975 ]<=1;
		white[ 976 ]<=1;
		white[ 977 ]<=1;
		white[ 978 ]<=1;
		white[ 979 ]<=1;
		white[ 980 ]<=1;
		white[ 981 ]<=1;
		white[ 982 ]<=1;
		white[ 983 ]<=1;
		white[ 984 ]<=1;
		white[ 985 ]<=1;
		white[ 986 ]<=1;
		white[ 987 ]<=1;
		white[ 988 ]<=1;
		white[ 989 ]<=1;
		white[ 990 ]<=1;
		white[ 991 ]<=1;
		white[ 992 ]<=1;
		white[ 993 ]<=1;
		white[ 994 ]<=1;
		white[ 995 ]<=1;
		white[ 996 ]<=1;
		white[ 997 ]<=1;
		white[ 998 ]<=1;
		white[ 999 ]<=1;
		white[ 1000 ]<=1;
		white[ 1001 ]<=1;
		white[ 1002 ]<=1;
		white[ 1003 ]<=1;
		white[ 1004 ]<=1;
		white[ 1005 ]<=1;
		white[ 1006 ]<=1;
		white[ 1007 ]<=1;
		white[ 1008 ]<=1;
		white[ 1009 ]<=1;
		white[ 1010 ]<=1;
		white[ 1011 ]<=1;
		white[ 1012 ]<=1;
		white[ 1013 ]<=1;
		white[ 1014 ]<=1;
		white[ 1015 ]<=1;
		white[ 1016 ]<=1;
		white[ 1017 ]<=1;
		white[ 1018 ]<=1;
		white[ 1019 ]<=0;
		white[ 1020 ]<=0;
		white[ 1021 ]<=1;
		white[ 1022 ]<=1;
		white[ 1023 ]<=1;
		white[ 1024 ]<=1;
		white[ 1025 ]<=1;
		white[ 1026 ]<=1;
		white[ 1027 ]<=1;
		white[ 1028 ]<=1;
		white[ 1029 ]<=1;
		white[ 1030 ]<=1;
		white[ 1031 ]<=1;
		white[ 1032 ]<=1;
		white[ 1033 ]<=1;
		white[ 1034 ]<=1;
		white[ 1035 ]<=1;
		white[ 1036 ]<=1;
		white[ 1037 ]<=1;
		white[ 1038 ]<=1;
		white[ 1039 ]<=1;
		white[ 1040 ]<=1;
		white[ 1041 ]<=1;
		white[ 1042 ]<=1;
		white[ 1043 ]<=1;
		white[ 1044 ]<=1;
		white[ 1045 ]<=1;
		white[ 1046 ]<=1;
		white[ 1047 ]<=1;
		white[ 1048 ]<=1;
		white[ 1049 ]<=1;
		white[ 1050 ]<=1;
		white[ 1051 ]<=1;
		white[ 1052 ]<=1;
		white[ 1053 ]<=1;
		white[ 1054 ]<=1;
		white[ 1055 ]<=1;
		white[ 1056 ]<=1;
		white[ 1057 ]<=1;
		white[ 1058 ]<=1;
		white[ 1059 ]<=1;
		white[ 1060 ]<=1;
		white[ 1061 ]<=1;
		white[ 1062 ]<=1;
		white[ 1063 ]<=1;
		white[ 1064 ]<=1;
		white[ 1065 ]<=1;
		white[ 1066 ]<=1;
		white[ 1067 ]<=1;
		white[ 1068 ]<=1;
		white[ 1069 ]<=1;
		white[ 1070 ]<=1;
		white[ 1071 ]<=1;
		white[ 1072 ]<=1;
		white[ 1073 ]<=1;
		white[ 1074 ]<=1;
		white[ 1075 ]<=1;
		white[ 1076 ]<=1;
		white[ 1077 ]<=1;
		white[ 1078 ]<=1;
		white[ 1079 ]<=0;
		white[ 1080 ]<=0;
		white[ 1081 ]<=1;
		white[ 1082 ]<=1;
		white[ 1083 ]<=1;
		white[ 1084 ]<=1;
		white[ 1085 ]<=1;
		white[ 1086 ]<=1;
		white[ 1087 ]<=1;
		white[ 1088 ]<=1;
		white[ 1089 ]<=1;
		white[ 1090 ]<=1;
		white[ 1091 ]<=1;
		white[ 1092 ]<=1;
		white[ 1093 ]<=1;
		white[ 1094 ]<=1;
		white[ 1095 ]<=1;
		white[ 1096 ]<=1;
		white[ 1097 ]<=1;
		white[ 1098 ]<=1;
		white[ 1099 ]<=1;
		white[ 1100 ]<=1;
		white[ 1101 ]<=1;
		white[ 1102 ]<=1;
		white[ 1103 ]<=1;
		white[ 1104 ]<=1;
		white[ 1105 ]<=1;
		white[ 1106 ]<=1;
		white[ 1107 ]<=1;
		white[ 1108 ]<=1;
		white[ 1109 ]<=1;
		white[ 1110 ]<=1;
		white[ 1111 ]<=1;
		white[ 1112 ]<=1;
		white[ 1113 ]<=1;
		white[ 1114 ]<=1;
		white[ 1115 ]<=1;
		white[ 1116 ]<=1;
		white[ 1117 ]<=1;
		white[ 1118 ]<=1;
		white[ 1119 ]<=1;
		white[ 1120 ]<=1;
		white[ 1121 ]<=1;
		white[ 1122 ]<=1;
		white[ 1123 ]<=1;
		white[ 1124 ]<=1;
		white[ 1125 ]<=1;
		white[ 1126 ]<=1;
		white[ 1127 ]<=1;
		white[ 1128 ]<=1;
		white[ 1129 ]<=1;
		white[ 1130 ]<=1;
		white[ 1131 ]<=1;
		white[ 1132 ]<=1;
		white[ 1133 ]<=1;
		white[ 1134 ]<=1;
		white[ 1135 ]<=1;
		white[ 1136 ]<=1;
		white[ 1137 ]<=1;
		white[ 1138 ]<=0;
		white[ 1139 ]<=0;
		white[ 1140 ]<=0;
		white[ 1141 ]<=0;
		white[ 1142 ]<=1;
		white[ 1143 ]<=1;
		white[ 1144 ]<=1;
		white[ 1145 ]<=1;
		white[ 1146 ]<=1;
		white[ 1147 ]<=1;
		white[ 1148 ]<=1;
		white[ 1149 ]<=1;
		white[ 1150 ]<=1;
		white[ 1151 ]<=1;
		white[ 1152 ]<=1;
		white[ 1153 ]<=1;
		white[ 1154 ]<=1;
		white[ 1155 ]<=1;
		white[ 1156 ]<=1;
		white[ 1157 ]<=1;
		white[ 1158 ]<=1;
		white[ 1159 ]<=1;
		white[ 1160 ]<=1;
		white[ 1161 ]<=1;
		white[ 1162 ]<=1;
		white[ 1163 ]<=1;
		white[ 1164 ]<=1;
		white[ 1165 ]<=1;
		white[ 1166 ]<=1;
		white[ 1167 ]<=1;
		white[ 1168 ]<=1;
		white[ 1169 ]<=1;
		white[ 1170 ]<=1;
		white[ 1171 ]<=1;
		white[ 1172 ]<=1;
		white[ 1173 ]<=1;
		white[ 1174 ]<=1;
		white[ 1175 ]<=1;
		white[ 1176 ]<=1;
		white[ 1177 ]<=1;
		white[ 1178 ]<=1;
		white[ 1179 ]<=1;
		white[ 1180 ]<=1;
		white[ 1181 ]<=1;
		white[ 1182 ]<=1;
		white[ 1183 ]<=1;
		white[ 1184 ]<=1;
		white[ 1185 ]<=1;
		white[ 1186 ]<=1;
		white[ 1187 ]<=1;
		white[ 1188 ]<=1;
		white[ 1189 ]<=1;
		white[ 1190 ]<=1;
		white[ 1191 ]<=1;
		white[ 1192 ]<=1;
		white[ 1193 ]<=1;
		white[ 1194 ]<=1;
		white[ 1195 ]<=1;
		white[ 1196 ]<=1;
		white[ 1197 ]<=1;
		white[ 1198 ]<=0;
		white[ 1199 ]<=0;
		white[ 1200 ]<=0;
		white[ 1201 ]<=0;
		white[ 1202 ]<=1;
		white[ 1203 ]<=1;
		white[ 1204 ]<=1;
		white[ 1205 ]<=1;
		white[ 1206 ]<=1;
		white[ 1207 ]<=1;
		white[ 1208 ]<=1;
		white[ 1209 ]<=1;
		white[ 1210 ]<=1;
		white[ 1211 ]<=1;
		white[ 1212 ]<=1;
		white[ 1213 ]<=1;
		white[ 1214 ]<=1;
		white[ 1215 ]<=1;
		white[ 1216 ]<=1;
		white[ 1217 ]<=1;
		white[ 1218 ]<=1;
		white[ 1219 ]<=1;
		white[ 1220 ]<=1;
		white[ 1221 ]<=1;
		white[ 1222 ]<=1;
		white[ 1223 ]<=1;
		white[ 1224 ]<=1;
		white[ 1225 ]<=1;
		white[ 1226 ]<=1;
		white[ 1227 ]<=1;
		white[ 1228 ]<=1;
		white[ 1229 ]<=1;
		white[ 1230 ]<=1;
		white[ 1231 ]<=1;
		white[ 1232 ]<=1;
		white[ 1233 ]<=1;
		white[ 1234 ]<=1;
		white[ 1235 ]<=1;
		white[ 1236 ]<=1;
		white[ 1237 ]<=1;
		white[ 1238 ]<=1;
		white[ 1239 ]<=1;
		white[ 1240 ]<=1;
		white[ 1241 ]<=1;
		white[ 1242 ]<=1;
		white[ 1243 ]<=1;
		white[ 1244 ]<=1;
		white[ 1245 ]<=1;
		white[ 1246 ]<=1;
		white[ 1247 ]<=1;
		white[ 1248 ]<=1;
		white[ 1249 ]<=1;
		white[ 1250 ]<=1;
		white[ 1251 ]<=1;
		white[ 1252 ]<=1;
		white[ 1253 ]<=1;
		white[ 1254 ]<=1;
		white[ 1255 ]<=1;
		white[ 1256 ]<=1;
		white[ 1257 ]<=1;
		white[ 1258 ]<=0;
		white[ 1259 ]<=0;
		white[ 1260 ]<=0;
		white[ 1261 ]<=0;
		white[ 1262 ]<=1;
		white[ 1263 ]<=1;
		white[ 1264 ]<=1;
		white[ 1265 ]<=1;
		white[ 1266 ]<=1;
		white[ 1267 ]<=1;
		white[ 1268 ]<=1;
		white[ 1269 ]<=1;
		white[ 1270 ]<=1;
		white[ 1271 ]<=1;
		white[ 1272 ]<=1;
		white[ 1273 ]<=1;
		white[ 1274 ]<=1;
		white[ 1275 ]<=1;
		white[ 1276 ]<=1;
		white[ 1277 ]<=1;
		white[ 1278 ]<=1;
		white[ 1279 ]<=1;
		white[ 1280 ]<=1;
		white[ 1281 ]<=1;
		white[ 1282 ]<=1;
		white[ 1283 ]<=1;
		white[ 1284 ]<=1;
		white[ 1285 ]<=1;
		white[ 1286 ]<=1;
		white[ 1287 ]<=1;
		white[ 1288 ]<=1;
		white[ 1289 ]<=1;
		white[ 1290 ]<=1;
		white[ 1291 ]<=1;
		white[ 1292 ]<=1;
		white[ 1293 ]<=1;
		white[ 1294 ]<=1;
		white[ 1295 ]<=1;
		white[ 1296 ]<=1;
		white[ 1297 ]<=1;
		white[ 1298 ]<=1;
		white[ 1299 ]<=1;
		white[ 1300 ]<=1;
		white[ 1301 ]<=1;
		white[ 1302 ]<=1;
		white[ 1303 ]<=1;
		white[ 1304 ]<=1;
		white[ 1305 ]<=1;
		white[ 1306 ]<=1;
		white[ 1307 ]<=1;
		white[ 1308 ]<=1;
		white[ 1309 ]<=1;
		white[ 1310 ]<=1;
		white[ 1311 ]<=1;
		white[ 1312 ]<=1;
		white[ 1313 ]<=1;
		white[ 1314 ]<=1;
		white[ 1315 ]<=1;
		white[ 1316 ]<=1;
		white[ 1317 ]<=1;
		white[ 1318 ]<=0;
		white[ 1319 ]<=0;
		white[ 1320 ]<=0;
		white[ 1321 ]<=0;
		white[ 1322 ]<=1;
		white[ 1323 ]<=1;
		white[ 1324 ]<=1;
		white[ 1325 ]<=1;
		white[ 1326 ]<=1;
		white[ 1327 ]<=1;
		white[ 1328 ]<=1;
		white[ 1329 ]<=1;
		white[ 1330 ]<=1;
		white[ 1331 ]<=1;
		white[ 1332 ]<=1;
		white[ 1333 ]<=1;
		white[ 1334 ]<=1;
		white[ 1335 ]<=1;
		white[ 1336 ]<=1;
		white[ 1337 ]<=1;
		white[ 1338 ]<=1;
		white[ 1339 ]<=1;
		white[ 1340 ]<=1;
		white[ 1341 ]<=1;
		white[ 1342 ]<=1;
		white[ 1343 ]<=1;
		white[ 1344 ]<=1;
		white[ 1345 ]<=1;
		white[ 1346 ]<=1;
		white[ 1347 ]<=1;
		white[ 1348 ]<=1;
		white[ 1349 ]<=1;
		white[ 1350 ]<=1;
		white[ 1351 ]<=1;
		white[ 1352 ]<=1;
		white[ 1353 ]<=1;
		white[ 1354 ]<=1;
		white[ 1355 ]<=1;
		white[ 1356 ]<=1;
		white[ 1357 ]<=1;
		white[ 1358 ]<=1;
		white[ 1359 ]<=1;
		white[ 1360 ]<=1;
		white[ 1361 ]<=1;
		white[ 1362 ]<=1;
		white[ 1363 ]<=1;
		white[ 1364 ]<=1;
		white[ 1365 ]<=1;
		white[ 1366 ]<=1;
		white[ 1367 ]<=1;
		white[ 1368 ]<=1;
		white[ 1369 ]<=1;
		white[ 1370 ]<=1;
		white[ 1371 ]<=1;
		white[ 1372 ]<=1;
		white[ 1373 ]<=1;
		white[ 1374 ]<=1;
		white[ 1375 ]<=1;
		white[ 1376 ]<=1;
		white[ 1377 ]<=0;
		white[ 1378 ]<=0;
		white[ 1379 ]<=0;
		white[ 1380 ]<=0;
		white[ 1381 ]<=0;
		white[ 1382 ]<=0;
		white[ 1383 ]<=1;
		white[ 1384 ]<=1;
		white[ 1385 ]<=1;
		white[ 1386 ]<=1;
		white[ 1387 ]<=1;
		white[ 1388 ]<=1;
		white[ 1389 ]<=1;
		white[ 1390 ]<=1;
		white[ 1391 ]<=1;
		white[ 1392 ]<=1;
		white[ 1393 ]<=1;
		white[ 1394 ]<=1;
		white[ 1395 ]<=1;
		white[ 1396 ]<=1;
		white[ 1397 ]<=1;
		white[ 1398 ]<=1;
		white[ 1399 ]<=1;
		white[ 1400 ]<=1;
		white[ 1401 ]<=1;
		white[ 1402 ]<=1;
		white[ 1403 ]<=1;
		white[ 1404 ]<=1;
		white[ 1405 ]<=1;
		white[ 1406 ]<=1;
		white[ 1407 ]<=1;
		white[ 1408 ]<=1;
		white[ 1409 ]<=1;
		white[ 1410 ]<=1;
		white[ 1411 ]<=1;
		white[ 1412 ]<=1;
		white[ 1413 ]<=1;
		white[ 1414 ]<=1;
		white[ 1415 ]<=1;
		white[ 1416 ]<=1;
		white[ 1417 ]<=1;
		white[ 1418 ]<=1;
		white[ 1419 ]<=1;
		white[ 1420 ]<=1;
		white[ 1421 ]<=1;
		white[ 1422 ]<=1;
		white[ 1423 ]<=1;
		white[ 1424 ]<=1;
		white[ 1425 ]<=1;
		white[ 1426 ]<=1;
		white[ 1427 ]<=1;
		white[ 1428 ]<=1;
		white[ 1429 ]<=1;
		white[ 1430 ]<=1;
		white[ 1431 ]<=1;
		white[ 1432 ]<=1;
		white[ 1433 ]<=1;
		white[ 1434 ]<=1;
		white[ 1435 ]<=1;
		white[ 1436 ]<=1;
		white[ 1437 ]<=0;
		white[ 1438 ]<=0;
		white[ 1439 ]<=0;
		white[ 1440 ]<=0;
		white[ 1441 ]<=0;
		white[ 1442 ]<=0;
		white[ 1443 ]<=1;
		white[ 1444 ]<=1;
		white[ 1445 ]<=1;
		white[ 1446 ]<=1;
		white[ 1447 ]<=1;
		white[ 1448 ]<=1;
		white[ 1449 ]<=1;
		white[ 1450 ]<=1;
		white[ 1451 ]<=1;
		white[ 1452 ]<=1;
		white[ 1453 ]<=1;
		white[ 1454 ]<=1;
		white[ 1455 ]<=1;
		white[ 1456 ]<=1;
		white[ 1457 ]<=1;
		white[ 1458 ]<=1;
		white[ 1459 ]<=1;
		white[ 1460 ]<=1;
		white[ 1461 ]<=1;
		white[ 1462 ]<=1;
		white[ 1463 ]<=1;
		white[ 1464 ]<=1;
		white[ 1465 ]<=1;
		white[ 1466 ]<=1;
		white[ 1467 ]<=1;
		white[ 1468 ]<=1;
		white[ 1469 ]<=1;
		white[ 1470 ]<=1;
		white[ 1471 ]<=1;
		white[ 1472 ]<=1;
		white[ 1473 ]<=1;
		white[ 1474 ]<=1;
		white[ 1475 ]<=1;
		white[ 1476 ]<=1;
		white[ 1477 ]<=1;
		white[ 1478 ]<=1;
		white[ 1479 ]<=1;
		white[ 1480 ]<=1;
		white[ 1481 ]<=1;
		white[ 1482 ]<=1;
		white[ 1483 ]<=1;
		white[ 1484 ]<=1;
		white[ 1485 ]<=1;
		white[ 1486 ]<=1;
		white[ 1487 ]<=1;
		white[ 1488 ]<=1;
		white[ 1489 ]<=1;
		white[ 1490 ]<=1;
		white[ 1491 ]<=1;
		white[ 1492 ]<=1;
		white[ 1493 ]<=1;
		white[ 1494 ]<=1;
		white[ 1495 ]<=1;
		white[ 1496 ]<=1;
		white[ 1497 ]<=0;
		white[ 1498 ]<=0;
		white[ 1499 ]<=0;
		white[ 1500 ]<=0;
		white[ 1501 ]<=0;
		white[ 1502 ]<=0;
		white[ 1503 ]<=0;
		white[ 1504 ]<=1;
		white[ 1505 ]<=1;
		white[ 1506 ]<=1;
		white[ 1507 ]<=1;
		white[ 1508 ]<=1;
		white[ 1509 ]<=1;
		white[ 1510 ]<=1;
		white[ 1511 ]<=1;
		white[ 1512 ]<=1;
		white[ 1513 ]<=1;
		white[ 1514 ]<=1;
		white[ 1515 ]<=1;
		white[ 1516 ]<=1;
		white[ 1517 ]<=1;
		white[ 1518 ]<=1;
		white[ 1519 ]<=1;
		white[ 1520 ]<=1;
		white[ 1521 ]<=1;
		white[ 1522 ]<=1;
		white[ 1523 ]<=1;
		white[ 1524 ]<=1;
		white[ 1525 ]<=1;
		white[ 1526 ]<=1;
		white[ 1527 ]<=1;
		white[ 1528 ]<=1;
		white[ 1529 ]<=1;
		white[ 1530 ]<=1;
		white[ 1531 ]<=1;
		white[ 1532 ]<=1;
		white[ 1533 ]<=1;
		white[ 1534 ]<=1;
		white[ 1535 ]<=1;
		white[ 1536 ]<=1;
		white[ 1537 ]<=1;
		white[ 1538 ]<=1;
		white[ 1539 ]<=1;
		white[ 1540 ]<=1;
		white[ 1541 ]<=1;
		white[ 1542 ]<=1;
		white[ 1543 ]<=1;
		white[ 1544 ]<=1;
		white[ 1545 ]<=1;
		white[ 1546 ]<=1;
		white[ 1547 ]<=1;
		white[ 1548 ]<=1;
		white[ 1549 ]<=1;
		white[ 1550 ]<=1;
		white[ 1551 ]<=1;
		white[ 1552 ]<=1;
		white[ 1553 ]<=1;
		white[ 1554 ]<=1;
		white[ 1555 ]<=1;
		white[ 1556 ]<=0;
		white[ 1557 ]<=0;
		white[ 1558 ]<=0;
		white[ 1559 ]<=0;
		white[ 1560 ]<=0;
		white[ 1561 ]<=0;
		white[ 1562 ]<=0;
		white[ 1563 ]<=0;
		white[ 1564 ]<=1;
		white[ 1565 ]<=1;
		white[ 1566 ]<=1;
		white[ 1567 ]<=1;
		white[ 1568 ]<=1;
		white[ 1569 ]<=1;
		white[ 1570 ]<=1;
		white[ 1571 ]<=1;
		white[ 1572 ]<=1;
		white[ 1573 ]<=1;
		white[ 1574 ]<=1;
		white[ 1575 ]<=1;
		white[ 1576 ]<=1;
		white[ 1577 ]<=1;
		white[ 1578 ]<=1;
		white[ 1579 ]<=1;
		white[ 1580 ]<=1;
		white[ 1581 ]<=1;
		white[ 1582 ]<=1;
		white[ 1583 ]<=1;
		white[ 1584 ]<=1;
		white[ 1585 ]<=1;
		white[ 1586 ]<=1;
		white[ 1587 ]<=1;
		white[ 1588 ]<=1;
		white[ 1589 ]<=1;
		white[ 1590 ]<=1;
		white[ 1591 ]<=1;
		white[ 1592 ]<=1;
		white[ 1593 ]<=1;
		white[ 1594 ]<=1;
		white[ 1595 ]<=1;
		white[ 1596 ]<=1;
		white[ 1597 ]<=1;
		white[ 1598 ]<=1;
		white[ 1599 ]<=1;
		white[ 1600 ]<=1;
		white[ 1601 ]<=1;
		white[ 1602 ]<=1;
		white[ 1603 ]<=1;
		white[ 1604 ]<=1;
		white[ 1605 ]<=1;
		white[ 1606 ]<=1;
		white[ 1607 ]<=1;
		white[ 1608 ]<=1;
		white[ 1609 ]<=1;
		white[ 1610 ]<=1;
		white[ 1611 ]<=1;
		white[ 1612 ]<=1;
		white[ 1613 ]<=1;
		white[ 1614 ]<=1;
		white[ 1615 ]<=1;
		white[ 1616 ]<=0;
		white[ 1617 ]<=0;
		white[ 1618 ]<=0;
		white[ 1619 ]<=0;
		white[ 1620 ]<=0;
		white[ 1621 ]<=0;
		white[ 1622 ]<=0;
		white[ 1623 ]<=0;
		white[ 1624 ]<=1;
		white[ 1625 ]<=1;
		white[ 1626 ]<=1;
		white[ 1627 ]<=1;
		white[ 1628 ]<=1;
		white[ 1629 ]<=1;
		white[ 1630 ]<=1;
		white[ 1631 ]<=1;
		white[ 1632 ]<=1;
		white[ 1633 ]<=1;
		white[ 1634 ]<=1;
		white[ 1635 ]<=1;
		white[ 1636 ]<=1;
		white[ 1637 ]<=1;
		white[ 1638 ]<=1;
		white[ 1639 ]<=1;
		white[ 1640 ]<=1;
		white[ 1641 ]<=1;
		white[ 1642 ]<=1;
		white[ 1643 ]<=1;
		white[ 1644 ]<=1;
		white[ 1645 ]<=1;
		white[ 1646 ]<=1;
		white[ 1647 ]<=1;
		white[ 1648 ]<=1;
		white[ 1649 ]<=1;
		white[ 1650 ]<=1;
		white[ 1651 ]<=1;
		white[ 1652 ]<=1;
		white[ 1653 ]<=1;
		white[ 1654 ]<=1;
		white[ 1655 ]<=1;
		white[ 1656 ]<=1;
		white[ 1657 ]<=1;
		white[ 1658 ]<=1;
		white[ 1659 ]<=1;
		white[ 1660 ]<=1;
		white[ 1661 ]<=1;
		white[ 1662 ]<=1;
		white[ 1663 ]<=1;
		white[ 1664 ]<=1;
		white[ 1665 ]<=1;
		white[ 1666 ]<=1;
		white[ 1667 ]<=1;
		white[ 1668 ]<=1;
		white[ 1669 ]<=1;
		white[ 1670 ]<=1;
		white[ 1671 ]<=1;
		white[ 1672 ]<=1;
		white[ 1673 ]<=1;
		white[ 1674 ]<=1;
		white[ 1675 ]<=0;
		white[ 1676 ]<=0;
		white[ 1677 ]<=0;
		white[ 1678 ]<=0;
		white[ 1679 ]<=0;
		white[ 1680 ]<=0;
		white[ 1681 ]<=0;
		white[ 1682 ]<=0;
		white[ 1683 ]<=0;
		white[ 1684 ]<=0;
		white[ 1685 ]<=1;
		white[ 1686 ]<=1;
		white[ 1687 ]<=1;
		white[ 1688 ]<=1;
		white[ 1689 ]<=1;
		white[ 1690 ]<=1;
		white[ 1691 ]<=1;
		white[ 1692 ]<=1;
		white[ 1693 ]<=1;
		white[ 1694 ]<=1;
		white[ 1695 ]<=1;
		white[ 1696 ]<=1;
		white[ 1697 ]<=1;
		white[ 1698 ]<=1;
		white[ 1699 ]<=1;
		white[ 1700 ]<=1;
		white[ 1701 ]<=1;
		white[ 1702 ]<=1;
		white[ 1703 ]<=1;
		white[ 1704 ]<=1;
		white[ 1705 ]<=1;
		white[ 1706 ]<=1;
		white[ 1707 ]<=1;
		white[ 1708 ]<=1;
		white[ 1709 ]<=1;
		white[ 1710 ]<=1;
		white[ 1711 ]<=1;
		white[ 1712 ]<=1;
		white[ 1713 ]<=1;
		white[ 1714 ]<=1;
		white[ 1715 ]<=1;
		white[ 1716 ]<=1;
		white[ 1717 ]<=1;
		white[ 1718 ]<=1;
		white[ 1719 ]<=1;
		white[ 1720 ]<=1;
		white[ 1721 ]<=1;
		white[ 1722 ]<=1;
		white[ 1723 ]<=1;
		white[ 1724 ]<=1;
		white[ 1725 ]<=1;
		white[ 1726 ]<=1;
		white[ 1727 ]<=1;
		white[ 1728 ]<=1;
		white[ 1729 ]<=1;
		white[ 1730 ]<=1;
		white[ 1731 ]<=1;
		white[ 1732 ]<=1;
		white[ 1733 ]<=1;
		white[ 1734 ]<=1;
		white[ 1735 ]<=0;
		white[ 1736 ]<=0;
		white[ 1737 ]<=0;
		white[ 1738 ]<=0;
		white[ 1739 ]<=0;
		white[ 1740 ]<=0;
		white[ 1741 ]<=0;
		white[ 1742 ]<=0;
		white[ 1743 ]<=0;
		white[ 1744 ]<=0;
		white[ 1745 ]<=1;
		white[ 1746 ]<=1;
		white[ 1747 ]<=1;
		white[ 1748 ]<=1;
		white[ 1749 ]<=1;
		white[ 1750 ]<=1;
		white[ 1751 ]<=1;
		white[ 1752 ]<=1;
		white[ 1753 ]<=1;
		white[ 1754 ]<=1;
		white[ 1755 ]<=1;
		white[ 1756 ]<=1;
		white[ 1757 ]<=1;
		white[ 1758 ]<=1;
		white[ 1759 ]<=1;
		white[ 1760 ]<=1;
		white[ 1761 ]<=1;
		white[ 1762 ]<=1;
		white[ 1763 ]<=1;
		white[ 1764 ]<=1;
		white[ 1765 ]<=1;
		white[ 1766 ]<=1;
		white[ 1767 ]<=1;
		white[ 1768 ]<=1;
		white[ 1769 ]<=1;
		white[ 1770 ]<=1;
		white[ 1771 ]<=1;
		white[ 1772 ]<=1;
		white[ 1773 ]<=1;
		white[ 1774 ]<=1;
		white[ 1775 ]<=1;
		white[ 1776 ]<=1;
		white[ 1777 ]<=1;
		white[ 1778 ]<=1;
		white[ 1779 ]<=1;
		white[ 1780 ]<=1;
		white[ 1781 ]<=1;
		white[ 1782 ]<=1;
		white[ 1783 ]<=1;
		white[ 1784 ]<=1;
		white[ 1785 ]<=1;
		white[ 1786 ]<=1;
		white[ 1787 ]<=1;
		white[ 1788 ]<=1;
		white[ 1789 ]<=1;
		white[ 1790 ]<=1;
		white[ 1791 ]<=1;
		white[ 1792 ]<=1;
		white[ 1793 ]<=1;
		white[ 1794 ]<=0;
		white[ 1795 ]<=0;
		white[ 1796 ]<=0;
		white[ 1797 ]<=0;
		white[ 1798 ]<=0;
		white[ 1799 ]<=0;
		white[ 1800 ]<=0;
		white[ 1801 ]<=0;
		white[ 1802 ]<=0;
		white[ 1803 ]<=0;
		white[ 1804 ]<=0;
		white[ 1805 ]<=0;
		white[ 1806 ]<=1;
		white[ 1807 ]<=1;
		white[ 1808 ]<=1;
		white[ 1809 ]<=1;
		white[ 1810 ]<=1;
		white[ 1811 ]<=1;
		white[ 1812 ]<=1;
		white[ 1813 ]<=1;
		white[ 1814 ]<=1;
		white[ 1815 ]<=1;
		white[ 1816 ]<=1;
		white[ 1817 ]<=1;
		white[ 1818 ]<=1;
		white[ 1819 ]<=1;
		white[ 1820 ]<=1;
		white[ 1821 ]<=1;
		white[ 1822 ]<=1;
		white[ 1823 ]<=1;
		white[ 1824 ]<=1;
		white[ 1825 ]<=1;
		white[ 1826 ]<=1;
		white[ 1827 ]<=1;
		white[ 1828 ]<=1;
		white[ 1829 ]<=1;
		white[ 1830 ]<=1;
		white[ 1831 ]<=1;
		white[ 1832 ]<=1;
		white[ 1833 ]<=1;
		white[ 1834 ]<=1;
		white[ 1835 ]<=1;
		white[ 1836 ]<=1;
		white[ 1837 ]<=1;
		white[ 1838 ]<=1;
		white[ 1839 ]<=1;
		white[ 1840 ]<=1;
		white[ 1841 ]<=1;
		white[ 1842 ]<=1;
		white[ 1843 ]<=1;
		white[ 1844 ]<=1;
		white[ 1845 ]<=1;
		white[ 1846 ]<=1;
		white[ 1847 ]<=1;
		white[ 1848 ]<=1;
		white[ 1849 ]<=1;
		white[ 1850 ]<=1;
		white[ 1851 ]<=1;
		white[ 1852 ]<=1;
		white[ 1853 ]<=1;
		white[ 1854 ]<=0;
		white[ 1855 ]<=0;
		white[ 1856 ]<=0;
		white[ 1857 ]<=0;
		white[ 1858 ]<=0;
		white[ 1859 ]<=0;
		white[ 1860 ]<=0;
		white[ 1861 ]<=0;
		white[ 1862 ]<=0;
		white[ 1863 ]<=0;
		white[ 1864 ]<=0;
		white[ 1865 ]<=0;
		white[ 1866 ]<=0;
		white[ 1867 ]<=1;
		white[ 1868 ]<=1;
		white[ 1869 ]<=1;
		white[ 1870 ]<=1;
		white[ 1871 ]<=1;
		white[ 1872 ]<=1;
		white[ 1873 ]<=1;
		white[ 1874 ]<=1;
		white[ 1875 ]<=1;
		white[ 1876 ]<=1;
		white[ 1877 ]<=1;
		white[ 1878 ]<=1;
		white[ 1879 ]<=1;
		white[ 1880 ]<=1;
		white[ 1881 ]<=1;
		white[ 1882 ]<=1;
		white[ 1883 ]<=1;
		white[ 1884 ]<=1;
		white[ 1885 ]<=1;
		white[ 1886 ]<=1;
		white[ 1887 ]<=1;
		white[ 1888 ]<=1;
		white[ 1889 ]<=1;
		white[ 1890 ]<=1;
		white[ 1891 ]<=1;
		white[ 1892 ]<=1;
		white[ 1893 ]<=1;
		white[ 1894 ]<=1;
		white[ 1895 ]<=1;
		white[ 1896 ]<=1;
		white[ 1897 ]<=1;
		white[ 1898 ]<=1;
		white[ 1899 ]<=1;
		white[ 1900 ]<=1;
		white[ 1901 ]<=1;
		white[ 1902 ]<=1;
		white[ 1903 ]<=1;
		white[ 1904 ]<=1;
		white[ 1905 ]<=1;
		white[ 1906 ]<=1;
		white[ 1907 ]<=1;
		white[ 1908 ]<=1;
		white[ 1909 ]<=1;
		white[ 1910 ]<=1;
		white[ 1911 ]<=1;
		white[ 1912 ]<=1;
		white[ 1913 ]<=0;
		white[ 1914 ]<=0;
		white[ 1915 ]<=0;
		white[ 1916 ]<=0;
		white[ 1917 ]<=0;
		white[ 1918 ]<=0;
		white[ 1919 ]<=0;
		white[ 1920 ]<=0;
		white[ 1921 ]<=0;
		white[ 1922 ]<=0;
		white[ 1923 ]<=0;
		white[ 1924 ]<=0;
		white[ 1925 ]<=0;
		white[ 1926 ]<=0;
		white[ 1927 ]<=1;
		white[ 1928 ]<=1;
		white[ 1929 ]<=1;
		white[ 1930 ]<=1;
		white[ 1931 ]<=1;
		white[ 1932 ]<=1;
		white[ 1933 ]<=1;
		white[ 1934 ]<=1;
		white[ 1935 ]<=1;
		white[ 1936 ]<=1;
		white[ 1937 ]<=1;
		white[ 1938 ]<=1;
		white[ 1939 ]<=1;
		white[ 1940 ]<=1;
		white[ 1941 ]<=1;
		white[ 1942 ]<=1;
		white[ 1943 ]<=1;
		white[ 1944 ]<=1;
		white[ 1945 ]<=1;
		white[ 1946 ]<=1;
		white[ 1947 ]<=1;
		white[ 1948 ]<=1;
		white[ 1949 ]<=1;
		white[ 1950 ]<=1;
		white[ 1951 ]<=1;
		white[ 1952 ]<=1;
		white[ 1953 ]<=1;
		white[ 1954 ]<=1;
		white[ 1955 ]<=1;
		white[ 1956 ]<=1;
		white[ 1957 ]<=1;
		white[ 1958 ]<=1;
		white[ 1959 ]<=1;
		white[ 1960 ]<=1;
		white[ 1961 ]<=1;
		white[ 1962 ]<=1;
		white[ 1963 ]<=1;
		white[ 1964 ]<=1;
		white[ 1965 ]<=1;
		white[ 1966 ]<=1;
		white[ 1967 ]<=1;
		white[ 1968 ]<=1;
		white[ 1969 ]<=1;
		white[ 1970 ]<=1;
		white[ 1971 ]<=1;
		white[ 1972 ]<=1;
		white[ 1973 ]<=0;
		white[ 1974 ]<=0;
		white[ 1975 ]<=0;
		white[ 1976 ]<=0;
		white[ 1977 ]<=0;
		white[ 1978 ]<=0;
		white[ 1979 ]<=0;
		white[ 1980 ]<=0;
		white[ 1981 ]<=0;
		white[ 1982 ]<=0;
		white[ 1983 ]<=0;
		white[ 1984 ]<=0;
		white[ 1985 ]<=0;
		white[ 1986 ]<=0;
		white[ 1987 ]<=0;
		white[ 1988 ]<=1;
		white[ 1989 ]<=1;
		white[ 1990 ]<=1;
		white[ 1991 ]<=1;
		white[ 1992 ]<=1;
		white[ 1993 ]<=1;
		white[ 1994 ]<=1;
		white[ 1995 ]<=1;
		white[ 1996 ]<=1;
		white[ 1997 ]<=1;
		white[ 1998 ]<=1;
		white[ 1999 ]<=1;
		white[ 2000 ]<=1;
		white[ 2001 ]<=1;
		white[ 2002 ]<=1;
		white[ 2003 ]<=1;
		white[ 2004 ]<=1;
		white[ 2005 ]<=1;
		white[ 2006 ]<=1;
		white[ 2007 ]<=1;
		white[ 2008 ]<=1;
		white[ 2009 ]<=1;
		white[ 2010 ]<=1;
		white[ 2011 ]<=1;
		white[ 2012 ]<=1;
		white[ 2013 ]<=1;
		white[ 2014 ]<=1;
		white[ 2015 ]<=1;
		white[ 2016 ]<=1;
		white[ 2017 ]<=1;
		white[ 2018 ]<=1;
		white[ 2019 ]<=1;
		white[ 2020 ]<=1;
		white[ 2021 ]<=1;
		white[ 2022 ]<=1;
		white[ 2023 ]<=1;
		white[ 2024 ]<=1;
		white[ 2025 ]<=1;
		white[ 2026 ]<=1;
		white[ 2027 ]<=1;
		white[ 2028 ]<=1;
		white[ 2029 ]<=1;
		white[ 2030 ]<=1;
		white[ 2031 ]<=1;
		white[ 2032 ]<=0;
		white[ 2033 ]<=0;
		white[ 2034 ]<=0;
		white[ 2035 ]<=0;
		white[ 2036 ]<=0;
		white[ 2037 ]<=0;
		white[ 2038 ]<=0;
		white[ 2039 ]<=0;
		white[ 2040 ]<=0;
		white[ 2041 ]<=0;
		white[ 2042 ]<=0;
		white[ 2043 ]<=0;
		white[ 2044 ]<=0;
		white[ 2045 ]<=0;
		white[ 2046 ]<=0;
		white[ 2047 ]<=0;
		white[ 2048 ]<=1;
		white[ 2049 ]<=1;
		white[ 2050 ]<=1;
		white[ 2051 ]<=1;
		white[ 2052 ]<=1;
		white[ 2053 ]<=1;
		white[ 2054 ]<=1;
		white[ 2055 ]<=1;
		white[ 2056 ]<=1;
		white[ 2057 ]<=1;
		white[ 2058 ]<=1;
		white[ 2059 ]<=1;
		white[ 2060 ]<=1;
		white[ 2061 ]<=1;
		white[ 2062 ]<=1;
		white[ 2063 ]<=1;
		white[ 2064 ]<=1;
		white[ 2065 ]<=1;
		white[ 2066 ]<=1;
		white[ 2067 ]<=1;
		white[ 2068 ]<=1;
		white[ 2069 ]<=1;
		white[ 2070 ]<=1;
		white[ 2071 ]<=1;
		white[ 2072 ]<=1;
		white[ 2073 ]<=1;
		white[ 2074 ]<=1;
		white[ 2075 ]<=1;
		white[ 2076 ]<=1;
		white[ 2077 ]<=1;
		white[ 2078 ]<=1;
		white[ 2079 ]<=1;
		white[ 2080 ]<=1;
		white[ 2081 ]<=1;
		white[ 2082 ]<=1;
		white[ 2083 ]<=1;
		white[ 2084 ]<=1;
		white[ 2085 ]<=1;
		white[ 2086 ]<=1;
		white[ 2087 ]<=1;
		white[ 2088 ]<=1;
		white[ 2089 ]<=1;
		white[ 2090 ]<=1;
		white[ 2091 ]<=0;
		white[ 2092 ]<=0;
		white[ 2093 ]<=0;
		white[ 2094 ]<=0;
		white[ 2095 ]<=0;
		white[ 2096 ]<=0;
		white[ 2097 ]<=0;
		white[ 2098 ]<=0;
		white[ 2099 ]<=0;
		white[ 2100 ]<=0;
		white[ 2101 ]<=0;
		white[ 2102 ]<=0;
		white[ 2103 ]<=0;
		white[ 2104 ]<=0;
		white[ 2105 ]<=0;
		white[ 2106 ]<=0;
		white[ 2107 ]<=0;
		white[ 2108 ]<=0;
		white[ 2109 ]<=1;
		white[ 2110 ]<=1;
		white[ 2111 ]<=1;
		white[ 2112 ]<=1;
		white[ 2113 ]<=1;
		white[ 2114 ]<=1;
		white[ 2115 ]<=1;
		white[ 2116 ]<=1;
		white[ 2117 ]<=1;
		white[ 2118 ]<=1;
		white[ 2119 ]<=1;
		white[ 2120 ]<=1;
		white[ 2121 ]<=1;
		white[ 2122 ]<=1;
		white[ 2123 ]<=1;
		white[ 2124 ]<=1;
		white[ 2125 ]<=1;
		white[ 2126 ]<=1;
		white[ 2127 ]<=1;
		white[ 2128 ]<=1;
		white[ 2129 ]<=1;
		white[ 2130 ]<=1;
		white[ 2131 ]<=1;
		white[ 2132 ]<=1;
		white[ 2133 ]<=1;
		white[ 2134 ]<=1;
		white[ 2135 ]<=1;
		white[ 2136 ]<=1;
		white[ 2137 ]<=1;
		white[ 2138 ]<=1;
		white[ 2139 ]<=1;
		white[ 2140 ]<=1;
		white[ 2141 ]<=1;
		white[ 2142 ]<=1;
		white[ 2143 ]<=1;
		white[ 2144 ]<=1;
		white[ 2145 ]<=1;
		white[ 2146 ]<=1;
		white[ 2147 ]<=1;
		white[ 2148 ]<=1;
		white[ 2149 ]<=1;
		white[ 2150 ]<=1;
		white[ 2151 ]<=0;
		white[ 2152 ]<=0;
		white[ 2153 ]<=0;
		white[ 2154 ]<=0;
		white[ 2155 ]<=0;
		white[ 2156 ]<=0;
		white[ 2157 ]<=0;
		white[ 2158 ]<=0;
		white[ 2159 ]<=0;
		white[ 2160 ]<=0;
		white[ 2161 ]<=0;
		white[ 2162 ]<=0;
		white[ 2163 ]<=0;
		white[ 2164 ]<=0;
		white[ 2165 ]<=0;
		white[ 2166 ]<=0;
		white[ 2167 ]<=0;
		white[ 2168 ]<=0;
		white[ 2169 ]<=0;
		white[ 2170 ]<=1;
		white[ 2171 ]<=1;
		white[ 2172 ]<=1;
		white[ 2173 ]<=1;
		white[ 2174 ]<=1;
		white[ 2175 ]<=1;
		white[ 2176 ]<=1;
		white[ 2177 ]<=1;
		white[ 2178 ]<=1;
		white[ 2179 ]<=1;
		white[ 2180 ]<=1;
		white[ 2181 ]<=1;
		white[ 2182 ]<=1;
		white[ 2183 ]<=1;
		white[ 2184 ]<=1;
		white[ 2185 ]<=1;
		white[ 2186 ]<=1;
		white[ 2187 ]<=1;
		white[ 2188 ]<=1;
		white[ 2189 ]<=1;
		white[ 2190 ]<=1;
		white[ 2191 ]<=1;
		white[ 2192 ]<=1;
		white[ 2193 ]<=1;
		white[ 2194 ]<=1;
		white[ 2195 ]<=1;
		white[ 2196 ]<=1;
		white[ 2197 ]<=1;
		white[ 2198 ]<=1;
		white[ 2199 ]<=1;
		white[ 2200 ]<=1;
		white[ 2201 ]<=1;
		white[ 2202 ]<=1;
		white[ 2203 ]<=1;
		white[ 2204 ]<=1;
		white[ 2205 ]<=1;
		white[ 2206 ]<=1;
		white[ 2207 ]<=1;
		white[ 2208 ]<=1;
		white[ 2209 ]<=1;
		white[ 2210 ]<=0;
		white[ 2211 ]<=0;
		white[ 2212 ]<=0;
		white[ 2213 ]<=0;
		white[ 2214 ]<=0;
		white[ 2215 ]<=0;
		white[ 2216 ]<=0;
		white[ 2217 ]<=0;
		white[ 2218 ]<=0;
		white[ 2219 ]<=0;
		white[ 2220 ]<=0;
		white[ 2221 ]<=0;
		white[ 2222 ]<=0;
		white[ 2223 ]<=0;
		white[ 2224 ]<=0;
		white[ 2225 ]<=0;
		white[ 2226 ]<=0;
		white[ 2227 ]<=0;
		white[ 2228 ]<=0;
		white[ 2229 ]<=0;
		white[ 2230 ]<=0;
		white[ 2231 ]<=1;
		white[ 2232 ]<=1;
		white[ 2233 ]<=1;
		white[ 2234 ]<=1;
		white[ 2235 ]<=1;
		white[ 2236 ]<=1;
		white[ 2237 ]<=1;
		white[ 2238 ]<=1;
		white[ 2239 ]<=1;
		white[ 2240 ]<=1;
		white[ 2241 ]<=1;
		white[ 2242 ]<=1;
		white[ 2243 ]<=1;
		white[ 2244 ]<=1;
		white[ 2245 ]<=1;
		white[ 2246 ]<=1;
		white[ 2247 ]<=1;
		white[ 2248 ]<=1;
		white[ 2249 ]<=1;
		white[ 2250 ]<=1;
		white[ 2251 ]<=1;
		white[ 2252 ]<=1;
		white[ 2253 ]<=1;
		white[ 2254 ]<=1;
		white[ 2255 ]<=1;
		white[ 2256 ]<=1;
		white[ 2257 ]<=1;
		white[ 2258 ]<=1;
		white[ 2259 ]<=1;
		white[ 2260 ]<=1;
		white[ 2261 ]<=1;
		white[ 2262 ]<=1;
		white[ 2263 ]<=1;
		white[ 2264 ]<=1;
		white[ 2265 ]<=1;
		white[ 2266 ]<=1;
		white[ 2267 ]<=1;
		white[ 2268 ]<=1;
		white[ 2269 ]<=0;
		white[ 2270 ]<=0;
		white[ 2271 ]<=0;
		white[ 2272 ]<=0;
		white[ 2273 ]<=0;
		white[ 2274 ]<=0;
		white[ 2275 ]<=0;
		white[ 2276 ]<=0;
		white[ 2277 ]<=0;
		white[ 2278 ]<=0;
		white[ 2279 ]<=0;
		white[ 2280 ]<=0;
		white[ 2281 ]<=0;
		white[ 2282 ]<=0;
		white[ 2283 ]<=0;
		white[ 2284 ]<=0;
		white[ 2285 ]<=0;
		white[ 2286 ]<=0;
		white[ 2287 ]<=0;
		white[ 2288 ]<=0;
		white[ 2289 ]<=0;
		white[ 2290 ]<=0;
		white[ 2291 ]<=1;
		white[ 2292 ]<=1;
		white[ 2293 ]<=1;
		white[ 2294 ]<=1;
		white[ 2295 ]<=1;
		white[ 2296 ]<=1;
		white[ 2297 ]<=1;
		white[ 2298 ]<=1;
		white[ 2299 ]<=1;
		white[ 2300 ]<=1;
		white[ 2301 ]<=1;
		white[ 2302 ]<=1;
		white[ 2303 ]<=1;
		white[ 2304 ]<=1;
		white[ 2305 ]<=1;
		white[ 2306 ]<=1;
		white[ 2307 ]<=1;
		white[ 2308 ]<=1;
		white[ 2309 ]<=1;
		white[ 2310 ]<=1;
		white[ 2311 ]<=1;
		white[ 2312 ]<=1;
		white[ 2313 ]<=1;
		white[ 2314 ]<=1;
		white[ 2315 ]<=1;
		white[ 2316 ]<=1;
		white[ 2317 ]<=1;
		white[ 2318 ]<=1;
		white[ 2319 ]<=1;
		white[ 2320 ]<=1;
		white[ 2321 ]<=1;
		white[ 2322 ]<=1;
		white[ 2323 ]<=1;
		white[ 2324 ]<=1;
		white[ 2325 ]<=1;
		white[ 2326 ]<=1;
		white[ 2327 ]<=1;
		white[ 2328 ]<=0;
		white[ 2329 ]<=0;
		white[ 2330 ]<=0;
		white[ 2331 ]<=0;
		white[ 2332 ]<=0;
		white[ 2333 ]<=0;
		white[ 2334 ]<=0;
		white[ 2335 ]<=0;
		white[ 2336 ]<=0;
		white[ 2337 ]<=0;
		white[ 2338 ]<=0;
		white[ 2339 ]<=0;
		white[ 2340 ]<=0;
		white[ 2341 ]<=0;
		white[ 2342 ]<=0;
		white[ 2343 ]<=0;
		white[ 2344 ]<=0;
		white[ 2345 ]<=0;
		white[ 2346 ]<=0;
		white[ 2347 ]<=0;
		white[ 2348 ]<=0;
		white[ 2349 ]<=0;
		white[ 2350 ]<=0;
		white[ 2351 ]<=0;
		white[ 2352 ]<=1;
		white[ 2353 ]<=1;
		white[ 2354 ]<=1;
		white[ 2355 ]<=1;
		white[ 2356 ]<=1;
		white[ 2357 ]<=1;
		white[ 2358 ]<=1;
		white[ 2359 ]<=1;
		white[ 2360 ]<=1;
		white[ 2361 ]<=1;
		white[ 2362 ]<=1;
		white[ 2363 ]<=1;
		white[ 2364 ]<=1;
		white[ 2365 ]<=1;
		white[ 2366 ]<=1;
		white[ 2367 ]<=1;
		white[ 2368 ]<=1;
		white[ 2369 ]<=1;
		white[ 2370 ]<=1;
		white[ 2371 ]<=1;
		white[ 2372 ]<=1;
		white[ 2373 ]<=1;
		white[ 2374 ]<=1;
		white[ 2375 ]<=1;
		white[ 2376 ]<=1;
		white[ 2377 ]<=1;
		white[ 2378 ]<=1;
		white[ 2379 ]<=1;
		white[ 2380 ]<=1;
		white[ 2381 ]<=1;
		white[ 2382 ]<=1;
		white[ 2383 ]<=1;
		white[ 2384 ]<=1;
		white[ 2385 ]<=1;
		white[ 2386 ]<=1;
		white[ 2387 ]<=1;
		white[ 2388 ]<=0;
		white[ 2389 ]<=0;
		white[ 2390 ]<=0;
		white[ 2391 ]<=0;
		white[ 2392 ]<=0;
		white[ 2393 ]<=0;
		white[ 2394 ]<=0;
		white[ 2395 ]<=0;
		white[ 2396 ]<=0;
		white[ 2397 ]<=0;
		white[ 2398 ]<=0;
		white[ 2399 ]<=0;
		white[ 2400 ]<=0;
		white[ 2401 ]<=0;
		white[ 2402 ]<=0;
		white[ 2403 ]<=0;
		white[ 2404 ]<=0;
		white[ 2405 ]<=0;
		white[ 2406 ]<=0;
		white[ 2407 ]<=0;
		white[ 2408 ]<=0;
		white[ 2409 ]<=0;
		white[ 2410 ]<=0;
		white[ 2411 ]<=0;
		white[ 2412 ]<=0;
		white[ 2413 ]<=1;
		white[ 2414 ]<=1;
		white[ 2415 ]<=1;
		white[ 2416 ]<=1;
		white[ 2417 ]<=1;
		white[ 2418 ]<=1;
		white[ 2419 ]<=1;
		white[ 2420 ]<=1;
		white[ 2421 ]<=1;
		white[ 2422 ]<=1;
		white[ 2423 ]<=1;
		white[ 2424 ]<=1;
		white[ 2425 ]<=1;
		white[ 2426 ]<=1;
		white[ 2427 ]<=1;
		white[ 2428 ]<=1;
		white[ 2429 ]<=1;
		white[ 2430 ]<=1;
		white[ 2431 ]<=1;
		white[ 2432 ]<=1;
		white[ 2433 ]<=1;
		white[ 2434 ]<=1;
		white[ 2435 ]<=1;
		white[ 2436 ]<=1;
		white[ 2437 ]<=1;
		white[ 2438 ]<=1;
		white[ 2439 ]<=1;
		white[ 2440 ]<=1;
		white[ 2441 ]<=1;
		white[ 2442 ]<=1;
		white[ 2443 ]<=1;
		white[ 2444 ]<=1;
		white[ 2445 ]<=1;
		white[ 2446 ]<=1;
		white[ 2447 ]<=0;
		white[ 2448 ]<=0;
		white[ 2449 ]<=0;
		white[ 2450 ]<=0;
		white[ 2451 ]<=0;
		white[ 2452 ]<=0;
		white[ 2453 ]<=0;
		white[ 2454 ]<=0;
		white[ 2455 ]<=0;
		white[ 2456 ]<=0;
		white[ 2457 ]<=0;
		white[ 2458 ]<=0;
		white[ 2459 ]<=0;
		white[ 2460 ]<=0;
		white[ 2461 ]<=0;
		white[ 2462 ]<=0;
		white[ 2463 ]<=0;
		white[ 2464 ]<=0;
		white[ 2465 ]<=0;
		white[ 2466 ]<=0;
		white[ 2467 ]<=0;
		white[ 2468 ]<=0;
		white[ 2469 ]<=0;
		white[ 2470 ]<=0;
		white[ 2471 ]<=0;
		white[ 2472 ]<=0;
		white[ 2473 ]<=0;
		white[ 2474 ]<=1;
		white[ 2475 ]<=1;
		white[ 2476 ]<=1;
		white[ 2477 ]<=1;
		white[ 2478 ]<=1;
		white[ 2479 ]<=1;
		white[ 2480 ]<=1;
		white[ 2481 ]<=1;
		white[ 2482 ]<=1;
		white[ 2483 ]<=1;
		white[ 2484 ]<=1;
		white[ 2485 ]<=1;
		white[ 2486 ]<=1;
		white[ 2487 ]<=1;
		white[ 2488 ]<=1;
		white[ 2489 ]<=1;
		white[ 2490 ]<=1;
		white[ 2491 ]<=1;
		white[ 2492 ]<=1;
		white[ 2493 ]<=1;
		white[ 2494 ]<=1;
		white[ 2495 ]<=1;
		white[ 2496 ]<=1;
		white[ 2497 ]<=1;
		white[ 2498 ]<=1;
		white[ 2499 ]<=1;
		white[ 2500 ]<=1;
		white[ 2501 ]<=1;
		white[ 2502 ]<=1;
		white[ 2503 ]<=1;
		white[ 2504 ]<=1;
		white[ 2505 ]<=1;
		white[ 2506 ]<=0;
		white[ 2507 ]<=0;
		white[ 2508 ]<=0;
		white[ 2509 ]<=0;
		white[ 2510 ]<=0;
		white[ 2511 ]<=0;
		white[ 2512 ]<=0;
		white[ 2513 ]<=0;
		white[ 2514 ]<=0;
		white[ 2515 ]<=0;
		white[ 2516 ]<=0;
		white[ 2517 ]<=0;
		white[ 2518 ]<=0;
		white[ 2519 ]<=0;
		white[ 2520 ]<=0;
		white[ 2521 ]<=0;
		white[ 2522 ]<=0;
		white[ 2523 ]<=0;
		white[ 2524 ]<=0;
		white[ 2525 ]<=0;
		white[ 2526 ]<=0;
		white[ 2527 ]<=0;
		white[ 2528 ]<=0;
		white[ 2529 ]<=0;
		white[ 2530 ]<=0;
		white[ 2531 ]<=0;
		white[ 2532 ]<=0;
		white[ 2533 ]<=0;
		white[ 2534 ]<=0;
		white[ 2535 ]<=1;
		white[ 2536 ]<=1;
		white[ 2537 ]<=1;
		white[ 2538 ]<=1;
		white[ 2539 ]<=1;
		white[ 2540 ]<=1;
		white[ 2541 ]<=1;
		white[ 2542 ]<=1;
		white[ 2543 ]<=1;
		white[ 2544 ]<=1;
		white[ 2545 ]<=1;
		white[ 2546 ]<=1;
		white[ 2547 ]<=1;
		white[ 2548 ]<=1;
		white[ 2549 ]<=1;
		white[ 2550 ]<=1;
		white[ 2551 ]<=1;
		white[ 2552 ]<=1;
		white[ 2553 ]<=1;
		white[ 2554 ]<=1;
		white[ 2555 ]<=1;
		white[ 2556 ]<=1;
		white[ 2557 ]<=1;
		white[ 2558 ]<=1;
		white[ 2559 ]<=1;
		white[ 2560 ]<=1;
		white[ 2561 ]<=1;
		white[ 2562 ]<=1;
		white[ 2563 ]<=1;
		white[ 2564 ]<=1;
		white[ 2565 ]<=0;
		white[ 2566 ]<=0;
		white[ 2567 ]<=0;
		white[ 2568 ]<=0;
		white[ 2569 ]<=0;
		white[ 2570 ]<=0;
		white[ 2571 ]<=0;
		white[ 2572 ]<=0;
		white[ 2573 ]<=0;
		white[ 2574 ]<=0;
		white[ 2575 ]<=0;
		white[ 2576 ]<=0;
		white[ 2577 ]<=0;
		white[ 2578 ]<=0;
		white[ 2579 ]<=0;
		white[ 2580 ]<=0;
		white[ 2581 ]<=0;
		white[ 2582 ]<=0;
		white[ 2583 ]<=0;
		white[ 2584 ]<=0;
		white[ 2585 ]<=0;
		white[ 2586 ]<=0;
		white[ 2587 ]<=0;
		white[ 2588 ]<=0;
		white[ 2589 ]<=0;
		white[ 2590 ]<=0;
		white[ 2591 ]<=0;
		white[ 2592 ]<=0;
		white[ 2593 ]<=0;
		white[ 2594 ]<=0;
		white[ 2595 ]<=1;
		white[ 2596 ]<=1;
		white[ 2597 ]<=1;
		white[ 2598 ]<=1;
		white[ 2599 ]<=1;
		white[ 2600 ]<=1;
		white[ 2601 ]<=1;
		white[ 2602 ]<=1;
		white[ 2603 ]<=1;
		white[ 2604 ]<=1;
		white[ 2605 ]<=1;
		white[ 2606 ]<=1;
		white[ 2607 ]<=1;
		white[ 2608 ]<=1;
		white[ 2609 ]<=1;
		white[ 2610 ]<=1;
		white[ 2611 ]<=1;
		white[ 2612 ]<=1;
		white[ 2613 ]<=1;
		white[ 2614 ]<=1;
		white[ 2615 ]<=1;
		white[ 2616 ]<=1;
		white[ 2617 ]<=1;
		white[ 2618 ]<=1;
		white[ 2619 ]<=1;
		white[ 2620 ]<=1;
		white[ 2621 ]<=1;
		white[ 2622 ]<=1;
		white[ 2623 ]<=1;
		white[ 2624 ]<=0;
		white[ 2625 ]<=0;
		white[ 2626 ]<=0;
		white[ 2627 ]<=0;
		white[ 2628 ]<=0;
		white[ 2629 ]<=0;
		white[ 2630 ]<=0;
		white[ 2631 ]<=0;
		white[ 2632 ]<=0;
		white[ 2633 ]<=0;
		white[ 2634 ]<=0;
		white[ 2635 ]<=0;
		white[ 2636 ]<=0;
		white[ 2637 ]<=0;
		white[ 2638 ]<=0;
		white[ 2639 ]<=0;
		white[ 2640 ]<=0;
		white[ 2641 ]<=0;
		white[ 2642 ]<=0;
		white[ 2643 ]<=0;
		white[ 2644 ]<=0;
		white[ 2645 ]<=0;
		white[ 2646 ]<=0;
		white[ 2647 ]<=0;
		white[ 2648 ]<=0;
		white[ 2649 ]<=0;
		white[ 2650 ]<=0;
		white[ 2651 ]<=0;
		white[ 2652 ]<=0;
		white[ 2653 ]<=0;
		white[ 2654 ]<=0;
		white[ 2655 ]<=0;
		white[ 2656 ]<=1;
		white[ 2657 ]<=1;
		white[ 2658 ]<=1;
		white[ 2659 ]<=1;
		white[ 2660 ]<=1;
		white[ 2661 ]<=1;
		white[ 2662 ]<=1;
		white[ 2663 ]<=1;
		white[ 2664 ]<=1;
		white[ 2665 ]<=1;
		white[ 2666 ]<=1;
		white[ 2667 ]<=1;
		white[ 2668 ]<=1;
		white[ 2669 ]<=1;
		white[ 2670 ]<=1;
		white[ 2671 ]<=1;
		white[ 2672 ]<=1;
		white[ 2673 ]<=1;
		white[ 2674 ]<=1;
		white[ 2675 ]<=1;
		white[ 2676 ]<=1;
		white[ 2677 ]<=1;
		white[ 2678 ]<=1;
		white[ 2679 ]<=1;
		white[ 2680 ]<=1;
		white[ 2681 ]<=1;
		white[ 2682 ]<=1;
		white[ 2683 ]<=1;
		white[ 2684 ]<=0;
		white[ 2685 ]<=0;
		white[ 2686 ]<=0;
		white[ 2687 ]<=0;
		white[ 2688 ]<=0;
		white[ 2689 ]<=0;
		white[ 2690 ]<=0;
		white[ 2691 ]<=0;
		white[ 2692 ]<=0;
		white[ 2693 ]<=0;
		white[ 2694 ]<=0;
		white[ 2695 ]<=0;
		white[ 2696 ]<=0;
		white[ 2697 ]<=0;
		white[ 2698 ]<=0;
		white[ 2699 ]<=0;
		white[ 2700 ]<=0;
		white[ 2701 ]<=0;
		white[ 2702 ]<=0;
		white[ 2703 ]<=0;
		white[ 2704 ]<=0;
		white[ 2705 ]<=0;
		white[ 2706 ]<=0;
		white[ 2707 ]<=0;
		white[ 2708 ]<=0;
		white[ 2709 ]<=0;
		white[ 2710 ]<=0;
		white[ 2711 ]<=0;
		white[ 2712 ]<=0;
		white[ 2713 ]<=0;
		white[ 2714 ]<=0;
		white[ 2715 ]<=0;
		white[ 2716 ]<=0;
		white[ 2717 ]<=1;
		white[ 2718 ]<=1;
		white[ 2719 ]<=1;
		white[ 2720 ]<=1;
		white[ 2721 ]<=1;
		white[ 2722 ]<=1;
		white[ 2723 ]<=1;
		white[ 2724 ]<=1;
		white[ 2725 ]<=1;
		white[ 2726 ]<=1;
		white[ 2727 ]<=1;
		white[ 2728 ]<=1;
		white[ 2729 ]<=1;
		white[ 2730 ]<=1;
		white[ 2731 ]<=1;
		white[ 2732 ]<=1;
		white[ 2733 ]<=1;
		white[ 2734 ]<=1;
		white[ 2735 ]<=1;
		white[ 2736 ]<=1;
		white[ 2737 ]<=1;
		white[ 2738 ]<=1;
		white[ 2739 ]<=1;
		white[ 2740 ]<=1;
		white[ 2741 ]<=1;
		white[ 2742 ]<=1;
		white[ 2743 ]<=0;
		white[ 2744 ]<=0;
		white[ 2745 ]<=0;
		white[ 2746 ]<=0;
		white[ 2747 ]<=0;
		white[ 2748 ]<=0;
		white[ 2749 ]<=0;
		white[ 2750 ]<=0;
		white[ 2751 ]<=0;
		white[ 2752 ]<=0;
		white[ 2753 ]<=0;
		white[ 2754 ]<=0;
		white[ 2755 ]<=0;
		white[ 2756 ]<=0;
		white[ 2757 ]<=0;
		white[ 2758 ]<=0;
		white[ 2759 ]<=0;
		white[ 2760 ]<=0;
		white[ 2761 ]<=0;
		white[ 2762 ]<=0;
		white[ 2763 ]<=0;
		white[ 2764 ]<=0;
		white[ 2765 ]<=0;
		white[ 2766 ]<=0;
		white[ 2767 ]<=0;
		white[ 2768 ]<=0;
		white[ 2769 ]<=0;
		white[ 2770 ]<=0;
		white[ 2771 ]<=0;
		white[ 2772 ]<=0;
		white[ 2773 ]<=0;
		white[ 2774 ]<=0;
		white[ 2775 ]<=0;
		white[ 2776 ]<=0;
		white[ 2777 ]<=0;
		white[ 2778 ]<=1;
		white[ 2779 ]<=1;
		white[ 2780 ]<=1;
		white[ 2781 ]<=1;
		white[ 2782 ]<=1;
		white[ 2783 ]<=1;
		white[ 2784 ]<=1;
		white[ 2785 ]<=1;
		white[ 2786 ]<=1;
		white[ 2787 ]<=1;
		white[ 2788 ]<=1;
		white[ 2789 ]<=1;
		white[ 2790 ]<=1;
		white[ 2791 ]<=1;
		white[ 2792 ]<=1;
		white[ 2793 ]<=1;
		white[ 2794 ]<=1;
		white[ 2795 ]<=1;
		white[ 2796 ]<=1;
		white[ 2797 ]<=1;
		white[ 2798 ]<=1;
		white[ 2799 ]<=1;
		white[ 2800 ]<=1;
		white[ 2801 ]<=1;
		white[ 2802 ]<=0;
		white[ 2803 ]<=0;
		white[ 2804 ]<=0;
		white[ 2805 ]<=0;
		white[ 2806 ]<=0;
		white[ 2807 ]<=0;
		white[ 2808 ]<=0;
		white[ 2809 ]<=0;
		white[ 2810 ]<=0;
		white[ 2811 ]<=0;
		white[ 2812 ]<=0;
		white[ 2813 ]<=0;
		white[ 2814 ]<=0;
		white[ 2815 ]<=0;
		white[ 2816 ]<=0;
		white[ 2817 ]<=0;
		white[ 2818 ]<=0;
		white[ 2819 ]<=0;
		white[ 2820 ]<=0;
		white[ 2821 ]<=0;
		white[ 2822 ]<=0;
		white[ 2823 ]<=0;
		white[ 2824 ]<=0;
		white[ 2825 ]<=0;
		white[ 2826 ]<=0;
		white[ 2827 ]<=0;
		white[ 2828 ]<=0;
		white[ 2829 ]<=0;
		white[ 2830 ]<=0;
		white[ 2831 ]<=0;
		white[ 2832 ]<=0;
		white[ 2833 ]<=0;
		white[ 2834 ]<=0;
		white[ 2835 ]<=0;
		white[ 2836 ]<=0;
		white[ 2837 ]<=0;
		white[ 2838 ]<=0;
		white[ 2839 ]<=1;
		white[ 2840 ]<=1;
		white[ 2841 ]<=1;
		white[ 2842 ]<=1;
		white[ 2843 ]<=1;
		white[ 2844 ]<=1;
		white[ 2845 ]<=1;
		white[ 2846 ]<=1;
		white[ 2847 ]<=1;
		white[ 2848 ]<=1;
		white[ 2849 ]<=1;
		white[ 2850 ]<=1;
		white[ 2851 ]<=1;
		white[ 2852 ]<=1;
		white[ 2853 ]<=1;
		white[ 2854 ]<=1;
		white[ 2855 ]<=1;
		white[ 2856 ]<=1;
		white[ 2857 ]<=1;
		white[ 2858 ]<=1;
		white[ 2859 ]<=1;
		white[ 2860 ]<=1;
		white[ 2861 ]<=0;
		white[ 2862 ]<=0;
		white[ 2863 ]<=0;
		white[ 2864 ]<=0;
		white[ 2865 ]<=0;
		white[ 2866 ]<=0;
		white[ 2867 ]<=0;
		white[ 2868 ]<=0;
		white[ 2869 ]<=0;
		white[ 2870 ]<=0;
		white[ 2871 ]<=0;
		white[ 2872 ]<=0;
		white[ 2873 ]<=0;
		white[ 2874 ]<=0;
		white[ 2875 ]<=0;
		white[ 2876 ]<=0;
		white[ 2877 ]<=0;
		white[ 2878 ]<=0;
		white[ 2879 ]<=0;
		white[ 2880 ]<=0;
		white[ 2881 ]<=0;
		white[ 2882 ]<=0;
		white[ 2883 ]<=0;
		white[ 2884 ]<=0;
		white[ 2885 ]<=0;
		white[ 2886 ]<=0;
		white[ 2887 ]<=0;
		white[ 2888 ]<=0;
		white[ 2889 ]<=0;
		white[ 2890 ]<=0;
		white[ 2891 ]<=0;
		white[ 2892 ]<=0;
		white[ 2893 ]<=0;
		white[ 2894 ]<=0;
		white[ 2895 ]<=0;
		white[ 2896 ]<=0;
		white[ 2897 ]<=0;
		white[ 2898 ]<=0;
		white[ 2899 ]<=0;
		white[ 2900 ]<=1;
		white[ 2901 ]<=1;
		white[ 2902 ]<=1;
		white[ 2903 ]<=1;
		white[ 2904 ]<=1;
		white[ 2905 ]<=1;
		white[ 2906 ]<=1;
		white[ 2907 ]<=1;
		white[ 2908 ]<=1;
		white[ 2909 ]<=1;
		white[ 2910 ]<=1;
		white[ 2911 ]<=1;
		white[ 2912 ]<=1;
		white[ 2913 ]<=1;
		white[ 2914 ]<=1;
		white[ 2915 ]<=1;
		white[ 2916 ]<=1;
		white[ 2917 ]<=1;
		white[ 2918 ]<=1;
		white[ 2919 ]<=1;
		white[ 2920 ]<=0;
		white[ 2921 ]<=0;
		white[ 2922 ]<=0;
		white[ 2923 ]<=0;
		white[ 2924 ]<=0;
		white[ 2925 ]<=0;
		white[ 2926 ]<=0;
		white[ 2927 ]<=0;
		white[ 2928 ]<=0;
		white[ 2929 ]<=0;
		white[ 2930 ]<=0;
		white[ 2931 ]<=0;
		white[ 2932 ]<=0;
		white[ 2933 ]<=0;
		white[ 2934 ]<=0;
		white[ 2935 ]<=0;
		white[ 2936 ]<=0;
		white[ 2937 ]<=0;
		white[ 2938 ]<=0;
		white[ 2939 ]<=0;
		white[ 2940 ]<=0;
		white[ 2941 ]<=0;
		white[ 2942 ]<=0;
		white[ 2943 ]<=0;
		white[ 2944 ]<=0;
		white[ 2945 ]<=0;
		white[ 2946 ]<=0;
		white[ 2947 ]<=0;
		white[ 2948 ]<=0;
		white[ 2949 ]<=0;
		white[ 2950 ]<=0;
		white[ 2951 ]<=0;
		white[ 2952 ]<=0;
		white[ 2953 ]<=0;
		white[ 2954 ]<=0;
		white[ 2955 ]<=0;
		white[ 2956 ]<=0;
		white[ 2957 ]<=0;
		white[ 2958 ]<=0;
		white[ 2959 ]<=0;
		white[ 2960 ]<=0;
		white[ 2961 ]<=1;
		white[ 2962 ]<=1;
		white[ 2963 ]<=1;
		white[ 2964 ]<=1;
		white[ 2965 ]<=1;
		white[ 2966 ]<=1;
		white[ 2967 ]<=1;
		white[ 2968 ]<=1;
		white[ 2969 ]<=1;
		white[ 2970 ]<=1;
		white[ 2971 ]<=1;
		white[ 2972 ]<=1;
		white[ 2973 ]<=1;
		white[ 2974 ]<=1;
		white[ 2975 ]<=1;
		white[ 2976 ]<=1;
		white[ 2977 ]<=1;
		white[ 2978 ]<=1;
		white[ 2979 ]<=0;
		white[ 2980 ]<=0;
		white[ 2981 ]<=0;
		white[ 2982 ]<=0;
		white[ 2983 ]<=0;
		white[ 2984 ]<=0;
		white[ 2985 ]<=0;
		white[ 2986 ]<=0;
		white[ 2987 ]<=0;
		white[ 2988 ]<=0;
		white[ 2989 ]<=0;
		white[ 2990 ]<=0;
		white[ 2991 ]<=0;
		white[ 2992 ]<=0;
		white[ 2993 ]<=0;
		white[ 2994 ]<=0;
		white[ 2995 ]<=0;
		white[ 2996 ]<=0;
		white[ 2997 ]<=0;
		white[ 2998 ]<=0;
		white[ 2999 ]<=0;
		white[ 3000 ]<=0;
		white[ 3001 ]<=0;
		white[ 3002 ]<=0;
		white[ 3003 ]<=0;
		white[ 3004 ]<=0;
		white[ 3005 ]<=0;
		white[ 3006 ]<=0;
		white[ 3007 ]<=0;
		white[ 3008 ]<=0;
		white[ 3009 ]<=0;
		white[ 3010 ]<=0;
		white[ 3011 ]<=0;
		white[ 3012 ]<=0;
		white[ 3013 ]<=0;
		white[ 3014 ]<=0;
		white[ 3015 ]<=0;
		white[ 3016 ]<=0;
		white[ 3017 ]<=0;
		white[ 3018 ]<=0;
		white[ 3019 ]<=0;
		white[ 3020 ]<=0;
		white[ 3021 ]<=0;
		white[ 3022 ]<=1;
		white[ 3023 ]<=1;
		white[ 3024 ]<=1;
		white[ 3025 ]<=1;
		white[ 3026 ]<=1;
		white[ 3027 ]<=1;
		white[ 3028 ]<=1;
		white[ 3029 ]<=1;
		white[ 3030 ]<=1;
		white[ 3031 ]<=1;
		white[ 3032 ]<=1;
		white[ 3033 ]<=1;
		white[ 3034 ]<=1;
		white[ 3035 ]<=1;
		white[ 3036 ]<=1;
		white[ 3037 ]<=1;
		white[ 3038 ]<=0;
		white[ 3039 ]<=0;
		white[ 3040 ]<=0;
		white[ 3041 ]<=0;
		white[ 3042 ]<=0;
		white[ 3043 ]<=0;
		white[ 3044 ]<=0;
		white[ 3045 ]<=0;
		white[ 3046 ]<=0;
		white[ 3047 ]<=0;
		white[ 3048 ]<=0;
		white[ 3049 ]<=0;
		white[ 3050 ]<=0;
		white[ 3051 ]<=0;
		white[ 3052 ]<=0;
		white[ 3053 ]<=0;
		white[ 3054 ]<=0;
		white[ 3055 ]<=0;
		white[ 3056 ]<=0;
		white[ 3057 ]<=0;
		white[ 3058 ]<=0;
		white[ 3059 ]<=0;
		white[ 3060 ]<=0;
		white[ 3061 ]<=0;
		white[ 3062 ]<=0;
		white[ 3063 ]<=0;
		white[ 3064 ]<=0;
		white[ 3065 ]<=0;
		white[ 3066 ]<=0;
		white[ 3067 ]<=0;
		white[ 3068 ]<=0;
		white[ 3069 ]<=0;
		white[ 3070 ]<=0;
		white[ 3071 ]<=0;
		white[ 3072 ]<=0;
		white[ 3073 ]<=0;
		white[ 3074 ]<=0;
		white[ 3075 ]<=0;
		white[ 3076 ]<=0;
		white[ 3077 ]<=0;
		white[ 3078 ]<=0;
		white[ 3079 ]<=0;
		white[ 3080 ]<=0;
		white[ 3081 ]<=0;
		white[ 3082 ]<=0;
		white[ 3083 ]<=1;
		white[ 3084 ]<=1;
		white[ 3085 ]<=1;
		white[ 3086 ]<=1;
		white[ 3087 ]<=1;
		white[ 3088 ]<=1;
		white[ 3089 ]<=1;
		white[ 3090 ]<=1;
		white[ 3091 ]<=1;
		white[ 3092 ]<=1;
		white[ 3093 ]<=1;
		white[ 3094 ]<=1;
		white[ 3095 ]<=1;
		white[ 3096 ]<=1;
		white[ 3097 ]<=0;
		white[ 3098 ]<=0;
		white[ 3099 ]<=0;
		white[ 3100 ]<=0;
		white[ 3101 ]<=0;
		white[ 3102 ]<=0;
		white[ 3103 ]<=0;
		white[ 3104 ]<=0;
		white[ 3105 ]<=0;
		white[ 3106 ]<=0;
		white[ 3107 ]<=0;
		white[ 3108 ]<=0;
		white[ 3109 ]<=0;
		white[ 3110 ]<=0;
		white[ 3111 ]<=0;
		white[ 3112 ]<=0;
		white[ 3113 ]<=0;
		white[ 3114 ]<=0;
		white[ 3115 ]<=0;
		white[ 3116 ]<=0;
		white[ 3117 ]<=0;
		white[ 3118 ]<=0;
		white[ 3119 ]<=0;
		white[ 3120 ]<=0;
		white[ 3121 ]<=0;
		white[ 3122 ]<=0;
		white[ 3123 ]<=0;
		white[ 3124 ]<=0;
		white[ 3125 ]<=0;
		white[ 3126 ]<=0;
		white[ 3127 ]<=0;
		white[ 3128 ]<=0;
		white[ 3129 ]<=0;
		white[ 3130 ]<=0;
		white[ 3131 ]<=0;
		white[ 3132 ]<=0;
		white[ 3133 ]<=0;
		white[ 3134 ]<=0;
		white[ 3135 ]<=0;
		white[ 3136 ]<=0;
		white[ 3137 ]<=0;
		white[ 3138 ]<=0;
		white[ 3139 ]<=0;
		white[ 3140 ]<=0;
		white[ 3141 ]<=0;
		white[ 3142 ]<=0;
		white[ 3143 ]<=0;
		white[ 3144 ]<=1;
		white[ 3145 ]<=1;
		white[ 3146 ]<=1;
		white[ 3147 ]<=1;
		white[ 3148 ]<=1;
		white[ 3149 ]<=1;
		white[ 3150 ]<=1;
		white[ 3151 ]<=1;
		white[ 3152 ]<=1;
		white[ 3153 ]<=1;
		white[ 3154 ]<=1;
		white[ 3155 ]<=1;
		white[ 3156 ]<=0;
		white[ 3157 ]<=0;
		white[ 3158 ]<=0;
		white[ 3159 ]<=0;
		white[ 3160 ]<=0;
		white[ 3161 ]<=0;
		white[ 3162 ]<=0;
		white[ 3163 ]<=0;
		white[ 3164 ]<=0;
		white[ 3165 ]<=0;
		white[ 3166 ]<=0;
		white[ 3167 ]<=0;
		white[ 3168 ]<=0;
		white[ 3169 ]<=0;
		white[ 3170 ]<=0;
		white[ 3171 ]<=0;
		white[ 3172 ]<=0;
		white[ 3173 ]<=0;
		white[ 3174 ]<=0;
		white[ 3175 ]<=0;
		white[ 3176 ]<=0;
		white[ 3177 ]<=0;
		white[ 3178 ]<=0;
		white[ 3179 ]<=0;
		white[ 3180 ]<=0;
		white[ 3181 ]<=0;
		white[ 3182 ]<=0;
		white[ 3183 ]<=0;
		white[ 3184 ]<=0;
		white[ 3185 ]<=0;
		white[ 3186 ]<=0;
		white[ 3187 ]<=0;
		white[ 3188 ]<=0;
		white[ 3189 ]<=0;
		white[ 3190 ]<=0;
		white[ 3191 ]<=0;
		white[ 3192 ]<=0;
		white[ 3193 ]<=0;
		white[ 3194 ]<=0;
		white[ 3195 ]<=0;
		white[ 3196 ]<=0;
		white[ 3197 ]<=0;
		white[ 3198 ]<=0;
		white[ 3199 ]<=0;
		white[ 3200 ]<=0;
		white[ 3201 ]<=0;
		white[ 3202 ]<=0;
		white[ 3203 ]<=0;
		white[ 3204 ]<=0;
		white[ 3205 ]<=1;
		white[ 3206 ]<=1;
		white[ 3207 ]<=1;
		white[ 3208 ]<=1;
		white[ 3209 ]<=1;
		white[ 3210 ]<=1;
		white[ 3211 ]<=1;
		white[ 3212 ]<=1;
		white[ 3213 ]<=1;
		white[ 3214 ]<=0;
		white[ 3215 ]<=0;
		white[ 3216 ]<=0;
		white[ 3217 ]<=0;
		white[ 3218 ]<=0;
		white[ 3219 ]<=0;
		white[ 3220 ]<=0;
		white[ 3221 ]<=0;
		white[ 3222 ]<=0;
		white[ 3223 ]<=0;
		white[ 3224 ]<=0;
		white[ 3225 ]<=0;
		white[ 3226 ]<=0;
		white[ 3227 ]<=0;
		white[ 3228 ]<=0;
		white[ 3229 ]<=0;
		white[ 3230 ]<=0;
		white[ 3231 ]<=0;
		white[ 3232 ]<=0;
		white[ 3233 ]<=0;
		white[ 3234 ]<=0;
		white[ 3235 ]<=0;
		white[ 3236 ]<=0;
		white[ 3237 ]<=0;
		white[ 3238 ]<=0;
		white[ 3239 ]<=0;
		white[ 3240 ]<=0;
		white[ 3241 ]<=0;
		white[ 3242 ]<=0;
		white[ 3243 ]<=0;
		white[ 3244 ]<=0;
		white[ 3245 ]<=0;
		white[ 3246 ]<=0;
		white[ 3247 ]<=0;
		white[ 3248 ]<=0;
		white[ 3249 ]<=0;
		white[ 3250 ]<=0;
		white[ 3251 ]<=0;
		white[ 3252 ]<=0;
		white[ 3253 ]<=0;
		white[ 3254 ]<=0;
		white[ 3255 ]<=0;
		white[ 3256 ]<=0;
		white[ 3257 ]<=0;
		white[ 3258 ]<=0;
		white[ 3259 ]<=0;
		white[ 3260 ]<=0;
		white[ 3261 ]<=0;
		white[ 3262 ]<=0;
		white[ 3263 ]<=0;
		white[ 3264 ]<=0;
		white[ 3265 ]<=0;
		white[ 3266 ]<=1;
		white[ 3267 ]<=1;
		white[ 3268 ]<=1;
		white[ 3269 ]<=1;
		white[ 3270 ]<=1;
		white[ 3271 ]<=1;
		white[ 3272 ]<=1;
		white[ 3273 ]<=0;
		white[ 3274 ]<=0;
		white[ 3275 ]<=0;
		white[ 3276 ]<=0;
		white[ 3277 ]<=0;
		white[ 3278 ]<=0;
		white[ 3279 ]<=0;
		white[ 3280 ]<=0;
		white[ 3281 ]<=0;
		white[ 3282 ]<=0;
		white[ 3283 ]<=0;
		white[ 3284 ]<=0;
		white[ 3285 ]<=0;
		white[ 3286 ]<=0;
		white[ 3287 ]<=0;
		white[ 3288 ]<=0;
		white[ 3289 ]<=0;
		white[ 3290 ]<=0;
		white[ 3291 ]<=0;
		white[ 3292 ]<=0;
		white[ 3293 ]<=0;
		white[ 3294 ]<=0;
		white[ 3295 ]<=0;
		white[ 3296 ]<=0;
		white[ 3297 ]<=0;
		white[ 3298 ]<=0;
		white[ 3299 ]<=0;
		white[ 3300 ]<=0;
		white[ 3301 ]<=0;
		white[ 3302 ]<=0;
		white[ 3303 ]<=0;
		white[ 3304 ]<=0;
		white[ 3305 ]<=0;
		white[ 3306 ]<=0;
		white[ 3307 ]<=0;
		white[ 3308 ]<=0;
		white[ 3309 ]<=0;
		white[ 3310 ]<=0;
		white[ 3311 ]<=0;
		white[ 3312 ]<=0;
		white[ 3313 ]<=0;
		white[ 3314 ]<=0;
		white[ 3315 ]<=0;
		white[ 3316 ]<=0;
		white[ 3317 ]<=0;
		white[ 3318 ]<=0;
		white[ 3319 ]<=0;
		white[ 3320 ]<=0;
		white[ 3321 ]<=0;
		white[ 3322 ]<=0;
		white[ 3323 ]<=0;
		white[ 3324 ]<=0;
		white[ 3325 ]<=0;
		white[ 3326 ]<=0;
		white[ 3327 ]<=0;
		white[ 3328 ]<=1;
		white[ 3329 ]<=1;
		white[ 3330 ]<=1;
		white[ 3331 ]<=1;
		white[ 3332 ]<=0;
		white[ 3333 ]<=0;
		white[ 3334 ]<=0;
		white[ 3335 ]<=0;
		white[ 3336 ]<=0;
		white[ 3337 ]<=0;
		white[ 3338 ]<=0;
		white[ 3339 ]<=0;
		white[ 3340 ]<=0;
		white[ 3341 ]<=0;
		white[ 3342 ]<=0;
		white[ 3343 ]<=0;
		white[ 3344 ]<=0;
		white[ 3345 ]<=0;
		white[ 3346 ]<=0;
		white[ 3347 ]<=0;
		white[ 3348 ]<=0;
		white[ 3349 ]<=0;
		white[ 3350 ]<=0;
		white[ 3351 ]<=0;
		white[ 3352 ]<=0;
		white[ 3353 ]<=0;
		white[ 3354 ]<=0;
		white[ 3355 ]<=0;
		white[ 3356 ]<=0;
		white[ 3357 ]<=0;
		white[ 3358 ]<=0;
		white[ 3359 ]<=0;
		white[ 3360 ]<=0;
		white[ 3361 ]<=0;
		white[ 3362 ]<=0;
		white[ 3363 ]<=0;
		white[ 3364 ]<=0;
		white[ 3365 ]<=0;
		white[ 3366 ]<=0;
		white[ 3367 ]<=0;
		white[ 3368 ]<=0;
		white[ 3369 ]<=0;
		white[ 3370 ]<=0;
		white[ 3371 ]<=0;
		white[ 3372 ]<=0;
		white[ 3373 ]<=0;
		white[ 3374 ]<=0;
		white[ 3375 ]<=0;
		white[ 3376 ]<=0;
		white[ 3377 ]<=0;
		white[ 3378 ]<=0;
		white[ 3379 ]<=0;
		white[ 3380 ]<=0;
		white[ 3381 ]<=0;
		white[ 3382 ]<=0;
		white[ 3383 ]<=0;
		white[ 3384 ]<=0;
		white[ 3385 ]<=0;
		white[ 3386 ]<=0;
		white[ 3387 ]<=0;
		white[ 3388 ]<=0;
		white[ 3389 ]<=1;
		white[ 3390 ]<=1;
		white[ 3391 ]<=0;
		white[ 3392 ]<=0;
		white[ 3393 ]<=0;
		white[ 3394 ]<=0;
		white[ 3395 ]<=0;
		white[ 3396 ]<=0;
		white[ 3397 ]<=0;
		white[ 3398 ]<=0;
		white[ 3399 ]<=0;
		white[ 3400 ]<=0;
		white[ 3401 ]<=0;
		white[ 3402 ]<=0;
		white[ 3403 ]<=0;
		white[ 3404 ]<=0;
		white[ 3405 ]<=0;
		white[ 3406 ]<=0;
		white[ 3407 ]<=0;
		white[ 3408 ]<=0;
		white[ 3409 ]<=0;
		white[ 3410 ]<=0;
		white[ 3411 ]<=0;
		white[ 3412 ]<=0;
		white[ 3413 ]<=0;
		white[ 3414 ]<=0;
		white[ 3415 ]<=0;
		white[ 3416 ]<=0;
		white[ 3417 ]<=0;
		white[ 3418 ]<=0;
		white[ 3419 ]<=0;
		white[ 3420 ]<=0;
		white[ 3421 ]<=0;
		white[ 3422 ]<=0;
		white[ 3423 ]<=0;
		white[ 3424 ]<=0;
		white[ 3425 ]<=0;
		white[ 3426 ]<=0;
		white[ 3427 ]<=0;
		white[ 3428 ]<=0;
		white[ 3429 ]<=0;
		white[ 3430 ]<=0;
		white[ 3431 ]<=0;
		white[ 3432 ]<=0;
		white[ 3433 ]<=0;
		white[ 3434 ]<=0;
		white[ 3435 ]<=0;
		white[ 3436 ]<=0;
		white[ 3437 ]<=0;
		white[ 3438 ]<=0;
		white[ 3439 ]<=0;
		white[ 3440 ]<=0;
		white[ 3441 ]<=0;
		white[ 3442 ]<=0;
		white[ 3443 ]<=0;
		white[ 3444 ]<=0;
		white[ 3445 ]<=0;
		white[ 3446 ]<=0;
		white[ 3447 ]<=0;
		white[ 3448 ]<=0;
		white[ 3449 ]<=0;
		white[ 3450 ]<=0;
		white[ 3451 ]<=0;
		white[ 3452 ]<=0;
		white[ 3453 ]<=0;
		white[ 3454 ]<=0;
		white[ 3455 ]<=0;
		white[ 3456 ]<=0;
		white[ 3457 ]<=0;
		white[ 3458 ]<=0;
		white[ 3459 ]<=0;
		white[ 3460 ]<=0;
		white[ 3461 ]<=0;
		white[ 3462 ]<=0;
		white[ 3463 ]<=0;
		white[ 3464 ]<=0;
		white[ 3465 ]<=0;
		white[ 3466 ]<=0;
		white[ 3467 ]<=0;
		white[ 3468 ]<=0;
		white[ 3469 ]<=0;
		white[ 3470 ]<=0;
		white[ 3471 ]<=0;
		white[ 3472 ]<=0;
		white[ 3473 ]<=0;
		white[ 3474 ]<=0;
		white[ 3475 ]<=0;
		white[ 3476 ]<=0;
		white[ 3477 ]<=0;
		white[ 3478 ]<=0;
		white[ 3479 ]<=0;
		white[ 3480 ]<=0;
		white[ 3481 ]<=0;
		white[ 3482 ]<=0;
		white[ 3483 ]<=0;
		white[ 3484 ]<=0;
		white[ 3485 ]<=0;
		white[ 3486 ]<=0;
		white[ 3487 ]<=0;
		white[ 3488 ]<=0;
		white[ 3489 ]<=0;
		white[ 3490 ]<=0;
		white[ 3491 ]<=0;
		white[ 3492 ]<=0;
		white[ 3493 ]<=0;
		white[ 3494 ]<=0;
		white[ 3495 ]<=0;
		white[ 3496 ]<=0;
		white[ 3497 ]<=0;
		white[ 3498 ]<=0;
		white[ 3499 ]<=0;
		white[ 3500 ]<=0;
		white[ 3501 ]<=0;
		white[ 3502 ]<=0;
		white[ 3503 ]<=0;
		white[ 3504 ]<=0;
		white[ 3505 ]<=0;
		white[ 3506 ]<=0;
		white[ 3507 ]<=0;
		white[ 3508 ]<=0;
		white[ 3509 ]<=0;
		white[ 3510 ]<=0;
		white[ 3511 ]<=0;
		white[ 3512 ]<=0;
		white[ 3513 ]<=0;
		white[ 3514 ]<=0;
		white[ 3515 ]<=0;
		white[ 3516 ]<=0;
		white[ 3517 ]<=0;
		white[ 3518 ]<=0;
		white[ 3519 ]<=0;
		white[ 3520 ]<=0;
		white[ 3521 ]<=0;
		white[ 3522 ]<=0;
		white[ 3523 ]<=0;
		white[ 3524 ]<=0;
		white[ 3525 ]<=0;
		white[ 3526 ]<=0;
		white[ 3527 ]<=0;
		white[ 3528 ]<=0;
		white[ 3529 ]<=0;
		white[ 3530 ]<=0;
		white[ 3531 ]<=0;
		white[ 3532 ]<=0;
		white[ 3533 ]<=0;
		white[ 3534 ]<=0;
		white[ 3535 ]<=0;
		white[ 3536 ]<=0;
		white[ 3537 ]<=0;
		white[ 3538 ]<=0;
		white[ 3539 ]<=0;
		white[ 3540 ]<=0;
		white[ 3541 ]<=0;
		white[ 3542 ]<=0;
		white[ 3543 ]<=0;
		white[ 3544 ]<=0;
		white[ 3545 ]<=0;
		white[ 3546 ]<=0;
		white[ 3547 ]<=0;
		white[ 3548 ]<=0;
		white[ 3549 ]<=0;
		white[ 3550 ]<=0;
		white[ 3551 ]<=0;
		white[ 3552 ]<=0;
		white[ 3553 ]<=0;
		white[ 3554 ]<=0;
		white[ 3555 ]<=0;
		white[ 3556 ]<=0;
		white[ 3557 ]<=0;
		white[ 3558 ]<=0;
		white[ 3559 ]<=0;
		white[ 3560 ]<=0;
		white[ 3561 ]<=0;
		white[ 3562 ]<=0;
		white[ 3563 ]<=0;
		white[ 3564 ]<=0;
		white[ 3565 ]<=0;
		white[ 3566 ]<=0;
		white[ 3567 ]<=0;
		white[ 3568 ]<=0;
		white[ 3569 ]<=0;
		white[ 3570 ]<=0;
		white[ 3571 ]<=0;
		white[ 3572 ]<=0;
		white[ 3573 ]<=0;
		white[ 3574 ]<=0;
		white[ 3575 ]<=0;
		white[ 3576 ]<=0;
		white[ 3577 ]<=0;
		white[ 3578 ]<=0;
		white[ 3579 ]<=0;
		white[ 3580 ]<=0;
		white[ 3581 ]<=0;
		white[ 3582 ]<=0;
		white[ 3583 ]<=0;
		white[ 3584 ]<=0;
		white[ 3585 ]<=0;
		white[ 3586 ]<=0;
		white[ 3587 ]<=0;
		white[ 3588 ]<=0;
		white[ 3589 ]<=0;
		white[ 3590 ]<=0;
		white[ 3591 ]<=0;
		white[ 3592 ]<=0;
		white[ 3593 ]<=0;
		white[ 3594 ]<=0;
		white[ 3595 ]<=0;
		white[ 3596 ]<=0;
		white[ 3597 ]<=0;
		white[ 3598 ]<=0;
		white[ 3599 ]<=0;
		end
			//coin
			18'd96239: begin
			white[ 0 ]<=0;
			white[ 1 ]<=0;
			white[ 2 ]<=0;
			white[ 3 ]<=0;
			white[ 4 ]<=0;
			white[ 5 ]<=0;
			white[ 6 ]<=0;
			white[ 7 ]<=0;
			white[ 8 ]<=0;
			white[ 9 ]<=0;
			white[ 10 ]<=0;
			white[ 11 ]<=0;
			white[ 12 ]<=0;
			white[ 13 ]<=0;
			white[ 14 ]<=0;
			white[ 15 ]<=0;
			white[ 16 ]<=0;
			white[ 17 ]<=0;
			white[ 18 ]<=0;
			white[ 19 ]<=0;
			white[ 20 ]<=0;
			white[ 21 ]<=0;
			white[ 22 ]<=0;
			white[ 23 ]<=1;
			white[ 24 ]<=1;
			white[ 25 ]<=1;
			white[ 26 ]<=1;
			white[ 27 ]<=1;
			white[ 28 ]<=1;
			white[ 29 ]<=1;
			white[ 30 ]<=1;
			white[ 31 ]<=1;
			white[ 32 ]<=1;
			white[ 33 ]<=1;
			white[ 34 ]<=1;
			white[ 35 ]<=1;
			white[ 36 ]<=0;
			white[ 37 ]<=0;
			white[ 38 ]<=0;
			white[ 39 ]<=0;
			white[ 40 ]<=0;
			white[ 41 ]<=0;
			white[ 42 ]<=0;
			white[ 43 ]<=0;
			white[ 44 ]<=0;
			white[ 45 ]<=0;
			white[ 46 ]<=0;
			white[ 47 ]<=0;
			white[ 48 ]<=0;
			white[ 49 ]<=0;
			white[ 50 ]<=0;
			white[ 51 ]<=0;
			white[ 52 ]<=0;
			white[ 53 ]<=0;
			white[ 54 ]<=0;
			white[ 55 ]<=0;
			white[ 56 ]<=0;
			white[ 57 ]<=0;
			white[ 58 ]<=0;
			white[ 59 ]<=0;
			white[ 60 ]<=0;
			white[ 61 ]<=0;
			white[ 62 ]<=0;
			white[ 63 ]<=0;
			white[ 64 ]<=0;
			white[ 65 ]<=0;
			white[ 66 ]<=0;
			white[ 67 ]<=0;
			white[ 68 ]<=0;
			white[ 69 ]<=0;
			white[ 70 ]<=0;
			white[ 71 ]<=0;
			white[ 72 ]<=0;
			white[ 73 ]<=0;
			white[ 74 ]<=0;
			white[ 75 ]<=0;
			white[ 76 ]<=0;
			white[ 77 ]<=0;
			white[ 78 ]<=0;
			white[ 79 ]<=1;
			white[ 80 ]<=1;
			white[ 81 ]<=1;
			white[ 82 ]<=1;
			white[ 83 ]<=1;
			white[ 84 ]<=1;
			white[ 85 ]<=1;
			white[ 86 ]<=1;
			white[ 87 ]<=1;
			white[ 88 ]<=1;
			white[ 89 ]<=1;
			white[ 90 ]<=1;
			white[ 91 ]<=1;
			white[ 92 ]<=1;
			white[ 93 ]<=1;
			white[ 94 ]<=1;
			white[ 95 ]<=1;
			white[ 96 ]<=1;
			white[ 97 ]<=1;
			white[ 98 ]<=1;
			white[ 99 ]<=1;
			white[ 100 ]<=0;
			white[ 101 ]<=0;
			white[ 102 ]<=0;
			white[ 103 ]<=0;
			white[ 104 ]<=0;
			white[ 105 ]<=0;
			white[ 106 ]<=0;
			white[ 107 ]<=0;
			white[ 108 ]<=0;
			white[ 109 ]<=0;
			white[ 110 ]<=0;
			white[ 111 ]<=0;
			white[ 112 ]<=0;
			white[ 113 ]<=0;
			white[ 114 ]<=0;
			white[ 115 ]<=0;
			white[ 116 ]<=0;
			white[ 117 ]<=0;
			white[ 118 ]<=0;
			white[ 119 ]<=0;
			white[ 120 ]<=0;
			white[ 121 ]<=0;
			white[ 122 ]<=0;
			white[ 123 ]<=0;
			white[ 124 ]<=0;
			white[ 125 ]<=0;
			white[ 126 ]<=0;
			white[ 127 ]<=0;
			white[ 128 ]<=0;
			white[ 129 ]<=0;
			white[ 130 ]<=0;
			white[ 131 ]<=0;
			white[ 132 ]<=0;
			white[ 133 ]<=0;
			white[ 134 ]<=0;
			white[ 135 ]<=0;
			white[ 136 ]<=0;
			white[ 137 ]<=1;
			white[ 138 ]<=1;
			white[ 139 ]<=1;
			white[ 140 ]<=1;
			white[ 141 ]<=1;
			white[ 142 ]<=1;
			white[ 143 ]<=1;
			white[ 144 ]<=1;
			white[ 145 ]<=1;
			white[ 146 ]<=1;
			white[ 147 ]<=1;
			white[ 148 ]<=1;
			white[ 149 ]<=1;
			white[ 150 ]<=1;
			white[ 151 ]<=1;
			white[ 152 ]<=1;
			white[ 153 ]<=1;
			white[ 154 ]<=1;
			white[ 155 ]<=1;
			white[ 156 ]<=1;
			white[ 157 ]<=1;
			white[ 158 ]<=1;
			white[ 159 ]<=1;
			white[ 160 ]<=1;
			white[ 161 ]<=1;
			white[ 162 ]<=0;
			white[ 163 ]<=0;
			white[ 164 ]<=0;
			white[ 165 ]<=0;
			white[ 166 ]<=0;
			white[ 167 ]<=0;
			white[ 168 ]<=0;
			white[ 169 ]<=0;
			white[ 170 ]<=0;
			white[ 171 ]<=0;
			white[ 172 ]<=0;
			white[ 173 ]<=0;
			white[ 174 ]<=0;
			white[ 175 ]<=0;
			white[ 176 ]<=0;
			white[ 177 ]<=0;
			white[ 178 ]<=0;
			white[ 179 ]<=0;
			white[ 180 ]<=0;
			white[ 181 ]<=0;
			white[ 182 ]<=0;
			white[ 183 ]<=0;
			white[ 184 ]<=0;
			white[ 185 ]<=0;
			white[ 186 ]<=0;
			white[ 187 ]<=0;
			white[ 188 ]<=0;
			white[ 189 ]<=0;
			white[ 190 ]<=0;
			white[ 191 ]<=0;
			white[ 192 ]<=0;
			white[ 193 ]<=0;
			white[ 194 ]<=0;
			white[ 195 ]<=1;
			white[ 196 ]<=1;
			white[ 197 ]<=1;
			white[ 198 ]<=1;
			white[ 199 ]<=1;
			white[ 200 ]<=1;
			white[ 201 ]<=1;
			white[ 202 ]<=1;
			white[ 203 ]<=1;
			white[ 204 ]<=1;
			white[ 205 ]<=1;
			white[ 206 ]<=1;
			white[ 207 ]<=1;
			white[ 208 ]<=1;
			white[ 209 ]<=1;
			white[ 210 ]<=1;
			white[ 211 ]<=1;
			white[ 212 ]<=1;
			white[ 213 ]<=1;
			white[ 214 ]<=1;
			white[ 215 ]<=1;
			white[ 216 ]<=1;
			white[ 217 ]<=1;
			white[ 218 ]<=1;
			white[ 219 ]<=1;
			white[ 220 ]<=1;
			white[ 221 ]<=1;
			white[ 222 ]<=1;
			white[ 223 ]<=1;
			white[ 224 ]<=0;
			white[ 225 ]<=0;
			white[ 226 ]<=0;
			white[ 227 ]<=0;
			white[ 228 ]<=0;
			white[ 229 ]<=0;
			white[ 230 ]<=0;
			white[ 231 ]<=0;
			white[ 232 ]<=0;
			white[ 233 ]<=0;
			white[ 234 ]<=0;
			white[ 235 ]<=0;
			white[ 236 ]<=0;
			white[ 237 ]<=0;
			white[ 238 ]<=0;
			white[ 239 ]<=0;
			white[ 240 ]<=0;
			white[ 241 ]<=0;
			white[ 242 ]<=0;
			white[ 243 ]<=0;
			white[ 244 ]<=0;
			white[ 245 ]<=0;
			white[ 246 ]<=0;
			white[ 247 ]<=0;
			white[ 248 ]<=0;
			white[ 249 ]<=0;
			white[ 250 ]<=0;
			white[ 251 ]<=0;
			white[ 252 ]<=0;
			white[ 253 ]<=1;
			white[ 254 ]<=1;
			white[ 255 ]<=1;
			white[ 256 ]<=1;
			white[ 257 ]<=1;
			white[ 258 ]<=1;
			white[ 259 ]<=1;
			white[ 260 ]<=1;
			white[ 261 ]<=1;
			white[ 262 ]<=1;
			white[ 263 ]<=1;
			white[ 264 ]<=1;
			white[ 265 ]<=1;
			white[ 266 ]<=1;
			white[ 267 ]<=1;
			white[ 268 ]<=1;
			white[ 269 ]<=1;
			white[ 270 ]<=1;
			white[ 271 ]<=1;
			white[ 272 ]<=1;
			white[ 273 ]<=1;
			white[ 274 ]<=1;
			white[ 275 ]<=1;
			white[ 276 ]<=1;
			white[ 277 ]<=1;
			white[ 278 ]<=1;
			white[ 279 ]<=1;
			white[ 280 ]<=1;
			white[ 281 ]<=1;
			white[ 282 ]<=1;
			white[ 283 ]<=1;
			white[ 284 ]<=1;
			white[ 285 ]<=1;
			white[ 286 ]<=0;
			white[ 287 ]<=0;
			white[ 288 ]<=0;
			white[ 289 ]<=0;
			white[ 290 ]<=0;
			white[ 291 ]<=0;
			white[ 292 ]<=0;
			white[ 293 ]<=0;
			white[ 294 ]<=0;
			white[ 295 ]<=0;
			white[ 296 ]<=0;
			white[ 297 ]<=0;
			white[ 298 ]<=0;
			white[ 299 ]<=0;
			white[ 300 ]<=0;
			white[ 301 ]<=0;
			white[ 302 ]<=0;
			white[ 303 ]<=0;
			white[ 304 ]<=0;
			white[ 305 ]<=0;
			white[ 306 ]<=0;
			white[ 307 ]<=0;
			white[ 308 ]<=0;
			white[ 309 ]<=0;
			white[ 310 ]<=0;
			white[ 311 ]<=0;
			white[ 312 ]<=1;
			white[ 313 ]<=1;
			white[ 314 ]<=1;
			white[ 315 ]<=1;
			white[ 316 ]<=1;
			white[ 317 ]<=1;
			white[ 318 ]<=1;
			white[ 319 ]<=1;
			white[ 320 ]<=1;
			white[ 321 ]<=1;
			white[ 322 ]<=1;
			white[ 323 ]<=1;
			white[ 324 ]<=1;
			white[ 325 ]<=1;
			white[ 326 ]<=1;
			white[ 327 ]<=1;
			white[ 328 ]<=1;
			white[ 329 ]<=1;
			white[ 330 ]<=1;
			white[ 331 ]<=1;
			white[ 332 ]<=1;
			white[ 333 ]<=1;
			white[ 334 ]<=1;
			white[ 335 ]<=1;
			white[ 336 ]<=1;
			white[ 337 ]<=1;
			white[ 338 ]<=1;
			white[ 339 ]<=1;
			white[ 340 ]<=1;
			white[ 341 ]<=1;
			white[ 342 ]<=1;
			white[ 343 ]<=1;
			white[ 344 ]<=1;
			white[ 345 ]<=1;
			white[ 346 ]<=1;
			white[ 347 ]<=0;
			white[ 348 ]<=0;
			white[ 349 ]<=0;
			white[ 350 ]<=0;
			white[ 351 ]<=0;
			white[ 352 ]<=0;
			white[ 353 ]<=0;
			white[ 354 ]<=0;
			white[ 355 ]<=0;
			white[ 356 ]<=0;
			white[ 357 ]<=0;
			white[ 358 ]<=0;
			white[ 359 ]<=0;
			white[ 360 ]<=0;
			white[ 361 ]<=0;
			white[ 362 ]<=0;
			white[ 363 ]<=0;
			white[ 364 ]<=0;
			white[ 365 ]<=0;
			white[ 366 ]<=0;
			white[ 367 ]<=0;
			white[ 368 ]<=0;
			white[ 369 ]<=0;
			white[ 370 ]<=0;
			white[ 371 ]<=1;
			white[ 372 ]<=1;
			white[ 373 ]<=1;
			white[ 374 ]<=1;
			white[ 375 ]<=1;
			white[ 376 ]<=1;
			white[ 377 ]<=1;
			white[ 378 ]<=1;
			white[ 379 ]<=1;
			white[ 380 ]<=1;
			white[ 381 ]<=1;
			white[ 382 ]<=1;
			white[ 383 ]<=1;
			white[ 384 ]<=1;
			white[ 385 ]<=1;
			white[ 386 ]<=1;
			white[ 387 ]<=1;
			white[ 388 ]<=1;
			white[ 389 ]<=1;
			white[ 390 ]<=1;
			white[ 391 ]<=1;
			white[ 392 ]<=1;
			white[ 393 ]<=1;
			white[ 394 ]<=1;
			white[ 395 ]<=1;
			white[ 396 ]<=1;
			white[ 397 ]<=1;
			white[ 398 ]<=1;
			white[ 399 ]<=1;
			white[ 400 ]<=1;
			white[ 401 ]<=1;
			white[ 402 ]<=1;
			white[ 403 ]<=1;
			white[ 404 ]<=1;
			white[ 405 ]<=1;
			white[ 406 ]<=1;
			white[ 407 ]<=1;
			white[ 408 ]<=1;
			white[ 409 ]<=0;
			white[ 410 ]<=0;
			white[ 411 ]<=0;
			white[ 412 ]<=0;
			white[ 413 ]<=0;
			white[ 414 ]<=0;
			white[ 415 ]<=0;
			white[ 416 ]<=0;
			white[ 417 ]<=0;
			white[ 418 ]<=0;
			white[ 419 ]<=0;
			white[ 420 ]<=0;
			white[ 421 ]<=0;
			white[ 422 ]<=0;
			white[ 423 ]<=0;
			white[ 424 ]<=0;
			white[ 425 ]<=0;
			white[ 426 ]<=0;
			white[ 427 ]<=0;
			white[ 428 ]<=0;
			white[ 429 ]<=0;
			white[ 430 ]<=1;
			white[ 431 ]<=1;
			white[ 432 ]<=1;
			white[ 433 ]<=1;
			white[ 434 ]<=1;
			white[ 435 ]<=1;
			white[ 436 ]<=1;
			white[ 437 ]<=1;
			white[ 438 ]<=1;
			white[ 439 ]<=1;
			white[ 440 ]<=1;
			white[ 441 ]<=1;
			white[ 442 ]<=1;
			white[ 443 ]<=1;
			white[ 444 ]<=1;
			white[ 445 ]<=1;
			white[ 446 ]<=1;
			white[ 447 ]<=1;
			white[ 448 ]<=1;
			white[ 449 ]<=1;
			white[ 450 ]<=1;
			white[ 451 ]<=1;
			white[ 452 ]<=1;
			white[ 453 ]<=1;
			white[ 454 ]<=1;
			white[ 455 ]<=1;
			white[ 456 ]<=1;
			white[ 457 ]<=1;
			white[ 458 ]<=1;
			white[ 459 ]<=1;
			white[ 460 ]<=1;
			white[ 461 ]<=1;
			white[ 462 ]<=1;
			white[ 463 ]<=1;
			white[ 464 ]<=1;
			white[ 465 ]<=1;
			white[ 466 ]<=1;
			white[ 467 ]<=1;
			white[ 468 ]<=1;
			white[ 469 ]<=1;
			white[ 470 ]<=0;
			white[ 471 ]<=0;
			white[ 472 ]<=0;
			white[ 473 ]<=0;
			white[ 474 ]<=0;
			white[ 475 ]<=0;
			white[ 476 ]<=0;
			white[ 477 ]<=0;
			white[ 478 ]<=0;
			white[ 479 ]<=0;
			white[ 480 ]<=0;
			white[ 481 ]<=0;
			white[ 482 ]<=0;
			white[ 483 ]<=0;
			white[ 484 ]<=0;
			white[ 485 ]<=0;
			white[ 486 ]<=0;
			white[ 487 ]<=0;
			white[ 488 ]<=1;
			white[ 489 ]<=1;
			white[ 490 ]<=1;
			white[ 491 ]<=1;
			white[ 492 ]<=1;
			white[ 493 ]<=1;
			white[ 494 ]<=1;
			white[ 495 ]<=1;
			white[ 496 ]<=1;
			white[ 497 ]<=1;
			white[ 498 ]<=1;
			white[ 499 ]<=1;
			white[ 500 ]<=1;
			white[ 501 ]<=1;
			white[ 502 ]<=1;
			white[ 503 ]<=1;
			white[ 504 ]<=1;
			white[ 505 ]<=1;
			white[ 506 ]<=1;
			white[ 507 ]<=1;
			white[ 508 ]<=1;
			white[ 509 ]<=1;
			white[ 510 ]<=1;
			white[ 511 ]<=1;
			white[ 512 ]<=1;
			white[ 513 ]<=1;
			white[ 514 ]<=1;
			white[ 515 ]<=1;
			white[ 516 ]<=1;
			white[ 517 ]<=1;
			white[ 518 ]<=1;
			white[ 519 ]<=1;
			white[ 520 ]<=1;
			white[ 521 ]<=1;
			white[ 522 ]<=1;
			white[ 523 ]<=1;
			white[ 524 ]<=1;
			white[ 525 ]<=1;
			white[ 526 ]<=1;
			white[ 527 ]<=1;
			white[ 528 ]<=1;
			white[ 529 ]<=1;
			white[ 530 ]<=1;
			white[ 531 ]<=0;
			white[ 532 ]<=0;
			white[ 533 ]<=0;
			white[ 534 ]<=0;
			white[ 535 ]<=0;
			white[ 536 ]<=0;
			white[ 537 ]<=0;
			white[ 538 ]<=0;
			white[ 539 ]<=0;
			white[ 540 ]<=0;
			white[ 541 ]<=0;
			white[ 542 ]<=0;
			white[ 543 ]<=0;
			white[ 544 ]<=0;
			white[ 545 ]<=0;
			white[ 546 ]<=0;
			white[ 547 ]<=1;
			white[ 548 ]<=1;
			white[ 549 ]<=1;
			white[ 550 ]<=1;
			white[ 551 ]<=1;
			white[ 552 ]<=1;
			white[ 553 ]<=1;
			white[ 554 ]<=1;
			white[ 555 ]<=1;
			white[ 556 ]<=1;
			white[ 557 ]<=1;
			white[ 558 ]<=1;
			white[ 559 ]<=1;
			white[ 560 ]<=1;
			white[ 561 ]<=1;
			white[ 562 ]<=1;
			white[ 563 ]<=1;
			white[ 564 ]<=1;
			white[ 565 ]<=1;
			white[ 566 ]<=1;
			white[ 567 ]<=1;
			white[ 568 ]<=1;
			white[ 569 ]<=1;
			white[ 570 ]<=1;
			white[ 571 ]<=1;
			white[ 572 ]<=1;
			white[ 573 ]<=1;
			white[ 574 ]<=1;
			white[ 575 ]<=1;
			white[ 576 ]<=1;
			white[ 577 ]<=1;
			white[ 578 ]<=1;
			white[ 579 ]<=1;
			white[ 580 ]<=1;
			white[ 581 ]<=1;
			white[ 582 ]<=1;
			white[ 583 ]<=1;
			white[ 584 ]<=1;
			white[ 585 ]<=1;
			white[ 586 ]<=1;
			white[ 587 ]<=1;
			white[ 588 ]<=1;
			white[ 589 ]<=1;
			white[ 590 ]<=1;
			white[ 591 ]<=1;
			white[ 592 ]<=0;
			white[ 593 ]<=0;
			white[ 594 ]<=0;
			white[ 595 ]<=0;
			white[ 596 ]<=0;
			white[ 597 ]<=0;
			white[ 598 ]<=0;
			white[ 599 ]<=0;
			white[ 600 ]<=0;
			white[ 601 ]<=0;
			white[ 602 ]<=0;
			white[ 603 ]<=0;
			white[ 604 ]<=0;
			white[ 605 ]<=0;
			white[ 606 ]<=0;
			white[ 607 ]<=1;
			white[ 608 ]<=1;
			white[ 609 ]<=1;
			white[ 610 ]<=1;
			white[ 611 ]<=1;
			white[ 612 ]<=1;
			white[ 613 ]<=1;
			white[ 614 ]<=1;
			white[ 615 ]<=1;
			white[ 616 ]<=1;
			white[ 617 ]<=1;
			white[ 618 ]<=1;
			white[ 619 ]<=1;
			white[ 620 ]<=1;
			white[ 621 ]<=1;
			white[ 622 ]<=1;
			white[ 623 ]<=1;
			white[ 624 ]<=1;
			white[ 625 ]<=1;
			white[ 626 ]<=1;
			white[ 627 ]<=1;
			white[ 628 ]<=1;
			white[ 629 ]<=1;
			white[ 630 ]<=1;
			white[ 631 ]<=1;
			white[ 632 ]<=1;
			white[ 633 ]<=1;
			white[ 634 ]<=1;
			white[ 635 ]<=1;
			white[ 636 ]<=1;
			white[ 637 ]<=1;
			white[ 638 ]<=1;
			white[ 639 ]<=1;
			white[ 640 ]<=1;
			white[ 641 ]<=1;
			white[ 642 ]<=1;
			white[ 643 ]<=1;
			white[ 644 ]<=1;
			white[ 645 ]<=1;
			white[ 646 ]<=1;
			white[ 647 ]<=1;
			white[ 648 ]<=1;
			white[ 649 ]<=1;
			white[ 650 ]<=1;
			white[ 651 ]<=1;
			white[ 652 ]<=1;
			white[ 653 ]<=0;
			white[ 654 ]<=0;
			white[ 655 ]<=0;
			white[ 656 ]<=0;
			white[ 657 ]<=0;
			white[ 658 ]<=0;
			white[ 659 ]<=0;
			white[ 660 ]<=0;
			white[ 661 ]<=0;
			white[ 662 ]<=0;
			white[ 663 ]<=0;
			white[ 664 ]<=0;
			white[ 665 ]<=0;
			white[ 666 ]<=1;
			white[ 667 ]<=1;
			white[ 668 ]<=1;
			white[ 669 ]<=1;
			white[ 670 ]<=1;
			white[ 671 ]<=1;
			white[ 672 ]<=1;
			white[ 673 ]<=1;
			white[ 674 ]<=1;
			white[ 675 ]<=1;
			white[ 676 ]<=1;
			white[ 677 ]<=1;
			white[ 678 ]<=1;
			white[ 679 ]<=1;
			white[ 680 ]<=1;
			white[ 681 ]<=1;
			white[ 682 ]<=1;
			white[ 683 ]<=1;
			white[ 684 ]<=1;
			white[ 685 ]<=1;
			white[ 686 ]<=1;
			white[ 687 ]<=1;
			white[ 688 ]<=1;
			white[ 689 ]<=1;
			white[ 690 ]<=1;
			white[ 691 ]<=1;
			white[ 692 ]<=1;
			white[ 693 ]<=1;
			white[ 694 ]<=1;
			white[ 695 ]<=1;
			white[ 696 ]<=1;
			white[ 697 ]<=1;
			white[ 698 ]<=1;
			white[ 699 ]<=1;
			white[ 700 ]<=1;
			white[ 701 ]<=1;
			white[ 702 ]<=1;
			white[ 703 ]<=1;
			white[ 704 ]<=1;
			white[ 705 ]<=1;
			white[ 706 ]<=1;
			white[ 707 ]<=1;
			white[ 708 ]<=1;
			white[ 709 ]<=1;
			white[ 710 ]<=1;
			white[ 711 ]<=1;
			white[ 712 ]<=1;
			white[ 713 ]<=1;
			white[ 714 ]<=0;
			white[ 715 ]<=0;
			white[ 716 ]<=0;
			white[ 717 ]<=0;
			white[ 718 ]<=0;
			white[ 719 ]<=0;
			white[ 720 ]<=0;
			white[ 721 ]<=0;
			white[ 722 ]<=0;
			white[ 723 ]<=0;
			white[ 724 ]<=0;
			white[ 725 ]<=1;
			white[ 726 ]<=1;
			white[ 727 ]<=1;
			white[ 728 ]<=1;
			white[ 729 ]<=1;
			white[ 730 ]<=1;
			white[ 731 ]<=1;
			white[ 732 ]<=1;
			white[ 733 ]<=1;
			white[ 734 ]<=1;
			white[ 735 ]<=1;
			white[ 736 ]<=1;
			white[ 737 ]<=1;
			white[ 738 ]<=1;
			white[ 739 ]<=1;
			white[ 740 ]<=1;
			white[ 741 ]<=1;
			white[ 742 ]<=1;
			white[ 743 ]<=1;
			white[ 744 ]<=1;
			white[ 745 ]<=1;
			white[ 746 ]<=1;
			white[ 747 ]<=1;
			white[ 748 ]<=1;
			white[ 749 ]<=1;
			white[ 750 ]<=1;
			white[ 751 ]<=1;
			white[ 752 ]<=1;
			white[ 753 ]<=1;
			white[ 754 ]<=1;
			white[ 755 ]<=1;
			white[ 756 ]<=1;
			white[ 757 ]<=1;
			white[ 758 ]<=1;
			white[ 759 ]<=1;
			white[ 760 ]<=1;
			white[ 761 ]<=1;
			white[ 762 ]<=1;
			white[ 763 ]<=1;
			white[ 764 ]<=1;
			white[ 765 ]<=1;
			white[ 766 ]<=1;
			white[ 767 ]<=1;
			white[ 768 ]<=1;
			white[ 769 ]<=1;
			white[ 770 ]<=1;
			white[ 771 ]<=1;
			white[ 772 ]<=1;
			white[ 773 ]<=1;
			white[ 774 ]<=0;
			white[ 775 ]<=0;
			white[ 776 ]<=0;
			white[ 777 ]<=0;
			white[ 778 ]<=0;
			white[ 779 ]<=0;
			white[ 780 ]<=0;
			white[ 781 ]<=0;
			white[ 782 ]<=0;
			white[ 783 ]<=0;
			white[ 784 ]<=1;
			white[ 785 ]<=1;
			white[ 786 ]<=1;
			white[ 787 ]<=1;
			white[ 788 ]<=1;
			white[ 789 ]<=1;
			white[ 790 ]<=1;
			white[ 791 ]<=1;
			white[ 792 ]<=1;
			white[ 793 ]<=1;
			white[ 794 ]<=1;
			white[ 795 ]<=1;
			white[ 796 ]<=1;
			white[ 797 ]<=1;
			white[ 798 ]<=1;
			white[ 799 ]<=1;
			white[ 800 ]<=1;
			white[ 801 ]<=1;
			white[ 802 ]<=1;
			white[ 803 ]<=1;
			white[ 804 ]<=1;
			white[ 805 ]<=1;
			white[ 806 ]<=1;
			white[ 807 ]<=1;
			white[ 808 ]<=1;
			white[ 809 ]<=1;
			white[ 810 ]<=1;
			white[ 811 ]<=1;
			white[ 812 ]<=1;
			white[ 813 ]<=1;
			white[ 814 ]<=1;
			white[ 815 ]<=1;
			white[ 816 ]<=1;
			white[ 817 ]<=1;
			white[ 818 ]<=1;
			white[ 819 ]<=1;
			white[ 820 ]<=1;
			white[ 821 ]<=1;
			white[ 822 ]<=1;
			white[ 823 ]<=1;
			white[ 824 ]<=1;
			white[ 825 ]<=1;
			white[ 826 ]<=1;
			white[ 827 ]<=1;
			white[ 828 ]<=1;
			white[ 829 ]<=1;
			white[ 830 ]<=1;
			white[ 831 ]<=1;
			white[ 832 ]<=1;
			white[ 833 ]<=1;
			white[ 834 ]<=1;
			white[ 835 ]<=0;
			white[ 836 ]<=0;
			white[ 837 ]<=0;
			white[ 838 ]<=0;
			white[ 839 ]<=0;
			white[ 840 ]<=0;
			white[ 841 ]<=0;
			white[ 842 ]<=0;
			white[ 843 ]<=0;
			white[ 844 ]<=1;
			white[ 845 ]<=1;
			white[ 846 ]<=1;
			white[ 847 ]<=1;
			white[ 848 ]<=1;
			white[ 849 ]<=1;
			white[ 850 ]<=1;
			white[ 851 ]<=1;
			white[ 852 ]<=1;
			white[ 853 ]<=1;
			white[ 854 ]<=1;
			white[ 855 ]<=1;
			white[ 856 ]<=1;
			white[ 857 ]<=1;
			white[ 858 ]<=1;
			white[ 859 ]<=1;
			white[ 860 ]<=1;
			white[ 861 ]<=1;
			white[ 862 ]<=1;
			white[ 863 ]<=1;
			white[ 864 ]<=1;
			white[ 865 ]<=1;
			white[ 866 ]<=1;
			white[ 867 ]<=1;
			white[ 868 ]<=1;
			white[ 869 ]<=1;
			white[ 870 ]<=1;
			white[ 871 ]<=1;
			white[ 872 ]<=1;
			white[ 873 ]<=1;
			white[ 874 ]<=1;
			white[ 875 ]<=1;
			white[ 876 ]<=1;
			white[ 877 ]<=1;
			white[ 878 ]<=1;
			white[ 879 ]<=1;
			white[ 880 ]<=1;
			white[ 881 ]<=1;
			white[ 882 ]<=1;
			white[ 883 ]<=1;
			white[ 884 ]<=1;
			white[ 885 ]<=1;
			white[ 886 ]<=1;
			white[ 887 ]<=1;
			white[ 888 ]<=1;
			white[ 889 ]<=1;
			white[ 890 ]<=1;
			white[ 891 ]<=1;
			white[ 892 ]<=1;
			white[ 893 ]<=1;
			white[ 894 ]<=1;
			white[ 895 ]<=1;
			white[ 896 ]<=0;
			white[ 897 ]<=0;
			white[ 898 ]<=0;
			white[ 899 ]<=0;
			white[ 900 ]<=0;
			white[ 901 ]<=0;
			white[ 902 ]<=0;
			white[ 903 ]<=1;
			white[ 904 ]<=1;
			white[ 905 ]<=1;
			white[ 906 ]<=1;
			white[ 907 ]<=1;
			white[ 908 ]<=1;
			white[ 909 ]<=1;
			white[ 910 ]<=1;
			white[ 911 ]<=1;
			white[ 912 ]<=1;
			white[ 913 ]<=1;
			white[ 914 ]<=1;
			white[ 915 ]<=1;
			white[ 916 ]<=1;
			white[ 917 ]<=1;
			white[ 918 ]<=1;
			white[ 919 ]<=1;
			white[ 920 ]<=1;
			white[ 921 ]<=1;
			white[ 922 ]<=1;
			white[ 923 ]<=1;
			white[ 924 ]<=1;
			white[ 925 ]<=1;
			white[ 926 ]<=1;
			white[ 927 ]<=1;
			white[ 928 ]<=1;
			white[ 929 ]<=1;
			white[ 930 ]<=1;
			white[ 931 ]<=1;
			white[ 932 ]<=1;
			white[ 933 ]<=1;
			white[ 934 ]<=1;
			white[ 935 ]<=1;
			white[ 936 ]<=1;
			white[ 937 ]<=1;
			white[ 938 ]<=1;
			white[ 939 ]<=1;
			white[ 940 ]<=1;
			white[ 941 ]<=1;
			white[ 942 ]<=1;
			white[ 943 ]<=1;
			white[ 944 ]<=1;
			white[ 945 ]<=1;
			white[ 946 ]<=1;
			white[ 947 ]<=1;
			white[ 948 ]<=1;
			white[ 949 ]<=1;
			white[ 950 ]<=1;
			white[ 951 ]<=1;
			white[ 952 ]<=1;
			white[ 953 ]<=1;
			white[ 954 ]<=1;
			white[ 955 ]<=1;
			white[ 956 ]<=0;
			white[ 957 ]<=0;
			white[ 958 ]<=0;
			white[ 959 ]<=0;
			white[ 960 ]<=0;
			white[ 961 ]<=0;
			white[ 962 ]<=0;
			white[ 963 ]<=1;
			white[ 964 ]<=1;
			white[ 965 ]<=1;
			white[ 966 ]<=1;
			white[ 967 ]<=1;
			white[ 968 ]<=1;
			white[ 969 ]<=1;
			white[ 970 ]<=1;
			white[ 971 ]<=1;
			white[ 972 ]<=1;
			white[ 973 ]<=1;
			white[ 974 ]<=1;
			white[ 975 ]<=1;
			white[ 976 ]<=1;
			white[ 977 ]<=1;
			white[ 978 ]<=1;
			white[ 979 ]<=1;
			white[ 980 ]<=1;
			white[ 981 ]<=1;
			white[ 982 ]<=1;
			white[ 983 ]<=1;
			white[ 984 ]<=1;
			white[ 985 ]<=1;
			white[ 986 ]<=1;
			white[ 987 ]<=1;
			white[ 988 ]<=1;
			white[ 989 ]<=1;
			white[ 990 ]<=1;
			white[ 991 ]<=1;
			white[ 992 ]<=1;
			white[ 993 ]<=1;
			white[ 994 ]<=1;
			white[ 995 ]<=1;
			white[ 996 ]<=1;
			white[ 997 ]<=1;
			white[ 998 ]<=1;
			white[ 999 ]<=1;
			white[ 1000 ]<=1;
			white[ 1001 ]<=1;
			white[ 1002 ]<=1;
			white[ 1003 ]<=1;
			white[ 1004 ]<=1;
			white[ 1005 ]<=1;
			white[ 1006 ]<=1;
			white[ 1007 ]<=1;
			white[ 1008 ]<=1;
			white[ 1009 ]<=1;
			white[ 1010 ]<=1;
			white[ 1011 ]<=1;
			white[ 1012 ]<=1;
			white[ 1013 ]<=1;
			white[ 1014 ]<=1;
			white[ 1015 ]<=1;
			white[ 1016 ]<=1;
			white[ 1017 ]<=0;
			white[ 1018 ]<=0;
			white[ 1019 ]<=0;
			white[ 1020 ]<=0;
			white[ 1021 ]<=0;
			white[ 1022 ]<=1;
			white[ 1023 ]<=1;
			white[ 1024 ]<=1;
			white[ 1025 ]<=1;
			white[ 1026 ]<=1;
			white[ 1027 ]<=1;
			white[ 1028 ]<=1;
			white[ 1029 ]<=1;
			white[ 1030 ]<=1;
			white[ 1031 ]<=1;
			white[ 1032 ]<=1;
			white[ 1033 ]<=1;
			white[ 1034 ]<=1;
			white[ 1035 ]<=1;
			white[ 1036 ]<=1;
			white[ 1037 ]<=1;
			white[ 1038 ]<=1;
			white[ 1039 ]<=1;
			white[ 1040 ]<=1;
			white[ 1041 ]<=1;
			white[ 1042 ]<=1;
			white[ 1043 ]<=1;
			white[ 1044 ]<=1;
			white[ 1045 ]<=1;
			white[ 1046 ]<=1;
			white[ 1047 ]<=1;
			white[ 1048 ]<=1;
			white[ 1049 ]<=1;
			white[ 1050 ]<=1;
			white[ 1051 ]<=1;
			white[ 1052 ]<=1;
			white[ 1053 ]<=1;
			white[ 1054 ]<=1;
			white[ 1055 ]<=1;
			white[ 1056 ]<=1;
			white[ 1057 ]<=1;
			white[ 1058 ]<=1;
			white[ 1059 ]<=1;
			white[ 1060 ]<=1;
			white[ 1061 ]<=1;
			white[ 1062 ]<=1;
			white[ 1063 ]<=1;
			white[ 1064 ]<=1;
			white[ 1065 ]<=1;
			white[ 1066 ]<=1;
			white[ 1067 ]<=1;
			white[ 1068 ]<=1;
			white[ 1069 ]<=1;
			white[ 1070 ]<=1;
			white[ 1071 ]<=1;
			white[ 1072 ]<=1;
			white[ 1073 ]<=1;
			white[ 1074 ]<=1;
			white[ 1075 ]<=1;
			white[ 1076 ]<=1;
			white[ 1077 ]<=0;
			white[ 1078 ]<=0;
			white[ 1079 ]<=0;
			white[ 1080 ]<=0;
			white[ 1081 ]<=0;
			white[ 1082 ]<=1;
			white[ 1083 ]<=1;
			white[ 1084 ]<=1;
			white[ 1085 ]<=1;
			white[ 1086 ]<=1;
			white[ 1087 ]<=1;
			white[ 1088 ]<=1;
			white[ 1089 ]<=1;
			white[ 1090 ]<=1;
			white[ 1091 ]<=1;
			white[ 1092 ]<=1;
			white[ 1093 ]<=1;
			white[ 1094 ]<=1;
			white[ 1095 ]<=1;
			white[ 1096 ]<=1;
			white[ 1097 ]<=1;
			white[ 1098 ]<=1;
			white[ 1099 ]<=1;
			white[ 1100 ]<=1;
			white[ 1101 ]<=1;
			white[ 1102 ]<=1;
			white[ 1103 ]<=1;
			white[ 1104 ]<=1;
			white[ 1105 ]<=1;
			white[ 1106 ]<=1;
			white[ 1107 ]<=1;
			white[ 1108 ]<=1;
			white[ 1109 ]<=1;
			white[ 1110 ]<=1;
			white[ 1111 ]<=1;
			white[ 1112 ]<=1;
			white[ 1113 ]<=1;
			white[ 1114 ]<=1;
			white[ 1115 ]<=1;
			white[ 1116 ]<=1;
			white[ 1117 ]<=1;
			white[ 1118 ]<=1;
			white[ 1119 ]<=1;
			white[ 1120 ]<=1;
			white[ 1121 ]<=1;
			white[ 1122 ]<=1;
			white[ 1123 ]<=1;
			white[ 1124 ]<=1;
			white[ 1125 ]<=1;
			white[ 1126 ]<=1;
			white[ 1127 ]<=1;
			white[ 1128 ]<=1;
			white[ 1129 ]<=1;
			white[ 1130 ]<=1;
			white[ 1131 ]<=1;
			white[ 1132 ]<=1;
			white[ 1133 ]<=1;
			white[ 1134 ]<=1;
			white[ 1135 ]<=1;
			white[ 1136 ]<=1;
			white[ 1137 ]<=1;
			white[ 1138 ]<=0;
			white[ 1139 ]<=0;
			white[ 1140 ]<=0;
			white[ 1141 ]<=1;
			white[ 1142 ]<=1;
			white[ 1143 ]<=1;
			white[ 1144 ]<=1;
			white[ 1145 ]<=1;
			white[ 1146 ]<=1;
			white[ 1147 ]<=1;
			white[ 1148 ]<=1;
			white[ 1149 ]<=1;
			white[ 1150 ]<=1;
			white[ 1151 ]<=1;
			white[ 1152 ]<=1;
			white[ 1153 ]<=1;
			white[ 1154 ]<=1;
			white[ 1155 ]<=1;
			white[ 1156 ]<=1;
			white[ 1157 ]<=1;
			white[ 1158 ]<=1;
			white[ 1159 ]<=1;
			white[ 1160 ]<=1;
			white[ 1161 ]<=1;
			white[ 1162 ]<=1;
			white[ 1163 ]<=1;
			white[ 1164 ]<=1;
			white[ 1165 ]<=1;
			white[ 1166 ]<=1;
			white[ 1167 ]<=1;
			white[ 1168 ]<=1;
			white[ 1169 ]<=1;
			white[ 1170 ]<=1;
			white[ 1171 ]<=1;
			white[ 1172 ]<=1;
			white[ 1173 ]<=1;
			white[ 1174 ]<=1;
			white[ 1175 ]<=1;
			white[ 1176 ]<=1;
			white[ 1177 ]<=1;
			white[ 1178 ]<=1;
			white[ 1179 ]<=1;
			white[ 1180 ]<=1;
			white[ 1181 ]<=1;
			white[ 1182 ]<=1;
			white[ 1183 ]<=1;
			white[ 1184 ]<=1;
			white[ 1185 ]<=1;
			white[ 1186 ]<=1;
			white[ 1187 ]<=1;
			white[ 1188 ]<=1;
			white[ 1189 ]<=1;
			white[ 1190 ]<=1;
			white[ 1191 ]<=1;
			white[ 1192 ]<=1;
			white[ 1193 ]<=1;
			white[ 1194 ]<=1;
			white[ 1195 ]<=1;
			white[ 1196 ]<=1;
			white[ 1197 ]<=1;
			white[ 1198 ]<=0;
			white[ 1199 ]<=0;
			white[ 1200 ]<=0;
			white[ 1201 ]<=1;
			white[ 1202 ]<=1;
			white[ 1203 ]<=1;
			white[ 1204 ]<=1;
			white[ 1205 ]<=1;
			white[ 1206 ]<=1;
			white[ 1207 ]<=1;
			white[ 1208 ]<=1;
			white[ 1209 ]<=1;
			white[ 1210 ]<=1;
			white[ 1211 ]<=1;
			white[ 1212 ]<=1;
			white[ 1213 ]<=1;
			white[ 1214 ]<=1;
			white[ 1215 ]<=1;
			white[ 1216 ]<=1;
			white[ 1217 ]<=1;
			white[ 1218 ]<=1;
			white[ 1219 ]<=1;
			white[ 1220 ]<=1;
			white[ 1221 ]<=1;
			white[ 1222 ]<=1;
			white[ 1223 ]<=1;
			white[ 1224 ]<=1;
			white[ 1225 ]<=1;
			white[ 1226 ]<=1;
			white[ 1227 ]<=1;
			white[ 1228 ]<=1;
			white[ 1229 ]<=1;
			white[ 1230 ]<=1;
			white[ 1231 ]<=1;
			white[ 1232 ]<=1;
			white[ 1233 ]<=1;
			white[ 1234 ]<=1;
			white[ 1235 ]<=1;
			white[ 1236 ]<=1;
			white[ 1237 ]<=1;
			white[ 1238 ]<=1;
			white[ 1239 ]<=1;
			white[ 1240 ]<=1;
			white[ 1241 ]<=1;
			white[ 1242 ]<=1;
			white[ 1243 ]<=1;
			white[ 1244 ]<=1;
			white[ 1245 ]<=1;
			white[ 1246 ]<=1;
			white[ 1247 ]<=1;
			white[ 1248 ]<=1;
			white[ 1249 ]<=1;
			white[ 1250 ]<=1;
			white[ 1251 ]<=1;
			white[ 1252 ]<=1;
			white[ 1253 ]<=1;
			white[ 1254 ]<=1;
			white[ 1255 ]<=1;
			white[ 1256 ]<=1;
			white[ 1257 ]<=1;
			white[ 1258 ]<=1;
			white[ 1259 ]<=0;
			white[ 1260 ]<=0;
			white[ 1261 ]<=1;
			white[ 1262 ]<=1;
			white[ 1263 ]<=1;
			white[ 1264 ]<=1;
			white[ 1265 ]<=1;
			white[ 1266 ]<=1;
			white[ 1267 ]<=1;
			white[ 1268 ]<=1;
			white[ 1269 ]<=1;
			white[ 1270 ]<=1;
			white[ 1271 ]<=1;
			white[ 1272 ]<=1;
			white[ 1273 ]<=1;
			white[ 1274 ]<=1;
			white[ 1275 ]<=1;
			white[ 1276 ]<=1;
			white[ 1277 ]<=1;
			white[ 1278 ]<=1;
			white[ 1279 ]<=1;
			white[ 1280 ]<=1;
			white[ 1281 ]<=1;
			white[ 1282 ]<=1;
			white[ 1283 ]<=1;
			white[ 1284 ]<=1;
			white[ 1285 ]<=1;
			white[ 1286 ]<=1;
			white[ 1287 ]<=1;
			white[ 1288 ]<=1;
			white[ 1289 ]<=1;
			white[ 1290 ]<=1;
			white[ 1291 ]<=1;
			white[ 1292 ]<=1;
			white[ 1293 ]<=1;
			white[ 1294 ]<=1;
			white[ 1295 ]<=1;
			white[ 1296 ]<=1;
			white[ 1297 ]<=1;
			white[ 1298 ]<=1;
			white[ 1299 ]<=1;
			white[ 1300 ]<=1;
			white[ 1301 ]<=1;
			white[ 1302 ]<=1;
			white[ 1303 ]<=1;
			white[ 1304 ]<=1;
			white[ 1305 ]<=1;
			white[ 1306 ]<=1;
			white[ 1307 ]<=1;
			white[ 1308 ]<=1;
			white[ 1309 ]<=1;
			white[ 1310 ]<=1;
			white[ 1311 ]<=1;
			white[ 1312 ]<=1;
			white[ 1313 ]<=1;
			white[ 1314 ]<=1;
			white[ 1315 ]<=1;
			white[ 1316 ]<=1;
			white[ 1317 ]<=1;
			white[ 1318 ]<=1;
			white[ 1319 ]<=0;
			white[ 1320 ]<=0;
			white[ 1321 ]<=1;
			white[ 1322 ]<=1;
			white[ 1323 ]<=1;
			white[ 1324 ]<=1;
			white[ 1325 ]<=1;
			white[ 1326 ]<=1;
			white[ 1327 ]<=1;
			white[ 1328 ]<=1;
			white[ 1329 ]<=1;
			white[ 1330 ]<=1;
			white[ 1331 ]<=1;
			white[ 1332 ]<=1;
			white[ 1333 ]<=1;
			white[ 1334 ]<=1;
			white[ 1335 ]<=1;
			white[ 1336 ]<=1;
			white[ 1337 ]<=1;
			white[ 1338 ]<=1;
			white[ 1339 ]<=1;
			white[ 1340 ]<=1;
			white[ 1341 ]<=1;
			white[ 1342 ]<=1;
			white[ 1343 ]<=1;
			white[ 1344 ]<=1;
			white[ 1345 ]<=1;
			white[ 1346 ]<=1;
			white[ 1347 ]<=1;
			white[ 1348 ]<=1;
			white[ 1349 ]<=1;
			white[ 1350 ]<=1;
			white[ 1351 ]<=1;
			white[ 1352 ]<=1;
			white[ 1353 ]<=1;
			white[ 1354 ]<=1;
			white[ 1355 ]<=1;
			white[ 1356 ]<=1;
			white[ 1357 ]<=1;
			white[ 1358 ]<=1;
			white[ 1359 ]<=1;
			white[ 1360 ]<=1;
			white[ 1361 ]<=1;
			white[ 1362 ]<=1;
			white[ 1363 ]<=1;
			white[ 1364 ]<=1;
			white[ 1365 ]<=1;
			white[ 1366 ]<=1;
			white[ 1367 ]<=1;
			white[ 1368 ]<=1;
			white[ 1369 ]<=1;
			white[ 1370 ]<=1;
			white[ 1371 ]<=1;
			white[ 1372 ]<=1;
			white[ 1373 ]<=1;
			white[ 1374 ]<=1;
			white[ 1375 ]<=1;
			white[ 1376 ]<=1;
			white[ 1377 ]<=1;
			white[ 1378 ]<=1;
			white[ 1379 ]<=0;
			white[ 1380 ]<=1;
			white[ 1381 ]<=1;
			white[ 1382 ]<=1;
			white[ 1383 ]<=1;
			white[ 1384 ]<=1;
			white[ 1385 ]<=1;
			white[ 1386 ]<=1;
			white[ 1387 ]<=1;
			white[ 1388 ]<=1;
			white[ 1389 ]<=1;
			white[ 1390 ]<=1;
			white[ 1391 ]<=1;
			white[ 1392 ]<=1;
			white[ 1393 ]<=1;
			white[ 1394 ]<=1;
			white[ 1395 ]<=1;
			white[ 1396 ]<=1;
			white[ 1397 ]<=1;
			white[ 1398 ]<=1;
			white[ 1399 ]<=1;
			white[ 1400 ]<=1;
			white[ 1401 ]<=1;
			white[ 1402 ]<=1;
			white[ 1403 ]<=1;
			white[ 1404 ]<=1;
			white[ 1405 ]<=1;
			white[ 1406 ]<=1;
			white[ 1407 ]<=1;
			white[ 1408 ]<=1;
			white[ 1409 ]<=1;
			white[ 1410 ]<=1;
			white[ 1411 ]<=1;
			white[ 1412 ]<=1;
			white[ 1413 ]<=1;
			white[ 1414 ]<=1;
			white[ 1415 ]<=1;
			white[ 1416 ]<=1;
			white[ 1417 ]<=1;
			white[ 1418 ]<=1;
			white[ 1419 ]<=1;
			white[ 1420 ]<=1;
			white[ 1421 ]<=1;
			white[ 1422 ]<=1;
			white[ 1423 ]<=1;
			white[ 1424 ]<=1;
			white[ 1425 ]<=1;
			white[ 1426 ]<=1;
			white[ 1427 ]<=1;
			white[ 1428 ]<=1;
			white[ 1429 ]<=1;
			white[ 1430 ]<=1;
			white[ 1431 ]<=1;
			white[ 1432 ]<=1;
			white[ 1433 ]<=1;
			white[ 1434 ]<=1;
			white[ 1435 ]<=1;
			white[ 1436 ]<=1;
			white[ 1437 ]<=1;
			white[ 1438 ]<=1;
			white[ 1439 ]<=1;
			white[ 1440 ]<=1;
			white[ 1441 ]<=1;
			white[ 1442 ]<=1;
			white[ 1443 ]<=1;
			white[ 1444 ]<=1;
			white[ 1445 ]<=1;
			white[ 1446 ]<=1;
			white[ 1447 ]<=1;
			white[ 1448 ]<=1;
			white[ 1449 ]<=1;
			white[ 1450 ]<=1;
			white[ 1451 ]<=1;
			white[ 1452 ]<=1;
			white[ 1453 ]<=1;
			white[ 1454 ]<=1;
			white[ 1455 ]<=1;
			white[ 1456 ]<=1;
			white[ 1457 ]<=1;
			white[ 1458 ]<=1;
			white[ 1459 ]<=1;
			white[ 1460 ]<=1;
			white[ 1461 ]<=1;
			white[ 1462 ]<=1;
			white[ 1463 ]<=1;
			white[ 1464 ]<=1;
			white[ 1465 ]<=1;
			white[ 1466 ]<=1;
			white[ 1467 ]<=1;
			white[ 1468 ]<=1;
			white[ 1469 ]<=1;
			white[ 1470 ]<=1;
			white[ 1471 ]<=1;
			white[ 1472 ]<=1;
			white[ 1473 ]<=1;
			white[ 1474 ]<=1;
			white[ 1475 ]<=1;
			white[ 1476 ]<=1;
			white[ 1477 ]<=1;
			white[ 1478 ]<=1;
			white[ 1479 ]<=1;
			white[ 1480 ]<=1;
			white[ 1481 ]<=1;
			white[ 1482 ]<=1;
			white[ 1483 ]<=1;
			white[ 1484 ]<=1;
			white[ 1485 ]<=1;
			white[ 1486 ]<=1;
			white[ 1487 ]<=1;
			white[ 1488 ]<=1;
			white[ 1489 ]<=1;
			white[ 1490 ]<=1;
			white[ 1491 ]<=1;
			white[ 1492 ]<=1;
			white[ 1493 ]<=1;
			white[ 1494 ]<=1;
			white[ 1495 ]<=1;
			white[ 1496 ]<=1;
			white[ 1497 ]<=1;
			white[ 1498 ]<=1;
			white[ 1499 ]<=1;
			white[ 1500 ]<=1;
			white[ 1501 ]<=1;
			white[ 1502 ]<=1;
			white[ 1503 ]<=1;
			white[ 1504 ]<=1;
			white[ 1505 ]<=1;
			white[ 1506 ]<=1;
			white[ 1507 ]<=1;
			white[ 1508 ]<=1;
			white[ 1509 ]<=1;
			white[ 1510 ]<=1;
			white[ 1511 ]<=1;
			white[ 1512 ]<=1;
			white[ 1513 ]<=1;
			white[ 1514 ]<=1;
			white[ 1515 ]<=1;
			white[ 1516 ]<=1;
			white[ 1517 ]<=1;
			white[ 1518 ]<=1;
			white[ 1519 ]<=1;
			white[ 1520 ]<=1;
			white[ 1521 ]<=1;
			white[ 1522 ]<=1;
			white[ 1523 ]<=1;
			white[ 1524 ]<=1;
			white[ 1525 ]<=1;
			white[ 1526 ]<=1;
			white[ 1527 ]<=1;
			white[ 1528 ]<=1;
			white[ 1529 ]<=1;
			white[ 1530 ]<=1;
			white[ 1531 ]<=1;
			white[ 1532 ]<=1;
			white[ 1533 ]<=1;
			white[ 1534 ]<=1;
			white[ 1535 ]<=1;
			white[ 1536 ]<=1;
			white[ 1537 ]<=1;
			white[ 1538 ]<=1;
			white[ 1539 ]<=1;
			white[ 1540 ]<=1;
			white[ 1541 ]<=1;
			white[ 1542 ]<=1;
			white[ 1543 ]<=1;
			white[ 1544 ]<=1;
			white[ 1545 ]<=1;
			white[ 1546 ]<=1;
			white[ 1547 ]<=1;
			white[ 1548 ]<=1;
			white[ 1549 ]<=1;
			white[ 1550 ]<=1;
			white[ 1551 ]<=1;
			white[ 1552 ]<=1;
			white[ 1553 ]<=1;
			white[ 1554 ]<=1;
			white[ 1555 ]<=1;
			white[ 1556 ]<=1;
			white[ 1557 ]<=1;
			white[ 1558 ]<=1;
			white[ 1559 ]<=1;
			white[ 1560 ]<=1;
			white[ 1561 ]<=1;
			white[ 1562 ]<=1;
			white[ 1563 ]<=1;
			white[ 1564 ]<=1;
			white[ 1565 ]<=1;
			white[ 1566 ]<=1;
			white[ 1567 ]<=1;
			white[ 1568 ]<=1;
			white[ 1569 ]<=1;
			white[ 1570 ]<=1;
			white[ 1571 ]<=1;
			white[ 1572 ]<=1;
			white[ 1573 ]<=1;
			white[ 1574 ]<=1;
			white[ 1575 ]<=1;
			white[ 1576 ]<=1;
			white[ 1577 ]<=1;
			white[ 1578 ]<=1;
			white[ 1579 ]<=1;
			white[ 1580 ]<=1;
			white[ 1581 ]<=1;
			white[ 1582 ]<=1;
			white[ 1583 ]<=1;
			white[ 1584 ]<=1;
			white[ 1585 ]<=1;
			white[ 1586 ]<=1;
			white[ 1587 ]<=1;
			white[ 1588 ]<=1;
			white[ 1589 ]<=1;
			white[ 1590 ]<=1;
			white[ 1591 ]<=1;
			white[ 1592 ]<=1;
			white[ 1593 ]<=1;
			white[ 1594 ]<=1;
			white[ 1595 ]<=1;
			white[ 1596 ]<=1;
			white[ 1597 ]<=1;
			white[ 1598 ]<=1;
			white[ 1599 ]<=1;
			white[ 1600 ]<=1;
			white[ 1601 ]<=1;
			white[ 1602 ]<=1;
			white[ 1603 ]<=1;
			white[ 1604 ]<=1;
			white[ 1605 ]<=1;
			white[ 1606 ]<=1;
			white[ 1607 ]<=1;
			white[ 1608 ]<=1;
			white[ 1609 ]<=1;
			white[ 1610 ]<=1;
			white[ 1611 ]<=1;
			white[ 1612 ]<=1;
			white[ 1613 ]<=1;
			white[ 1614 ]<=1;
			white[ 1615 ]<=1;
			white[ 1616 ]<=1;
			white[ 1617 ]<=1;
			white[ 1618 ]<=1;
			white[ 1619 ]<=1;
			white[ 1620 ]<=1;
			white[ 1621 ]<=1;
			white[ 1622 ]<=1;
			white[ 1623 ]<=1;
			white[ 1624 ]<=1;
			white[ 1625 ]<=1;
			white[ 1626 ]<=1;
			white[ 1627 ]<=1;
			white[ 1628 ]<=1;
			white[ 1629 ]<=1;
			white[ 1630 ]<=1;
			white[ 1631 ]<=1;
			white[ 1632 ]<=1;
			white[ 1633 ]<=1;
			white[ 1634 ]<=1;
			white[ 1635 ]<=1;
			white[ 1636 ]<=1;
			white[ 1637 ]<=1;
			white[ 1638 ]<=1;
			white[ 1639 ]<=1;
			white[ 1640 ]<=1;
			white[ 1641 ]<=1;
			white[ 1642 ]<=1;
			white[ 1643 ]<=1;
			white[ 1644 ]<=1;
			white[ 1645 ]<=1;
			white[ 1646 ]<=1;
			white[ 1647 ]<=1;
			white[ 1648 ]<=1;
			white[ 1649 ]<=1;
			white[ 1650 ]<=1;
			white[ 1651 ]<=1;
			white[ 1652 ]<=1;
			white[ 1653 ]<=1;
			white[ 1654 ]<=1;
			white[ 1655 ]<=1;
			white[ 1656 ]<=1;
			white[ 1657 ]<=1;
			white[ 1658 ]<=1;
			white[ 1659 ]<=1;
			white[ 1660 ]<=1;
			white[ 1661 ]<=1;
			white[ 1662 ]<=1;
			white[ 1663 ]<=1;
			white[ 1664 ]<=1;
			white[ 1665 ]<=1;
			white[ 1666 ]<=1;
			white[ 1667 ]<=1;
			white[ 1668 ]<=1;
			white[ 1669 ]<=1;
			white[ 1670 ]<=1;
			white[ 1671 ]<=1;
			white[ 1672 ]<=1;
			white[ 1673 ]<=1;
			white[ 1674 ]<=1;
			white[ 1675 ]<=1;
			white[ 1676 ]<=1;
			white[ 1677 ]<=1;
			white[ 1678 ]<=1;
			white[ 1679 ]<=1;
			white[ 1680 ]<=1;
			white[ 1681 ]<=1;
			white[ 1682 ]<=1;
			white[ 1683 ]<=1;
			white[ 1684 ]<=1;
			white[ 1685 ]<=1;
			white[ 1686 ]<=1;
			white[ 1687 ]<=1;
			white[ 1688 ]<=1;
			white[ 1689 ]<=1;
			white[ 1690 ]<=1;
			white[ 1691 ]<=1;
			white[ 1692 ]<=1;
			white[ 1693 ]<=1;
			white[ 1694 ]<=1;
			white[ 1695 ]<=1;
			white[ 1696 ]<=1;
			white[ 1697 ]<=1;
			white[ 1698 ]<=1;
			white[ 1699 ]<=1;
			white[ 1700 ]<=1;
			white[ 1701 ]<=1;
			white[ 1702 ]<=1;
			white[ 1703 ]<=1;
			white[ 1704 ]<=1;
			white[ 1705 ]<=1;
			white[ 1706 ]<=1;
			white[ 1707 ]<=1;
			white[ 1708 ]<=1;
			white[ 1709 ]<=1;
			white[ 1710 ]<=1;
			white[ 1711 ]<=1;
			white[ 1712 ]<=1;
			white[ 1713 ]<=1;
			white[ 1714 ]<=1;
			white[ 1715 ]<=1;
			white[ 1716 ]<=1;
			white[ 1717 ]<=1;
			white[ 1718 ]<=1;
			white[ 1719 ]<=1;
			white[ 1720 ]<=1;
			white[ 1721 ]<=1;
			white[ 1722 ]<=1;
			white[ 1723 ]<=1;
			white[ 1724 ]<=1;
			white[ 1725 ]<=1;
			white[ 1726 ]<=1;
			white[ 1727 ]<=1;
			white[ 1728 ]<=1;
			white[ 1729 ]<=1;
			white[ 1730 ]<=1;
			white[ 1731 ]<=1;
			white[ 1732 ]<=1;
			white[ 1733 ]<=1;
			white[ 1734 ]<=1;
			white[ 1735 ]<=1;
			white[ 1736 ]<=1;
			white[ 1737 ]<=1;
			white[ 1738 ]<=1;
			white[ 1739 ]<=1;
			white[ 1740 ]<=1;
			white[ 1741 ]<=1;
			white[ 1742 ]<=1;
			white[ 1743 ]<=1;
			white[ 1744 ]<=1;
			white[ 1745 ]<=1;
			white[ 1746 ]<=1;
			white[ 1747 ]<=1;
			white[ 1748 ]<=1;
			white[ 1749 ]<=1;
			white[ 1750 ]<=1;
			white[ 1751 ]<=1;
			white[ 1752 ]<=1;
			white[ 1753 ]<=1;
			white[ 1754 ]<=1;
			white[ 1755 ]<=1;
			white[ 1756 ]<=1;
			white[ 1757 ]<=1;
			white[ 1758 ]<=1;
			white[ 1759 ]<=1;
			white[ 1760 ]<=1;
			white[ 1761 ]<=1;
			white[ 1762 ]<=1;
			white[ 1763 ]<=1;
			white[ 1764 ]<=1;
			white[ 1765 ]<=1;
			white[ 1766 ]<=1;
			white[ 1767 ]<=1;
			white[ 1768 ]<=1;
			white[ 1769 ]<=1;
			white[ 1770 ]<=1;
			white[ 1771 ]<=1;
			white[ 1772 ]<=1;
			white[ 1773 ]<=1;
			white[ 1774 ]<=1;
			white[ 1775 ]<=1;
			white[ 1776 ]<=1;
			white[ 1777 ]<=1;
			white[ 1778 ]<=1;
			white[ 1779 ]<=1;
			white[ 1780 ]<=1;
			white[ 1781 ]<=1;
			white[ 1782 ]<=1;
			white[ 1783 ]<=1;
			white[ 1784 ]<=1;
			white[ 1785 ]<=1;
			white[ 1786 ]<=1;
			white[ 1787 ]<=1;
			white[ 1788 ]<=1;
			white[ 1789 ]<=1;
			white[ 1790 ]<=1;
			white[ 1791 ]<=1;
			white[ 1792 ]<=1;
			white[ 1793 ]<=1;
			white[ 1794 ]<=1;
			white[ 1795 ]<=1;
			white[ 1796 ]<=1;
			white[ 1797 ]<=1;
			white[ 1798 ]<=1;
			white[ 1799 ]<=1;
			white[ 1800 ]<=1;
			white[ 1801 ]<=1;
			white[ 1802 ]<=1;
			white[ 1803 ]<=1;
			white[ 1804 ]<=1;
			white[ 1805 ]<=1;
			white[ 1806 ]<=1;
			white[ 1807 ]<=1;
			white[ 1808 ]<=1;
			white[ 1809 ]<=1;
			white[ 1810 ]<=1;
			white[ 1811 ]<=1;
			white[ 1812 ]<=1;
			white[ 1813 ]<=1;
			white[ 1814 ]<=1;
			white[ 1815 ]<=1;
			white[ 1816 ]<=1;
			white[ 1817 ]<=1;
			white[ 1818 ]<=1;
			white[ 1819 ]<=1;
			white[ 1820 ]<=1;
			white[ 1821 ]<=1;
			white[ 1822 ]<=1;
			white[ 1823 ]<=1;
			white[ 1824 ]<=1;
			white[ 1825 ]<=1;
			white[ 1826 ]<=1;
			white[ 1827 ]<=1;
			white[ 1828 ]<=1;
			white[ 1829 ]<=1;
			white[ 1830 ]<=1;
			white[ 1831 ]<=1;
			white[ 1832 ]<=1;
			white[ 1833 ]<=1;
			white[ 1834 ]<=1;
			white[ 1835 ]<=1;
			white[ 1836 ]<=1;
			white[ 1837 ]<=1;
			white[ 1838 ]<=1;
			white[ 1839 ]<=1;
			white[ 1840 ]<=1;
			white[ 1841 ]<=1;
			white[ 1842 ]<=1;
			white[ 1843 ]<=1;
			white[ 1844 ]<=1;
			white[ 1845 ]<=1;
			white[ 1846 ]<=1;
			white[ 1847 ]<=1;
			white[ 1848 ]<=1;
			white[ 1849 ]<=1;
			white[ 1850 ]<=1;
			white[ 1851 ]<=1;
			white[ 1852 ]<=1;
			white[ 1853 ]<=1;
			white[ 1854 ]<=1;
			white[ 1855 ]<=1;
			white[ 1856 ]<=1;
			white[ 1857 ]<=1;
			white[ 1858 ]<=1;
			white[ 1859 ]<=1;
			white[ 1860 ]<=1;
			white[ 1861 ]<=1;
			white[ 1862 ]<=1;
			white[ 1863 ]<=1;
			white[ 1864 ]<=1;
			white[ 1865 ]<=1;
			white[ 1866 ]<=1;
			white[ 1867 ]<=1;
			white[ 1868 ]<=1;
			white[ 1869 ]<=1;
			white[ 1870 ]<=1;
			white[ 1871 ]<=1;
			white[ 1872 ]<=1;
			white[ 1873 ]<=1;
			white[ 1874 ]<=1;
			white[ 1875 ]<=1;
			white[ 1876 ]<=1;
			white[ 1877 ]<=1;
			white[ 1878 ]<=1;
			white[ 1879 ]<=1;
			white[ 1880 ]<=1;
			white[ 1881 ]<=1;
			white[ 1882 ]<=1;
			white[ 1883 ]<=1;
			white[ 1884 ]<=1;
			white[ 1885 ]<=1;
			white[ 1886 ]<=1;
			white[ 1887 ]<=1;
			white[ 1888 ]<=1;
			white[ 1889 ]<=1;
			white[ 1890 ]<=1;
			white[ 1891 ]<=1;
			white[ 1892 ]<=1;
			white[ 1893 ]<=1;
			white[ 1894 ]<=1;
			white[ 1895 ]<=1;
			white[ 1896 ]<=1;
			white[ 1897 ]<=1;
			white[ 1898 ]<=1;
			white[ 1899 ]<=1;
			white[ 1900 ]<=1;
			white[ 1901 ]<=1;
			white[ 1902 ]<=1;
			white[ 1903 ]<=1;
			white[ 1904 ]<=1;
			white[ 1905 ]<=1;
			white[ 1906 ]<=1;
			white[ 1907 ]<=1;
			white[ 1908 ]<=1;
			white[ 1909 ]<=1;
			white[ 1910 ]<=1;
			white[ 1911 ]<=1;
			white[ 1912 ]<=1;
			white[ 1913 ]<=1;
			white[ 1914 ]<=1;
			white[ 1915 ]<=1;
			white[ 1916 ]<=1;
			white[ 1917 ]<=1;
			white[ 1918 ]<=1;
			white[ 1919 ]<=1;
			white[ 1920 ]<=1;
			white[ 1921 ]<=1;
			white[ 1922 ]<=1;
			white[ 1923 ]<=1;
			white[ 1924 ]<=1;
			white[ 1925 ]<=1;
			white[ 1926 ]<=1;
			white[ 1927 ]<=1;
			white[ 1928 ]<=1;
			white[ 1929 ]<=1;
			white[ 1930 ]<=1;
			white[ 1931 ]<=1;
			white[ 1932 ]<=1;
			white[ 1933 ]<=1;
			white[ 1934 ]<=1;
			white[ 1935 ]<=1;
			white[ 1936 ]<=1;
			white[ 1937 ]<=1;
			white[ 1938 ]<=1;
			white[ 1939 ]<=1;
			white[ 1940 ]<=1;
			white[ 1941 ]<=1;
			white[ 1942 ]<=1;
			white[ 1943 ]<=1;
			white[ 1944 ]<=1;
			white[ 1945 ]<=1;
			white[ 1946 ]<=1;
			white[ 1947 ]<=1;
			white[ 1948 ]<=1;
			white[ 1949 ]<=1;
			white[ 1950 ]<=1;
			white[ 1951 ]<=1;
			white[ 1952 ]<=1;
			white[ 1953 ]<=1;
			white[ 1954 ]<=1;
			white[ 1955 ]<=1;
			white[ 1956 ]<=1;
			white[ 1957 ]<=1;
			white[ 1958 ]<=1;
			white[ 1959 ]<=1;
			white[ 1960 ]<=1;
			white[ 1961 ]<=1;
			white[ 1962 ]<=1;
			white[ 1963 ]<=1;
			white[ 1964 ]<=1;
			white[ 1965 ]<=1;
			white[ 1966 ]<=1;
			white[ 1967 ]<=1;
			white[ 1968 ]<=1;
			white[ 1969 ]<=1;
			white[ 1970 ]<=1;
			white[ 1971 ]<=1;
			white[ 1972 ]<=1;
			white[ 1973 ]<=1;
			white[ 1974 ]<=1;
			white[ 1975 ]<=1;
			white[ 1976 ]<=1;
			white[ 1977 ]<=1;
			white[ 1978 ]<=1;
			white[ 1979 ]<=1;
			white[ 1980 ]<=1;
			white[ 1981 ]<=1;
			white[ 1982 ]<=1;
			white[ 1983 ]<=1;
			white[ 1984 ]<=1;
			white[ 1985 ]<=1;
			white[ 1986 ]<=1;
			white[ 1987 ]<=1;
			white[ 1988 ]<=1;
			white[ 1989 ]<=1;
			white[ 1990 ]<=1;
			white[ 1991 ]<=1;
			white[ 1992 ]<=1;
			white[ 1993 ]<=1;
			white[ 1994 ]<=1;
			white[ 1995 ]<=1;
			white[ 1996 ]<=1;
			white[ 1997 ]<=1;
			white[ 1998 ]<=1;
			white[ 1999 ]<=1;
			white[ 2000 ]<=1;
			white[ 2001 ]<=1;
			white[ 2002 ]<=1;
			white[ 2003 ]<=1;
			white[ 2004 ]<=1;
			white[ 2005 ]<=1;
			white[ 2006 ]<=1;
			white[ 2007 ]<=1;
			white[ 2008 ]<=1;
			white[ 2009 ]<=1;
			white[ 2010 ]<=1;
			white[ 2011 ]<=1;
			white[ 2012 ]<=1;
			white[ 2013 ]<=1;
			white[ 2014 ]<=1;
			white[ 2015 ]<=1;
			white[ 2016 ]<=1;
			white[ 2017 ]<=1;
			white[ 2018 ]<=1;
			white[ 2019 ]<=1;
			white[ 2020 ]<=1;
			white[ 2021 ]<=1;
			white[ 2022 ]<=1;
			white[ 2023 ]<=1;
			white[ 2024 ]<=1;
			white[ 2025 ]<=1;
			white[ 2026 ]<=1;
			white[ 2027 ]<=1;
			white[ 2028 ]<=1;
			white[ 2029 ]<=1;
			white[ 2030 ]<=1;
			white[ 2031 ]<=1;
			white[ 2032 ]<=1;
			white[ 2033 ]<=1;
			white[ 2034 ]<=1;
			white[ 2035 ]<=1;
			white[ 2036 ]<=1;
			white[ 2037 ]<=1;
			white[ 2038 ]<=1;
			white[ 2039 ]<=1;
			white[ 2040 ]<=1;
			white[ 2041 ]<=1;
			white[ 2042 ]<=1;
			white[ 2043 ]<=1;
			white[ 2044 ]<=1;
			white[ 2045 ]<=1;
			white[ 2046 ]<=1;
			white[ 2047 ]<=1;
			white[ 2048 ]<=1;
			white[ 2049 ]<=1;
			white[ 2050 ]<=1;
			white[ 2051 ]<=1;
			white[ 2052 ]<=1;
			white[ 2053 ]<=1;
			white[ 2054 ]<=1;
			white[ 2055 ]<=1;
			white[ 2056 ]<=1;
			white[ 2057 ]<=1;
			white[ 2058 ]<=1;
			white[ 2059 ]<=1;
			white[ 2060 ]<=1;
			white[ 2061 ]<=1;
			white[ 2062 ]<=1;
			white[ 2063 ]<=1;
			white[ 2064 ]<=1;
			white[ 2065 ]<=1;
			white[ 2066 ]<=1;
			white[ 2067 ]<=1;
			white[ 2068 ]<=1;
			white[ 2069 ]<=1;
			white[ 2070 ]<=1;
			white[ 2071 ]<=1;
			white[ 2072 ]<=1;
			white[ 2073 ]<=1;
			white[ 2074 ]<=1;
			white[ 2075 ]<=1;
			white[ 2076 ]<=1;
			white[ 2077 ]<=1;
			white[ 2078 ]<=1;
			white[ 2079 ]<=1;
			white[ 2080 ]<=1;
			white[ 2081 ]<=1;
			white[ 2082 ]<=1;
			white[ 2083 ]<=1;
			white[ 2084 ]<=1;
			white[ 2085 ]<=1;
			white[ 2086 ]<=1;
			white[ 2087 ]<=1;
			white[ 2088 ]<=1;
			white[ 2089 ]<=1;
			white[ 2090 ]<=1;
			white[ 2091 ]<=1;
			white[ 2092 ]<=1;
			white[ 2093 ]<=1;
			white[ 2094 ]<=1;
			white[ 2095 ]<=1;
			white[ 2096 ]<=1;
			white[ 2097 ]<=1;
			white[ 2098 ]<=1;
			white[ 2099 ]<=1;
			white[ 2100 ]<=1;
			white[ 2101 ]<=1;
			white[ 2102 ]<=1;
			white[ 2103 ]<=1;
			white[ 2104 ]<=1;
			white[ 2105 ]<=1;
			white[ 2106 ]<=1;
			white[ 2107 ]<=1;
			white[ 2108 ]<=1;
			white[ 2109 ]<=1;
			white[ 2110 ]<=1;
			white[ 2111 ]<=1;
			white[ 2112 ]<=1;
			white[ 2113 ]<=1;
			white[ 2114 ]<=1;
			white[ 2115 ]<=1;
			white[ 2116 ]<=1;
			white[ 2117 ]<=1;
			white[ 2118 ]<=1;
			white[ 2119 ]<=1;
			white[ 2120 ]<=1;
			white[ 2121 ]<=1;
			white[ 2122 ]<=1;
			white[ 2123 ]<=1;
			white[ 2124 ]<=1;
			white[ 2125 ]<=1;
			white[ 2126 ]<=1;
			white[ 2127 ]<=1;
			white[ 2128 ]<=1;
			white[ 2129 ]<=1;
			white[ 2130 ]<=1;
			white[ 2131 ]<=1;
			white[ 2132 ]<=1;
			white[ 2133 ]<=1;
			white[ 2134 ]<=1;
			white[ 2135 ]<=1;
			white[ 2136 ]<=1;
			white[ 2137 ]<=1;
			white[ 2138 ]<=1;
			white[ 2139 ]<=1;
			white[ 2140 ]<=1;
			white[ 2141 ]<=1;
			white[ 2142 ]<=1;
			white[ 2143 ]<=1;
			white[ 2144 ]<=1;
			white[ 2145 ]<=1;
			white[ 2146 ]<=1;
			white[ 2147 ]<=1;
			white[ 2148 ]<=1;
			white[ 2149 ]<=1;
			white[ 2150 ]<=1;
			white[ 2151 ]<=1;
			white[ 2152 ]<=1;
			white[ 2153 ]<=1;
			white[ 2154 ]<=1;
			white[ 2155 ]<=1;
			white[ 2156 ]<=1;
			white[ 2157 ]<=1;
			white[ 2158 ]<=1;
			white[ 2159 ]<=1;
			white[ 2160 ]<=0;
			white[ 2161 ]<=1;
			white[ 2162 ]<=1;
			white[ 2163 ]<=1;
			white[ 2164 ]<=1;
			white[ 2165 ]<=1;
			white[ 2166 ]<=1;
			white[ 2167 ]<=1;
			white[ 2168 ]<=1;
			white[ 2169 ]<=1;
			white[ 2170 ]<=1;
			white[ 2171 ]<=1;
			white[ 2172 ]<=1;
			white[ 2173 ]<=1;
			white[ 2174 ]<=1;
			white[ 2175 ]<=1;
			white[ 2176 ]<=1;
			white[ 2177 ]<=1;
			white[ 2178 ]<=1;
			white[ 2179 ]<=1;
			white[ 2180 ]<=1;
			white[ 2181 ]<=1;
			white[ 2182 ]<=1;
			white[ 2183 ]<=1;
			white[ 2184 ]<=1;
			white[ 2185 ]<=1;
			white[ 2186 ]<=1;
			white[ 2187 ]<=1;
			white[ 2188 ]<=1;
			white[ 2189 ]<=1;
			white[ 2190 ]<=1;
			white[ 2191 ]<=1;
			white[ 2192 ]<=1;
			white[ 2193 ]<=1;
			white[ 2194 ]<=1;
			white[ 2195 ]<=1;
			white[ 2196 ]<=1;
			white[ 2197 ]<=1;
			white[ 2198 ]<=1;
			white[ 2199 ]<=1;
			white[ 2200 ]<=1;
			white[ 2201 ]<=1;
			white[ 2202 ]<=1;
			white[ 2203 ]<=1;
			white[ 2204 ]<=1;
			white[ 2205 ]<=1;
			white[ 2206 ]<=1;
			white[ 2207 ]<=1;
			white[ 2208 ]<=1;
			white[ 2209 ]<=1;
			white[ 2210 ]<=1;
			white[ 2211 ]<=1;
			white[ 2212 ]<=1;
			white[ 2213 ]<=1;
			white[ 2214 ]<=1;
			white[ 2215 ]<=1;
			white[ 2216 ]<=1;
			white[ 2217 ]<=1;
			white[ 2218 ]<=1;
			white[ 2219 ]<=1;
			white[ 2220 ]<=0;
			white[ 2221 ]<=1;
			white[ 2222 ]<=1;
			white[ 2223 ]<=1;
			white[ 2224 ]<=1;
			white[ 2225 ]<=1;
			white[ 2226 ]<=1;
			white[ 2227 ]<=1;
			white[ 2228 ]<=1;
			white[ 2229 ]<=1;
			white[ 2230 ]<=1;
			white[ 2231 ]<=1;
			white[ 2232 ]<=1;
			white[ 2233 ]<=1;
			white[ 2234 ]<=1;
			white[ 2235 ]<=1;
			white[ 2236 ]<=1;
			white[ 2237 ]<=1;
			white[ 2238 ]<=1;
			white[ 2239 ]<=1;
			white[ 2240 ]<=1;
			white[ 2241 ]<=1;
			white[ 2242 ]<=1;
			white[ 2243 ]<=1;
			white[ 2244 ]<=1;
			white[ 2245 ]<=1;
			white[ 2246 ]<=1;
			white[ 2247 ]<=1;
			white[ 2248 ]<=1;
			white[ 2249 ]<=1;
			white[ 2250 ]<=1;
			white[ 2251 ]<=1;
			white[ 2252 ]<=1;
			white[ 2253 ]<=1;
			white[ 2254 ]<=1;
			white[ 2255 ]<=1;
			white[ 2256 ]<=1;
			white[ 2257 ]<=1;
			white[ 2258 ]<=1;
			white[ 2259 ]<=1;
			white[ 2260 ]<=1;
			white[ 2261 ]<=1;
			white[ 2262 ]<=1;
			white[ 2263 ]<=1;
			white[ 2264 ]<=1;
			white[ 2265 ]<=1;
			white[ 2266 ]<=1;
			white[ 2267 ]<=1;
			white[ 2268 ]<=1;
			white[ 2269 ]<=1;
			white[ 2270 ]<=1;
			white[ 2271 ]<=1;
			white[ 2272 ]<=1;
			white[ 2273 ]<=1;
			white[ 2274 ]<=1;
			white[ 2275 ]<=1;
			white[ 2276 ]<=1;
			white[ 2277 ]<=1;
			white[ 2278 ]<=1;
			white[ 2279 ]<=1;
			white[ 2280 ]<=0;
			white[ 2281 ]<=1;
			white[ 2282 ]<=1;
			white[ 2283 ]<=1;
			white[ 2284 ]<=1;
			white[ 2285 ]<=1;
			white[ 2286 ]<=1;
			white[ 2287 ]<=1;
			white[ 2288 ]<=1;
			white[ 2289 ]<=1;
			white[ 2290 ]<=1;
			white[ 2291 ]<=1;
			white[ 2292 ]<=1;
			white[ 2293 ]<=1;
			white[ 2294 ]<=1;
			white[ 2295 ]<=1;
			white[ 2296 ]<=1;
			white[ 2297 ]<=1;
			white[ 2298 ]<=1;
			white[ 2299 ]<=1;
			white[ 2300 ]<=1;
			white[ 2301 ]<=1;
			white[ 2302 ]<=1;
			white[ 2303 ]<=1;
			white[ 2304 ]<=1;
			white[ 2305 ]<=1;
			white[ 2306 ]<=1;
			white[ 2307 ]<=1;
			white[ 2308 ]<=1;
			white[ 2309 ]<=1;
			white[ 2310 ]<=1;
			white[ 2311 ]<=1;
			white[ 2312 ]<=1;
			white[ 2313 ]<=1;
			white[ 2314 ]<=1;
			white[ 2315 ]<=1;
			white[ 2316 ]<=1;
			white[ 2317 ]<=1;
			white[ 2318 ]<=1;
			white[ 2319 ]<=1;
			white[ 2320 ]<=1;
			white[ 2321 ]<=1;
			white[ 2322 ]<=1;
			white[ 2323 ]<=1;
			white[ 2324 ]<=1;
			white[ 2325 ]<=1;
			white[ 2326 ]<=1;
			white[ 2327 ]<=1;
			white[ 2328 ]<=1;
			white[ 2329 ]<=1;
			white[ 2330 ]<=1;
			white[ 2331 ]<=1;
			white[ 2332 ]<=1;
			white[ 2333 ]<=1;
			white[ 2334 ]<=1;
			white[ 2335 ]<=1;
			white[ 2336 ]<=1;
			white[ 2337 ]<=1;
			white[ 2338 ]<=1;
			white[ 2339 ]<=0;
			white[ 2340 ]<=0;
			white[ 2341 ]<=1;
			white[ 2342 ]<=1;
			white[ 2343 ]<=1;
			white[ 2344 ]<=1;
			white[ 2345 ]<=1;
			white[ 2346 ]<=1;
			white[ 2347 ]<=1;
			white[ 2348 ]<=1;
			white[ 2349 ]<=1;
			white[ 2350 ]<=1;
			white[ 2351 ]<=1;
			white[ 2352 ]<=1;
			white[ 2353 ]<=1;
			white[ 2354 ]<=1;
			white[ 2355 ]<=1;
			white[ 2356 ]<=1;
			white[ 2357 ]<=1;
			white[ 2358 ]<=1;
			white[ 2359 ]<=1;
			white[ 2360 ]<=1;
			white[ 2361 ]<=1;
			white[ 2362 ]<=1;
			white[ 2363 ]<=1;
			white[ 2364 ]<=1;
			white[ 2365 ]<=1;
			white[ 2366 ]<=1;
			white[ 2367 ]<=1;
			white[ 2368 ]<=1;
			white[ 2369 ]<=1;
			white[ 2370 ]<=1;
			white[ 2371 ]<=1;
			white[ 2372 ]<=1;
			white[ 2373 ]<=1;
			white[ 2374 ]<=1;
			white[ 2375 ]<=1;
			white[ 2376 ]<=1;
			white[ 2377 ]<=1;
			white[ 2378 ]<=1;
			white[ 2379 ]<=1;
			white[ 2380 ]<=1;
			white[ 2381 ]<=1;
			white[ 2382 ]<=1;
			white[ 2383 ]<=1;
			white[ 2384 ]<=1;
			white[ 2385 ]<=1;
			white[ 2386 ]<=1;
			white[ 2387 ]<=1;
			white[ 2388 ]<=1;
			white[ 2389 ]<=1;
			white[ 2390 ]<=1;
			white[ 2391 ]<=1;
			white[ 2392 ]<=1;
			white[ 2393 ]<=1;
			white[ 2394 ]<=1;
			white[ 2395 ]<=1;
			white[ 2396 ]<=1;
			white[ 2397 ]<=1;
			white[ 2398 ]<=1;
			white[ 2399 ]<=0;
			white[ 2400 ]<=0;
			white[ 2401 ]<=0;
			white[ 2402 ]<=1;
			white[ 2403 ]<=1;
			white[ 2404 ]<=1;
			white[ 2405 ]<=1;
			white[ 2406 ]<=1;
			white[ 2407 ]<=1;
			white[ 2408 ]<=1;
			white[ 2409 ]<=1;
			white[ 2410 ]<=1;
			white[ 2411 ]<=1;
			white[ 2412 ]<=1;
			white[ 2413 ]<=1;
			white[ 2414 ]<=1;
			white[ 2415 ]<=1;
			white[ 2416 ]<=1;
			white[ 2417 ]<=1;
			white[ 2418 ]<=1;
			white[ 2419 ]<=1;
			white[ 2420 ]<=1;
			white[ 2421 ]<=1;
			white[ 2422 ]<=1;
			white[ 2423 ]<=1;
			white[ 2424 ]<=1;
			white[ 2425 ]<=1;
			white[ 2426 ]<=1;
			white[ 2427 ]<=1;
			white[ 2428 ]<=1;
			white[ 2429 ]<=1;
			white[ 2430 ]<=1;
			white[ 2431 ]<=1;
			white[ 2432 ]<=1;
			white[ 2433 ]<=1;
			white[ 2434 ]<=1;
			white[ 2435 ]<=1;
			white[ 2436 ]<=1;
			white[ 2437 ]<=1;
			white[ 2438 ]<=1;
			white[ 2439 ]<=1;
			white[ 2440 ]<=1;
			white[ 2441 ]<=1;
			white[ 2442 ]<=1;
			white[ 2443 ]<=1;
			white[ 2444 ]<=1;
			white[ 2445 ]<=1;
			white[ 2446 ]<=1;
			white[ 2447 ]<=1;
			white[ 2448 ]<=1;
			white[ 2449 ]<=1;
			white[ 2450 ]<=1;
			white[ 2451 ]<=1;
			white[ 2452 ]<=1;
			white[ 2453 ]<=1;
			white[ 2454 ]<=1;
			white[ 2455 ]<=1;
			white[ 2456 ]<=1;
			white[ 2457 ]<=1;
			white[ 2458 ]<=1;
			white[ 2459 ]<=0;
			white[ 2460 ]<=0;
			white[ 2461 ]<=0;
			white[ 2462 ]<=1;
			white[ 2463 ]<=1;
			white[ 2464 ]<=1;
			white[ 2465 ]<=1;
			white[ 2466 ]<=1;
			white[ 2467 ]<=1;
			white[ 2468 ]<=1;
			white[ 2469 ]<=1;
			white[ 2470 ]<=1;
			white[ 2471 ]<=1;
			white[ 2472 ]<=1;
			white[ 2473 ]<=1;
			white[ 2474 ]<=1;
			white[ 2475 ]<=1;
			white[ 2476 ]<=1;
			white[ 2477 ]<=1;
			white[ 2478 ]<=1;
			white[ 2479 ]<=1;
			white[ 2480 ]<=1;
			white[ 2481 ]<=1;
			white[ 2482 ]<=1;
			white[ 2483 ]<=1;
			white[ 2484 ]<=1;
			white[ 2485 ]<=1;
			white[ 2486 ]<=1;
			white[ 2487 ]<=1;
			white[ 2488 ]<=1;
			white[ 2489 ]<=1;
			white[ 2490 ]<=1;
			white[ 2491 ]<=1;
			white[ 2492 ]<=1;
			white[ 2493 ]<=1;
			white[ 2494 ]<=1;
			white[ 2495 ]<=1;
			white[ 2496 ]<=1;
			white[ 2497 ]<=1;
			white[ 2498 ]<=1;
			white[ 2499 ]<=1;
			white[ 2500 ]<=1;
			white[ 2501 ]<=1;
			white[ 2502 ]<=1;
			white[ 2503 ]<=1;
			white[ 2504 ]<=1;
			white[ 2505 ]<=1;
			white[ 2506 ]<=1;
			white[ 2507 ]<=1;
			white[ 2508 ]<=1;
			white[ 2509 ]<=1;
			white[ 2510 ]<=1;
			white[ 2511 ]<=1;
			white[ 2512 ]<=1;
			white[ 2513 ]<=1;
			white[ 2514 ]<=1;
			white[ 2515 ]<=1;
			white[ 2516 ]<=1;
			white[ 2517 ]<=1;
			white[ 2518 ]<=0;
			white[ 2519 ]<=0;
			white[ 2520 ]<=0;
			white[ 2521 ]<=0;
			white[ 2522 ]<=0;
			white[ 2523 ]<=1;
			white[ 2524 ]<=1;
			white[ 2525 ]<=1;
			white[ 2526 ]<=1;
			white[ 2527 ]<=1;
			white[ 2528 ]<=1;
			white[ 2529 ]<=1;
			white[ 2530 ]<=1;
			white[ 2531 ]<=1;
			white[ 2532 ]<=1;
			white[ 2533 ]<=1;
			white[ 2534 ]<=1;
			white[ 2535 ]<=1;
			white[ 2536 ]<=1;
			white[ 2537 ]<=1;
			white[ 2538 ]<=1;
			white[ 2539 ]<=1;
			white[ 2540 ]<=1;
			white[ 2541 ]<=1;
			white[ 2542 ]<=1;
			white[ 2543 ]<=1;
			white[ 2544 ]<=1;
			white[ 2545 ]<=1;
			white[ 2546 ]<=1;
			white[ 2547 ]<=1;
			white[ 2548 ]<=1;
			white[ 2549 ]<=1;
			white[ 2550 ]<=1;
			white[ 2551 ]<=1;
			white[ 2552 ]<=1;
			white[ 2553 ]<=1;
			white[ 2554 ]<=1;
			white[ 2555 ]<=1;
			white[ 2556 ]<=1;
			white[ 2557 ]<=1;
			white[ 2558 ]<=1;
			white[ 2559 ]<=1;
			white[ 2560 ]<=1;
			white[ 2561 ]<=1;
			white[ 2562 ]<=1;
			white[ 2563 ]<=1;
			white[ 2564 ]<=1;
			white[ 2565 ]<=1;
			white[ 2566 ]<=1;
			white[ 2567 ]<=1;
			white[ 2568 ]<=1;
			white[ 2569 ]<=1;
			white[ 2570 ]<=1;
			white[ 2571 ]<=1;
			white[ 2572 ]<=1;
			white[ 2573 ]<=1;
			white[ 2574 ]<=1;
			white[ 2575 ]<=1;
			white[ 2576 ]<=1;
			white[ 2577 ]<=1;
			white[ 2578 ]<=0;
			white[ 2579 ]<=0;
			white[ 2580 ]<=0;
			white[ 2581 ]<=0;
			white[ 2582 ]<=0;
			white[ 2583 ]<=1;
			white[ 2584 ]<=1;
			white[ 2585 ]<=1;
			white[ 2586 ]<=1;
			white[ 2587 ]<=1;
			white[ 2588 ]<=1;
			white[ 2589 ]<=1;
			white[ 2590 ]<=1;
			white[ 2591 ]<=1;
			white[ 2592 ]<=1;
			white[ 2593 ]<=1;
			white[ 2594 ]<=1;
			white[ 2595 ]<=1;
			white[ 2596 ]<=1;
			white[ 2597 ]<=1;
			white[ 2598 ]<=1;
			white[ 2599 ]<=1;
			white[ 2600 ]<=1;
			white[ 2601 ]<=1;
			white[ 2602 ]<=1;
			white[ 2603 ]<=1;
			white[ 2604 ]<=1;
			white[ 2605 ]<=1;
			white[ 2606 ]<=1;
			white[ 2607 ]<=1;
			white[ 2608 ]<=1;
			white[ 2609 ]<=1;
			white[ 2610 ]<=1;
			white[ 2611 ]<=1;
			white[ 2612 ]<=1;
			white[ 2613 ]<=1;
			white[ 2614 ]<=1;
			white[ 2615 ]<=1;
			white[ 2616 ]<=1;
			white[ 2617 ]<=1;
			white[ 2618 ]<=1;
			white[ 2619 ]<=1;
			white[ 2620 ]<=1;
			white[ 2621 ]<=1;
			white[ 2622 ]<=1;
			white[ 2623 ]<=1;
			white[ 2624 ]<=1;
			white[ 2625 ]<=1;
			white[ 2626 ]<=1;
			white[ 2627 ]<=1;
			white[ 2628 ]<=1;
			white[ 2629 ]<=1;
			white[ 2630 ]<=1;
			white[ 2631 ]<=1;
			white[ 2632 ]<=1;
			white[ 2633 ]<=1;
			white[ 2634 ]<=1;
			white[ 2635 ]<=1;
			white[ 2636 ]<=1;
			white[ 2637 ]<=0;
			white[ 2638 ]<=0;
			white[ 2639 ]<=0;
			white[ 2640 ]<=0;
			white[ 2641 ]<=0;
			white[ 2642 ]<=0;
			white[ 2643 ]<=0;
			white[ 2644 ]<=1;
			white[ 2645 ]<=1;
			white[ 2646 ]<=1;
			white[ 2647 ]<=1;
			white[ 2648 ]<=1;
			white[ 2649 ]<=1;
			white[ 2650 ]<=1;
			white[ 2651 ]<=1;
			white[ 2652 ]<=1;
			white[ 2653 ]<=1;
			white[ 2654 ]<=1;
			white[ 2655 ]<=1;
			white[ 2656 ]<=1;
			white[ 2657 ]<=1;
			white[ 2658 ]<=1;
			white[ 2659 ]<=1;
			white[ 2660 ]<=1;
			white[ 2661 ]<=1;
			white[ 2662 ]<=1;
			white[ 2663 ]<=1;
			white[ 2664 ]<=1;
			white[ 2665 ]<=1;
			white[ 2666 ]<=1;
			white[ 2667 ]<=1;
			white[ 2668 ]<=1;
			white[ 2669 ]<=1;
			white[ 2670 ]<=1;
			white[ 2671 ]<=1;
			white[ 2672 ]<=1;
			white[ 2673 ]<=1;
			white[ 2674 ]<=1;
			white[ 2675 ]<=1;
			white[ 2676 ]<=1;
			white[ 2677 ]<=1;
			white[ 2678 ]<=1;
			white[ 2679 ]<=1;
			white[ 2680 ]<=1;
			white[ 2681 ]<=1;
			white[ 2682 ]<=1;
			white[ 2683 ]<=1;
			white[ 2684 ]<=1;
			white[ 2685 ]<=1;
			white[ 2686 ]<=1;
			white[ 2687 ]<=1;
			white[ 2688 ]<=1;
			white[ 2689 ]<=1;
			white[ 2690 ]<=1;
			white[ 2691 ]<=1;
			white[ 2692 ]<=1;
			white[ 2693 ]<=1;
			white[ 2694 ]<=1;
			white[ 2695 ]<=1;
			white[ 2696 ]<=1;
			white[ 2697 ]<=0;
			white[ 2698 ]<=0;
			white[ 2699 ]<=0;
			white[ 2700 ]<=0;
			white[ 2701 ]<=0;
			white[ 2702 ]<=0;
			white[ 2703 ]<=0;
			white[ 2704 ]<=1;
			white[ 2705 ]<=1;
			white[ 2706 ]<=1;
			white[ 2707 ]<=1;
			white[ 2708 ]<=1;
			white[ 2709 ]<=1;
			white[ 2710 ]<=1;
			white[ 2711 ]<=1;
			white[ 2712 ]<=1;
			white[ 2713 ]<=1;
			white[ 2714 ]<=1;
			white[ 2715 ]<=1;
			white[ 2716 ]<=1;
			white[ 2717 ]<=1;
			white[ 2718 ]<=1;
			white[ 2719 ]<=1;
			white[ 2720 ]<=1;
			white[ 2721 ]<=1;
			white[ 2722 ]<=1;
			white[ 2723 ]<=1;
			white[ 2724 ]<=1;
			white[ 2725 ]<=1;
			white[ 2726 ]<=1;
			white[ 2727 ]<=1;
			white[ 2728 ]<=1;
			white[ 2729 ]<=1;
			white[ 2730 ]<=1;
			white[ 2731 ]<=1;
			white[ 2732 ]<=1;
			white[ 2733 ]<=1;
			white[ 2734 ]<=1;
			white[ 2735 ]<=1;
			white[ 2736 ]<=1;
			white[ 2737 ]<=1;
			white[ 2738 ]<=1;
			white[ 2739 ]<=1;
			white[ 2740 ]<=1;
			white[ 2741 ]<=1;
			white[ 2742 ]<=1;
			white[ 2743 ]<=1;
			white[ 2744 ]<=1;
			white[ 2745 ]<=1;
			white[ 2746 ]<=1;
			white[ 2747 ]<=1;
			white[ 2748 ]<=1;
			white[ 2749 ]<=1;
			white[ 2750 ]<=1;
			white[ 2751 ]<=1;
			white[ 2752 ]<=1;
			white[ 2753 ]<=1;
			white[ 2754 ]<=1;
			white[ 2755 ]<=1;
			white[ 2756 ]<=0;
			white[ 2757 ]<=0;
			white[ 2758 ]<=0;
			white[ 2759 ]<=0;
			white[ 2760 ]<=0;
			white[ 2761 ]<=0;
			white[ 2762 ]<=0;
			white[ 2763 ]<=0;
			white[ 2764 ]<=0;
			white[ 2765 ]<=1;
			white[ 2766 ]<=1;
			white[ 2767 ]<=1;
			white[ 2768 ]<=1;
			white[ 2769 ]<=1;
			white[ 2770 ]<=1;
			white[ 2771 ]<=1;
			white[ 2772 ]<=1;
			white[ 2773 ]<=1;
			white[ 2774 ]<=1;
			white[ 2775 ]<=1;
			white[ 2776 ]<=1;
			white[ 2777 ]<=1;
			white[ 2778 ]<=1;
			white[ 2779 ]<=1;
			white[ 2780 ]<=1;
			white[ 2781 ]<=1;
			white[ 2782 ]<=1;
			white[ 2783 ]<=1;
			white[ 2784 ]<=1;
			white[ 2785 ]<=1;
			white[ 2786 ]<=1;
			white[ 2787 ]<=1;
			white[ 2788 ]<=1;
			white[ 2789 ]<=1;
			white[ 2790 ]<=1;
			white[ 2791 ]<=1;
			white[ 2792 ]<=1;
			white[ 2793 ]<=1;
			white[ 2794 ]<=1;
			white[ 2795 ]<=1;
			white[ 2796 ]<=1;
			white[ 2797 ]<=1;
			white[ 2798 ]<=1;
			white[ 2799 ]<=1;
			white[ 2800 ]<=1;
			white[ 2801 ]<=1;
			white[ 2802 ]<=1;
			white[ 2803 ]<=1;
			white[ 2804 ]<=1;
			white[ 2805 ]<=1;
			white[ 2806 ]<=1;
			white[ 2807 ]<=1;
			white[ 2808 ]<=1;
			white[ 2809 ]<=1;
			white[ 2810 ]<=1;
			white[ 2811 ]<=1;
			white[ 2812 ]<=1;
			white[ 2813 ]<=1;
			white[ 2814 ]<=1;
			white[ 2815 ]<=1;
			white[ 2816 ]<=0;
			white[ 2817 ]<=0;
			white[ 2818 ]<=0;
			white[ 2819 ]<=0;
			white[ 2820 ]<=0;
			white[ 2821 ]<=0;
			white[ 2822 ]<=0;
			white[ 2823 ]<=0;
			white[ 2824 ]<=0;
			white[ 2825 ]<=0;
			white[ 2826 ]<=1;
			white[ 2827 ]<=1;
			white[ 2828 ]<=1;
			white[ 2829 ]<=1;
			white[ 2830 ]<=1;
			white[ 2831 ]<=1;
			white[ 2832 ]<=1;
			white[ 2833 ]<=1;
			white[ 2834 ]<=1;
			white[ 2835 ]<=1;
			white[ 2836 ]<=1;
			white[ 2837 ]<=1;
			white[ 2838 ]<=1;
			white[ 2839 ]<=1;
			white[ 2840 ]<=1;
			white[ 2841 ]<=1;
			white[ 2842 ]<=1;
			white[ 2843 ]<=1;
			white[ 2844 ]<=1;
			white[ 2845 ]<=1;
			white[ 2846 ]<=1;
			white[ 2847 ]<=1;
			white[ 2848 ]<=1;
			white[ 2849 ]<=1;
			white[ 2850 ]<=1;
			white[ 2851 ]<=1;
			white[ 2852 ]<=1;
			white[ 2853 ]<=1;
			white[ 2854 ]<=1;
			white[ 2855 ]<=1;
			white[ 2856 ]<=1;
			white[ 2857 ]<=1;
			white[ 2858 ]<=1;
			white[ 2859 ]<=1;
			white[ 2860 ]<=1;
			white[ 2861 ]<=1;
			white[ 2862 ]<=1;
			white[ 2863 ]<=1;
			white[ 2864 ]<=1;
			white[ 2865 ]<=1;
			white[ 2866 ]<=1;
			white[ 2867 ]<=1;
			white[ 2868 ]<=1;
			white[ 2869 ]<=1;
			white[ 2870 ]<=1;
			white[ 2871 ]<=1;
			white[ 2872 ]<=1;
			white[ 2873 ]<=1;
			white[ 2874 ]<=1;
			white[ 2875 ]<=0;
			white[ 2876 ]<=0;
			white[ 2877 ]<=0;
			white[ 2878 ]<=0;
			white[ 2879 ]<=0;
			white[ 2880 ]<=0;
			white[ 2881 ]<=0;
			white[ 2882 ]<=0;
			white[ 2883 ]<=0;
			white[ 2884 ]<=0;
			white[ 2885 ]<=0;
			white[ 2886 ]<=0;
			white[ 2887 ]<=1;
			white[ 2888 ]<=1;
			white[ 2889 ]<=1;
			white[ 2890 ]<=1;
			white[ 2891 ]<=1;
			white[ 2892 ]<=1;
			white[ 2893 ]<=1;
			white[ 2894 ]<=1;
			white[ 2895 ]<=1;
			white[ 2896 ]<=1;
			white[ 2897 ]<=1;
			white[ 2898 ]<=1;
			white[ 2899 ]<=1;
			white[ 2900 ]<=1;
			white[ 2901 ]<=1;
			white[ 2902 ]<=1;
			white[ 2903 ]<=1;
			white[ 2904 ]<=1;
			white[ 2905 ]<=1;
			white[ 2906 ]<=1;
			white[ 2907 ]<=1;
			white[ 2908 ]<=1;
			white[ 2909 ]<=1;
			white[ 2910 ]<=1;
			white[ 2911 ]<=1;
			white[ 2912 ]<=1;
			white[ 2913 ]<=1;
			white[ 2914 ]<=1;
			white[ 2915 ]<=1;
			white[ 2916 ]<=1;
			white[ 2917 ]<=1;
			white[ 2918 ]<=1;
			white[ 2919 ]<=1;
			white[ 2920 ]<=1;
			white[ 2921 ]<=1;
			white[ 2922 ]<=1;
			white[ 2923 ]<=1;
			white[ 2924 ]<=1;
			white[ 2925 ]<=1;
			white[ 2926 ]<=1;
			white[ 2927 ]<=1;
			white[ 2928 ]<=1;
			white[ 2929 ]<=1;
			white[ 2930 ]<=1;
			white[ 2931 ]<=1;
			white[ 2932 ]<=1;
			white[ 2933 ]<=1;
			white[ 2934 ]<=0;
			white[ 2935 ]<=0;
			white[ 2936 ]<=0;
			white[ 2937 ]<=0;
			white[ 2938 ]<=0;
			white[ 2939 ]<=0;
			white[ 2940 ]<=0;
			white[ 2941 ]<=0;
			white[ 2942 ]<=0;
			white[ 2943 ]<=0;
			white[ 2944 ]<=0;
			white[ 2945 ]<=0;
			white[ 2946 ]<=0;
			white[ 2947 ]<=0;
			white[ 2948 ]<=1;
			white[ 2949 ]<=1;
			white[ 2950 ]<=1;
			white[ 2951 ]<=1;
			white[ 2952 ]<=1;
			white[ 2953 ]<=1;
			white[ 2954 ]<=1;
			white[ 2955 ]<=1;
			white[ 2956 ]<=1;
			white[ 2957 ]<=1;
			white[ 2958 ]<=1;
			white[ 2959 ]<=1;
			white[ 2960 ]<=1;
			white[ 2961 ]<=1;
			white[ 2962 ]<=1;
			white[ 2963 ]<=1;
			white[ 2964 ]<=1;
			white[ 2965 ]<=1;
			white[ 2966 ]<=1;
			white[ 2967 ]<=1;
			white[ 2968 ]<=1;
			white[ 2969 ]<=1;
			white[ 2970 ]<=1;
			white[ 2971 ]<=1;
			white[ 2972 ]<=1;
			white[ 2973 ]<=1;
			white[ 2974 ]<=1;
			white[ 2975 ]<=1;
			white[ 2976 ]<=1;
			white[ 2977 ]<=1;
			white[ 2978 ]<=1;
			white[ 2979 ]<=1;
			white[ 2980 ]<=1;
			white[ 2981 ]<=1;
			white[ 2982 ]<=1;
			white[ 2983 ]<=1;
			white[ 2984 ]<=1;
			white[ 2985 ]<=1;
			white[ 2986 ]<=1;
			white[ 2987 ]<=1;
			white[ 2988 ]<=1;
			white[ 2989 ]<=1;
			white[ 2990 ]<=1;
			white[ 2991 ]<=1;
			white[ 2992 ]<=1;
			white[ 2993 ]<=1;
			white[ 2994 ]<=0;
			white[ 2995 ]<=0;
			white[ 2996 ]<=0;
			white[ 2997 ]<=0;
			white[ 2998 ]<=0;
			white[ 2999 ]<=0;
			white[ 3000 ]<=0;
			white[ 3001 ]<=0;
			white[ 3002 ]<=0;
			white[ 3003 ]<=0;
			white[ 3004 ]<=0;
			white[ 3005 ]<=0;
			white[ 3006 ]<=0;
			white[ 3007 ]<=0;
			white[ 3008 ]<=0;
			white[ 3009 ]<=1;
			white[ 3010 ]<=1;
			white[ 3011 ]<=1;
			white[ 3012 ]<=1;
			white[ 3013 ]<=1;
			white[ 3014 ]<=1;
			white[ 3015 ]<=1;
			white[ 3016 ]<=1;
			white[ 3017 ]<=1;
			white[ 3018 ]<=1;
			white[ 3019 ]<=1;
			white[ 3020 ]<=1;
			white[ 3021 ]<=1;
			white[ 3022 ]<=1;
			white[ 3023 ]<=1;
			white[ 3024 ]<=1;
			white[ 3025 ]<=1;
			white[ 3026 ]<=1;
			white[ 3027 ]<=1;
			white[ 3028 ]<=1;
			white[ 3029 ]<=1;
			white[ 3030 ]<=1;
			white[ 3031 ]<=1;
			white[ 3032 ]<=1;
			white[ 3033 ]<=1;
			white[ 3034 ]<=1;
			white[ 3035 ]<=1;
			white[ 3036 ]<=1;
			white[ 3037 ]<=1;
			white[ 3038 ]<=1;
			white[ 3039 ]<=1;
			white[ 3040 ]<=1;
			white[ 3041 ]<=1;
			white[ 3042 ]<=1;
			white[ 3043 ]<=1;
			white[ 3044 ]<=1;
			white[ 3045 ]<=1;
			white[ 3046 ]<=1;
			white[ 3047 ]<=1;
			white[ 3048 ]<=1;
			white[ 3049 ]<=1;
			white[ 3050 ]<=1;
			white[ 3051 ]<=1;
			white[ 3052 ]<=1;
			white[ 3053 ]<=0;
			white[ 3054 ]<=0;
			white[ 3055 ]<=0;
			white[ 3056 ]<=0;
			white[ 3057 ]<=0;
			white[ 3058 ]<=0;
			white[ 3059 ]<=0;
			white[ 3060 ]<=0;
			white[ 3061 ]<=0;
			white[ 3062 ]<=0;
			white[ 3063 ]<=0;
			white[ 3064 ]<=0;
			white[ 3065 ]<=0;
			white[ 3066 ]<=0;
			white[ 3067 ]<=0;
			white[ 3068 ]<=0;
			white[ 3069 ]<=0;
			white[ 3070 ]<=1;
			white[ 3071 ]<=1;
			white[ 3072 ]<=1;
			white[ 3073 ]<=1;
			white[ 3074 ]<=1;
			white[ 3075 ]<=1;
			white[ 3076 ]<=1;
			white[ 3077 ]<=1;
			white[ 3078 ]<=1;
			white[ 3079 ]<=1;
			white[ 3080 ]<=1;
			white[ 3081 ]<=1;
			white[ 3082 ]<=1;
			white[ 3083 ]<=1;
			white[ 3084 ]<=1;
			white[ 3085 ]<=1;
			white[ 3086 ]<=1;
			white[ 3087 ]<=1;
			white[ 3088 ]<=1;
			white[ 3089 ]<=1;
			white[ 3090 ]<=1;
			white[ 3091 ]<=1;
			white[ 3092 ]<=1;
			white[ 3093 ]<=1;
			white[ 3094 ]<=1;
			white[ 3095 ]<=1;
			white[ 3096 ]<=1;
			white[ 3097 ]<=1;
			white[ 3098 ]<=1;
			white[ 3099 ]<=1;
			white[ 3100 ]<=1;
			white[ 3101 ]<=1;
			white[ 3102 ]<=1;
			white[ 3103 ]<=1;
			white[ 3104 ]<=1;
			white[ 3105 ]<=1;
			white[ 3106 ]<=1;
			white[ 3107 ]<=1;
			white[ 3108 ]<=1;
			white[ 3109 ]<=1;
			white[ 3110 ]<=1;
			white[ 3111 ]<=1;
			white[ 3112 ]<=0;
			white[ 3113 ]<=0;
			white[ 3114 ]<=0;
			white[ 3115 ]<=0;
			white[ 3116 ]<=0;
			white[ 3117 ]<=0;
			white[ 3118 ]<=0;
			white[ 3119 ]<=0;
			white[ 3120 ]<=0;
			white[ 3121 ]<=0;
			white[ 3122 ]<=0;
			white[ 3123 ]<=0;
			white[ 3124 ]<=0;
			white[ 3125 ]<=0;
			white[ 3126 ]<=0;
			white[ 3127 ]<=0;
			white[ 3128 ]<=0;
			white[ 3129 ]<=0;
			white[ 3130 ]<=1;
			white[ 3131 ]<=1;
			white[ 3132 ]<=1;
			white[ 3133 ]<=1;
			white[ 3134 ]<=1;
			white[ 3135 ]<=1;
			white[ 3136 ]<=1;
			white[ 3137 ]<=1;
			white[ 3138 ]<=1;
			white[ 3139 ]<=1;
			white[ 3140 ]<=1;
			white[ 3141 ]<=1;
			white[ 3142 ]<=1;
			white[ 3143 ]<=1;
			white[ 3144 ]<=1;
			white[ 3145 ]<=1;
			white[ 3146 ]<=1;
			white[ 3147 ]<=1;
			white[ 3148 ]<=1;
			white[ 3149 ]<=1;
			white[ 3150 ]<=1;
			white[ 3151 ]<=1;
			white[ 3152 ]<=1;
			white[ 3153 ]<=1;
			white[ 3154 ]<=1;
			white[ 3155 ]<=1;
			white[ 3156 ]<=1;
			white[ 3157 ]<=1;
			white[ 3158 ]<=1;
			white[ 3159 ]<=1;
			white[ 3160 ]<=1;
			white[ 3161 ]<=1;
			white[ 3162 ]<=1;
			white[ 3163 ]<=1;
			white[ 3164 ]<=1;
			white[ 3165 ]<=1;
			white[ 3166 ]<=1;
			white[ 3167 ]<=1;
			white[ 3168 ]<=1;
			white[ 3169 ]<=1;
			white[ 3170 ]<=1;
			white[ 3171 ]<=0;
			white[ 3172 ]<=0;
			white[ 3173 ]<=0;
			white[ 3174 ]<=0;
			white[ 3175 ]<=0;
			white[ 3176 ]<=0;
			white[ 3177 ]<=0;
			white[ 3178 ]<=0;
			white[ 3179 ]<=0;
			white[ 3180 ]<=0;
			white[ 3181 ]<=0;
			white[ 3182 ]<=0;
			white[ 3183 ]<=0;
			white[ 3184 ]<=0;
			white[ 3185 ]<=0;
			white[ 3186 ]<=0;
			white[ 3187 ]<=0;
			white[ 3188 ]<=0;
			white[ 3189 ]<=0;
			white[ 3190 ]<=0;
			white[ 3191 ]<=0;
			white[ 3192 ]<=1;
			white[ 3193 ]<=1;
			white[ 3194 ]<=1;
			white[ 3195 ]<=1;
			white[ 3196 ]<=1;
			white[ 3197 ]<=1;
			white[ 3198 ]<=1;
			white[ 3199 ]<=1;
			white[ 3200 ]<=1;
			white[ 3201 ]<=1;
			white[ 3202 ]<=1;
			white[ 3203 ]<=1;
			white[ 3204 ]<=1;
			white[ 3205 ]<=1;
			white[ 3206 ]<=1;
			white[ 3207 ]<=1;
			white[ 3208 ]<=1;
			white[ 3209 ]<=1;
			white[ 3210 ]<=1;
			white[ 3211 ]<=1;
			white[ 3212 ]<=1;
			white[ 3213 ]<=1;
			white[ 3214 ]<=1;
			white[ 3215 ]<=1;
			white[ 3216 ]<=1;
			white[ 3217 ]<=1;
			white[ 3218 ]<=1;
			white[ 3219 ]<=1;
			white[ 3220 ]<=1;
			white[ 3221 ]<=1;
			white[ 3222 ]<=1;
			white[ 3223 ]<=1;
			white[ 3224 ]<=1;
			white[ 3225 ]<=1;
			white[ 3226 ]<=1;
			white[ 3227 ]<=1;
			white[ 3228 ]<=1;
			white[ 3229 ]<=1;
			white[ 3230 ]<=0;
			white[ 3231 ]<=0;
			white[ 3232 ]<=0;
			white[ 3233 ]<=0;
			white[ 3234 ]<=0;
			white[ 3235 ]<=0;
			white[ 3236 ]<=0;
			white[ 3237 ]<=0;
			white[ 3238 ]<=0;
			white[ 3239 ]<=0;
			white[ 3240 ]<=0;
			white[ 3241 ]<=0;
			white[ 3242 ]<=0;
			white[ 3243 ]<=0;
			white[ 3244 ]<=0;
			white[ 3245 ]<=0;
			white[ 3246 ]<=0;
			white[ 3247 ]<=0;
			white[ 3248 ]<=0;
			white[ 3249 ]<=0;
			white[ 3250 ]<=0;
			white[ 3251 ]<=0;
			white[ 3252 ]<=0;
			white[ 3253 ]<=1;
			white[ 3254 ]<=1;
			white[ 3255 ]<=1;
			white[ 3256 ]<=1;
			white[ 3257 ]<=1;
			white[ 3258 ]<=1;
			white[ 3259 ]<=1;
			white[ 3260 ]<=1;
			white[ 3261 ]<=1;
			white[ 3262 ]<=1;
			white[ 3263 ]<=1;
			white[ 3264 ]<=1;
			white[ 3265 ]<=1;
			white[ 3266 ]<=1;
			white[ 3267 ]<=1;
			white[ 3268 ]<=1;
			white[ 3269 ]<=1;
			white[ 3270 ]<=1;
			white[ 3271 ]<=1;
			white[ 3272 ]<=1;
			white[ 3273 ]<=1;
			white[ 3274 ]<=1;
			white[ 3275 ]<=1;
			white[ 3276 ]<=1;
			white[ 3277 ]<=1;
			white[ 3278 ]<=1;
			white[ 3279 ]<=1;
			white[ 3280 ]<=1;
			white[ 3281 ]<=1;
			white[ 3282 ]<=1;
			white[ 3283 ]<=1;
			white[ 3284 ]<=1;
			white[ 3285 ]<=1;
			white[ 3286 ]<=1;
			white[ 3287 ]<=1;
			white[ 3288 ]<=0;
			white[ 3289 ]<=0;
			white[ 3290 ]<=0;
			white[ 3291 ]<=0;
			white[ 3292 ]<=0;
			white[ 3293 ]<=0;
			white[ 3294 ]<=0;
			white[ 3295 ]<=0;
			white[ 3296 ]<=0;
			white[ 3297 ]<=0;
			white[ 3298 ]<=0;
			white[ 3299 ]<=0;
			white[ 3300 ]<=0;
			white[ 3301 ]<=0;
			white[ 3302 ]<=0;
			white[ 3303 ]<=0;
			white[ 3304 ]<=0;
			white[ 3305 ]<=0;
			white[ 3306 ]<=0;
			white[ 3307 ]<=0;
			white[ 3308 ]<=0;
			white[ 3309 ]<=0;
			white[ 3310 ]<=0;
			white[ 3311 ]<=0;
			white[ 3312 ]<=0;
			white[ 3313 ]<=0;
			white[ 3314 ]<=1;
			white[ 3315 ]<=1;
			white[ 3316 ]<=1;
			white[ 3317 ]<=1;
			white[ 3318 ]<=1;
			white[ 3319 ]<=1;
			white[ 3320 ]<=1;
			white[ 3321 ]<=1;
			white[ 3322 ]<=1;
			white[ 3323 ]<=1;
			white[ 3324 ]<=1;
			white[ 3325 ]<=1;
			white[ 3326 ]<=1;
			white[ 3327 ]<=1;
			white[ 3328 ]<=1;
			white[ 3329 ]<=1;
			white[ 3330 ]<=1;
			white[ 3331 ]<=1;
			white[ 3332 ]<=1;
			white[ 3333 ]<=1;
			white[ 3334 ]<=1;
			white[ 3335 ]<=1;
			white[ 3336 ]<=1;
			white[ 3337 ]<=1;
			white[ 3338 ]<=1;
			white[ 3339 ]<=1;
			white[ 3340 ]<=1;
			white[ 3341 ]<=1;
			white[ 3342 ]<=1;
			white[ 3343 ]<=1;
			white[ 3344 ]<=1;
			white[ 3345 ]<=1;
			white[ 3346 ]<=1;
			white[ 3347 ]<=0;
			white[ 3348 ]<=0;
			white[ 3349 ]<=0;
			white[ 3350 ]<=0;
			white[ 3351 ]<=0;
			white[ 3352 ]<=0;
			white[ 3353 ]<=0;
			white[ 3354 ]<=0;
			white[ 3355 ]<=0;
			white[ 3356 ]<=0;
			white[ 3357 ]<=0;
			white[ 3358 ]<=0;
			white[ 3359 ]<=0;
			white[ 3360 ]<=0;
			white[ 3361 ]<=0;
			white[ 3362 ]<=0;
			white[ 3363 ]<=0;
			white[ 3364 ]<=0;
			white[ 3365 ]<=0;
			white[ 3366 ]<=0;
			white[ 3367 ]<=0;
			white[ 3368 ]<=0;
			white[ 3369 ]<=0;
			white[ 3370 ]<=0;
			white[ 3371 ]<=0;
			white[ 3372 ]<=0;
			white[ 3373 ]<=0;
			white[ 3374 ]<=0;
			white[ 3375 ]<=0;
			white[ 3376 ]<=1;
			white[ 3377 ]<=1;
			white[ 3378 ]<=1;
			white[ 3379 ]<=1;
			white[ 3380 ]<=1;
			white[ 3381 ]<=1;
			white[ 3382 ]<=1;
			white[ 3383 ]<=1;
			white[ 3384 ]<=1;
			white[ 3385 ]<=1;
			white[ 3386 ]<=1;
			white[ 3387 ]<=1;
			white[ 3388 ]<=1;
			white[ 3389 ]<=1;
			white[ 3390 ]<=1;
			white[ 3391 ]<=1;
			white[ 3392 ]<=1;
			white[ 3393 ]<=1;
			white[ 3394 ]<=1;
			white[ 3395 ]<=1;
			white[ 3396 ]<=1;
			white[ 3397 ]<=1;
			white[ 3398 ]<=1;
			white[ 3399 ]<=1;
			white[ 3400 ]<=1;
			white[ 3401 ]<=1;
			white[ 3402 ]<=1;
			white[ 3403 ]<=1;
			white[ 3404 ]<=1;
			white[ 3405 ]<=0;
			white[ 3406 ]<=0;
			white[ 3407 ]<=0;
			white[ 3408 ]<=0;
			white[ 3409 ]<=0;
			white[ 3410 ]<=0;
			white[ 3411 ]<=0;
			white[ 3412 ]<=0;
			white[ 3413 ]<=0;
			white[ 3414 ]<=0;
			white[ 3415 ]<=0;
			white[ 3416 ]<=0;
			white[ 3417 ]<=0;
			white[ 3418 ]<=0;
			white[ 3419 ]<=0;
			white[ 3420 ]<=0;
			white[ 3421 ]<=0;
			white[ 3422 ]<=0;
			white[ 3423 ]<=0;
			white[ 3424 ]<=0;
			white[ 3425 ]<=0;
			white[ 3426 ]<=0;
			white[ 3427 ]<=0;
			white[ 3428 ]<=0;
			white[ 3429 ]<=0;
			white[ 3430 ]<=0;
			white[ 3431 ]<=0;
			white[ 3432 ]<=0;
			white[ 3433 ]<=0;
			white[ 3434 ]<=0;
			white[ 3435 ]<=0;
			white[ 3436 ]<=0;
			white[ 3437 ]<=0;
			white[ 3438 ]<=1;
			white[ 3439 ]<=1;
			white[ 3440 ]<=1;
			white[ 3441 ]<=1;
			white[ 3442 ]<=1;
			white[ 3443 ]<=1;
			white[ 3444 ]<=1;
			white[ 3445 ]<=1;
			white[ 3446 ]<=1;
			white[ 3447 ]<=1;
			white[ 3448 ]<=1;
			white[ 3449 ]<=1;
			white[ 3450 ]<=1;
			white[ 3451 ]<=1;
			white[ 3452 ]<=1;
			white[ 3453 ]<=1;
			white[ 3454 ]<=1;
			white[ 3455 ]<=1;
			white[ 3456 ]<=1;
			white[ 3457 ]<=1;
			white[ 3458 ]<=1;
			white[ 3459 ]<=1;
			white[ 3460 ]<=1;
			white[ 3461 ]<=1;
			white[ 3462 ]<=1;
			white[ 3463 ]<=0;
			white[ 3464 ]<=0;
			white[ 3465 ]<=0;
			white[ 3466 ]<=0;
			white[ 3467 ]<=0;
			white[ 3468 ]<=0;
			white[ 3469 ]<=0;
			white[ 3470 ]<=0;
			white[ 3471 ]<=0;
			white[ 3472 ]<=0;
			white[ 3473 ]<=0;
			white[ 3474 ]<=0;
			white[ 3475 ]<=0;
			white[ 3476 ]<=0;
			white[ 3477 ]<=0;
			white[ 3478 ]<=0;
			white[ 3479 ]<=0;
			white[ 3480 ]<=0;
			white[ 3481 ]<=0;
			white[ 3482 ]<=0;
			white[ 3483 ]<=0;
			white[ 3484 ]<=0;
			white[ 3485 ]<=0;
			white[ 3486 ]<=0;
			white[ 3487 ]<=0;
			white[ 3488 ]<=0;
			white[ 3489 ]<=0;
			white[ 3490 ]<=0;
			white[ 3491 ]<=0;
			white[ 3492 ]<=0;
			white[ 3493 ]<=0;
			white[ 3494 ]<=0;
			white[ 3495 ]<=0;
			white[ 3496 ]<=0;
			white[ 3497 ]<=0;
			white[ 3498 ]<=0;
			white[ 3499 ]<=0;
			white[ 3500 ]<=1;
			white[ 3501 ]<=1;
			white[ 3502 ]<=1;
			white[ 3503 ]<=1;
			white[ 3504 ]<=1;
			white[ 3505 ]<=1;
			white[ 3506 ]<=1;
			white[ 3507 ]<=1;
			white[ 3508 ]<=1;
			white[ 3509 ]<=1;
			white[ 3510 ]<=1;
			white[ 3511 ]<=1;
			white[ 3512 ]<=1;
			white[ 3513 ]<=1;
			white[ 3514 ]<=1;
			white[ 3515 ]<=1;
			white[ 3516 ]<=1;
			white[ 3517 ]<=1;
			white[ 3518 ]<=1;
			white[ 3519 ]<=1;
			white[ 3520 ]<=1;
			white[ 3521 ]<=0;
			white[ 3522 ]<=0;
			white[ 3523 ]<=0;
			white[ 3524 ]<=0;
			white[ 3525 ]<=0;
			white[ 3526 ]<=0;
			white[ 3527 ]<=0;
			white[ 3528 ]<=0;
			white[ 3529 ]<=0;
			white[ 3530 ]<=0;
			white[ 3531 ]<=0;
			white[ 3532 ]<=0;
			white[ 3533 ]<=0;
			white[ 3534 ]<=0;
			white[ 3535 ]<=0;
			white[ 3536 ]<=0;
			white[ 3537 ]<=0;
			white[ 3538 ]<=0;
			white[ 3539 ]<=0;
			white[ 3540 ]<=0;
			white[ 3541 ]<=0;
			white[ 3542 ]<=0;
			white[ 3543 ]<=0;
			white[ 3544 ]<=0;
			white[ 3545 ]<=0;
			white[ 3546 ]<=0;
			white[ 3547 ]<=0;
			white[ 3548 ]<=0;
			white[ 3549 ]<=0;
			white[ 3550 ]<=0;
			white[ 3551 ]<=0;
			white[ 3552 ]<=0;
			white[ 3553 ]<=0;
			white[ 3554 ]<=0;
			white[ 3555 ]<=0;
			white[ 3556 ]<=0;
			white[ 3557 ]<=0;
			white[ 3558 ]<=0;
			white[ 3559 ]<=0;
			white[ 3560 ]<=0;
			white[ 3561 ]<=0;
			white[ 3562 ]<=0;
			white[ 3563 ]<=1;
			white[ 3564 ]<=1;
			white[ 3565 ]<=1;
			white[ 3566 ]<=1;
			white[ 3567 ]<=1;
			white[ 3568 ]<=1;
			white[ 3569 ]<=1;
			white[ 3570 ]<=1;
			white[ 3571 ]<=1;
			white[ 3572 ]<=1;
			white[ 3573 ]<=1;
			white[ 3574 ]<=1;
			white[ 3575 ]<=1;
			white[ 3576 ]<=1;
			white[ 3577 ]<=1;
			white[ 3578 ]<=0;
			white[ 3579 ]<=0;
			white[ 3580 ]<=0;
			white[ 3581 ]<=0;
			white[ 3582 ]<=0;
			white[ 3583 ]<=0;
			white[ 3584 ]<=0;
			white[ 3585 ]<=0;
			white[ 3586 ]<=0;
			white[ 3587 ]<=0;
			white[ 3588 ]<=0;
			white[ 3589 ]<=0;
			white[ 3590 ]<=0;
			white[ 3591 ]<=0;
			white[ 3592 ]<=0;
			white[ 3593 ]<=0;
			white[ 3594 ]<=0;
			white[ 3595 ]<=0;
			white[ 3596 ]<=0;
			white[ 3597 ]<=0;
			white[ 3598 ]<=0;
			white[ 3599 ]<=0;
			end

			//indicator
			18'd99839:begin
			white[ 0 ]<=0;
			white[ 1 ]<=0;
			white[ 2 ]<=0;
			white[ 3 ]<=0;
			white[ 4 ]<=0;
			white[ 5 ]<=0;
			white[ 6 ]<=0;
			white[ 7 ]<=0;
			white[ 8 ]<=0;
			white[ 9 ]<=0;
			white[ 10 ]<=0;
			white[ 11 ]<=0;
			white[ 12 ]<=0;
			white[ 13 ]<=0;
			white[ 14 ]<=0;
			white[ 15 ]<=0;
			white[ 16 ]<=0;
			white[ 17 ]<=0;
			white[ 18 ]<=0;
			white[ 19 ]<=0;
			white[ 20 ]<=0;
			white[ 21 ]<=0;
			white[ 22 ]<=0;
			white[ 23 ]<=0;
			white[ 24 ]<=0;
			white[ 25 ]<=0;
			white[ 26 ]<=0;
			white[ 27 ]<=0;
			white[ 28 ]<=0;
			white[ 29 ]<=0;
			white[ 30 ]<=0;
			white[ 31 ]<=0;
			white[ 32 ]<=0;
			white[ 33 ]<=0;
			white[ 34 ]<=0;
			white[ 35 ]<=0;
			white[ 36 ]<=0;
			white[ 37 ]<=0;
			white[ 38 ]<=0;
			white[ 39 ]<=0;
			white[ 40 ]<=0;
			white[ 41 ]<=0;
			white[ 42 ]<=0;
			white[ 43 ]<=0;
			white[ 44 ]<=0;
			white[ 45 ]<=0;
			white[ 46 ]<=0;
			white[ 47 ]<=0;
			white[ 48 ]<=0;
			white[ 49 ]<=0;
			white[ 50 ]<=0;
			white[ 51 ]<=0;
			white[ 52 ]<=0;
			white[ 53 ]<=0;
			white[ 54 ]<=0;
			white[ 55 ]<=0;
			white[ 56 ]<=0;
			white[ 57 ]<=0;
			white[ 58 ]<=0;
			white[ 59 ]<=0;
			white[ 60 ]<=0;
			white[ 61 ]<=0;
			white[ 62 ]<=0;
			white[ 63 ]<=0;
			white[ 64 ]<=0;
			white[ 65 ]<=0;
			white[ 66 ]<=0;
			white[ 67 ]<=0;
			white[ 68 ]<=0;
			white[ 69 ]<=0;
			white[ 70 ]<=0;
			white[ 71 ]<=0;
			white[ 72 ]<=0;
			white[ 73 ]<=0;
			white[ 74 ]<=0;
			white[ 75 ]<=0;
			white[ 76 ]<=0;
			white[ 77 ]<=0;
			white[ 78 ]<=0;
			white[ 79 ]<=0;
			white[ 80 ]<=0;
			white[ 81 ]<=0;
			white[ 82 ]<=0;
			white[ 83 ]<=0;
			white[ 84 ]<=0;
			white[ 85 ]<=1;
			white[ 86 ]<=1;
			white[ 87 ]<=1;
			white[ 88 ]<=1;
			white[ 89 ]<=1;
			white[ 90 ]<=1;
			white[ 91 ]<=1;
			white[ 92 ]<=1;
			white[ 93 ]<=1;
			white[ 94 ]<=1;
			white[ 95 ]<=1;
			white[ 96 ]<=0;
			white[ 97 ]<=0;
			white[ 98 ]<=0;
			white[ 99 ]<=0;
			white[ 100 ]<=0;
			white[ 101 ]<=0;
			white[ 102 ]<=0;
			white[ 103 ]<=0;
			white[ 104 ]<=0;
			white[ 105 ]<=0;
			white[ 106 ]<=0;
			white[ 107 ]<=0;
			white[ 108 ]<=0;
			white[ 109 ]<=0;
			white[ 110 ]<=0;
			white[ 111 ]<=0;
			white[ 112 ]<=0;
			white[ 113 ]<=0;
			white[ 114 ]<=0;
			white[ 115 ]<=0;
			white[ 116 ]<=0;
			white[ 117 ]<=0;
			white[ 118 ]<=0;
			white[ 119 ]<=0;
			white[ 120 ]<=0;
			white[ 121 ]<=0;
			white[ 122 ]<=0;
			white[ 123 ]<=0;
			white[ 124 ]<=0;
			white[ 125 ]<=0;
			white[ 126 ]<=0;
			white[ 127 ]<=0;
			white[ 128 ]<=0;
			white[ 129 ]<=0;
			white[ 130 ]<=0;
			white[ 131 ]<=0;
			white[ 132 ]<=0;
			white[ 133 ]<=0;
			white[ 134 ]<=0;
			white[ 135 ]<=0;
			white[ 136 ]<=0;
			white[ 137 ]<=0;
			white[ 138 ]<=0;
			white[ 139 ]<=0;
			white[ 140 ]<=0;
			white[ 141 ]<=0;
			white[ 142 ]<=0;
			white[ 143 ]<=1;
			white[ 144 ]<=1;
			white[ 145 ]<=1;
			white[ 146 ]<=1;
			white[ 147 ]<=1;
			white[ 148 ]<=1;
			white[ 149 ]<=1;
			white[ 150 ]<=1;
			white[ 151 ]<=1;
			white[ 152 ]<=1;
			white[ 153 ]<=1;
			white[ 154 ]<=1;
			white[ 155 ]<=1;
			white[ 156 ]<=1;
			white[ 157 ]<=1;
			white[ 158 ]<=0;
			white[ 159 ]<=0;
			white[ 160 ]<=0;
			white[ 161 ]<=0;
			white[ 162 ]<=0;
			white[ 163 ]<=0;
			white[ 164 ]<=0;
			white[ 165 ]<=0;
			white[ 166 ]<=0;
			white[ 167 ]<=0;
			white[ 168 ]<=0;
			white[ 169 ]<=0;
			white[ 170 ]<=0;
			white[ 171 ]<=0;
			white[ 172 ]<=0;
			white[ 173 ]<=0;
			white[ 174 ]<=0;
			white[ 175 ]<=0;
			white[ 176 ]<=0;
			white[ 177 ]<=0;
			white[ 178 ]<=0;
			white[ 179 ]<=0;
			white[ 180 ]<=0;
			white[ 181 ]<=0;
			white[ 182 ]<=0;
			white[ 183 ]<=0;
			white[ 184 ]<=0;
			white[ 185 ]<=0;
			white[ 186 ]<=0;
			white[ 187 ]<=0;
			white[ 188 ]<=0;
			white[ 189 ]<=0;
			white[ 190 ]<=0;
			white[ 191 ]<=0;
			white[ 192 ]<=0;
			white[ 193 ]<=0;
			white[ 194 ]<=0;
			white[ 195 ]<=0;
			white[ 196 ]<=0;
			white[ 197 ]<=0;
			white[ 198 ]<=0;
			white[ 199 ]<=0;
			white[ 200 ]<=0;
			white[ 201 ]<=1;
			white[ 202 ]<=1;
			white[ 203 ]<=1;
			white[ 204 ]<=1;
			white[ 205 ]<=1;
			white[ 206 ]<=1;
			white[ 207 ]<=1;
			white[ 208 ]<=1;
			white[ 209 ]<=1;
			white[ 210 ]<=1;
			white[ 211 ]<=1;
			white[ 212 ]<=1;
			white[ 213 ]<=1;
			white[ 214 ]<=1;
			white[ 215 ]<=1;
			white[ 216 ]<=1;
			white[ 217 ]<=1;
			white[ 218 ]<=1;
			white[ 219 ]<=1;
			white[ 220 ]<=0;
			white[ 221 ]<=0;
			white[ 222 ]<=0;
			white[ 223 ]<=0;
			white[ 224 ]<=0;
			white[ 225 ]<=0;
			white[ 226 ]<=0;
			white[ 227 ]<=0;
			white[ 228 ]<=0;
			white[ 229 ]<=0;
			white[ 230 ]<=0;
			white[ 231 ]<=0;
			white[ 232 ]<=0;
			white[ 233 ]<=0;
			white[ 234 ]<=0;
			white[ 235 ]<=0;
			white[ 236 ]<=0;
			white[ 237 ]<=0;
			white[ 238 ]<=0;
			white[ 239 ]<=0;
			white[ 240 ]<=0;
			white[ 241 ]<=0;
			white[ 242 ]<=0;
			white[ 243 ]<=0;
			white[ 244 ]<=0;
			white[ 245 ]<=0;
			white[ 246 ]<=0;
			white[ 247 ]<=0;
			white[ 248 ]<=0;
			white[ 249 ]<=0;
			white[ 250 ]<=0;
			white[ 251 ]<=0;
			white[ 252 ]<=0;
			white[ 253 ]<=0;
			white[ 254 ]<=0;
			white[ 255 ]<=0;
			white[ 256 ]<=0;
			white[ 257 ]<=0;
			white[ 258 ]<=0;
			white[ 259 ]<=1;
			white[ 260 ]<=1;
			white[ 261 ]<=1;
			white[ 262 ]<=1;
			white[ 263 ]<=1;
			white[ 264 ]<=1;
			white[ 265 ]<=1;
			white[ 266 ]<=1;
			white[ 267 ]<=1;
			white[ 268 ]<=1;
			white[ 269 ]<=1;
			white[ 270 ]<=1;
			white[ 271 ]<=1;
			white[ 272 ]<=1;
			white[ 273 ]<=1;
			white[ 274 ]<=1;
			white[ 275 ]<=1;
			white[ 276 ]<=1;
			white[ 277 ]<=1;
			white[ 278 ]<=1;
			white[ 279 ]<=1;
			white[ 280 ]<=1;
			white[ 281 ]<=1;
			white[ 282 ]<=0;
			white[ 283 ]<=0;
			white[ 284 ]<=0;
			white[ 285 ]<=0;
			white[ 286 ]<=0;
			white[ 287 ]<=0;
			white[ 288 ]<=0;
			white[ 289 ]<=0;
			white[ 290 ]<=0;
			white[ 291 ]<=0;
			white[ 292 ]<=0;
			white[ 293 ]<=0;
			white[ 294 ]<=0;
			white[ 295 ]<=0;
			white[ 296 ]<=0;
			white[ 297 ]<=0;
			white[ 298 ]<=0;
			white[ 299 ]<=0;
			white[ 300 ]<=0;
			white[ 301 ]<=0;
			white[ 302 ]<=0;
			white[ 303 ]<=0;
			white[ 304 ]<=0;
			white[ 305 ]<=0;
			white[ 306 ]<=0;
			white[ 307 ]<=0;
			white[ 308 ]<=0;
			white[ 309 ]<=0;
			white[ 310 ]<=0;
			white[ 311 ]<=0;
			white[ 312 ]<=0;
			white[ 313 ]<=0;
			white[ 314 ]<=0;
			white[ 315 ]<=0;
			white[ 316 ]<=0;
			white[ 317 ]<=0;
			white[ 318 ]<=1;
			white[ 319 ]<=1;
			white[ 320 ]<=1;
			white[ 321 ]<=1;
			white[ 322 ]<=1;
			white[ 323 ]<=1;
			white[ 324 ]<=1;
			white[ 325 ]<=1;
			white[ 326 ]<=1;
			white[ 327 ]<=1;
			white[ 328 ]<=1;
			white[ 329 ]<=1;
			white[ 330 ]<=1;
			white[ 331 ]<=1;
			white[ 332 ]<=1;
			white[ 333 ]<=1;
			white[ 334 ]<=1;
			white[ 335 ]<=1;
			white[ 336 ]<=1;
			white[ 337 ]<=1;
			white[ 338 ]<=1;
			white[ 339 ]<=1;
			white[ 340 ]<=1;
			white[ 341 ]<=1;
			white[ 342 ]<=1;
			white[ 343 ]<=0;
			white[ 344 ]<=0;
			white[ 345 ]<=0;
			white[ 346 ]<=0;
			white[ 347 ]<=0;
			white[ 348 ]<=0;
			white[ 349 ]<=0;
			white[ 350 ]<=0;
			white[ 351 ]<=0;
			white[ 352 ]<=0;
			white[ 353 ]<=0;
			white[ 354 ]<=0;
			white[ 355 ]<=0;
			white[ 356 ]<=0;
			white[ 357 ]<=0;
			white[ 358 ]<=0;
			white[ 359 ]<=0;
			white[ 360 ]<=0;
			white[ 361 ]<=0;
			white[ 362 ]<=0;
			white[ 363 ]<=0;
			white[ 364 ]<=0;
			white[ 365 ]<=0;
			white[ 366 ]<=0;
			white[ 367 ]<=0;
			white[ 368 ]<=0;
			white[ 369 ]<=0;
			white[ 370 ]<=0;
			white[ 371 ]<=0;
			white[ 372 ]<=0;
			white[ 373 ]<=0;
			white[ 374 ]<=0;
			white[ 375 ]<=0;
			white[ 376 ]<=0;
			white[ 377 ]<=1;
			white[ 378 ]<=1;
			white[ 379 ]<=1;
			white[ 380 ]<=1;
			white[ 381 ]<=1;
			white[ 382 ]<=1;
			white[ 383 ]<=1;
			white[ 384 ]<=1;
			white[ 385 ]<=1;
			white[ 386 ]<=1;
			white[ 387 ]<=1;
			white[ 388 ]<=1;
			white[ 389 ]<=1;
			white[ 390 ]<=1;
			white[ 391 ]<=1;
			white[ 392 ]<=1;
			white[ 393 ]<=1;
			white[ 394 ]<=1;
			white[ 395 ]<=1;
			white[ 396 ]<=1;
			white[ 397 ]<=1;
			white[ 398 ]<=1;
			white[ 399 ]<=1;
			white[ 400 ]<=1;
			white[ 401 ]<=1;
			white[ 402 ]<=1;
			white[ 403 ]<=1;
			white[ 404 ]<=0;
			white[ 405 ]<=0;
			white[ 406 ]<=0;
			white[ 407 ]<=0;
			white[ 408 ]<=0;
			white[ 409 ]<=0;
			white[ 410 ]<=0;
			white[ 411 ]<=0;
			white[ 412 ]<=0;
			white[ 413 ]<=0;
			white[ 414 ]<=0;
			white[ 415 ]<=0;
			white[ 416 ]<=0;
			white[ 417 ]<=0;
			white[ 418 ]<=0;
			white[ 419 ]<=0;
			white[ 420 ]<=0;
			white[ 421 ]<=0;
			white[ 422 ]<=0;
			white[ 423 ]<=0;
			white[ 424 ]<=0;
			white[ 425 ]<=0;
			white[ 426 ]<=0;
			white[ 427 ]<=0;
			white[ 428 ]<=0;
			white[ 429 ]<=0;
			white[ 430 ]<=0;
			white[ 431 ]<=0;
			white[ 432 ]<=0;
			white[ 433 ]<=0;
			white[ 434 ]<=0;
			white[ 435 ]<=0;
			white[ 436 ]<=1;
			white[ 437 ]<=1;
			white[ 438 ]<=1;
			white[ 439 ]<=1;
			white[ 440 ]<=1;
			white[ 441 ]<=1;
			white[ 442 ]<=1;
			white[ 443 ]<=1;
			white[ 444 ]<=1;
			white[ 445 ]<=1;
			white[ 446 ]<=1;
			white[ 447 ]<=1;
			white[ 448 ]<=1;
			white[ 449 ]<=1;
			white[ 450 ]<=1;
			white[ 451 ]<=1;
			white[ 452 ]<=1;
			white[ 453 ]<=1;
			white[ 454 ]<=1;
			white[ 455 ]<=1;
			white[ 456 ]<=1;
			white[ 457 ]<=1;
			white[ 458 ]<=1;
			white[ 459 ]<=1;
			white[ 460 ]<=1;
			white[ 461 ]<=1;
			white[ 462 ]<=1;
			white[ 463 ]<=1;
			white[ 464 ]<=1;
			white[ 465 ]<=0;
			white[ 466 ]<=0;
			white[ 467 ]<=0;
			white[ 468 ]<=0;
			white[ 469 ]<=0;
			white[ 470 ]<=0;
			white[ 471 ]<=0;
			white[ 472 ]<=0;
			white[ 473 ]<=0;
			white[ 474 ]<=0;
			white[ 475 ]<=0;
			white[ 476 ]<=0;
			white[ 477 ]<=0;
			white[ 478 ]<=0;
			white[ 479 ]<=0;
			white[ 480 ]<=0;
			white[ 481 ]<=0;
			white[ 482 ]<=0;
			white[ 483 ]<=0;
			white[ 484 ]<=0;
			white[ 485 ]<=0;
			white[ 486 ]<=0;
			white[ 487 ]<=0;
			white[ 488 ]<=0;
			white[ 489 ]<=0;
			white[ 490 ]<=0;
			white[ 491 ]<=0;
			white[ 492 ]<=0;
			white[ 493 ]<=0;
			white[ 494 ]<=0;
			white[ 495 ]<=0;
			white[ 496 ]<=1;
			white[ 497 ]<=1;
			white[ 498 ]<=1;
			white[ 499 ]<=1;
			white[ 500 ]<=1;
			white[ 501 ]<=1;
			white[ 502 ]<=1;
			white[ 503 ]<=1;
			white[ 504 ]<=1;
			white[ 505 ]<=1;
			white[ 506 ]<=1;
			white[ 507 ]<=1;
			white[ 508 ]<=1;
			white[ 509 ]<=1;
			white[ 510 ]<=1;
			white[ 511 ]<=1;
			white[ 512 ]<=1;
			white[ 513 ]<=1;
			white[ 514 ]<=1;
			white[ 515 ]<=1;
			white[ 516 ]<=1;
			white[ 517 ]<=1;
			white[ 518 ]<=1;
			white[ 519 ]<=1;
			white[ 520 ]<=1;
			white[ 521 ]<=1;
			white[ 522 ]<=1;
			white[ 523 ]<=1;
			white[ 524 ]<=1;
			white[ 525 ]<=1;
			white[ 526 ]<=0;
			white[ 527 ]<=0;
			white[ 528 ]<=0;
			white[ 529 ]<=0;
			white[ 530 ]<=0;
			white[ 531 ]<=0;
			white[ 532 ]<=0;
			white[ 533 ]<=0;
			white[ 534 ]<=0;
			white[ 535 ]<=0;
			white[ 536 ]<=0;
			white[ 537 ]<=0;
			white[ 538 ]<=0;
			white[ 539 ]<=0;
			white[ 540 ]<=0;
			white[ 541 ]<=0;
			white[ 542 ]<=0;
			white[ 543 ]<=0;
			white[ 544 ]<=0;
			white[ 545 ]<=0;
			white[ 546 ]<=0;
			white[ 547 ]<=0;
			white[ 548 ]<=0;
			white[ 549 ]<=0;
			white[ 550 ]<=0;
			white[ 551 ]<=0;
			white[ 552 ]<=0;
			white[ 553 ]<=0;
			white[ 554 ]<=0;
			white[ 555 ]<=1;
			white[ 556 ]<=1;
			white[ 557 ]<=1;
			white[ 558 ]<=1;
			white[ 559 ]<=1;
			white[ 560 ]<=1;
			white[ 561 ]<=1;
			white[ 562 ]<=1;
			white[ 563 ]<=1;
			white[ 564 ]<=1;
			white[ 565 ]<=1;
			white[ 566 ]<=1;
			white[ 567 ]<=1;
			white[ 568 ]<=1;
			white[ 569 ]<=1;
			white[ 570 ]<=1;
			white[ 571 ]<=1;
			white[ 572 ]<=1;
			white[ 573 ]<=1;
			white[ 574 ]<=1;
			white[ 575 ]<=1;
			white[ 576 ]<=1;
			white[ 577 ]<=1;
			white[ 578 ]<=1;
			white[ 579 ]<=1;
			white[ 580 ]<=1;
			white[ 581 ]<=1;
			white[ 582 ]<=1;
			white[ 583 ]<=1;
			white[ 584 ]<=1;
			white[ 585 ]<=1;
			white[ 586 ]<=0;
			white[ 587 ]<=0;
			white[ 588 ]<=0;
			white[ 589 ]<=0;
			white[ 590 ]<=0;
			white[ 591 ]<=0;
			white[ 592 ]<=0;
			white[ 593 ]<=0;
			white[ 594 ]<=0;
			white[ 595 ]<=0;
			white[ 596 ]<=0;
			white[ 597 ]<=0;
			white[ 598 ]<=0;
			white[ 599 ]<=0;
			white[ 600 ]<=0;
			white[ 601 ]<=0;
			white[ 602 ]<=0;
			white[ 603 ]<=0;
			white[ 604 ]<=0;
			white[ 605 ]<=0;
			white[ 606 ]<=0;
			white[ 607 ]<=0;
			white[ 608 ]<=0;
			white[ 609 ]<=0;
			white[ 610 ]<=0;
			white[ 611 ]<=0;
			white[ 612 ]<=0;
			white[ 613 ]<=0;
			white[ 614 ]<=1;
			white[ 615 ]<=1;
			white[ 616 ]<=1;
			white[ 617 ]<=1;
			white[ 618 ]<=1;
			white[ 619 ]<=1;
			white[ 620 ]<=1;
			white[ 621 ]<=1;
			white[ 622 ]<=1;
			white[ 623 ]<=1;
			white[ 624 ]<=1;
			white[ 625 ]<=1;
			white[ 626 ]<=1;
			white[ 627 ]<=1;
			white[ 628 ]<=1;
			white[ 629 ]<=1;
			white[ 630 ]<=1;
			white[ 631 ]<=1;
			white[ 632 ]<=1;
			white[ 633 ]<=1;
			white[ 634 ]<=1;
			white[ 635 ]<=1;
			white[ 636 ]<=1;
			white[ 637 ]<=1;
			white[ 638 ]<=1;
			white[ 639 ]<=1;
			white[ 640 ]<=1;
			white[ 641 ]<=1;
			white[ 642 ]<=1;
			white[ 643 ]<=1;
			white[ 644 ]<=1;
			white[ 645 ]<=1;
			white[ 646 ]<=1;
			white[ 647 ]<=0;
			white[ 648 ]<=0;
			white[ 649 ]<=0;
			white[ 650 ]<=0;
			white[ 651 ]<=0;
			white[ 652 ]<=0;
			white[ 653 ]<=0;
			white[ 654 ]<=0;
			white[ 655 ]<=0;
			white[ 656 ]<=0;
			white[ 657 ]<=0;
			white[ 658 ]<=0;
			white[ 659 ]<=0;
			white[ 660 ]<=0;
			white[ 661 ]<=0;
			white[ 662 ]<=0;
			white[ 663 ]<=0;
			white[ 664 ]<=0;
			white[ 665 ]<=0;
			white[ 666 ]<=0;
			white[ 667 ]<=0;
			white[ 668 ]<=0;
			white[ 669 ]<=0;
			white[ 670 ]<=0;
			white[ 671 ]<=0;
			white[ 672 ]<=0;
			white[ 673 ]<=0;
			white[ 674 ]<=1;
			white[ 675 ]<=1;
			white[ 676 ]<=1;
			white[ 677 ]<=1;
			white[ 678 ]<=1;
			white[ 679 ]<=1;
			white[ 680 ]<=1;
			white[ 681 ]<=1;
			white[ 682 ]<=1;
			white[ 683 ]<=1;
			white[ 684 ]<=1;
			white[ 685 ]<=1;
			white[ 686 ]<=1;
			white[ 687 ]<=1;
			white[ 688 ]<=1;
			white[ 689 ]<=1;
			white[ 690 ]<=1;
			white[ 691 ]<=1;
			white[ 692 ]<=1;
			white[ 693 ]<=1;
			white[ 694 ]<=1;
			white[ 695 ]<=1;
			white[ 696 ]<=1;
			white[ 697 ]<=1;
			white[ 698 ]<=1;
			white[ 699 ]<=1;
			white[ 700 ]<=1;
			white[ 701 ]<=1;
			white[ 702 ]<=1;
			white[ 703 ]<=1;
			white[ 704 ]<=1;
			white[ 705 ]<=1;
			white[ 706 ]<=1;
			white[ 707 ]<=0;
			white[ 708 ]<=0;
			white[ 709 ]<=0;
			white[ 710 ]<=0;
			white[ 711 ]<=0;
			white[ 712 ]<=0;
			white[ 713 ]<=0;
			white[ 714 ]<=0;
			white[ 715 ]<=0;
			white[ 716 ]<=0;
			white[ 717 ]<=0;
			white[ 718 ]<=0;
			white[ 719 ]<=0;
			white[ 720 ]<=0;
			white[ 721 ]<=0;
			white[ 722 ]<=0;
			white[ 723 ]<=0;
			white[ 724 ]<=0;
			white[ 725 ]<=0;
			white[ 726 ]<=0;
			white[ 727 ]<=0;
			white[ 728 ]<=0;
			white[ 729 ]<=0;
			white[ 730 ]<=0;
			white[ 731 ]<=0;
			white[ 732 ]<=0;
			white[ 733 ]<=1;
			white[ 734 ]<=1;
			white[ 735 ]<=1;
			white[ 736 ]<=1;
			white[ 737 ]<=1;
			white[ 738 ]<=1;
			white[ 739 ]<=1;
			white[ 740 ]<=1;
			white[ 741 ]<=1;
			white[ 742 ]<=1;
			white[ 743 ]<=1;
			white[ 744 ]<=1;
			white[ 745 ]<=1;
			white[ 746 ]<=1;
			white[ 747 ]<=1;
			white[ 748 ]<=1;
			white[ 749 ]<=1;
			white[ 750 ]<=1;
			white[ 751 ]<=1;
			white[ 752 ]<=1;
			white[ 753 ]<=1;
			white[ 754 ]<=1;
			white[ 755 ]<=1;
			white[ 756 ]<=1;
			white[ 757 ]<=1;
			white[ 758 ]<=1;
			white[ 759 ]<=1;
			white[ 760 ]<=1;
			white[ 761 ]<=1;
			white[ 762 ]<=1;
			white[ 763 ]<=1;
			white[ 764 ]<=1;
			white[ 765 ]<=1;
			white[ 766 ]<=1;
			white[ 767 ]<=1;
			white[ 768 ]<=0;
			white[ 769 ]<=0;
			white[ 770 ]<=0;
			white[ 771 ]<=0;
			white[ 772 ]<=0;
			white[ 773 ]<=0;
			white[ 774 ]<=0;
			white[ 775 ]<=0;
			white[ 776 ]<=0;
			white[ 777 ]<=0;
			white[ 778 ]<=0;
			white[ 779 ]<=0;
			white[ 780 ]<=0;
			white[ 781 ]<=0;
			white[ 782 ]<=0;
			white[ 783 ]<=0;
			white[ 784 ]<=0;
			white[ 785 ]<=0;
			white[ 786 ]<=0;
			white[ 787 ]<=0;
			white[ 788 ]<=0;
			white[ 789 ]<=0;
			white[ 790 ]<=0;
			white[ 791 ]<=0;
			white[ 792 ]<=0;
			white[ 793 ]<=1;
			white[ 794 ]<=1;
			white[ 795 ]<=1;
			white[ 796 ]<=1;
			white[ 797 ]<=1;
			white[ 798 ]<=1;
			white[ 799 ]<=1;
			white[ 800 ]<=1;
			white[ 801 ]<=1;
			white[ 802 ]<=1;
			white[ 803 ]<=1;
			white[ 804 ]<=1;
			white[ 805 ]<=1;
			white[ 806 ]<=1;
			white[ 807 ]<=1;
			white[ 808 ]<=1;
			white[ 809 ]<=1;
			white[ 810 ]<=1;
			white[ 811 ]<=1;
			white[ 812 ]<=0;
			white[ 813 ]<=0;
			white[ 814 ]<=1;
			white[ 815 ]<=1;
			white[ 816 ]<=1;
			white[ 817 ]<=1;
			white[ 818 ]<=1;
			white[ 819 ]<=1;
			white[ 820 ]<=1;
			white[ 821 ]<=1;
			white[ 822 ]<=1;
			white[ 823 ]<=1;
			white[ 824 ]<=1;
			white[ 825 ]<=1;
			white[ 826 ]<=1;
			white[ 827 ]<=1;
			white[ 828 ]<=0;
			white[ 829 ]<=0;
			white[ 830 ]<=0;
			white[ 831 ]<=0;
			white[ 832 ]<=0;
			white[ 833 ]<=0;
			white[ 834 ]<=0;
			white[ 835 ]<=0;
			white[ 836 ]<=0;
			white[ 837 ]<=0;
			white[ 838 ]<=0;
			white[ 839 ]<=0;
			white[ 840 ]<=0;
			white[ 841 ]<=0;
			white[ 842 ]<=0;
			white[ 843 ]<=0;
			white[ 844 ]<=0;
			white[ 845 ]<=0;
			white[ 846 ]<=0;
			white[ 847 ]<=0;
			white[ 848 ]<=0;
			white[ 849 ]<=0;
			white[ 850 ]<=0;
			white[ 851 ]<=0;
			white[ 852 ]<=0;
			white[ 853 ]<=1;
			white[ 854 ]<=1;
			white[ 855 ]<=1;
			white[ 856 ]<=1;
			white[ 857 ]<=1;
			white[ 858 ]<=1;
			white[ 859 ]<=1;
			white[ 860 ]<=1;
			white[ 861 ]<=1;
			white[ 862 ]<=1;
			white[ 863 ]<=1;
			white[ 864 ]<=1;
			white[ 865 ]<=1;
			white[ 866 ]<=1;
			white[ 867 ]<=1;
			white[ 868 ]<=1;
			white[ 869 ]<=1;
			white[ 870 ]<=1;
			white[ 871 ]<=0;
			white[ 872 ]<=0;
			white[ 873 ]<=0;
			white[ 874 ]<=0;
			white[ 875 ]<=1;
			white[ 876 ]<=1;
			white[ 877 ]<=1;
			white[ 878 ]<=1;
			white[ 879 ]<=1;
			white[ 880 ]<=1;
			white[ 881 ]<=1;
			white[ 882 ]<=1;
			white[ 883 ]<=1;
			white[ 884 ]<=1;
			white[ 885 ]<=1;
			white[ 886 ]<=1;
			white[ 887 ]<=1;
			white[ 888 ]<=0;
			white[ 889 ]<=0;
			white[ 890 ]<=0;
			white[ 891 ]<=0;
			white[ 892 ]<=0;
			white[ 893 ]<=0;
			white[ 894 ]<=0;
			white[ 895 ]<=0;
			white[ 896 ]<=0;
			white[ 897 ]<=0;
			white[ 898 ]<=0;
			white[ 899 ]<=0;
			white[ 900 ]<=0;
			white[ 901 ]<=0;
			white[ 902 ]<=0;
			white[ 903 ]<=0;
			white[ 904 ]<=0;
			white[ 905 ]<=0;
			white[ 906 ]<=0;
			white[ 907 ]<=0;
			white[ 908 ]<=0;
			white[ 909 ]<=0;
			white[ 910 ]<=0;
			white[ 911 ]<=0;
			white[ 912 ]<=1;
			white[ 913 ]<=1;
			white[ 914 ]<=1;
			white[ 915 ]<=1;
			white[ 916 ]<=1;
			white[ 917 ]<=1;
			white[ 918 ]<=1;
			white[ 919 ]<=1;
			white[ 920 ]<=1;
			white[ 921 ]<=1;
			white[ 922 ]<=1;
			white[ 923 ]<=1;
			white[ 924 ]<=1;
			white[ 925 ]<=1;
			white[ 926 ]<=1;
			white[ 927 ]<=1;
			white[ 928 ]<=1;
			white[ 929 ]<=1;
			white[ 930 ]<=1;
			white[ 931 ]<=0;
			white[ 932 ]<=0;
			white[ 933 ]<=0;
			white[ 934 ]<=0;
			white[ 935 ]<=1;
			white[ 936 ]<=1;
			white[ 937 ]<=1;
			white[ 938 ]<=1;
			white[ 939 ]<=1;
			white[ 940 ]<=1;
			white[ 941 ]<=1;
			white[ 942 ]<=1;
			white[ 943 ]<=1;
			white[ 944 ]<=1;
			white[ 945 ]<=1;
			white[ 946 ]<=1;
			white[ 947 ]<=1;
			white[ 948 ]<=1;
			white[ 949 ]<=0;
			white[ 950 ]<=0;
			white[ 951 ]<=0;
			white[ 952 ]<=0;
			white[ 953 ]<=0;
			white[ 954 ]<=0;
			white[ 955 ]<=0;
			white[ 956 ]<=0;
			white[ 957 ]<=0;
			white[ 958 ]<=0;
			white[ 959 ]<=0;
			white[ 960 ]<=0;
			white[ 961 ]<=0;
			white[ 962 ]<=0;
			white[ 963 ]<=0;
			white[ 964 ]<=0;
			white[ 965 ]<=0;
			white[ 966 ]<=0;
			white[ 967 ]<=0;
			white[ 968 ]<=0;
			white[ 969 ]<=0;
			white[ 970 ]<=0;
			white[ 971 ]<=0;
			white[ 972 ]<=1;
			white[ 973 ]<=1;
			white[ 974 ]<=1;
			white[ 975 ]<=1;
			white[ 976 ]<=1;
			white[ 977 ]<=1;
			white[ 978 ]<=1;
			white[ 979 ]<=1;
			white[ 980 ]<=1;
			white[ 981 ]<=1;
			white[ 982 ]<=1;
			white[ 983 ]<=1;
			white[ 984 ]<=1;
			white[ 985 ]<=1;
			white[ 986 ]<=1;
			white[ 987 ]<=1;
			white[ 988 ]<=1;
			white[ 989 ]<=1;
			white[ 990 ]<=1;
			white[ 991 ]<=0;
			white[ 992 ]<=0;
			white[ 993 ]<=0;
			white[ 994 ]<=0;
			white[ 995 ]<=1;
			white[ 996 ]<=1;
			white[ 997 ]<=1;
			white[ 998 ]<=1;
			white[ 999 ]<=1;
			white[ 1000 ]<=1;
			white[ 1001 ]<=1;
			white[ 1002 ]<=1;
			white[ 1003 ]<=1;
			white[ 1004 ]<=1;
			white[ 1005 ]<=1;
			white[ 1006 ]<=1;
			white[ 1007 ]<=1;
			white[ 1008 ]<=1;
			white[ 1009 ]<=0;
			white[ 1010 ]<=0;
			white[ 1011 ]<=0;
			white[ 1012 ]<=0;
			white[ 1013 ]<=0;
			white[ 1014 ]<=0;
			white[ 1015 ]<=0;
			white[ 1016 ]<=0;
			white[ 1017 ]<=0;
			white[ 1018 ]<=0;
			white[ 1019 ]<=0;
			white[ 1020 ]<=0;
			white[ 1021 ]<=0;
			white[ 1022 ]<=0;
			white[ 1023 ]<=0;
			white[ 1024 ]<=0;
			white[ 1025 ]<=0;
			white[ 1026 ]<=0;
			white[ 1027 ]<=0;
			white[ 1028 ]<=0;
			white[ 1029 ]<=0;
			white[ 1030 ]<=0;
			white[ 1031 ]<=1;
			white[ 1032 ]<=1;
			white[ 1033 ]<=1;
			white[ 1034 ]<=1;
			white[ 1035 ]<=1;
			white[ 1036 ]<=1;
			white[ 1037 ]<=1;
			white[ 1038 ]<=1;
			white[ 1039 ]<=1;
			white[ 1040 ]<=1;
			white[ 1041 ]<=1;
			white[ 1042 ]<=1;
			white[ 1043 ]<=1;
			white[ 1044 ]<=1;
			white[ 1045 ]<=1;
			white[ 1046 ]<=1;
			white[ 1047 ]<=1;
			white[ 1048 ]<=1;
			white[ 1049 ]<=1;
			white[ 1050 ]<=1;
			white[ 1051 ]<=1;
			white[ 1052 ]<=1;
			white[ 1053 ]<=1;
			white[ 1054 ]<=1;
			white[ 1055 ]<=1;
			white[ 1056 ]<=1;
			white[ 1057 ]<=1;
			white[ 1058 ]<=1;
			white[ 1059 ]<=1;
			white[ 1060 ]<=1;
			white[ 1061 ]<=1;
			white[ 1062 ]<=1;
			white[ 1063 ]<=1;
			white[ 1064 ]<=1;
			white[ 1065 ]<=1;
			white[ 1066 ]<=1;
			white[ 1067 ]<=1;
			white[ 1068 ]<=1;
			white[ 1069 ]<=1;
			white[ 1070 ]<=0;
			white[ 1071 ]<=0;
			white[ 1072 ]<=0;
			white[ 1073 ]<=0;
			white[ 1074 ]<=0;
			white[ 1075 ]<=0;
			white[ 1076 ]<=0;
			white[ 1077 ]<=0;
			white[ 1078 ]<=0;
			white[ 1079 ]<=0;
			white[ 1080 ]<=0;
			white[ 1081 ]<=0;
			white[ 1082 ]<=0;
			white[ 1083 ]<=0;
			white[ 1084 ]<=0;
			white[ 1085 ]<=0;
			white[ 1086 ]<=0;
			white[ 1087 ]<=0;
			white[ 1088 ]<=0;
			white[ 1089 ]<=0;
			white[ 1090 ]<=1;
			white[ 1091 ]<=1;
			white[ 1092 ]<=1;
			white[ 1093 ]<=1;
			white[ 1094 ]<=1;
			white[ 1095 ]<=1;
			white[ 1096 ]<=1;
			white[ 1097 ]<=1;
			white[ 1098 ]<=1;
			white[ 1099 ]<=1;
			white[ 1100 ]<=1;
			white[ 1101 ]<=1;
			white[ 1102 ]<=1;
			white[ 1103 ]<=1;
			white[ 1104 ]<=1;
			white[ 1105 ]<=1;
			white[ 1106 ]<=1;
			white[ 1107 ]<=1;
			white[ 1108 ]<=1;
			white[ 1109 ]<=1;
			white[ 1110 ]<=1;
			white[ 1111 ]<=1;
			white[ 1112 ]<=1;
			white[ 1113 ]<=1;
			white[ 1114 ]<=1;
			white[ 1115 ]<=1;
			white[ 1116 ]<=1;
			white[ 1117 ]<=1;
			white[ 1118 ]<=1;
			white[ 1119 ]<=1;
			white[ 1120 ]<=1;
			white[ 1121 ]<=1;
			white[ 1122 ]<=1;
			white[ 1123 ]<=1;
			white[ 1124 ]<=1;
			white[ 1125 ]<=1;
			white[ 1126 ]<=1;
			white[ 1127 ]<=1;
			white[ 1128 ]<=1;
			white[ 1129 ]<=1;
			white[ 1130 ]<=1;
			white[ 1131 ]<=0;
			white[ 1132 ]<=0;
			white[ 1133 ]<=0;
			white[ 1134 ]<=0;
			white[ 1135 ]<=0;
			white[ 1136 ]<=0;
			white[ 1137 ]<=0;
			white[ 1138 ]<=0;
			white[ 1139 ]<=0;
			white[ 1140 ]<=0;
			white[ 1141 ]<=0;
			white[ 1142 ]<=0;
			white[ 1143 ]<=0;
			white[ 1144 ]<=0;
			white[ 1145 ]<=0;
			white[ 1146 ]<=0;
			white[ 1147 ]<=0;
			white[ 1148 ]<=0;
			white[ 1149 ]<=0;
			white[ 1150 ]<=1;
			white[ 1151 ]<=1;
			white[ 1152 ]<=1;
			white[ 1153 ]<=1;
			white[ 1154 ]<=1;
			white[ 1155 ]<=1;
			white[ 1156 ]<=1;
			white[ 1157 ]<=1;
			white[ 1158 ]<=1;
			white[ 1159 ]<=1;
			white[ 1160 ]<=1;
			white[ 1161 ]<=1;
			white[ 1162 ]<=1;
			white[ 1163 ]<=1;
			white[ 1164 ]<=1;
			white[ 1165 ]<=1;
			white[ 1166 ]<=1;
			white[ 1167 ]<=1;
			white[ 1168 ]<=1;
			white[ 1169 ]<=1;
			white[ 1170 ]<=1;
			white[ 1171 ]<=1;
			white[ 1172 ]<=1;
			white[ 1173 ]<=1;
			white[ 1174 ]<=1;
			white[ 1175 ]<=1;
			white[ 1176 ]<=1;
			white[ 1177 ]<=1;
			white[ 1178 ]<=1;
			white[ 1179 ]<=1;
			white[ 1180 ]<=1;
			white[ 1181 ]<=1;
			white[ 1182 ]<=1;
			white[ 1183 ]<=1;
			white[ 1184 ]<=1;
			white[ 1185 ]<=1;
			white[ 1186 ]<=1;
			white[ 1187 ]<=1;
			white[ 1188 ]<=1;
			white[ 1189 ]<=1;
			white[ 1190 ]<=1;
			white[ 1191 ]<=0;
			white[ 1192 ]<=0;
			white[ 1193 ]<=0;
			white[ 1194 ]<=0;
			white[ 1195 ]<=0;
			white[ 1196 ]<=0;
			white[ 1197 ]<=0;
			white[ 1198 ]<=0;
			white[ 1199 ]<=0;
			white[ 1200 ]<=0;
			white[ 1201 ]<=0;
			white[ 1202 ]<=0;
			white[ 1203 ]<=0;
			white[ 1204 ]<=0;
			white[ 1205 ]<=0;
			white[ 1206 ]<=0;
			white[ 1207 ]<=0;
			white[ 1208 ]<=1;
			white[ 1209 ]<=1;
			white[ 1210 ]<=1;
			white[ 1211 ]<=1;
			white[ 1212 ]<=1;
			white[ 1213 ]<=1;
			white[ 1214 ]<=1;
			white[ 1215 ]<=1;
			white[ 1216 ]<=1;
			white[ 1217 ]<=1;
			white[ 1218 ]<=1;
			white[ 1219 ]<=1;
			white[ 1220 ]<=1;
			white[ 1221 ]<=1;
			white[ 1222 ]<=1;
			white[ 1223 ]<=1;
			white[ 1224 ]<=1;
			white[ 1225 ]<=1;
			white[ 1226 ]<=1;
			white[ 1227 ]<=1;
			white[ 1228 ]<=1;
			white[ 1229 ]<=1;
			white[ 1230 ]<=1;
			white[ 1231 ]<=1;
			white[ 1232 ]<=1;
			white[ 1233 ]<=1;
			white[ 1234 ]<=1;
			white[ 1235 ]<=1;
			white[ 1236 ]<=1;
			white[ 1237 ]<=1;
			white[ 1238 ]<=1;
			white[ 1239 ]<=1;
			white[ 1240 ]<=1;
			white[ 1241 ]<=1;
			white[ 1242 ]<=1;
			white[ 1243 ]<=1;
			white[ 1244 ]<=1;
			white[ 1245 ]<=1;
			white[ 1246 ]<=1;
			white[ 1247 ]<=1;
			white[ 1248 ]<=1;
			white[ 1249 ]<=1;
			white[ 1250 ]<=1;
			white[ 1251 ]<=1;
			white[ 1252 ]<=1;
			white[ 1253 ]<=0;
			white[ 1254 ]<=0;
			white[ 1255 ]<=0;
			white[ 1256 ]<=0;
			white[ 1257 ]<=0;
			white[ 1258 ]<=0;
			white[ 1259 ]<=0;
			white[ 1260 ]<=0;
			white[ 1261 ]<=0;
			white[ 1262 ]<=0;
			white[ 1263 ]<=0;
			white[ 1264 ]<=0;
			white[ 1265 ]<=0;
			white[ 1266 ]<=1;
			white[ 1267 ]<=1;
			white[ 1268 ]<=1;
			white[ 1269 ]<=1;
			white[ 1270 ]<=1;
			white[ 1271 ]<=1;
			white[ 1272 ]<=1;
			white[ 1273 ]<=1;
			white[ 1274 ]<=1;
			white[ 1275 ]<=1;
			white[ 1276 ]<=1;
			white[ 1277 ]<=1;
			white[ 1278 ]<=1;
			white[ 1279 ]<=1;
			white[ 1280 ]<=1;
			white[ 1281 ]<=1;
			white[ 1282 ]<=1;
			white[ 1283 ]<=1;
			white[ 1284 ]<=1;
			white[ 1285 ]<=1;
			white[ 1286 ]<=1;
			white[ 1287 ]<=1;
			white[ 1288 ]<=1;
			white[ 1289 ]<=1;
			white[ 1290 ]<=1;
			white[ 1291 ]<=1;
			white[ 1292 ]<=1;
			white[ 1293 ]<=1;
			white[ 1294 ]<=1;
			white[ 1295 ]<=1;
			white[ 1296 ]<=1;
			white[ 1297 ]<=1;
			white[ 1298 ]<=1;
			white[ 1299 ]<=1;
			white[ 1300 ]<=1;
			white[ 1301 ]<=1;
			white[ 1302 ]<=1;
			white[ 1303 ]<=1;
			white[ 1304 ]<=1;
			white[ 1305 ]<=1;
			white[ 1306 ]<=1;
			white[ 1307 ]<=1;
			white[ 1308 ]<=1;
			white[ 1309 ]<=1;
			white[ 1310 ]<=1;
			white[ 1311 ]<=1;
			white[ 1312 ]<=1;
			white[ 1313 ]<=1;
			white[ 1314 ]<=1;
			white[ 1315 ]<=0;
			white[ 1316 ]<=0;
			white[ 1317 ]<=0;
			white[ 1318 ]<=0;
			white[ 1319 ]<=0;
			white[ 1320 ]<=0;
			white[ 1321 ]<=0;
			white[ 1322 ]<=0;
			white[ 1323 ]<=0;
			white[ 1324 ]<=0;
			white[ 1325 ]<=0;
			white[ 1326 ]<=1;
			white[ 1327 ]<=1;
			white[ 1328 ]<=1;
			white[ 1329 ]<=1;
			white[ 1330 ]<=1;
			white[ 1331 ]<=1;
			white[ 1332 ]<=1;
			white[ 1333 ]<=1;
			white[ 1334 ]<=1;
			white[ 1335 ]<=1;
			white[ 1336 ]<=1;
			white[ 1337 ]<=1;
			white[ 1338 ]<=1;
			white[ 1339 ]<=1;
			white[ 1340 ]<=1;
			white[ 1341 ]<=1;
			white[ 1342 ]<=1;
			white[ 1343 ]<=1;
			white[ 1344 ]<=1;
			white[ 1345 ]<=1;
			white[ 1346 ]<=1;
			white[ 1347 ]<=1;
			white[ 1348 ]<=1;
			white[ 1349 ]<=1;
			white[ 1350 ]<=1;
			white[ 1351 ]<=1;
			white[ 1352 ]<=1;
			white[ 1353 ]<=1;
			white[ 1354 ]<=1;
			white[ 1355 ]<=1;
			white[ 1356 ]<=1;
			white[ 1357 ]<=1;
			white[ 1358 ]<=1;
			white[ 1359 ]<=1;
			white[ 1360 ]<=1;
			white[ 1361 ]<=1;
			white[ 1362 ]<=1;
			white[ 1363 ]<=1;
			white[ 1364 ]<=1;
			white[ 1365 ]<=1;
			white[ 1366 ]<=1;
			white[ 1367 ]<=1;
			white[ 1368 ]<=1;
			white[ 1369 ]<=1;
			white[ 1370 ]<=1;
			white[ 1371 ]<=1;
			white[ 1372 ]<=1;
			white[ 1373 ]<=1;
			white[ 1374 ]<=1;
			white[ 1375 ]<=0;
			white[ 1376 ]<=0;
			white[ 1377 ]<=0;
			white[ 1378 ]<=0;
			white[ 1379 ]<=0;
			white[ 1380 ]<=0;
			white[ 1381 ]<=0;
			white[ 1382 ]<=0;
			white[ 1383 ]<=0;
			white[ 1384 ]<=0;
			white[ 1385 ]<=1;
			white[ 1386 ]<=1;
			white[ 1387 ]<=1;
			white[ 1388 ]<=1;
			white[ 1389 ]<=1;
			white[ 1390 ]<=1;
			white[ 1391 ]<=1;
			white[ 1392 ]<=1;
			white[ 1393 ]<=1;
			white[ 1394 ]<=1;
			white[ 1395 ]<=1;
			white[ 1396 ]<=1;
			white[ 1397 ]<=1;
			white[ 1398 ]<=1;
			white[ 1399 ]<=1;
			white[ 1400 ]<=1;
			white[ 1401 ]<=1;
			white[ 1402 ]<=1;
			white[ 1403 ]<=1;
			white[ 1404 ]<=1;
			white[ 1405 ]<=1;
			white[ 1406 ]<=1;
			white[ 1407 ]<=1;
			white[ 1408 ]<=1;
			white[ 1409 ]<=1;
			white[ 1410 ]<=1;
			white[ 1411 ]<=1;
			white[ 1412 ]<=1;
			white[ 1413 ]<=1;
			white[ 1414 ]<=1;
			white[ 1415 ]<=1;
			white[ 1416 ]<=1;
			white[ 1417 ]<=1;
			white[ 1418 ]<=1;
			white[ 1419 ]<=1;
			white[ 1420 ]<=1;
			white[ 1421 ]<=1;
			white[ 1422 ]<=1;
			white[ 1423 ]<=1;
			white[ 1424 ]<=1;
			white[ 1425 ]<=1;
			white[ 1426 ]<=1;
			white[ 1427 ]<=1;
			white[ 1428 ]<=1;
			white[ 1429 ]<=1;
			white[ 1430 ]<=1;
			white[ 1431 ]<=1;
			white[ 1432 ]<=1;
			white[ 1433 ]<=1;
			white[ 1434 ]<=1;
			white[ 1435 ]<=1;
			white[ 1436 ]<=0;
			white[ 1437 ]<=0;
			white[ 1438 ]<=0;
			white[ 1439 ]<=0;
			white[ 1440 ]<=0;
			white[ 1441 ]<=0;
			white[ 1442 ]<=0;
			white[ 1443 ]<=0;
			white[ 1444 ]<=0;
			white[ 1445 ]<=1;
			white[ 1446 ]<=1;
			white[ 1447 ]<=1;
			white[ 1448 ]<=1;
			white[ 1449 ]<=1;
			white[ 1450 ]<=1;
			white[ 1451 ]<=1;
			white[ 1452 ]<=1;
			white[ 1453 ]<=1;
			white[ 1454 ]<=1;
			white[ 1455 ]<=1;
			white[ 1456 ]<=1;
			white[ 1457 ]<=1;
			white[ 1458 ]<=1;
			white[ 1459 ]<=1;
			white[ 1460 ]<=1;
			white[ 1461 ]<=1;
			white[ 1462 ]<=1;
			white[ 1463 ]<=1;
			white[ 1464 ]<=1;
			white[ 1465 ]<=1;
			white[ 1466 ]<=1;
			white[ 1467 ]<=1;
			white[ 1468 ]<=1;
			white[ 1469 ]<=1;
			white[ 1470 ]<=1;
			white[ 1471 ]<=1;
			white[ 1472 ]<=1;
			white[ 1473 ]<=1;
			white[ 1474 ]<=1;
			white[ 1475 ]<=1;
			white[ 1476 ]<=1;
			white[ 1477 ]<=1;
			white[ 1478 ]<=1;
			white[ 1479 ]<=1;
			white[ 1480 ]<=1;
			white[ 1481 ]<=1;
			white[ 1482 ]<=1;
			white[ 1483 ]<=1;
			white[ 1484 ]<=1;
			white[ 1485 ]<=1;
			white[ 1486 ]<=1;
			white[ 1487 ]<=1;
			white[ 1488 ]<=1;
			white[ 1489 ]<=1;
			white[ 1490 ]<=1;
			white[ 1491 ]<=1;
			white[ 1492 ]<=1;
			white[ 1493 ]<=1;
			white[ 1494 ]<=1;
			white[ 1495 ]<=1;
			white[ 1496 ]<=0;
			white[ 1497 ]<=0;
			white[ 1498 ]<=0;
			white[ 1499 ]<=0;
			white[ 1500 ]<=0;
			white[ 1501 ]<=0;
			white[ 1502 ]<=0;
			white[ 1503 ]<=0;
			white[ 1504 ]<=0;
			white[ 1505 ]<=1;
			white[ 1506 ]<=1;
			white[ 1507 ]<=1;
			white[ 1508 ]<=1;
			white[ 1509 ]<=1;
			white[ 1510 ]<=1;
			white[ 1511 ]<=1;
			white[ 1512 ]<=1;
			white[ 1513 ]<=1;
			white[ 1514 ]<=1;
			white[ 1515 ]<=1;
			white[ 1516 ]<=1;
			white[ 1517 ]<=1;
			white[ 1518 ]<=1;
			white[ 1519 ]<=1;
			white[ 1520 ]<=1;
			white[ 1521 ]<=1;
			white[ 1522 ]<=1;
			white[ 1523 ]<=1;
			white[ 1524 ]<=1;
			white[ 1525 ]<=1;
			white[ 1526 ]<=1;
			white[ 1527 ]<=1;
			white[ 1528 ]<=1;
			white[ 1529 ]<=1;
			white[ 1530 ]<=1;
			white[ 1531 ]<=1;
			white[ 1532 ]<=1;
			white[ 1533 ]<=1;
			white[ 1534 ]<=1;
			white[ 1535 ]<=1;
			white[ 1536 ]<=1;
			white[ 1537 ]<=1;
			white[ 1538 ]<=1;
			white[ 1539 ]<=1;
			white[ 1540 ]<=1;
			white[ 1541 ]<=1;
			white[ 1542 ]<=1;
			white[ 1543 ]<=1;
			white[ 1544 ]<=1;
			white[ 1545 ]<=1;
			white[ 1546 ]<=1;
			white[ 1547 ]<=1;
			white[ 1548 ]<=1;
			white[ 1549 ]<=1;
			white[ 1550 ]<=1;
			white[ 1551 ]<=1;
			white[ 1552 ]<=1;
			white[ 1553 ]<=1;
			white[ 1554 ]<=1;
			white[ 1555 ]<=1;
			white[ 1556 ]<=0;
			white[ 1557 ]<=0;
			white[ 1558 ]<=0;
			white[ 1559 ]<=0;
			white[ 1560 ]<=0;
			white[ 1561 ]<=0;
			white[ 1562 ]<=0;
			white[ 1563 ]<=0;
			white[ 1564 ]<=0;
			white[ 1565 ]<=1;
			white[ 1566 ]<=1;
			white[ 1567 ]<=1;
			white[ 1568 ]<=1;
			white[ 1569 ]<=1;
			white[ 1570 ]<=1;
			white[ 1571 ]<=1;
			white[ 1572 ]<=1;
			white[ 1573 ]<=1;
			white[ 1574 ]<=1;
			white[ 1575 ]<=1;
			white[ 1576 ]<=1;
			white[ 1577 ]<=1;
			white[ 1578 ]<=1;
			white[ 1579 ]<=1;
			white[ 1580 ]<=1;
			white[ 1581 ]<=1;
			white[ 1582 ]<=1;
			white[ 1583 ]<=1;
			white[ 1584 ]<=1;
			white[ 1585 ]<=1;
			white[ 1586 ]<=1;
			white[ 1587 ]<=1;
			white[ 1588 ]<=1;
			white[ 1589 ]<=1;
			white[ 1590 ]<=1;
			white[ 1591 ]<=1;
			white[ 1592 ]<=1;
			white[ 1593 ]<=1;
			white[ 1594 ]<=1;
			white[ 1595 ]<=1;
			white[ 1596 ]<=1;
			white[ 1597 ]<=1;
			white[ 1598 ]<=1;
			white[ 1599 ]<=1;
			white[ 1600 ]<=1;
			white[ 1601 ]<=1;
			white[ 1602 ]<=1;
			white[ 1603 ]<=1;
			white[ 1604 ]<=1;
			white[ 1605 ]<=1;
			white[ 1606 ]<=1;
			white[ 1607 ]<=1;
			white[ 1608 ]<=1;
			white[ 1609 ]<=1;
			white[ 1610 ]<=1;
			white[ 1611 ]<=1;
			white[ 1612 ]<=1;
			white[ 1613 ]<=1;
			white[ 1614 ]<=1;
			white[ 1615 ]<=1;
			white[ 1616 ]<=0;
			white[ 1617 ]<=0;
			white[ 1618 ]<=0;
			white[ 1619 ]<=0;
			white[ 1620 ]<=0;
			white[ 1621 ]<=0;
			white[ 1622 ]<=0;
			white[ 1623 ]<=0;
			white[ 1624 ]<=0;
			white[ 1625 ]<=1;
			white[ 1626 ]<=1;
			white[ 1627 ]<=1;
			white[ 1628 ]<=1;
			white[ 1629 ]<=1;
			white[ 1630 ]<=1;
			white[ 1631 ]<=1;
			white[ 1632 ]<=1;
			white[ 1633 ]<=1;
			white[ 1634 ]<=1;
			white[ 1635 ]<=1;
			white[ 1636 ]<=1;
			white[ 1637 ]<=1;
			white[ 1638 ]<=1;
			white[ 1639 ]<=1;
			white[ 1640 ]<=1;
			white[ 1641 ]<=1;
			white[ 1642 ]<=1;
			white[ 1643 ]<=1;
			white[ 1644 ]<=1;
			white[ 1645 ]<=1;
			white[ 1646 ]<=1;
			white[ 1647 ]<=1;
			white[ 1648 ]<=1;
			white[ 1649 ]<=1;
			white[ 1650 ]<=1;
			white[ 1651 ]<=1;
			white[ 1652 ]<=1;
			white[ 1653 ]<=1;
			white[ 1654 ]<=1;
			white[ 1655 ]<=1;
			white[ 1656 ]<=1;
			white[ 1657 ]<=1;
			white[ 1658 ]<=1;
			white[ 1659 ]<=1;
			white[ 1660 ]<=1;
			white[ 1661 ]<=1;
			white[ 1662 ]<=1;
			white[ 1663 ]<=1;
			white[ 1664 ]<=1;
			white[ 1665 ]<=1;
			white[ 1666 ]<=1;
			white[ 1667 ]<=1;
			white[ 1668 ]<=1;
			white[ 1669 ]<=1;
			white[ 1670 ]<=1;
			white[ 1671 ]<=1;
			white[ 1672 ]<=1;
			white[ 1673 ]<=1;
			white[ 1674 ]<=1;
			white[ 1675 ]<=1;
			white[ 1676 ]<=0;
			white[ 1677 ]<=0;
			white[ 1678 ]<=0;
			white[ 1679 ]<=0;
			white[ 1680 ]<=0;
			white[ 1681 ]<=0;
			white[ 1682 ]<=0;
			white[ 1683 ]<=0;
			white[ 1684 ]<=0;
			white[ 1685 ]<=0;
			white[ 1686 ]<=1;
			white[ 1687 ]<=1;
			white[ 1688 ]<=1;
			white[ 1689 ]<=1;
			white[ 1690 ]<=1;
			white[ 1691 ]<=1;
			white[ 1692 ]<=1;
			white[ 1693 ]<=1;
			white[ 1694 ]<=1;
			white[ 1695 ]<=1;
			white[ 1696 ]<=1;
			white[ 1697 ]<=1;
			white[ 1698 ]<=1;
			white[ 1699 ]<=1;
			white[ 1700 ]<=1;
			white[ 1701 ]<=1;
			white[ 1702 ]<=1;
			white[ 1703 ]<=1;
			white[ 1704 ]<=1;
			white[ 1705 ]<=1;
			white[ 1706 ]<=1;
			white[ 1707 ]<=1;
			white[ 1708 ]<=1;
			white[ 1709 ]<=1;
			white[ 1710 ]<=1;
			white[ 1711 ]<=1;
			white[ 1712 ]<=1;
			white[ 1713 ]<=1;
			white[ 1714 ]<=1;
			white[ 1715 ]<=1;
			white[ 1716 ]<=1;
			white[ 1717 ]<=1;
			white[ 1718 ]<=1;
			white[ 1719 ]<=1;
			white[ 1720 ]<=1;
			white[ 1721 ]<=1;
			white[ 1722 ]<=1;
			white[ 1723 ]<=1;
			white[ 1724 ]<=1;
			white[ 1725 ]<=1;
			white[ 1726 ]<=1;
			white[ 1727 ]<=1;
			white[ 1728 ]<=1;
			white[ 1729 ]<=1;
			white[ 1730 ]<=1;
			white[ 1731 ]<=1;
			white[ 1732 ]<=1;
			white[ 1733 ]<=1;
			white[ 1734 ]<=1;
			white[ 1735 ]<=0;
			white[ 1736 ]<=0;
			white[ 1737 ]<=0;
			white[ 1738 ]<=0;
			white[ 1739 ]<=0;
			white[ 1740 ]<=0;
			white[ 1741 ]<=0;
			white[ 1742 ]<=0;
			white[ 1743 ]<=0;
			white[ 1744 ]<=0;
			white[ 1745 ]<=0;
			white[ 1746 ]<=0;
			white[ 1747 ]<=0;
			white[ 1748 ]<=0;
			white[ 1749 ]<=1;
			white[ 1750 ]<=1;
			white[ 1751 ]<=1;
			white[ 1752 ]<=1;
			white[ 1753 ]<=1;
			white[ 1754 ]<=1;
			white[ 1755 ]<=1;
			white[ 1756 ]<=1;
			white[ 1757 ]<=1;
			white[ 1758 ]<=1;
			white[ 1759 ]<=1;
			white[ 1760 ]<=1;
			white[ 1761 ]<=1;
			white[ 1762 ]<=1;
			white[ 1763 ]<=1;
			white[ 1764 ]<=1;
			white[ 1765 ]<=1;
			white[ 1766 ]<=1;
			white[ 1767 ]<=1;
			white[ 1768 ]<=1;
			white[ 1769 ]<=1;
			white[ 1770 ]<=1;
			white[ 1771 ]<=1;
			white[ 1772 ]<=1;
			white[ 1773 ]<=1;
			white[ 1774 ]<=1;
			white[ 1775 ]<=1;
			white[ 1776 ]<=1;
			white[ 1777 ]<=1;
			white[ 1778 ]<=1;
			white[ 1779 ]<=1;
			white[ 1780 ]<=1;
			white[ 1781 ]<=1;
			white[ 1782 ]<=1;
			white[ 1783 ]<=1;
			white[ 1784 ]<=1;
			white[ 1785 ]<=1;
			white[ 1786 ]<=1;
			white[ 1787 ]<=1;
			white[ 1788 ]<=1;
			white[ 1789 ]<=1;
			white[ 1790 ]<=1;
			white[ 1791 ]<=1;
			white[ 1792 ]<=1;
			white[ 1793 ]<=0;
			white[ 1794 ]<=0;
			white[ 1795 ]<=0;
			white[ 1796 ]<=0;
			white[ 1797 ]<=0;
			white[ 1798 ]<=0;
			white[ 1799 ]<=0;
			white[ 1800 ]<=0;
			white[ 1801 ]<=0;
			white[ 1802 ]<=0;
			white[ 1803 ]<=0;
			white[ 1804 ]<=0;
			white[ 1805 ]<=0;
			white[ 1806 ]<=0;
			white[ 1807 ]<=0;
			white[ 1808 ]<=0;
			white[ 1809 ]<=1;
			white[ 1810 ]<=1;
			white[ 1811 ]<=1;
			white[ 1812 ]<=1;
			white[ 1813 ]<=1;
			white[ 1814 ]<=1;
			white[ 1815 ]<=1;
			white[ 1816 ]<=1;
			white[ 1817 ]<=1;
			white[ 1818 ]<=1;
			white[ 1819 ]<=1;
			white[ 1820 ]<=1;
			white[ 1821 ]<=1;
			white[ 1822 ]<=1;
			white[ 1823 ]<=1;
			white[ 1824 ]<=1;
			white[ 1825 ]<=1;
			white[ 1826 ]<=1;
			white[ 1827 ]<=1;
			white[ 1828 ]<=1;
			white[ 1829 ]<=1;
			white[ 1830 ]<=1;
			white[ 1831 ]<=1;
			white[ 1832 ]<=1;
			white[ 1833 ]<=1;
			white[ 1834 ]<=1;
			white[ 1835 ]<=1;
			white[ 1836 ]<=1;
			white[ 1837 ]<=1;
			white[ 1838 ]<=1;
			white[ 1839 ]<=1;
			white[ 1840 ]<=1;
			white[ 1841 ]<=1;
			white[ 1842 ]<=1;
			white[ 1843 ]<=1;
			white[ 1844 ]<=1;
			white[ 1845 ]<=1;
			white[ 1846 ]<=1;
			white[ 1847 ]<=1;
			white[ 1848 ]<=1;
			white[ 1849 ]<=1;
			white[ 1850 ]<=1;
			white[ 1851 ]<=1;
			white[ 1852 ]<=1;
			white[ 1853 ]<=0;
			white[ 1854 ]<=0;
			white[ 1855 ]<=0;
			white[ 1856 ]<=0;
			white[ 1857 ]<=0;
			white[ 1858 ]<=0;
			white[ 1859 ]<=0;
			white[ 1860 ]<=0;
			white[ 1861 ]<=0;
			white[ 1862 ]<=0;
			white[ 1863 ]<=0;
			white[ 1864 ]<=0;
			white[ 1865 ]<=0;
			white[ 1866 ]<=0;
			white[ 1867 ]<=0;
			white[ 1868 ]<=0;
			white[ 1869 ]<=1;
			white[ 1870 ]<=1;
			white[ 1871 ]<=1;
			white[ 1872 ]<=1;
			white[ 1873 ]<=1;
			white[ 1874 ]<=1;
			white[ 1875 ]<=1;
			white[ 1876 ]<=1;
			white[ 1877 ]<=1;
			white[ 1878 ]<=1;
			white[ 1879 ]<=1;
			white[ 1880 ]<=1;
			white[ 1881 ]<=1;
			white[ 1882 ]<=1;
			white[ 1883 ]<=1;
			white[ 1884 ]<=1;
			white[ 1885 ]<=1;
			white[ 1886 ]<=1;
			white[ 1887 ]<=1;
			white[ 1888 ]<=1;
			white[ 1889 ]<=1;
			white[ 1890 ]<=1;
			white[ 1891 ]<=1;
			white[ 1892 ]<=1;
			white[ 1893 ]<=1;
			white[ 1894 ]<=1;
			white[ 1895 ]<=1;
			white[ 1896 ]<=1;
			white[ 1897 ]<=1;
			white[ 1898 ]<=1;
			white[ 1899 ]<=1;
			white[ 1900 ]<=1;
			white[ 1901 ]<=1;
			white[ 1902 ]<=1;
			white[ 1903 ]<=1;
			white[ 1904 ]<=1;
			white[ 1905 ]<=1;
			white[ 1906 ]<=1;
			white[ 1907 ]<=1;
			white[ 1908 ]<=1;
			white[ 1909 ]<=1;
			white[ 1910 ]<=1;
			white[ 1911 ]<=1;
			white[ 1912 ]<=1;
			white[ 1913 ]<=0;
			white[ 1914 ]<=0;
			white[ 1915 ]<=0;
			white[ 1916 ]<=0;
			white[ 1917 ]<=0;
			white[ 1918 ]<=0;
			white[ 1919 ]<=0;
			white[ 1920 ]<=0;
			white[ 1921 ]<=0;
			white[ 1922 ]<=0;
			white[ 1923 ]<=0;
			white[ 1924 ]<=0;
			white[ 1925 ]<=0;
			white[ 1926 ]<=0;
			white[ 1927 ]<=0;
			white[ 1928 ]<=1;
			white[ 1929 ]<=1;
			white[ 1930 ]<=1;
			white[ 1931 ]<=1;
			white[ 1932 ]<=1;
			white[ 1933 ]<=1;
			white[ 1934 ]<=1;
			white[ 1935 ]<=1;
			white[ 1936 ]<=1;
			white[ 1937 ]<=1;
			white[ 1938 ]<=1;
			white[ 1939 ]<=1;
			white[ 1940 ]<=1;
			white[ 1941 ]<=1;
			white[ 1942 ]<=1;
			white[ 1943 ]<=1;
			white[ 1944 ]<=1;
			white[ 1945 ]<=1;
			white[ 1946 ]<=1;
			white[ 1947 ]<=1;
			white[ 1948 ]<=1;
			white[ 1949 ]<=1;
			white[ 1950 ]<=1;
			white[ 1951 ]<=1;
			white[ 1952 ]<=1;
			white[ 1953 ]<=1;
			white[ 1954 ]<=1;
			white[ 1955 ]<=1;
			white[ 1956 ]<=1;
			white[ 1957 ]<=1;
			white[ 1958 ]<=1;
			white[ 1959 ]<=1;
			white[ 1960 ]<=1;
			white[ 1961 ]<=1;
			white[ 1962 ]<=1;
			white[ 1963 ]<=1;
			white[ 1964 ]<=1;
			white[ 1965 ]<=1;
			white[ 1966 ]<=1;
			white[ 1967 ]<=1;
			white[ 1968 ]<=1;
			white[ 1969 ]<=1;
			white[ 1970 ]<=1;
			white[ 1971 ]<=1;
			white[ 1972 ]<=1;
			white[ 1973 ]<=0;
			white[ 1974 ]<=0;
			white[ 1975 ]<=0;
			white[ 1976 ]<=0;
			white[ 1977 ]<=0;
			white[ 1978 ]<=0;
			white[ 1979 ]<=0;
			white[ 1980 ]<=0;
			white[ 1981 ]<=0;
			white[ 1982 ]<=0;
			white[ 1983 ]<=0;
			white[ 1984 ]<=0;
			white[ 1985 ]<=0;
			white[ 1986 ]<=0;
			white[ 1987 ]<=0;
			white[ 1988 ]<=1;
			white[ 1989 ]<=1;
			white[ 1990 ]<=1;
			white[ 1991 ]<=1;
			white[ 1992 ]<=1;
			white[ 1993 ]<=1;
			white[ 1994 ]<=1;
			white[ 1995 ]<=1;
			white[ 1996 ]<=1;
			white[ 1997 ]<=1;
			white[ 1998 ]<=1;
			white[ 1999 ]<=1;
			white[ 2000 ]<=1;
			white[ 2001 ]<=1;
			white[ 2002 ]<=1;
			white[ 2003 ]<=1;
			white[ 2004 ]<=1;
			white[ 2005 ]<=1;
			white[ 2006 ]<=1;
			white[ 2007 ]<=1;
			white[ 2008 ]<=1;
			white[ 2009 ]<=1;
			white[ 2010 ]<=1;
			white[ 2011 ]<=1;
			white[ 2012 ]<=1;
			white[ 2013 ]<=1;
			white[ 2014 ]<=1;
			white[ 2015 ]<=1;
			white[ 2016 ]<=1;
			white[ 2017 ]<=1;
			white[ 2018 ]<=1;
			white[ 2019 ]<=1;
			white[ 2020 ]<=1;
			white[ 2021 ]<=1;
			white[ 2022 ]<=1;
			white[ 2023 ]<=1;
			white[ 2024 ]<=1;
			white[ 2025 ]<=1;
			white[ 2026 ]<=1;
			white[ 2027 ]<=1;
			white[ 2028 ]<=1;
			white[ 2029 ]<=1;
			white[ 2030 ]<=1;
			white[ 2031 ]<=1;
			white[ 2032 ]<=1;
			white[ 2033 ]<=0;
			white[ 2034 ]<=0;
			white[ 2035 ]<=0;
			white[ 2036 ]<=0;
			white[ 2037 ]<=0;
			white[ 2038 ]<=0;
			white[ 2039 ]<=0;
			white[ 2040 ]<=0;
			white[ 2041 ]<=0;
			white[ 2042 ]<=0;
			white[ 2043 ]<=0;
			white[ 2044 ]<=0;
			white[ 2045 ]<=0;
			white[ 2046 ]<=0;
			white[ 2047 ]<=0;
			white[ 2048 ]<=1;
			white[ 2049 ]<=1;
			white[ 2050 ]<=1;
			white[ 2051 ]<=1;
			white[ 2052 ]<=1;
			white[ 2053 ]<=1;
			white[ 2054 ]<=1;
			white[ 2055 ]<=1;
			white[ 2056 ]<=1;
			white[ 2057 ]<=1;
			white[ 2058 ]<=1;
			white[ 2059 ]<=1;
			white[ 2060 ]<=1;
			white[ 2061 ]<=1;
			white[ 2062 ]<=1;
			white[ 2063 ]<=1;
			white[ 2064 ]<=1;
			white[ 2065 ]<=1;
			white[ 2066 ]<=1;
			white[ 2067 ]<=1;
			white[ 2068 ]<=1;
			white[ 2069 ]<=1;
			white[ 2070 ]<=1;
			white[ 2071 ]<=1;
			white[ 2072 ]<=1;
			white[ 2073 ]<=1;
			white[ 2074 ]<=1;
			white[ 2075 ]<=1;
			white[ 2076 ]<=1;
			white[ 2077 ]<=1;
			white[ 2078 ]<=1;
			white[ 2079 ]<=1;
			white[ 2080 ]<=1;
			white[ 2081 ]<=1;
			white[ 2082 ]<=1;
			white[ 2083 ]<=1;
			white[ 2084 ]<=1;
			white[ 2085 ]<=1;
			white[ 2086 ]<=1;
			white[ 2087 ]<=1;
			white[ 2088 ]<=1;
			white[ 2089 ]<=1;
			white[ 2090 ]<=1;
			white[ 2091 ]<=1;
			white[ 2092 ]<=1;
			white[ 2093 ]<=0;
			white[ 2094 ]<=0;
			white[ 2095 ]<=0;
			white[ 2096 ]<=0;
			white[ 2097 ]<=0;
			white[ 2098 ]<=0;
			white[ 2099 ]<=0;
			white[ 2100 ]<=0;
			white[ 2101 ]<=0;
			white[ 2102 ]<=0;
			white[ 2103 ]<=0;
			white[ 2104 ]<=0;
			white[ 2105 ]<=0;
			white[ 2106 ]<=0;
			white[ 2107 ]<=0;
			white[ 2108 ]<=1;
			white[ 2109 ]<=1;
			white[ 2110 ]<=1;
			white[ 2111 ]<=1;
			white[ 2112 ]<=1;
			white[ 2113 ]<=1;
			white[ 2114 ]<=1;
			white[ 2115 ]<=1;
			white[ 2116 ]<=1;
			white[ 2117 ]<=1;
			white[ 2118 ]<=1;
			white[ 2119 ]<=1;
			white[ 2120 ]<=1;
			white[ 2121 ]<=1;
			white[ 2122 ]<=1;
			white[ 2123 ]<=1;
			white[ 2124 ]<=1;
			white[ 2125 ]<=1;
			white[ 2126 ]<=1;
			white[ 2127 ]<=1;
			white[ 2128 ]<=1;
			white[ 2129 ]<=1;
			white[ 2130 ]<=1;
			white[ 2131 ]<=1;
			white[ 2132 ]<=1;
			white[ 2133 ]<=1;
			white[ 2134 ]<=1;
			white[ 2135 ]<=1;
			white[ 2136 ]<=1;
			white[ 2137 ]<=1;
			white[ 2138 ]<=1;
			white[ 2139 ]<=1;
			white[ 2140 ]<=1;
			white[ 2141 ]<=1;
			white[ 2142 ]<=1;
			white[ 2143 ]<=1;
			white[ 2144 ]<=1;
			white[ 2145 ]<=1;
			white[ 2146 ]<=1;
			white[ 2147 ]<=1;
			white[ 2148 ]<=1;
			white[ 2149 ]<=1;
			white[ 2150 ]<=1;
			white[ 2151 ]<=1;
			white[ 2152 ]<=1;
			white[ 2153 ]<=1;
			white[ 2154 ]<=0;
			white[ 2155 ]<=0;
			white[ 2156 ]<=0;
			white[ 2157 ]<=0;
			white[ 2158 ]<=0;
			white[ 2159 ]<=0;
			white[ 2160 ]<=0;
			white[ 2161 ]<=0;
			white[ 2162 ]<=0;
			white[ 2163 ]<=0;
			white[ 2164 ]<=0;
			white[ 2165 ]<=0;
			white[ 2166 ]<=0;
			white[ 2167 ]<=0;
			white[ 2168 ]<=1;
			white[ 2169 ]<=1;
			white[ 2170 ]<=1;
			white[ 2171 ]<=1;
			white[ 2172 ]<=1;
			white[ 2173 ]<=1;
			white[ 2174 ]<=1;
			white[ 2175 ]<=1;
			white[ 2176 ]<=1;
			white[ 2177 ]<=1;
			white[ 2178 ]<=1;
			white[ 2179 ]<=1;
			white[ 2180 ]<=1;
			white[ 2181 ]<=1;
			white[ 2182 ]<=1;
			white[ 2183 ]<=1;
			white[ 2184 ]<=1;
			white[ 2185 ]<=1;
			white[ 2186 ]<=1;
			white[ 2187 ]<=1;
			white[ 2188 ]<=1;
			white[ 2189 ]<=1;
			white[ 2190 ]<=1;
			white[ 2191 ]<=1;
			white[ 2192 ]<=1;
			white[ 2193 ]<=1;
			white[ 2194 ]<=1;
			white[ 2195 ]<=1;
			white[ 2196 ]<=1;
			white[ 2197 ]<=1;
			white[ 2198 ]<=1;
			white[ 2199 ]<=1;
			white[ 2200 ]<=1;
			white[ 2201 ]<=1;
			white[ 2202 ]<=1;
			white[ 2203 ]<=1;
			white[ 2204 ]<=1;
			white[ 2205 ]<=1;
			white[ 2206 ]<=1;
			white[ 2207 ]<=1;
			white[ 2208 ]<=1;
			white[ 2209 ]<=1;
			white[ 2210 ]<=1;
			white[ 2211 ]<=1;
			white[ 2212 ]<=1;
			white[ 2213 ]<=1;
			white[ 2214 ]<=0;
			white[ 2215 ]<=0;
			white[ 2216 ]<=0;
			white[ 2217 ]<=0;
			white[ 2218 ]<=0;
			white[ 2219 ]<=0;
			white[ 2220 ]<=0;
			white[ 2221 ]<=0;
			white[ 2222 ]<=0;
			white[ 2223 ]<=0;
			white[ 2224 ]<=0;
			white[ 2225 ]<=0;
			white[ 2226 ]<=0;
			white[ 2227 ]<=0;
			white[ 2228 ]<=1;
			white[ 2229 ]<=1;
			white[ 2230 ]<=1;
			white[ 2231 ]<=1;
			white[ 2232 ]<=1;
			white[ 2233 ]<=1;
			white[ 2234 ]<=1;
			white[ 2235 ]<=1;
			white[ 2236 ]<=1;
			white[ 2237 ]<=1;
			white[ 2238 ]<=1;
			white[ 2239 ]<=1;
			white[ 2240 ]<=1;
			white[ 2241 ]<=1;
			white[ 2242 ]<=1;
			white[ 2243 ]<=1;
			white[ 2244 ]<=1;
			white[ 2245 ]<=1;
			white[ 2246 ]<=1;
			white[ 2247 ]<=1;
			white[ 2248 ]<=1;
			white[ 2249 ]<=1;
			white[ 2250 ]<=1;
			white[ 2251 ]<=1;
			white[ 2252 ]<=1;
			white[ 2253 ]<=1;
			white[ 2254 ]<=1;
			white[ 2255 ]<=1;
			white[ 2256 ]<=1;
			white[ 2257 ]<=1;
			white[ 2258 ]<=1;
			white[ 2259 ]<=1;
			white[ 2260 ]<=1;
			white[ 2261 ]<=1;
			white[ 2262 ]<=1;
			white[ 2263 ]<=1;
			white[ 2264 ]<=1;
			white[ 2265 ]<=1;
			white[ 2266 ]<=1;
			white[ 2267 ]<=1;
			white[ 2268 ]<=1;
			white[ 2269 ]<=1;
			white[ 2270 ]<=1;
			white[ 2271 ]<=1;
			white[ 2272 ]<=1;
			white[ 2273 ]<=1;
			white[ 2274 ]<=0;
			white[ 2275 ]<=0;
			white[ 2276 ]<=0;
			white[ 2277 ]<=0;
			white[ 2278 ]<=0;
			white[ 2279 ]<=0;
			white[ 2280 ]<=0;
			white[ 2281 ]<=0;
			white[ 2282 ]<=0;
			white[ 2283 ]<=0;
			white[ 2284 ]<=0;
			white[ 2285 ]<=0;
			white[ 2286 ]<=0;
			white[ 2287 ]<=0;
			white[ 2288 ]<=1;
			white[ 2289 ]<=1;
			white[ 2290 ]<=1;
			white[ 2291 ]<=1;
			white[ 2292 ]<=1;
			white[ 2293 ]<=1;
			white[ 2294 ]<=1;
			white[ 2295 ]<=1;
			white[ 2296 ]<=1;
			white[ 2297 ]<=1;
			white[ 2298 ]<=1;
			white[ 2299 ]<=1;
			white[ 2300 ]<=1;
			white[ 2301 ]<=1;
			white[ 2302 ]<=1;
			white[ 2303 ]<=1;
			white[ 2304 ]<=1;
			white[ 2305 ]<=1;
			white[ 2306 ]<=1;
			white[ 2307 ]<=1;
			white[ 2308 ]<=1;
			white[ 2309 ]<=1;
			white[ 2310 ]<=0;
			white[ 2311 ]<=1;
			white[ 2312 ]<=1;
			white[ 2313 ]<=1;
			white[ 2314 ]<=1;
			white[ 2315 ]<=1;
			white[ 2316 ]<=1;
			white[ 2317 ]<=1;
			white[ 2318 ]<=1;
			white[ 2319 ]<=1;
			white[ 2320 ]<=1;
			white[ 2321 ]<=1;
			white[ 2322 ]<=1;
			white[ 2323 ]<=1;
			white[ 2324 ]<=1;
			white[ 2325 ]<=1;
			white[ 2326 ]<=1;
			white[ 2327 ]<=1;
			white[ 2328 ]<=1;
			white[ 2329 ]<=1;
			white[ 2330 ]<=1;
			white[ 2331 ]<=1;
			white[ 2332 ]<=1;
			white[ 2333 ]<=1;
			white[ 2334 ]<=0;
			white[ 2335 ]<=0;
			white[ 2336 ]<=0;
			white[ 2337 ]<=0;
			white[ 2338 ]<=0;
			white[ 2339 ]<=0;
			white[ 2340 ]<=0;
			white[ 2341 ]<=0;
			white[ 2342 ]<=0;
			white[ 2343 ]<=0;
			white[ 2344 ]<=0;
			white[ 2345 ]<=0;
			white[ 2346 ]<=0;
			white[ 2347 ]<=1;
			white[ 2348 ]<=1;
			white[ 2349 ]<=1;
			white[ 2350 ]<=1;
			white[ 2351 ]<=1;
			white[ 2352 ]<=1;
			white[ 2353 ]<=1;
			white[ 2354 ]<=1;
			white[ 2355 ]<=1;
			white[ 2356 ]<=1;
			white[ 2357 ]<=1;
			white[ 2358 ]<=1;
			white[ 2359 ]<=1;
			white[ 2360 ]<=1;
			white[ 2361 ]<=1;
			white[ 2362 ]<=1;
			white[ 2363 ]<=1;
			white[ 2364 ]<=1;
			white[ 2365 ]<=1;
			white[ 2366 ]<=1;
			white[ 2367 ]<=1;
			white[ 2368 ]<=1;
			white[ 2369 ]<=1;
			white[ 2370 ]<=1;
			white[ 2371 ]<=1;
			white[ 2372 ]<=1;
			white[ 2373 ]<=1;
			white[ 2374 ]<=1;
			white[ 2375 ]<=1;
			white[ 2376 ]<=1;
			white[ 2377 ]<=1;
			white[ 2378 ]<=1;
			white[ 2379 ]<=1;
			white[ 2380 ]<=1;
			white[ 2381 ]<=1;
			white[ 2382 ]<=1;
			white[ 2383 ]<=1;
			white[ 2384 ]<=1;
			white[ 2385 ]<=1;
			white[ 2386 ]<=1;
			white[ 2387 ]<=1;
			white[ 2388 ]<=1;
			white[ 2389 ]<=1;
			white[ 2390 ]<=1;
			white[ 2391 ]<=1;
			white[ 2392 ]<=1;
			white[ 2393 ]<=1;
			white[ 2394 ]<=0;
			white[ 2395 ]<=0;
			white[ 2396 ]<=0;
			white[ 2397 ]<=0;
			white[ 2398 ]<=0;
			white[ 2399 ]<=0;
			white[ 2400 ]<=0;
			white[ 2401 ]<=0;
			white[ 2402 ]<=0;
			white[ 2403 ]<=0;
			white[ 2404 ]<=0;
			white[ 2405 ]<=0;
			white[ 2406 ]<=0;
			white[ 2407 ]<=1;
			white[ 2408 ]<=1;
			white[ 2409 ]<=1;
			white[ 2410 ]<=1;
			white[ 2411 ]<=1;
			white[ 2412 ]<=1;
			white[ 2413 ]<=1;
			white[ 2414 ]<=1;
			white[ 2415 ]<=1;
			white[ 2416 ]<=1;
			white[ 2417 ]<=1;
			white[ 2418 ]<=1;
			white[ 2419 ]<=1;
			white[ 2420 ]<=1;
			white[ 2421 ]<=1;
			white[ 2422 ]<=1;
			white[ 2423 ]<=1;
			white[ 2424 ]<=0;
			white[ 2425 ]<=0;
			white[ 2426 ]<=1;
			white[ 2427 ]<=1;
			white[ 2428 ]<=1;
			white[ 2429 ]<=1;
			white[ 2430 ]<=1;
			white[ 2431 ]<=1;
			white[ 2432 ]<=1;
			white[ 2433 ]<=1;
			white[ 2434 ]<=1;
			white[ 2435 ]<=0;
			white[ 2436 ]<=0;
			white[ 2437 ]<=1;
			white[ 2438 ]<=1;
			white[ 2439 ]<=1;
			white[ 2440 ]<=1;
			white[ 2441 ]<=1;
			white[ 2442 ]<=1;
			white[ 2443 ]<=1;
			white[ 2444 ]<=1;
			white[ 2445 ]<=1;
			white[ 2446 ]<=1;
			white[ 2447 ]<=1;
			white[ 2448 ]<=1;
			white[ 2449 ]<=1;
			white[ 2450 ]<=1;
			white[ 2451 ]<=1;
			white[ 2452 ]<=1;
			white[ 2453 ]<=1;
			white[ 2454 ]<=0;
			white[ 2455 ]<=0;
			white[ 2456 ]<=0;
			white[ 2457 ]<=0;
			white[ 2458 ]<=0;
			white[ 2459 ]<=0;
			white[ 2460 ]<=0;
			white[ 2461 ]<=0;
			white[ 2462 ]<=0;
			white[ 2463 ]<=0;
			white[ 2464 ]<=0;
			white[ 2465 ]<=0;
			white[ 2466 ]<=0;
			white[ 2467 ]<=1;
			white[ 2468 ]<=1;
			white[ 2469 ]<=1;
			white[ 2470 ]<=1;
			white[ 2471 ]<=1;
			white[ 2472 ]<=1;
			white[ 2473 ]<=1;
			white[ 2474 ]<=1;
			white[ 2475 ]<=1;
			white[ 2476 ]<=1;
			white[ 2477 ]<=1;
			white[ 2478 ]<=1;
			white[ 2479 ]<=1;
			white[ 2480 ]<=1;
			white[ 2481 ]<=1;
			white[ 2482 ]<=1;
			white[ 2483 ]<=0;
			white[ 2484 ]<=0;
			white[ 2485 ]<=0;
			white[ 2486 ]<=1;
			white[ 2487 ]<=1;
			white[ 2488 ]<=1;
			white[ 2489 ]<=1;
			white[ 2490 ]<=1;
			white[ 2491 ]<=1;
			white[ 2492 ]<=1;
			white[ 2493 ]<=1;
			white[ 2494 ]<=1;
			white[ 2495 ]<=0;
			white[ 2496 ]<=0;
			white[ 2497 ]<=0;
			white[ 2498 ]<=1;
			white[ 2499 ]<=1;
			white[ 2500 ]<=1;
			white[ 2501 ]<=1;
			white[ 2502 ]<=1;
			white[ 2503 ]<=1;
			white[ 2504 ]<=1;
			white[ 2505 ]<=1;
			white[ 2506 ]<=1;
			white[ 2507 ]<=1;
			white[ 2508 ]<=1;
			white[ 2509 ]<=1;
			white[ 2510 ]<=1;
			white[ 2511 ]<=1;
			white[ 2512 ]<=1;
			white[ 2513 ]<=1;
			white[ 2514 ]<=0;
			white[ 2515 ]<=0;
			white[ 2516 ]<=0;
			white[ 2517 ]<=0;
			white[ 2518 ]<=0;
			white[ 2519 ]<=0;
			white[ 2520 ]<=0;
			white[ 2521 ]<=0;
			white[ 2522 ]<=0;
			white[ 2523 ]<=0;
			white[ 2524 ]<=0;
			white[ 2525 ]<=0;
			white[ 2526 ]<=0;
			white[ 2527 ]<=1;
			white[ 2528 ]<=1;
			white[ 2529 ]<=1;
			white[ 2530 ]<=1;
			white[ 2531 ]<=1;
			white[ 2532 ]<=1;
			white[ 2533 ]<=1;
			white[ 2534 ]<=1;
			white[ 2535 ]<=1;
			white[ 2536 ]<=1;
			white[ 2537 ]<=1;
			white[ 2538 ]<=1;
			white[ 2539 ]<=0;
			white[ 2540 ]<=0;
			white[ 2541 ]<=1;
			white[ 2542 ]<=1;
			white[ 2543 ]<=1;
			white[ 2544 ]<=1;
			white[ 2545 ]<=1;
			white[ 2546 ]<=0;
			white[ 2547 ]<=0;
			white[ 2548 ]<=1;
			white[ 2549 ]<=1;
			white[ 2550 ]<=1;
			white[ 2551 ]<=1;
			white[ 2552 ]<=1;
			white[ 2553 ]<=1;
			white[ 2554 ]<=0;
			white[ 2555 ]<=1;
			white[ 2556 ]<=1;
			white[ 2557 ]<=1;
			white[ 2558 ]<=1;
			white[ 2559 ]<=1;
			white[ 2560 ]<=0;
			white[ 2561 ]<=0;
			white[ 2562 ]<=1;
			white[ 2563 ]<=1;
			white[ 2564 ]<=1;
			white[ 2565 ]<=1;
			white[ 2566 ]<=1;
			white[ 2567 ]<=1;
			white[ 2568 ]<=1;
			white[ 2569 ]<=1;
			white[ 2570 ]<=1;
			white[ 2571 ]<=1;
			white[ 2572 ]<=1;
			white[ 2573 ]<=1;
			white[ 2574 ]<=0;
			white[ 2575 ]<=0;
			white[ 2576 ]<=0;
			white[ 2577 ]<=0;
			white[ 2578 ]<=0;
			white[ 2579 ]<=0;
			white[ 2580 ]<=0;
			white[ 2581 ]<=0;
			white[ 2582 ]<=0;
			white[ 2583 ]<=0;
			white[ 2584 ]<=0;
			white[ 2585 ]<=0;
			white[ 2586 ]<=0;
			white[ 2587 ]<=1;
			white[ 2588 ]<=1;
			white[ 2589 ]<=1;
			white[ 2590 ]<=1;
			white[ 2591 ]<=1;
			white[ 2592 ]<=1;
			white[ 2593 ]<=1;
			white[ 2594 ]<=1;
			white[ 2595 ]<=1;
			white[ 2596 ]<=1;
			white[ 2597 ]<=1;
			white[ 2598 ]<=1;
			white[ 2599 ]<=1;
			white[ 2600 ]<=1;
			white[ 2601 ]<=1;
			white[ 2602 ]<=1;
			white[ 2603 ]<=1;
			white[ 2604 ]<=1;
			white[ 2605 ]<=1;
			white[ 2606 ]<=1;
			white[ 2607 ]<=1;
			white[ 2608 ]<=0;
			white[ 2609 ]<=1;
			white[ 2610 ]<=1;
			white[ 2611 ]<=1;
			white[ 2612 ]<=0;
			white[ 2613 ]<=1;
			white[ 2614 ]<=1;
			white[ 2615 ]<=1;
			white[ 2616 ]<=1;
			white[ 2617 ]<=1;
			white[ 2618 ]<=1;
			white[ 2619 ]<=1;
			white[ 2620 ]<=1;
			white[ 2621 ]<=1;
			white[ 2622 ]<=1;
			white[ 2623 ]<=1;
			white[ 2624 ]<=1;
			white[ 2625 ]<=1;
			white[ 2626 ]<=1;
			white[ 2627 ]<=1;
			white[ 2628 ]<=1;
			white[ 2629 ]<=1;
			white[ 2630 ]<=1;
			white[ 2631 ]<=1;
			white[ 2632 ]<=1;
			white[ 2633 ]<=1;
			white[ 2634 ]<=1;
			white[ 2635 ]<=0;
			white[ 2636 ]<=0;
			white[ 2637 ]<=0;
			white[ 2638 ]<=0;
			white[ 2639 ]<=0;
			white[ 2640 ]<=0;
			white[ 2641 ]<=0;
			white[ 2642 ]<=0;
			white[ 2643 ]<=0;
			white[ 2644 ]<=0;
			white[ 2645 ]<=0;
			white[ 2646 ]<=0;
			white[ 2647 ]<=1;
			white[ 2648 ]<=1;
			white[ 2649 ]<=1;
			white[ 2650 ]<=1;
			white[ 2651 ]<=1;
			white[ 2652 ]<=1;
			white[ 2653 ]<=1;
			white[ 2654 ]<=1;
			white[ 2655 ]<=1;
			white[ 2656 ]<=1;
			white[ 2657 ]<=1;
			white[ 2658 ]<=1;
			white[ 2659 ]<=1;
			white[ 2660 ]<=1;
			white[ 2661 ]<=1;
			white[ 2662 ]<=1;
			white[ 2663 ]<=1;
			white[ 2664 ]<=1;
			white[ 2665 ]<=1;
			white[ 2666 ]<=1;
			white[ 2667 ]<=1;
			white[ 2668 ]<=0;
			white[ 2669 ]<=1;
			white[ 2670 ]<=1;
			white[ 2671 ]<=1;
			white[ 2672 ]<=0;
			white[ 2673 ]<=1;
			white[ 2674 ]<=1;
			white[ 2675 ]<=1;
			white[ 2676 ]<=1;
			white[ 2677 ]<=1;
			white[ 2678 ]<=1;
			white[ 2679 ]<=1;
			white[ 2680 ]<=1;
			white[ 2681 ]<=1;
			white[ 2682 ]<=1;
			white[ 2683 ]<=1;
			white[ 2684 ]<=1;
			white[ 2685 ]<=1;
			white[ 2686 ]<=1;
			white[ 2687 ]<=1;
			white[ 2688 ]<=1;
			white[ 2689 ]<=1;
			white[ 2690 ]<=1;
			white[ 2691 ]<=1;
			white[ 2692 ]<=1;
			white[ 2693 ]<=1;
			white[ 2694 ]<=1;
			white[ 2695 ]<=0;
			white[ 2696 ]<=0;
			white[ 2697 ]<=0;
			white[ 2698 ]<=0;
			white[ 2699 ]<=0;
			white[ 2700 ]<=0;
			white[ 2701 ]<=0;
			white[ 2702 ]<=0;
			white[ 2703 ]<=0;
			white[ 2704 ]<=0;
			white[ 2705 ]<=0;
			white[ 2706 ]<=0;
			white[ 2707 ]<=1;
			white[ 2708 ]<=1;
			white[ 2709 ]<=1;
			white[ 2710 ]<=1;
			white[ 2711 ]<=1;
			white[ 2712 ]<=1;
			white[ 2713 ]<=1;
			white[ 2714 ]<=1;
			white[ 2715 ]<=1;
			white[ 2716 ]<=0;
			white[ 2717 ]<=1;
			white[ 2718 ]<=1;
			white[ 2719 ]<=1;
			white[ 2720 ]<=1;
			white[ 2721 ]<=1;
			white[ 2722 ]<=1;
			white[ 2723 ]<=1;
			white[ 2724 ]<=1;
			white[ 2725 ]<=0;
			white[ 2726 ]<=0;
			white[ 2727 ]<=1;
			white[ 2728 ]<=1;
			white[ 2729 ]<=1;
			white[ 2730 ]<=1;
			white[ 2731 ]<=1;
			white[ 2732 ]<=1;
			white[ 2733 ]<=1;
			white[ 2734 ]<=1;
			white[ 2735 ]<=0;
			white[ 2736 ]<=1;
			white[ 2737 ]<=1;
			white[ 2738 ]<=1;
			white[ 2739 ]<=1;
			white[ 2740 ]<=1;
			white[ 2741 ]<=1;
			white[ 2742 ]<=1;
			white[ 2743 ]<=1;
			white[ 2744 ]<=1;
			white[ 2745 ]<=1;
			white[ 2746 ]<=1;
			white[ 2747 ]<=1;
			white[ 2748 ]<=1;
			white[ 2749 ]<=1;
			white[ 2750 ]<=1;
			white[ 2751 ]<=1;
			white[ 2752 ]<=1;
			white[ 2753 ]<=1;
			white[ 2754 ]<=1;
			white[ 2755 ]<=0;
			white[ 2756 ]<=0;
			white[ 2757 ]<=0;
			white[ 2758 ]<=0;
			white[ 2759 ]<=0;
			white[ 2760 ]<=0;
			white[ 2761 ]<=0;
			white[ 2762 ]<=0;
			white[ 2763 ]<=0;
			white[ 2764 ]<=0;
			white[ 2765 ]<=0;
			white[ 2766 ]<=0;
			white[ 2767 ]<=1;
			white[ 2768 ]<=1;
			white[ 2769 ]<=1;
			white[ 2770 ]<=1;
			white[ 2771 ]<=1;
			white[ 2772 ]<=1;
			white[ 2773 ]<=1;
			white[ 2774 ]<=1;
			white[ 2775 ]<=1;
			white[ 2776 ]<=1;
			white[ 2777 ]<=1;
			white[ 2778 ]<=1;
			white[ 2779 ]<=1;
			white[ 2780 ]<=1;
			white[ 2781 ]<=1;
			white[ 2782 ]<=1;
			white[ 2783 ]<=1;
			white[ 2784 ]<=1;
			white[ 2785 ]<=1;
			white[ 2786 ]<=1;
			white[ 2787 ]<=1;
			white[ 2788 ]<=1;
			white[ 2789 ]<=0;
			white[ 2790 ]<=0;
			white[ 2791 ]<=0;
			white[ 2792 ]<=1;
			white[ 2793 ]<=1;
			white[ 2794 ]<=1;
			white[ 2795 ]<=1;
			white[ 2796 ]<=1;
			white[ 2797 ]<=1;
			white[ 2798 ]<=1;
			white[ 2799 ]<=1;
			white[ 2800 ]<=1;
			white[ 2801 ]<=1;
			white[ 2802 ]<=1;
			white[ 2803 ]<=1;
			white[ 2804 ]<=1;
			white[ 2805 ]<=1;
			white[ 2806 ]<=1;
			white[ 2807 ]<=1;
			white[ 2808 ]<=1;
			white[ 2809 ]<=1;
			white[ 2810 ]<=1;
			white[ 2811 ]<=1;
			white[ 2812 ]<=1;
			white[ 2813 ]<=1;
			white[ 2814 ]<=1;
			white[ 2815 ]<=0;
			white[ 2816 ]<=0;
			white[ 2817 ]<=0;
			white[ 2818 ]<=0;
			white[ 2819 ]<=0;
			white[ 2820 ]<=0;
			white[ 2821 ]<=0;
			white[ 2822 ]<=0;
			white[ 2823 ]<=0;
			white[ 2824 ]<=0;
			white[ 2825 ]<=0;
			white[ 2826 ]<=0;
			white[ 2827 ]<=1;
			white[ 2828 ]<=1;
			white[ 2829 ]<=1;
			white[ 2830 ]<=1;
			white[ 2831 ]<=1;
			white[ 2832 ]<=1;
			white[ 2833 ]<=1;
			white[ 2834 ]<=1;
			white[ 2835 ]<=1;
			white[ 2836 ]<=1;
			white[ 2837 ]<=1;
			white[ 2838 ]<=1;
			white[ 2839 ]<=1;
			white[ 2840 ]<=1;
			white[ 2841 ]<=1;
			white[ 2842 ]<=1;
			white[ 2843 ]<=1;
			white[ 2844 ]<=1;
			white[ 2845 ]<=1;
			white[ 2846 ]<=1;
			white[ 2847 ]<=1;
			white[ 2848 ]<=1;
			white[ 2849 ]<=0;
			white[ 2850 ]<=0;
			white[ 2851 ]<=0;
			white[ 2852 ]<=1;
			white[ 2853 ]<=1;
			white[ 2854 ]<=1;
			white[ 2855 ]<=1;
			white[ 2856 ]<=1;
			white[ 2857 ]<=1;
			white[ 2858 ]<=1;
			white[ 2859 ]<=1;
			white[ 2860 ]<=1;
			white[ 2861 ]<=1;
			white[ 2862 ]<=1;
			white[ 2863 ]<=1;
			white[ 2864 ]<=1;
			white[ 2865 ]<=1;
			white[ 2866 ]<=1;
			white[ 2867 ]<=1;
			white[ 2868 ]<=1;
			white[ 2869 ]<=1;
			white[ 2870 ]<=1;
			white[ 2871 ]<=1;
			white[ 2872 ]<=1;
			white[ 2873 ]<=1;
			white[ 2874 ]<=1;
			white[ 2875 ]<=0;
			white[ 2876 ]<=0;
			white[ 2877 ]<=0;
			white[ 2878 ]<=0;
			white[ 2879 ]<=0;
			white[ 2880 ]<=0;
			white[ 2881 ]<=0;
			white[ 2882 ]<=0;
			white[ 2883 ]<=0;
			white[ 2884 ]<=0;
			white[ 2885 ]<=0;
			white[ 2886 ]<=0;
			white[ 2887 ]<=1;
			white[ 2888 ]<=1;
			white[ 2889 ]<=1;
			white[ 2890 ]<=1;
			white[ 2891 ]<=1;
			white[ 2892 ]<=1;
			white[ 2893 ]<=1;
			white[ 2894 ]<=1;
			white[ 2895 ]<=1;
			white[ 2896 ]<=1;
			white[ 2897 ]<=1;
			white[ 2898 ]<=1;
			white[ 2899 ]<=1;
			white[ 2900 ]<=1;
			white[ 2901 ]<=1;
			white[ 2902 ]<=1;
			white[ 2903 ]<=1;
			white[ 2904 ]<=1;
			white[ 2905 ]<=0;
			white[ 2906 ]<=1;
			white[ 2907 ]<=1;
			white[ 2908 ]<=1;
			white[ 2909 ]<=1;
			white[ 2910 ]<=1;
			white[ 2911 ]<=1;
			white[ 2912 ]<=1;
			white[ 2913 ]<=1;
			white[ 2914 ]<=1;
			white[ 2915 ]<=0;
			white[ 2916 ]<=1;
			white[ 2917 ]<=1;
			white[ 2918 ]<=1;
			white[ 2919 ]<=1;
			white[ 2920 ]<=1;
			white[ 2921 ]<=1;
			white[ 2922 ]<=1;
			white[ 2923 ]<=1;
			white[ 2924 ]<=1;
			white[ 2925 ]<=1;
			white[ 2926 ]<=1;
			white[ 2927 ]<=1;
			white[ 2928 ]<=1;
			white[ 2929 ]<=1;
			white[ 2930 ]<=1;
			white[ 2931 ]<=1;
			white[ 2932 ]<=1;
			white[ 2933 ]<=1;
			white[ 2934 ]<=1;
			white[ 2935 ]<=0;
			white[ 2936 ]<=0;
			white[ 2937 ]<=0;
			white[ 2938 ]<=0;
			white[ 2939 ]<=0;
			white[ 2940 ]<=0;
			white[ 2941 ]<=0;
			white[ 2942 ]<=0;
			white[ 2943 ]<=0;
			white[ 2944 ]<=0;
			white[ 2945 ]<=0;
			white[ 2946 ]<=0;
			white[ 2947 ]<=1;
			white[ 2948 ]<=1;
			white[ 2949 ]<=1;
			white[ 2950 ]<=1;
			white[ 2951 ]<=1;
			white[ 2952 ]<=1;
			white[ 2953 ]<=1;
			white[ 2954 ]<=1;
			white[ 2955 ]<=1;
			white[ 2956 ]<=1;
			white[ 2957 ]<=1;
			white[ 2958 ]<=1;
			white[ 2959 ]<=1;
			white[ 2960 ]<=1;
			white[ 2961 ]<=1;
			white[ 2962 ]<=1;
			white[ 2963 ]<=1;
			white[ 2964 ]<=1;
			white[ 2965 ]<=0;
			white[ 2966 ]<=1;
			white[ 2967 ]<=1;
			white[ 2968 ]<=1;
			white[ 2969 ]<=1;
			white[ 2970 ]<=1;
			white[ 2971 ]<=1;
			white[ 2972 ]<=1;
			white[ 2973 ]<=1;
			white[ 2974 ]<=1;
			white[ 2975 ]<=0;
			white[ 2976 ]<=1;
			white[ 2977 ]<=1;
			white[ 2978 ]<=1;
			white[ 2979 ]<=1;
			white[ 2980 ]<=1;
			white[ 2981 ]<=1;
			white[ 2982 ]<=1;
			white[ 2983 ]<=1;
			white[ 2984 ]<=1;
			white[ 2985 ]<=1;
			white[ 2986 ]<=1;
			white[ 2987 ]<=1;
			white[ 2988 ]<=1;
			white[ 2989 ]<=1;
			white[ 2990 ]<=1;
			white[ 2991 ]<=1;
			white[ 2992 ]<=1;
			white[ 2993 ]<=1;
			white[ 2994 ]<=1;
			white[ 2995 ]<=0;
			white[ 2996 ]<=0;
			white[ 2997 ]<=0;
			white[ 2998 ]<=0;
			white[ 2999 ]<=0;
			white[ 3000 ]<=0;
			white[ 3001 ]<=0;
			white[ 3002 ]<=0;
			white[ 3003 ]<=0;
			white[ 3004 ]<=0;
			white[ 3005 ]<=0;
			white[ 3006 ]<=0;
			white[ 3007 ]<=1;
			white[ 3008 ]<=1;
			white[ 3009 ]<=1;
			white[ 3010 ]<=1;
			white[ 3011 ]<=1;
			white[ 3012 ]<=1;
			white[ 3013 ]<=1;
			white[ 3014 ]<=1;
			white[ 3015 ]<=1;
			white[ 3016 ]<=1;
			white[ 3017 ]<=1;
			white[ 3018 ]<=1;
			white[ 3019 ]<=1;
			white[ 3020 ]<=1;
			white[ 3021 ]<=1;
			white[ 3022 ]<=1;
			white[ 3023 ]<=1;
			white[ 3024 ]<=1;
			white[ 3025 ]<=1;
			white[ 3026 ]<=1;
			white[ 3027 ]<=1;
			white[ 3028 ]<=1;
			white[ 3029 ]<=1;
			white[ 3030 ]<=1;
			white[ 3031 ]<=1;
			white[ 3032 ]<=1;
			white[ 3033 ]<=1;
			white[ 3034 ]<=1;
			white[ 3035 ]<=0;
			white[ 3036 ]<=1;
			white[ 3037 ]<=1;
			white[ 3038 ]<=1;
			white[ 3039 ]<=1;
			white[ 3040 ]<=1;
			white[ 3041 ]<=1;
			white[ 3042 ]<=1;
			white[ 3043 ]<=1;
			white[ 3044 ]<=1;
			white[ 3045 ]<=1;
			white[ 3046 ]<=1;
			white[ 3047 ]<=1;
			white[ 3048 ]<=1;
			white[ 3049 ]<=1;
			white[ 3050 ]<=1;
			white[ 3051 ]<=1;
			white[ 3052 ]<=1;
			white[ 3053 ]<=1;
			white[ 3054 ]<=1;
			white[ 3055 ]<=0;
			white[ 3056 ]<=0;
			white[ 3057 ]<=0;
			white[ 3058 ]<=0;
			white[ 3059 ]<=0;
			white[ 3060 ]<=0;
			white[ 3061 ]<=0;
			white[ 3062 ]<=0;
			white[ 3063 ]<=0;
			white[ 3064 ]<=0;
			white[ 3065 ]<=0;
			white[ 3066 ]<=0;
			white[ 3067 ]<=1;
			white[ 3068 ]<=1;
			white[ 3069 ]<=1;
			white[ 3070 ]<=1;
			white[ 3071 ]<=1;
			white[ 3072 ]<=1;
			white[ 3073 ]<=1;
			white[ 3074 ]<=1;
			white[ 3075 ]<=1;
			white[ 3076 ]<=1;
			white[ 3077 ]<=1;
			white[ 3078 ]<=1;
			white[ 3079 ]<=1;
			white[ 3080 ]<=0;
			white[ 3081 ]<=1;
			white[ 3082 ]<=1;
			white[ 3083 ]<=1;
			white[ 3084 ]<=1;
			white[ 3085 ]<=1;
			white[ 3086 ]<=0;
			white[ 3087 ]<=1;
			white[ 3088 ]<=1;
			white[ 3089 ]<=1;
			white[ 3090 ]<=1;
			white[ 3091 ]<=1;
			white[ 3092 ]<=1;
			white[ 3093 ]<=1;
			white[ 3094 ]<=0;
			white[ 3095 ]<=1;
			white[ 3096 ]<=1;
			white[ 3097 ]<=1;
			white[ 3098 ]<=1;
			white[ 3099 ]<=1;
			white[ 3100 ]<=1;
			white[ 3101 ]<=1;
			white[ 3102 ]<=1;
			white[ 3103 ]<=1;
			white[ 3104 ]<=1;
			white[ 3105 ]<=1;
			white[ 3106 ]<=1;
			white[ 3107 ]<=1;
			white[ 3108 ]<=1;
			white[ 3109 ]<=1;
			white[ 3110 ]<=1;
			white[ 3111 ]<=1;
			white[ 3112 ]<=1;
			white[ 3113 ]<=1;
			white[ 3114 ]<=1;
			white[ 3115 ]<=0;
			white[ 3116 ]<=0;
			white[ 3117 ]<=0;
			white[ 3118 ]<=0;
			white[ 3119 ]<=0;
			white[ 3120 ]<=0;
			white[ 3121 ]<=0;
			white[ 3122 ]<=0;
			white[ 3123 ]<=0;
			white[ 3124 ]<=0;
			white[ 3125 ]<=0;
			white[ 3126 ]<=0;
			white[ 3127 ]<=1;
			white[ 3128 ]<=1;
			white[ 3129 ]<=1;
			white[ 3130 ]<=1;
			white[ 3131 ]<=1;
			white[ 3132 ]<=1;
			white[ 3133 ]<=1;
			white[ 3134 ]<=1;
			white[ 3135 ]<=1;
			white[ 3136 ]<=1;
			white[ 3137 ]<=1;
			white[ 3138 ]<=1;
			white[ 3139 ]<=1;
			white[ 3140 ]<=0;
			white[ 3141 ]<=1;
			white[ 3142 ]<=1;
			white[ 3143 ]<=1;
			white[ 3144 ]<=1;
			white[ 3145 ]<=1;
			white[ 3146 ]<=0;
			white[ 3147 ]<=0;
			white[ 3148 ]<=0;
			white[ 3149 ]<=0;
			white[ 3150 ]<=0;
			white[ 3151 ]<=0;
			white[ 3152 ]<=0;
			white[ 3153 ]<=0;
			white[ 3154 ]<=1;
			white[ 3155 ]<=1;
			white[ 3156 ]<=1;
			white[ 3157 ]<=1;
			white[ 3158 ]<=1;
			white[ 3159 ]<=1;
			white[ 3160 ]<=0;
			white[ 3161 ]<=1;
			white[ 3162 ]<=1;
			white[ 3163 ]<=1;
			white[ 3164 ]<=1;
			white[ 3165 ]<=1;
			white[ 3166 ]<=1;
			white[ 3167 ]<=1;
			white[ 3168 ]<=1;
			white[ 3169 ]<=1;
			white[ 3170 ]<=1;
			white[ 3171 ]<=1;
			white[ 3172 ]<=1;
			white[ 3173 ]<=1;
			white[ 3174 ]<=1;
			white[ 3175 ]<=0;
			white[ 3176 ]<=0;
			white[ 3177 ]<=0;
			white[ 3178 ]<=0;
			white[ 3179 ]<=0;
			white[ 3180 ]<=0;
			white[ 3181 ]<=0;
			white[ 3182 ]<=0;
			white[ 3183 ]<=0;
			white[ 3184 ]<=0;
			white[ 3185 ]<=0;
			white[ 3186 ]<=0;
			white[ 3187 ]<=1;
			white[ 3188 ]<=1;
			white[ 3189 ]<=1;
			white[ 3190 ]<=1;
			white[ 3191 ]<=1;
			white[ 3192 ]<=1;
			white[ 3193 ]<=1;
			white[ 3194 ]<=1;
			white[ 3195 ]<=1;
			white[ 3196 ]<=1;
			white[ 3197 ]<=1;
			white[ 3198 ]<=0;
			white[ 3199 ]<=1;
			white[ 3200 ]<=1;
			white[ 3201 ]<=1;
			white[ 3202 ]<=1;
			white[ 3203 ]<=1;
			white[ 3204 ]<=1;
			white[ 3205 ]<=0;
			white[ 3206 ]<=0;
			white[ 3207 ]<=0;
			white[ 3208 ]<=0;
			white[ 3209 ]<=0;
			white[ 3210 ]<=0;
			white[ 3211 ]<=0;
			white[ 3212 ]<=0;
			white[ 3213 ]<=0;
			white[ 3214 ]<=1;
			white[ 3215 ]<=1;
			white[ 3216 ]<=1;
			white[ 3217 ]<=1;
			white[ 3218 ]<=1;
			white[ 3219 ]<=1;
			white[ 3220 ]<=0;
			white[ 3221 ]<=1;
			white[ 3222 ]<=0;
			white[ 3223 ]<=1;
			white[ 3224 ]<=1;
			white[ 3225 ]<=1;
			white[ 3226 ]<=1;
			white[ 3227 ]<=1;
			white[ 3228 ]<=1;
			white[ 3229 ]<=1;
			white[ 3230 ]<=1;
			white[ 3231 ]<=1;
			white[ 3232 ]<=1;
			white[ 3233 ]<=1;
			white[ 3234 ]<=1;
			white[ 3235 ]<=0;
			white[ 3236 ]<=0;
			white[ 3237 ]<=0;
			white[ 3238 ]<=0;
			white[ 3239 ]<=0;
			white[ 3240 ]<=0;
			white[ 3241 ]<=0;
			white[ 3242 ]<=0;
			white[ 3243 ]<=0;
			white[ 3244 ]<=0;
			white[ 3245 ]<=0;
			white[ 3246 ]<=0;
			white[ 3247 ]<=1;
			white[ 3248 ]<=1;
			white[ 3249 ]<=1;
			white[ 3250 ]<=1;
			white[ 3251 ]<=1;
			white[ 3252 ]<=1;
			white[ 3253 ]<=1;
			white[ 3254 ]<=1;
			white[ 3255 ]<=1;
			white[ 3256 ]<=1;
			white[ 3257 ]<=1;
			white[ 3258 ]<=1;
			white[ 3259 ]<=0;
			white[ 3260 ]<=1;
			white[ 3261 ]<=0;
			white[ 3262 ]<=1;
			white[ 3263 ]<=1;
			white[ 3264 ]<=1;
			white[ 3265 ]<=1;
			white[ 3266 ]<=0;
			white[ 3267 ]<=0;
			white[ 3268 ]<=0;
			white[ 3269 ]<=0;
			white[ 3270 ]<=0;
			white[ 3271 ]<=0;
			white[ 3272 ]<=0;
			white[ 3273 ]<=0;
			white[ 3274 ]<=0;
			white[ 3275 ]<=0;
			white[ 3276 ]<=1;
			white[ 3277 ]<=1;
			white[ 3278 ]<=1;
			white[ 3279 ]<=0;
			white[ 3280 ]<=1;
			white[ 3281 ]<=1;
			white[ 3282 ]<=1;
			white[ 3283 ]<=1;
			white[ 3284 ]<=1;
			white[ 3285 ]<=1;
			white[ 3286 ]<=1;
			white[ 3287 ]<=1;
			white[ 3288 ]<=1;
			white[ 3289 ]<=1;
			white[ 3290 ]<=1;
			white[ 3291 ]<=1;
			white[ 3292 ]<=1;
			white[ 3293 ]<=1;
			white[ 3294 ]<=1;
			white[ 3295 ]<=0;
			white[ 3296 ]<=0;
			white[ 3297 ]<=0;
			white[ 3298 ]<=0;
			white[ 3299 ]<=0;
			white[ 3300 ]<=0;
			white[ 3301 ]<=0;
			white[ 3302 ]<=0;
			white[ 3303 ]<=0;
			white[ 3304 ]<=0;
			white[ 3305 ]<=0;
			white[ 3306 ]<=0;
			white[ 3307 ]<=1;
			white[ 3308 ]<=1;
			white[ 3309 ]<=1;
			white[ 3310 ]<=1;
			white[ 3311 ]<=1;
			white[ 3312 ]<=1;
			white[ 3313 ]<=1;
			white[ 3314 ]<=1;
			white[ 3315 ]<=1;
			white[ 3316 ]<=1;
			white[ 3317 ]<=1;
			white[ 3318 ]<=1;
			white[ 3319 ]<=1;
			white[ 3320 ]<=1;
			white[ 3321 ]<=0;
			white[ 3322 ]<=1;
			white[ 3323 ]<=1;
			white[ 3324 ]<=1;
			white[ 3325 ]<=1;
			white[ 3326 ]<=0;
			white[ 3327 ]<=0;
			white[ 3328 ]<=0;
			white[ 3329 ]<=0;
			white[ 3330 ]<=0;
			white[ 3331 ]<=0;
			white[ 3332 ]<=0;
			white[ 3333 ]<=0;
			white[ 3334 ]<=0;
			white[ 3335 ]<=1;
			white[ 3336 ]<=1;
			white[ 3337 ]<=1;
			white[ 3338 ]<=1;
			white[ 3339 ]<=0;
			white[ 3340 ]<=1;
			white[ 3341 ]<=1;
			white[ 3342 ]<=1;
			white[ 3343 ]<=1;
			white[ 3344 ]<=1;
			white[ 3345 ]<=1;
			white[ 3346 ]<=1;
			white[ 3347 ]<=1;
			white[ 3348 ]<=1;
			white[ 3349 ]<=1;
			white[ 3350 ]<=1;
			white[ 3351 ]<=1;
			white[ 3352 ]<=1;
			white[ 3353 ]<=1;
			white[ 3354 ]<=1;
			white[ 3355 ]<=0;
			white[ 3356 ]<=0;
			white[ 3357 ]<=0;
			white[ 3358 ]<=0;
			white[ 3359 ]<=0;
			white[ 3360 ]<=0;
			white[ 3361 ]<=0;
			white[ 3362 ]<=0;
			white[ 3363 ]<=0;
			white[ 3364 ]<=0;
			white[ 3365 ]<=0;
			white[ 3366 ]<=0;
			white[ 3367 ]<=1;
			white[ 3368 ]<=1;
			white[ 3369 ]<=1;
			white[ 3370 ]<=1;
			white[ 3371 ]<=1;
			white[ 3372 ]<=1;
			white[ 3373 ]<=1;
			white[ 3374 ]<=1;
			white[ 3375 ]<=1;
			white[ 3376 ]<=1;
			white[ 3377 ]<=1;
			white[ 3378 ]<=1;
			white[ 3379 ]<=1;
			white[ 3380 ]<=1;
			white[ 3381 ]<=1;
			white[ 3382 ]<=1;
			white[ 3383 ]<=1;
			white[ 3384 ]<=1;
			white[ 3385 ]<=1;
			white[ 3386 ]<=0;
			white[ 3387 ]<=0;
			white[ 3388 ]<=0;
			white[ 3389 ]<=0;
			white[ 3390 ]<=0;
			white[ 3391 ]<=0;
			white[ 3392 ]<=0;
			white[ 3393 ]<=0;
			white[ 3394 ]<=0;
			white[ 3395 ]<=1;
			white[ 3396 ]<=1;
			white[ 3397 ]<=1;
			white[ 3398 ]<=1;
			white[ 3399 ]<=1;
			white[ 3400 ]<=1;
			white[ 3401 ]<=1;
			white[ 3402 ]<=1;
			white[ 3403 ]<=1;
			white[ 3404 ]<=1;
			white[ 3405 ]<=1;
			white[ 3406 ]<=1;
			white[ 3407 ]<=1;
			white[ 3408 ]<=1;
			white[ 3409 ]<=1;
			white[ 3410 ]<=1;
			white[ 3411 ]<=1;
			white[ 3412 ]<=1;
			white[ 3413 ]<=1;
			white[ 3414 ]<=1;
			white[ 3415 ]<=0;
			white[ 3416 ]<=0;
			white[ 3417 ]<=0;
			white[ 3418 ]<=0;
			white[ 3419 ]<=0;
			white[ 3420 ]<=0;
			white[ 3421 ]<=0;
			white[ 3422 ]<=0;
			white[ 3423 ]<=0;
			white[ 3424 ]<=0;
			white[ 3425 ]<=0;
			white[ 3426 ]<=0;
			white[ 3427 ]<=1;
			white[ 3428 ]<=1;
			white[ 3429 ]<=1;
			white[ 3430 ]<=1;
			white[ 3431 ]<=1;
			white[ 3432 ]<=1;
			white[ 3433 ]<=1;
			white[ 3434 ]<=1;
			white[ 3435 ]<=1;
			white[ 3436 ]<=1;
			white[ 3437 ]<=1;
			white[ 3438 ]<=1;
			white[ 3439 ]<=1;
			white[ 3440 ]<=1;
			white[ 3441 ]<=1;
			white[ 3442 ]<=1;
			white[ 3443 ]<=1;
			white[ 3444 ]<=1;
			white[ 3445 ]<=0;
			white[ 3446 ]<=0;
			white[ 3447 ]<=0;
			white[ 3448 ]<=0;
			white[ 3449 ]<=0;
			white[ 3450 ]<=0;
			white[ 3451 ]<=0;
			white[ 3452 ]<=0;
			white[ 3453 ]<=0;
			white[ 3454 ]<=0;
			white[ 3455 ]<=0;
			white[ 3456 ]<=1;
			white[ 3457 ]<=1;
			white[ 3458 ]<=1;
			white[ 3459 ]<=1;
			white[ 3460 ]<=0;
			white[ 3461 ]<=1;
			white[ 3462 ]<=1;
			white[ 3463 ]<=1;
			white[ 3464 ]<=1;
			white[ 3465 ]<=1;
			white[ 3466 ]<=1;
			white[ 3467 ]<=1;
			white[ 3468 ]<=1;
			white[ 3469 ]<=1;
			white[ 3470 ]<=1;
			white[ 3471 ]<=1;
			white[ 3472 ]<=1;
			white[ 3473 ]<=1;
			white[ 3474 ]<=1;
			white[ 3475 ]<=0;
			white[ 3476 ]<=0;
			white[ 3477 ]<=0;
			white[ 3478 ]<=0;
			white[ 3479 ]<=0;
			white[ 3480 ]<=0;
			white[ 3481 ]<=0;
			white[ 3482 ]<=0;
			white[ 3483 ]<=0;
			white[ 3484 ]<=0;
			white[ 3485 ]<=0;
			white[ 3486 ]<=0;
			white[ 3487 ]<=1;
			white[ 3488 ]<=1;
			white[ 3489 ]<=1;
			white[ 3490 ]<=1;
			white[ 3491 ]<=1;
			white[ 3492 ]<=1;
			white[ 3493 ]<=1;
			white[ 3494 ]<=1;
			white[ 3495 ]<=1;
			white[ 3496 ]<=1;
			white[ 3497 ]<=1;
			white[ 3498 ]<=1;
			white[ 3499 ]<=1;
			white[ 3500 ]<=1;
			white[ 3501 ]<=1;
			white[ 3502 ]<=1;
			white[ 3503 ]<=1;
			white[ 3504 ]<=1;
			white[ 3505 ]<=1;
			white[ 3506 ]<=0;
			white[ 3507 ]<=0;
			white[ 3508 ]<=0;
			white[ 3509 ]<=0;
			white[ 3510 ]<=0;
			white[ 3511 ]<=0;
			white[ 3512 ]<=0;
			white[ 3513 ]<=0;
			white[ 3514 ]<=0;
			white[ 3515 ]<=1;
			white[ 3516 ]<=1;
			white[ 3517 ]<=1;
			white[ 3518 ]<=1;
			white[ 3519 ]<=1;
			white[ 3520 ]<=1;
			white[ 3521 ]<=1;
			white[ 3522 ]<=1;
			white[ 3523 ]<=1;
			white[ 3524 ]<=1;
			white[ 3525 ]<=1;
			white[ 3526 ]<=1;
			white[ 3527 ]<=1;
			white[ 3528 ]<=1;
			white[ 3529 ]<=1;
			white[ 3530 ]<=1;
			white[ 3531 ]<=1;
			white[ 3532 ]<=1;
			white[ 3533 ]<=1;
			white[ 3534 ]<=0;
			white[ 3535 ]<=0;
			white[ 3536 ]<=0;
			white[ 3537 ]<=0;
			white[ 3538 ]<=0;
			white[ 3539 ]<=0;
			white[ 3540 ]<=0;
			white[ 3541 ]<=0;
			white[ 3542 ]<=0;
			white[ 3543 ]<=0;
			white[ 3544 ]<=0;
			white[ 3545 ]<=0;
			white[ 3546 ]<=0;
			white[ 3547 ]<=1;
			white[ 3548 ]<=1;
			white[ 3549 ]<=1;
			white[ 3550 ]<=1;
			white[ 3551 ]<=1;
			white[ 3552 ]<=1;
			white[ 3553 ]<=1;
			white[ 3554 ]<=1;
			white[ 3555 ]<=1;
			white[ 3556 ]<=1;
			white[ 3557 ]<=1;
			white[ 3558 ]<=1;
			white[ 3559 ]<=1;
			white[ 3560 ]<=1;
			white[ 3561 ]<=1;
			white[ 3562 ]<=1;
			white[ 3563 ]<=1;
			white[ 3564 ]<=1;
			white[ 3565 ]<=1;
			white[ 3566 ]<=1;
			white[ 3567 ]<=1;
			white[ 3568 ]<=1;
			white[ 3569 ]<=0;
			white[ 3570 ]<=0;
			white[ 3571 ]<=0;
			white[ 3572 ]<=1;
			white[ 3573 ]<=1;
			white[ 3574 ]<=1;
			white[ 3575 ]<=1;
			white[ 3576 ]<=1;
			white[ 3577 ]<=1;
			white[ 3578 ]<=1;
			white[ 3579 ]<=1;
			white[ 3580 ]<=1;
			white[ 3581 ]<=1;
			white[ 3582 ]<=1;
			white[ 3583 ]<=1;
			white[ 3584 ]<=1;
			white[ 3585 ]<=1;
			white[ 3586 ]<=1;
			white[ 3587 ]<=1;
			white[ 3588 ]<=1;
			white[ 3589 ]<=1;
			white[ 3590 ]<=1;
			white[ 3591 ]<=1;
			white[ 3592 ]<=1;
			white[ 3593 ]<=1;
			white[ 3594 ]<=0;
			white[ 3595 ]<=0;
			white[ 3596 ]<=0;
			white[ 3597 ]<=0;
			white[ 3598 ]<=0;
			white[ 3599 ]<=0;
			end
endcase
end
end

always@(posedge iclk or negedge ireset_n)
begin
	if(!ireset_n)
	begin
		oOVERRIDE<= 0;
		oADDR <= 18'bZ;
		counter <= 6'd59;
	end
	else if(display_area)
	begin
		if(counter == 0)
			counter <= 6'd59;
		else
			counter <= counter-1;			
		oOVERRIDE <=white[counter + 60*(iy_cnt-isymbol_pos_y)];
		oADDR <= iBASE_ADDR + counter + 60*(iy_cnt-isymbol_pos_y);		
	end
	else
	begin
		oOVERRIDE <= 0;
		oADDR <= 18'bZ;
	end
end

endmodule
